/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/path","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/network","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","child_process","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/native/electron-sandbox/native","vs/platform/configuration/common/configurationModels","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/services","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/storage/common/storageIpc","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],se=function(Q){for(var e=[],D=0,n=Q.length;D<n;D++)e[D]=ne[Q[D]];return e};define(ne[110],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function D(k,T){if(!k)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=D;function n(k,T="Unreachable"){throw new Error(T)}e.assertNever=n}),define(ne[50],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(A){return A?A.replace(/\$\((.*?)\)/g,(b,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=D;class n{constructor(b,P,I){this.id=b,this.definition=P,this.description=I,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",n.circleFilled.definition),n.closeDirty=new n("close-dirty",n.circleFilled.definition),n.terminalDecorationSuccess=new n("terminal-decoration-success",n.circleFilled.definition),n.debugBreakpoint=new n("debug-breakpoint",n.circleFilled.definition),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",n.circleFilled.definition),n.debugHint=new n("debug-hint",n.circleFilled.definition),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circle=new n("circle",{fontCharacter:"\\eabc"}),n.circleOutline=new n("circle-outline",n.circle.definition),n.terminalDecorationIncomplete=new n("terminal-decoration-incomplete",n.circle.definition),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",n.circle.definition),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.circleSmallFilled=new n("circle-small-filled",{fontCharacter:"\\eb8a"}),n.debugStackframeDot=new n("debug-stackframe-dot",n.circleSmallFilled.definition),n.terminalDecorationMark=new n("terminal-decoration-mark",n.circleSmallFilled.definition),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLarge=new n("circle-large",{fontCharacter:"\\ebb5"}),n.circleLargeOutline=new n("circle-large-outline",n.circleLarge.definition),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.layoutSidebarRightOff=new n("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),n.layoutPanelOff=new n("layout-panel-off",{fontCharacter:"\\ec01"}),n.layoutSidebarLeftOff=new n("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.terminalDecorationError=new n("terminal-decoration-error",n.errorSmall.definition),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.heartFilled=new n("heart-filled",{fontCharacter:"\\ec04"}),n.map=new n("map",{fontCharacter:"\\ec05"}),n.mapFilled=new n("map-filled",{fontCharacter:"\\ec06"}),n.circleSmall=new n("circle-small",{fontCharacter:"\\ec07"}),n.bellSlash=new n("bell-slash",{fontCharacter:"\\ec08"}),n.bellSlashDot=new n("bell-slash-dot",{fontCharacter:"\\ec09"}),n.commentUnresolved=new n("comment-unresolved",{fontCharacter:"\\ec0a"}),n.gitPullRequestGoToChanges=new n("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),n.gitPullRequestNewChanges=new n("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),n.searchFuzzy=new n("search-fuzzy",{fontCharacter:"\\ec0d"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function k(A,b){const P=["codicon","codicon-"+A];return b&&P.push("codicon-modifier-"+b),P}e.getClassNamesArray=k;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function P(w){if(w instanceof n)return["codicon","codicon-"+w.id];const m=b.exec(w.id);if(!m)return P(n.error);const[,y,d]=m,S=["codicon","codicon-"+y];return d&&S.push("codicon-modifier-"+d.substr(1)),S}A.asClassNameArray=P;function I(w){return P(w).join(" ")}A.asClassName=I;function E(w){return"."+P(w).join(".")}A.asCSSSelector=E})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ne[60],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(b,P,I)=>{let E=null,w=null;if(typeof I.value=="function"?(E="value",w=I.value):typeof I.get=="function"&&(E="get",w=I.get),!w)throw new Error("not supported");I[E]=A(w,P)}}e.createDecorator=D;function n(A,b,P){let I=null,E=null;if(typeof P.value=="function"?(I="value",E=P.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(I="get",E=P.get),!E)throw new Error("not supported");const w=`$memoize$${b}`;P[I]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,m)}),this[w]}}e.memoize=n;function k(A,b,P){return D((I,E)=>{const w=`$debounce$${E}`,m=`$debounce$result$${E}`;return function(...y){this[m]||(this[m]=P?P():void 0),clearTimeout(this[w]),b&&(this[m]=b(this[m],...y),y=[this[m]]),this[w]=setTimeout(()=>{I.apply(this,y),this[m]=P?P():void 0},A)}})}e.debounce=k;function T(A,b,P){return D((I,E)=>{const w=`$throttle$timer$${E}`,m=`$throttle$result$${E}`,y=`$throttle$lastRun$${E}`,d=`$throttle$pending$${E}`;return function(...S){if(this[m]||(this[m]=P?P():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...S)),this[d])return;const C=this[y]+A;C<=Date.now()?(this[y]=Date.now(),I.apply(this,[this[m]]),this[m]=P?P():void 0):(this[d]=!0,this[w]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),I.apply(this,[this[m]]),this[m]=P?P():void 0},C-Date.now()))}})}e.throttle=T}),define(ne[10],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?u.isErrorNoTelemetry(s)?new u(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(r=>{r(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=D,e.errorHandler=new D;function n(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=n;function k(c){P(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function T(c){P(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=T;function A(c){if(c instanceof Error){const{name:s,message:r}=c,t=c.stacktrace||c.stack;return{$isError:!0,name:s,message:r,stack:t,noTelemetry:u.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=A;const b="Canceled";function P(c){return c instanceof I?!0:c instanceof Error&&c.name===b&&c.message===b}e.isCancellationError=P;class I extends Error{constructor(){super(b);this.name=this.message}}e.CancellationError=I;function E(){const c=new Error(b);return c.name=c.message,c}e.canceled=E;function w(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=w;function m(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=m;function y(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(c){const s=new Error(`${c} has been disposed`);return s.name="DISPOSED",s}e.disposed=d;function S(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=S;class C extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=C;class p extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=p;class g extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=g;class u extends Error{constructor(s){super(s);this.name="CodeExpectedError"}static fromError(s){if(s instanceof u)return s;const r=new u;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=u;class f extends Error{constructor(s){super(s||"An unexpected bug occurred.");Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(ne[18],se([0,1,10]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function n(J,ie=0){return J[J.length-(1+ie)]}e.tail=n;function k(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}e.tail2=k;function T(J,ie,re=(ue,he)=>ue===he){if(J===ie)return!0;if(!J||!ie||J.length!==ie.length)return!1;for(let ue=0,he=J.length;ue<he;ue++)if(!re(J[ue],ie[ue]))return!1;return!0}e.equals=T;function A(J,ie){const re=J.length-1;ie<re&&(J[ie]=J[re]),J.pop()}e.removeFastWithoutKeepingOrder=A;function b(J,ie,re){return P(J.length,ue=>re(J[ue],ie))}e.binarySearch=b;function P(J,ie){let re=0,ue=J-1;for(;re<=ue;){const he=(re+ue)/2|0,ve=ie(he);if(ve<0)re=he+1;else if(ve>0)ue=he-1;else return he}return-(re+1)}e.binarySearch2=P;function I(J,ie){let re=0,ue=J.length;if(ue===0)return 0;for(;re<ue;){const he=Math.floor((re+ue)/2);ie(J[he])?ue=he:re=he+1}return re}e.findFirstInSorted=I;function E(J,ie,re){if(J=J|0,J>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],he=[],ve=[],ye=[];for(const Ce of ie){const Pe=re(Ce,ue);Pe<0?he.push(Ce):Pe>0?ve.push(Ce):ye.push(Ce)}return J<he.length?E(J,he,re):J<he.length+ye.length?ye[0]:E(J-(he.length+ye.length),ve,re)}e.quickSelect=E;function w(J,ie){const re=[];let ue;for(const he of J.slice(0).sort(ie))!ue||ie(ue[0],he)!==0?(ue=[he],re.push(ue)):ue.push(he);return re}e.groupBy=w;function m(J,ie,re){const ue=[];function he(Ce,Pe,Ue){if(Pe===0&&Ue.length===0)return;const We=ue[ue.length-1];We&&We.start+We.deleteCount===Ce?(We.deleteCount+=Pe,We.toInsert.push(...Ue)):ue.push({start:Ce,deleteCount:Pe,toInsert:Ue})}let ve=0,ye=0;for(;;){if(ve===J.length){he(ve,0,ie.slice(ye));break}if(ye===ie.length){he(ve,J.length-ve,[]);break}const Ce=J[ve],Pe=ie[ye],Ue=re(Ce,Pe);Ue===0?(ve+=1,ye+=1):Ue<0?(he(ve,1,[]),ve+=1):Ue>0&&(he(ve,0,[Pe]),ye+=1)}return ue}e.sortedDiff=m;function y(J,ie,re){const ue=m(J,ie,re),he=[],ve=[];for(const ye of ue)he.push(...J.slice(ye.start,ye.start+ye.deleteCount)),ve.push(...ye.toInsert);return{removed:he,added:ve}}e.delta=y;function d(J,ie,re){if(re===0)return[];const ue=J.slice(0,re).sort(ie);return C(J,ie,ue,re,J.length),ue}e.top=d;function S(J,ie,re,ue,he){return re===0?Promise.resolve([]):new Promise((ve,ye)=>{(async()=>{const Ce=J.length,Pe=J.slice(0,re).sort(ie);for(let Ue=re,We=Math.min(re+ue,Ce);Ue<Ce;Ue=We,We=Math.min(We+ue,Ce)){if(Ue>re&&await new Promise(Be=>setTimeout(Be)),he&&he.isCancellationRequested)throw new D.CancellationError;C(J,ie,Pe,Ue,We)}return Pe})().then(ve,ye)})}e.topAsync=S;function C(J,ie,re,ue,he){for(const ve=re.length;ue<he;ue++){const ye=J[ue];if(ie(ye,re[ve-1])<0){re.pop();const Ce=I(re,Pe=>ie(ye,Pe)<0);re.splice(Ce,0,ye)}}}function p(J){return J.filter(ie=>!!ie)}e.coalesce=p;function g(J){let ie=0;for(let re=0;re<J.length;re++)J[re]&&(J[ie]=J[re],ie+=1);J.length=ie}e.coalesceInPlace=g;function u(J,ie,re){J.splice(re,0,J.splice(ie,1)[0])}e.move=u;function f(J){return!Array.isArray(J)||J.length===0}e.isFalsyOrEmpty=f;function c(J){return Array.isArray(J)&&J.length>0}e.isNonEmptyArray=c;function s(J,ie=re=>re){const re=new Set;return J.filter(ue=>{const he=ie(ue);return re.has(he)?!1:(re.add(he),!0)})}e.distinct=s;function r(J){const ie=new Set;return re=>{const ue=J(re);return ie.has(ue)?!1:(ie.add(ue),!0)}}e.uniqueFilter=r;function t(J,ie){const re=i(J,ie);if(re!==-1)return J[re]}e.findLast=t;function i(J,ie){for(let re=J.length-1;re>=0;re--){const ue=J[re];if(ie(ue))return re}return-1}e.lastIndex=i;function o(J,ie){return J.length>0?J[0]:ie}e.firstOrDefault=o;function l(J,ie){return J.length>0?J[J.length-1]:ie}e.lastOrDefault=l;function a(J,ie,re=(ue,he)=>ue===he){let ue=0;for(let he=0,ve=Math.min(J.length,ie.length);he<ve&&re(J[he],ie[he]);he++)ue++;return ue}e.commonPrefixLength=a;function h(J){return[].concat(...J)}e.flatten=h;function v(J,ie){let re=typeof ie=="number"?J:0;typeof ie=="number"?re=J:(re=0,ie=J);const ue=[];if(re<=ie)for(let he=re;he<ie;he++)ue.push(he);else for(let he=re;he>ie;he--)ue.push(he);return ue}e.range=v;function R(J,ie,re){return J.reduce((ue,he)=>(ue[ie(he)]=re?re(he):he,ue),Object.create(null))}e.index=R;function M(J,ie){return J.push(ie),()=>F(J,ie)}e.insert=M;function F(J,ie){const re=J.indexOf(ie);if(re>-1)return J.splice(re,1),ie}e.remove=F;function O(J,ie,re){const ue=J.slice(0,ie),he=J.slice(ie);return ue.concat(re,he)}e.arrayInsert=O;function L(J,ie){let re;if(typeof ie=="number"){let ue=ie;re=()=>{const he=Math.sin(ue++)*179426549;return he-Math.floor(he)}}else re=Math.random;for(let ue=J.length-1;ue>0;ue-=1){const he=Math.floor(re()*(ue+1)),ve=J[ue];J[ue]=J[he],J[he]=ve}}e.shuffle=L;function N(J,ie){const re=J.indexOf(ie);re>-1&&(J.splice(re,1),J.unshift(ie))}e.pushToStart=N;function $(J,ie){const re=J.indexOf(ie);re>-1&&(J.splice(re,1),J.push(ie))}e.pushToEnd=$;function H(J,ie){for(const re of ie)J.push(re)}e.pushMany=H;function Y(J,ie){return Array.isArray(J)?J.map(ie):ie(J)}e.mapArrayOrNot=Y;function te(J){return Array.isArray(J)?J:[J]}e.asArray=te;function q(J){return J[Math.floor(Math.random()*J.length)]}e.getRandomElement=q;function W(J,ie){for(const re of J){const ue=ie(re);if(ue!==void 0)return ue}}e.mapFind=W;function x(J,ie,re){const ue=ee(J,ie),he=J.length,ve=re.length;J.length=he+ve;for(let ye=he-1;ye>=ue;ye--)J[ye+ve]=J[ye];for(let ye=0;ye<ve;ye++)J[ye+ue]=re[ye]}e.insertInto=x;function K(J,ie,re,ue){const he=ee(J,ie),ve=J.splice(he,re);return x(J,he,ue),ve}e.splice=K;function ee(J,ie){return ie<0?Math.max(ie+J.length,0):Math.min(ie,J.length)}var ce;(function(J){function ie(he){return he<0}J.isLessThan=ie;function re(he){return he>0}J.isGreaterThan=re;function ue(he){return he===0}J.isNeitherLessOrGreaterThan=ue,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function z(J,ie){return(re,ue)=>ie(J(re),J(ue))}e.compareBy=z;function V(...J){return(ie,re)=>{for(const ue of J){const he=ue(ie,re);if(!ce.isNeitherLessOrGreaterThan(he))return he}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=V;const _=(J,ie)=>J-ie;e.numberComparator=_;function U(J,ie){if(J.length===0)return;let re=J[0];for(let ue=1;ue<J.length;ue++){const he=J[ue];ie(he,re)>0&&(re=he)}return re}e.findMaxBy=U;function j(J,ie){if(J.length===0)return;let re=J[0];for(let ue=1;ue<J.length;ue++){const he=J[ue];ie(he,re)>=0&&(re=he)}return re}e.findLastMaxBy=j;function B(J,ie){return U(J,(re,ue)=>-ie(re,ue))}e.findMinBy=B;class X{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let re=this.firstIdx;for(;re<this.items.length&&ie(this.items[re]);)re++;const ue=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,ue}takeFromEndWhile(ie){let re=this.lastIdx;for(;re>=0&&ie(this.items[re]);)re--;const ue=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const re=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,re}}e.ArrayQueue=X;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(re=>(ie(re),!0))}toArray(){const ie=[];return this.iterate(re=>(ie.push(re),!0)),ie}filter(ie){return new oe(re=>this.iterate(ue=>ie(ue)?re(ue):!0))}map(ie){return new oe(re=>this.iterate(ue=>re(ie(ue))))}some(ie){let re=!1;return this.iterate(ue=>(re=ie(ue),!re)),re}findFirst(ie){let re;return this.iterate(ue=>ie(ue)?(re=ue,!1):!0),re}findLast(ie){let re;return this.iterate(ue=>(ie(ue)&&(re=ue),!0)),re}findLastMaxBy(ie){let re,ue=!0;return this.iterate(he=>((ue||ce.isGreaterThan(ie(he,re)))&&(ue=!1,re=he),!0)),re}}e.CallbackIterable=oe,oe.empty=new oe(J=>{})}),define(ne[74],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(n){const k=this;let T=!1,A;return function(){return T||(T=!0,A=n.apply(k,arguments)),A}}e.once=D}),define(ne[51],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(n){function k(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}n.is=k;const T=Object.freeze([]);function A(){return T}n.empty=A;function*b(r){yield r}n.single=b;function P(r){return r||T}n.from=P;function I(r){return!r||r[Symbol.iterator]().next().done===!0}n.isEmpty=I;function E(r){return r[Symbol.iterator]().next().value}n.first=E;function w(r,t){for(const i of r)if(t(i))return!0;return!1}n.some=w;function m(r,t){for(const i of r)if(t(i))return i}n.find=m;function*y(r,t){for(const i of r)t(i)&&(yield i)}n.filter=y;function*d(r,t){let i=0;for(const o of r)yield t(o,i++)}n.map=d;function*S(...r){for(const t of r)for(const i of t)yield i}n.concat=S;function*C(r){for(const t of r)for(const i of t)yield i}n.concatNested=C;function p(r,t,i){let o=i;for(const l of r)o=t(o,l);return o}n.reduce=p;function g(r,t){let i=0;for(const o of r)t(o,i++)}n.forEach=g;function*u(r,t,i=r.length){for(t<0&&(t+=r.length),i<0?i+=r.length:i>r.length&&(i=r.length);t<i;t++)yield r[t]}n.slice=u;function f(r,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,r];const o=r[Symbol.iterator]();for(let l=0;l<t;l++){const a=o.next();if(a.done)return[i,n.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return o}}]}n.consume=f;function c(r){return f(r)[0]}n.collect=c;function s(r,t,i=(o,l)=>o===l){const o=r[Symbol.iterator](),l=t[Symbol.iterator]();for(;;){const a=o.next(),h=l.next();if(a.done!==h.done)return!1;if(a.done)return!0;if(!i(a.value,h.value))return!1}}n.equals=s})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var n;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(s){s.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(s,r=!1){let t=0;const i=s.length;let o="",l=0,a=16,h=0;function v($){let H=0,Y=0;for(;H<$;){const te=s.charCodeAt(t);if(te>=48&&te<=57)Y=Y*16+te-48;else if(te>=65&&te<=70)Y=Y*16+te-65+10;else if(te>=97&&te<=102)Y=Y*16+te-97+10;else break;t++,H++}return H<$&&(Y=-1),Y}function R($){t=$,o="",l=0,a=16,h=0}function M(){const $=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&I(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&I(s.charCodeAt(t)))for(t++;t<s.length&&I(s.charCodeAt(t));)t++;else return h=3,s.substring($,t);let H=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&I(s.charCodeAt(t))){for(t++;t<s.length&&I(s.charCodeAt(t));)t++;H=t}else h=3;return s.substring($,H)}function F(){let $="",H=t;for(;;){if(t>=i){$+=s.substring(H,t),h=2;break}const Y=s.charCodeAt(t);if(Y===34){$+=s.substring(H,t),t++;break}if(Y===92){if($+=s.substring(H,t),t++,t>=i){h=2;break}switch(s.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const q=v(4);q>=0?$+=String.fromCharCode(q):h=4;break}default:h=5}H=t;continue}if(Y>=0&&Y<=31)if(P(Y)){$+=s.substring(H,t),h=2;break}else h=6;t++}return $}function O(){if(o="",h=0,l=t,t>=i)return l=i,a=17;let $=s.charCodeAt(t);if(b($)){do t++,o+=String.fromCharCode($),$=s.charCodeAt(t);while(b($));return a=15}if(P($))return t++,o+=String.fromCharCode($),$===13&&s.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch($){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=F(),a=10;case 47:{const H=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!P(s.charCodeAt(t));)t++;return o=s.substring(H,t),a=12}if(s.charCodeAt(t+1)===42){t+=2;const Y=i-1;let te=!1;for(;t<Y;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,te=!0;break}t++}return te||(t++,h=1),o=s.substring(H,t),a=13}return o+=String.fromCharCode($),t++,a=16}case 45:if(o+=String.fromCharCode($),t++,t===i||!I(s.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=M(),a=11;default:for(;t<i&&L($);)t++,$=s.charCodeAt(t);if(l!==t){switch(o=s.substring(l,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode($),t++,a=16}}function L($){if(b($)||P($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let $;do $=O();while($>=12&&$<=15);return $}return{setPosition:R,getPosition:()=>t,scan:r?N:O,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>t-l,getTokenError:()=>h}}e.createScanner=A;function b(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function P(s){return s===10||s===13||s===8232||s===8233}function I(s){return s>=48&&s<=57}var E;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(E||(E={}));function w(s,r){const t=[],i=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(v,R,M,F){l.value=v,l.offset=R,l.length=M,l.type=F,l.colonOffset=void 0,o=l}try{u(s,{onObjectBegin:(v,R)=>{if(r<=v)throw i;o=void 0,a=r>v,t.push("")},onObjectProperty:(v,R,M)=>{if(r<R||(h(v,R,M,"property"),t[t.length-1]=v,r<=R+M))throw i},onObjectEnd:(v,R)=>{if(r<=v)throw i;o=void 0,t.pop()},onArrayBegin:(v,R)=>{if(r<=v)throw i;o=void 0,t.push(0)},onArrayEnd:(v,R)=>{if(r<=v)throw i;o=void 0,t.pop()},onLiteralValue:(v,R,M)=>{if(r<R||(h(v,R,M,c(v)),r<=R+M))throw i},onSeparator:(v,R,M)=>{if(r<=R)throw i;if(v===":"&&o&&o.type==="property")o.colonOffset=R,a=!1,o=void 0;else if(v===","){const F=t[t.length-1];typeof F=="number"?t[t.length-1]=F+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(v){if(v!==i)throw v}return{path:t,previousNode:o,isAtPropertyKey:a,matches:v=>{let R=0;for(let M=0;R<v.length&&M<t.length;M++)if(v[R]===t[M]||v[R]==="*")R++;else if(v[R]!=="**")return!1;return R===v.length}}}e.getLocation=w;function m(s,r=[],t=T.DEFAULT){let i=null,o=[];const l=[];function a(v){Array.isArray(o)?o.push(v):i!==null&&(o[i]=v)}return u(s,{onObjectBegin:()=>{const v={};a(v),l.push(o),o=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const v=[];a(v),l.push(o),o=v,i=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:a,onError:(v,R,M)=>{r.push({error:v,offset:R,length:M})}},t),o[0]}e.parse=m;function y(s,r=[],t=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(v){i.type==="property"&&(i.length=v-i.offset,i=i.parent)}function l(v){return i.children.push(v),v}u(s,{onObjectBegin:v=>{i=l({type:"object",offset:v,length:-1,parent:i,children:[]})},onObjectProperty:(v,R,M)=>{i=l({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:v,offset:R,length:M,parent:i})},onObjectEnd:(v,R)=>{i.length=v+R-i.offset,i=i.parent,o(v+R)},onArrayBegin:(v,R)=>{i=l({type:"array",offset:v,length:-1,parent:i,children:[]})},onArrayEnd:(v,R)=>{i.length=v+R-i.offset,i=i.parent,o(v+R)},onLiteralValue:(v,R,M)=>{l({type:c(v),offset:R,length:M,parent:i,value:v}),o(R+M)},onSeparator:(v,R,M)=>{i.type==="property"&&(v===":"?i.colonOffset=R:v===","&&o(R))},onError:(v,R,M)=>{r.push({error:v,offset:R,length:M})}},t);const h=i.children[0];return h&&delete h.parent,h}e.parseTree=y;function d(s,r){if(!s)return;let t=s;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const l of t.children)if(Array.isArray(l.children)&&l.children[0].value===i){t=l.children[1],o=!0;break}if(!o)return}else{const o=i;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=d;function S(s){if(!s.parent||!s.parent.children)return[];const r=S(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;r.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&r.push(t)}return r}e.getNodePath=S;function C(s){switch(s.type){case"array":return s.children.map(C);case"object":{const r=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(r[t.children[0].value]=C(i))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=C;function p(s,r,t=!1){return r>=s.offset&&r<s.offset+s.length||t&&r===s.offset+s.length}e.contains=p;function g(s,r,t=!1){if(p(s,r,t)){const i=s.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=r;o++){const l=g(i[o],r,t);if(l)return l}return s}}e.findNodeAtOffset=g;function u(s,r,t=T.DEFAULT){const i=A(s,!1);function o(z){return z?()=>z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(z){return z?V=>z(V,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=o(r.onObjectBegin),h=l(r.onObjectProperty),v=o(r.onObjectEnd),R=o(r.onArrayBegin),M=o(r.onArrayEnd),F=l(r.onLiteralValue),O=l(r.onSeparator),L=o(r.onComment),N=l(r.onError),$=t&&t.disallowComments,H=t&&t.allowTrailingComma;function Y(){for(;;){const z=i.scan();switch(i.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:$||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(z){case 12:case 13:$?te(10):L();break;case 16:te(1);break;case 15:case 14:break;default:return z}}}function te(z,V=[],_=[]){if(N(z),V.length+_.length>0){let U=i.getToken();for(;U!==17;){if(V.indexOf(U)!==-1){Y();break}else if(_.indexOf(U)!==-1)break;U=Y()}}}function q(z){const V=i.getTokenValue();return z?F(V):h(V),Y(),!0}function W(){switch(i.getToken()){case 11:{let z=0;try{z=JSON.parse(i.getTokenValue()),typeof z!="number"&&(te(2),z=0)}catch{te(2)}F(z);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return Y(),!0}function x(){return i.getToken()!==10?(te(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(O(":"),Y(),ce()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function K(){a(),Y();let z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(z||te(4,[],[]),O(","),Y(),i.getToken()===2&&H)break}else z&&te(6,[],[]);x()||te(4,[],[2,5]),z=!0}return v(),i.getToken()!==2?te(7,[2],[]):Y(),!0}function ee(){R(),Y();let z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(z||te(4,[],[]),O(","),Y(),i.getToken()===4&&H)break}else z&&te(6,[],[]);ce()||te(4,[],[4,5]),z=!0}return M(),i.getToken()!==4?te(8,[4],[]):Y(),!0}function ce(){switch(i.getToken()){case 3:return ee();case 1:return K();case 10:return q(!0);default:return W()}}return Y(),i.getToken()===17?t.allowEmptyContent?!0:(te(4,[],[]),!1):ce()?(i.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.visit=u;function f(s,r){const t=A(s),i=[];let o,l=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:l!==a&&i.push(s.substring(l,a)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),l=t.getPosition();break}while(o!==17);return i.join("")}e.stripComments=f;function c(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ne[52],se([0,1,35]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(I,E,w){let m,y,d,S,C;if(E){for(S=E.offset,C=S+E.length,d=S;d>0&&!P(I,d-1);)d--;let a=C;for(;a<I.length&&!P(I,a);)a++;y=I.substring(d,a),m=A(y,w)}else y=I,m=0,d=0,S=0,C=I.length;const p=b(w,I);let g=!1,u=0,f;w.insertSpaces?f=T(" ",w.tabSize||4):f="	";const c=(0,D.createScanner)(y,!1);let s=!1;function r(){return p+T(f,m+u)}function t(){let a=c.scan();for(g=!1;a===15||a===14;)g=g||a===14,a=c.scan();return s=a===16||c.getTokenError()!==0,a}const i=[];function o(a,h,v){!s&&h<C&&v>S&&I.substring(h,v)!==a&&i.push({offset:h,length:v-h,content:a})}let l=t();if(l!==17){const a=c.getTokenOffset()+d,h=T(f,m);o(h,d,a)}for(;l!==17;){let a=c.getTokenOffset()+c.getTokenLength()+d,h=t(),v="";for(;!g&&(h===12||h===13);){const M=c.getTokenOffset()+d;o(" ",a,M),a=c.getTokenOffset()+c.getTokenLength()+d,v=h===12?r():"",h=t()}if(h===2)l!==1&&(u--,v=r());else if(h===4)l!==3&&(u--,v=r());else{switch(l){case 3:case 1:u++,v=r();break;case 5:case 12:v=r();break;case 13:g?v=r():v=" ";break;case 6:v=" ";break;case 10:if(h===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?v=" ":h!==5&&h!==17&&(s=!0);break;case 16:s=!0;break}g&&(h===12||h===13)&&(v=r())}const R=c.getTokenOffset()+d;o(v,a,R),l=h}return i}e.format=n;function k(I,E){const w=JSON.stringify(I,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?w.replace(/\r\n|\r|\n/g,E.eol):w}e.toFormattedString=k;function T(I,E){let w="";for(let m=0;m<E;m++)w+=I;return w}function A(I,E){let w=0,m=0;const y=E.tabSize||4;for(;w<I.length;){const d=I.charAt(w);if(d===" ")m++;else if(d==="	")m+=y;else break;w++}return Math.floor(m/y)}function b(I,E){for(let w=0;w<E.length;w++){const m=E.charAt(w);if(m==="\r")return w+1<E.length&&E.charAt(w+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=b;function P(I,E){return`\r
`.indexOf(I.charAt(E))!==-1}e.isEOL=P}),define(ne[75],se([0,1,35,52]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(I,E,w){return T(I,E,void 0,w)}e.removeProperty=k;function T(I,E,w,m,y){const d=E.slice(),S=[],C=(0,D.parseTree)(I,S);let p,g;for(;d.length>0&&(g=d.pop(),p=(0,D.findNodeAtLocation)(C,d),p===void 0&&w!==void 0);)typeof g=="string"?w={[g]:w}:w=[w];if(p)if(p.type==="object"&&typeof g=="string"&&Array.isArray(p.children)){const u=(0,D.findNodeAtLocation)(p,[g]);if(u!==void 0)if(w===void 0){if(!u.parent)throw new Error("Malformed AST");const f=p.children.indexOf(u.parent);let c,s=u.parent.offset+u.parent.length;if(f>0){const r=p.children[f-1];c=r.offset+r.length}else c=p.offset+1,p.children.length>1&&(s=p.children[1].offset);return A(I,{offset:c,length:s-c,content:""},m)}else return A(I,{offset:u.offset,length:u.length,content:JSON.stringify(w)},m);else{if(w===void 0)return[];const f=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,c=y?y(p.children.map(r=>r.children[0].value)):p.children.length;let s;if(c>0){const r=p.children[c-1];s={offset:r.offset+r.length,length:0,content:","+f}}else p.children.length===0?s={offset:p.offset+1,length:0,content:f}:s={offset:p.offset+1,length:0,content:f+","};return A(I,s,m)}}else if(p.type==="array"&&typeof g=="number"&&Array.isArray(p.children))if(w!==void 0){const u=`${JSON.stringify(w)}`;let f;if(p.children.length===0||g===0)f={offset:p.offset+1,length:0,content:p.children.length===0?u:u+","};else{const c=g===-1||g>p.children.length?p.children.length:g,s=p.children[c-1];f={offset:s.offset+s.length,length:0,content:","+u}}return A(I,f,m)}else{const u=g,f=p.children[u];let c;if(p.children.length===1)c={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===u){const s=p.children[u-1],r=s.offset+s.length,t=p.offset+p.length;c={offset:r,length:t-2-r,content:""}}else c={offset:f.offset,length:p.children[u+1].offset-f.offset,content:""};return A(I,c,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${p.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return A(I,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(w)},m)}}e.setProperty=T;function A(I,E,w){let m=b(I,E),y=E.offset,d=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;y>0&&!(0,n.isEOL)(m,y-1);)y--;for(;d<m.length&&!(0,n.isEOL)(m,d);)d++}const S=(0,n.format)(m,{offset:y,length:d-y},w);for(let p=S.length-1;p>=0;p--){const g=S[p];m=b(m,g),y=Math.min(y,g.offset),d=Math.max(d,g.offset+g.length),d+=g.content.length-g.length}const C=I.length-(m.length-d)-y;return[{offset:y,length:C,content:m.substring(y,d)}]}e.withFormatting=A;function b(I,E){return I.substring(0,E.offset)+E.content+I.substring(E.offset+E.length)}e.applyEdit=b;function P(I,E){const w=E.slice(0).sort((y,d)=>{const S=y.offset-d.offset;return S===0?y.length-d.length:S});let m=I.length;for(let y=w.length-1;y>=0;y--){const d=w[y];if(d.offset+d.length<=m)I=b(I,d);else throw new Error("Overlapping edit");m=d.offset}return I}e.applyEdits=P}),define(ne[111],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new D(()=>k(this.getValue()))}}e.Lazy=D}),define(ne[2],se([0,1,74,51]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let T=null;function A(l){T=l}if(e.setDisposableTracker=A,k){const l="__is_disposable_tracked__";A(new class{trackDisposable(a){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[l]||console.log(h)},3e3)}setParent(a,h){if(a&&a!==u.None)try{a[l]=!0}catch{}}markAsDisposed(a){if(a&&a!==u.None)try{a[l]=!0}catch{}}markAsSingleton(a){}})}function b(l){return T?.trackDisposable(l),l}function P(l){T?.markAsDisposed(l)}function I(l,a){T?.setParent(l,a)}function E(l,a){if(!!T)for(const h of l)T.setParent(h,a)}function w(l){return T?.markAsSingleton(l),l}e.markAsSingleton=w;class m extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=m;function y(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=y;function d(l){if(n.Iterable.is(l)){const a=[];for(const h of l)if(h)try{h.dispose()}catch(v){a.push(v)}if(a.length===1)throw a[0];if(a.length>1)throw new m(a);return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=d;function S(l){for(const a of l)y(a)&&a.dispose();return[]}e.disposeIfDisposable=S;function C(...l){const a=p(()=>d(l));return E(l,a),a}e.combinedDisposable=C;function p(l){const a=b({dispose:(0,D.once)(()=>{P(a),l()})});return a}e.toDisposable=p;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return I(a,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new g,b(this),I(this._store,this)}dispose(){P(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&I(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&I(a,null),a}}e.MutableDisposable=f;class c{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(a){let h=a;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,P(this))},this}}e.SafeDisposable=s;class r{constructor(){this.references=new Map}acquire(a,...h){let v=this.references.get(a);v||(v={counter:0,object:this.createReferencedObject(a,...h)},this.references.set(a,v));const{object:R}=v,M=(0,D.once)(()=>{--v.counter==0&&(this.destroyReferencedObject(a,v.object),this.references.delete(a))});return v.counter++,{object:R,dispose:M}}}e.ReferenceCollection=r;class t{constructor(a){this.referenceCollection=a}async acquire(a,...h){const v=this.referenceCollection.acquire(a,...h);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(R){throw v.dispose(),R}}}e.AsyncReferenceCollection=t;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function o(l){const a=new g;try{l(a)}finally{a.dispose()}}e.disposeOnReturn=o}),define(ne[112],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const A=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const b=new D(T);if(this._first===D.Undefined)this._first=b,this._last=b;else if(A){const I=this._last;this._last=b,b.prev=I,I.next=b}else{const I=this._first;this._first=b,b.next=I,I.prev=b}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(b))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=n}),function(){function Q(k){const T=[];typeof k=="number"&&T.push("code/timeOrigin",k);function A(P){T.push(P,Date.now())}function b(){const P=[];for(let I=0;I<T.length;I+=2)P.push({name:T[I],startTime:T[I+1]});return P}return{mark:A,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(k+A.startTime)});return T}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=D(n))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var n in D)(typeof exports=="object"?exports:Q)[n]=D[n]}}(typeof self!="undefined"?self:this,function(){return function(Q){var e={};function D(n){if(e[n])return e[n].exports;var k=e[n]={i:n,l:!1,exports:{}};return Q[n].call(k.exports,k,k.exports,D),k.l=!0,k.exports}return D.m=Q,D.c=e,D.d=function(n,k,T){D.o(n,k)||Object.defineProperty(n,k,{enumerable:!0,get:T})},D.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},D.t=function(n,k){if(1&k&&(n=D(n)),8&k||4&k&&typeof n=="object"&&n&&n.__esModule)return n;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:n}),2&k&&typeof n!="string")for(var A in n)D.d(T,A,function(b){return n[b]}.bind(null,A));return T},D.n=function(n){var k=n&&n.__esModule?function(){return n.default}:function(){return n};return D.d(k,"a",k),k},D.o=function(n,k){return Object.prototype.hasOwnProperty.call(n,k)},D.p="",D(D.s=0)}([function(Q,e,D){(function(n){var k;e=Q.exports=_,k=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],P=e.src=[],I=0,E=I++;P[E]="0|[1-9]\\d*";var w=I++;P[w]="[0-9]+";var m=I++;P[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=I++;P[y]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var d=I++;P[d]="("+P[w]+")\\.("+P[w]+")\\.("+P[w]+")";var S=I++;P[S]="(?:"+P[E]+"|"+P[m]+")";var C=I++;P[C]="(?:"+P[w]+"|"+P[m]+")";var p=I++;P[p]="(?:-("+P[S]+"(?:\\."+P[S]+")*))";var g=I++;P[g]="(?:-?("+P[C]+"(?:\\."+P[C]+")*))";var u=I++;P[u]="[0-9A-Za-z-]+";var f=I++;P[f]="(?:\\+("+P[u]+"(?:\\."+P[u]+")*))";var c=I++,s="v?"+P[y]+P[p]+"?"+P[f]+"?";P[c]="^"+s+"$";var r="[v=\\s]*"+P[d]+P[g]+"?"+P[f]+"?",t=I++;P[t]="^"+r+"$";var i=I++;P[i]="((?:<|>)?=?)";var o=I++;P[o]=P[w]+"|x|X|\\*";var l=I++;P[l]=P[E]+"|x|X|\\*";var a=I++;P[a]="[v=\\s]*("+P[l]+")(?:\\.("+P[l]+")(?:\\.("+P[l]+")(?:"+P[p]+")?"+P[f]+"?)?)?";var h=I++;P[h]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[g]+")?"+P[f]+"?)?)?";var v=I++;P[v]="^"+P[i]+"\\s*"+P[a]+"$";var R=I++;P[R]="^"+P[i]+"\\s*"+P[h]+"$";var M=I++;P[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=I++;P[F]="(?:~>?)";var O=I++;P[O]="(\\s*)"+P[F]+"\\s+",b[O]=new RegExp(P[O],"g");var L=I++;P[L]="^"+P[F]+P[a]+"$";var N=I++;P[N]="^"+P[F]+P[h]+"$";var $=I++;P[$]="(?:\\^)";var H=I++;P[H]="(\\s*)"+P[$]+"\\s+",b[H]=new RegExp(P[H],"g");var Y=I++;P[Y]="^"+P[$]+P[a]+"$";var te=I++;P[te]="^"+P[$]+P[h]+"$";var q=I++;P[q]="^"+P[i]+"\\s*("+r+")$|^$";var W=I++;P[W]="^"+P[i]+"\\s*("+s+")$|^$";var x=I++;P[x]="(\\s*)"+P[i]+"\\s*("+r+"|"+P[a]+")",b[x]=new RegExp(P[x],"g");var K=I++;P[K]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ee=I++;P[ee]="^\\s*("+P[h]+")\\s+-\\s+("+P[h]+")\\s*$";var ce=I++;P[ce]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)k(z,P[z]),b[z]||(b[z]=new RegExp(P[z]));function V(ae,de){if(ae instanceof _)return ae;if(typeof ae!="string"||ae.length>T||!(de?b[t]:b[c]).test(ae))return null;try{return new _(ae,de)}catch{return null}}function _(ae,de){if(ae instanceof _){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof _))return new _(ae,de);k("SemVer",ae,de),this.loose=de;var fe=ae.trim().match(de?b[t]:b[c]);if(!fe)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<A)return Ie}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=V,e.valid=function(ae,de){var fe=V(ae,de);return fe?fe.version:null},e.clean=function(ae,de){var fe=V(ae.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(ae){return k("SemVer.compare",this.version,this.loose,ae),ae instanceof _||(ae=new _(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},_.prototype.compareMain=function(ae){return ae instanceof _||(ae=new _(ae,this.loose)),j(this.major,ae.major)||j(this.minor,ae.minor)||j(this.patch,ae.patch)},_.prototype.comparePre=function(ae){if(ae instanceof _||(ae=new _(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],be=ae.prerelease[de];if(k("prerelease compare",de,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return j(fe,be)}while(++de)},_.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new _(ae,fe).inc(de,be).version}catch{return null}},e.diff=function(ae,de){if(J(ae,de))return null;var fe=V(ae),be=V(de);if(fe.prerelease.length||be.prerelease.length){for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==be[Ie])return Ie},e.compareIdentifiers=j;var U=/^[0-9]+$/;function j(ae,de){var fe=U.test(ae),be=U.test(de);return fe&&be&&(ae=+ae,de=+de),fe&&!be?-1:be&&!fe?1:ae<de?-1:ae>de?1:0}function B(ae,de,fe){return new _(ae,fe).compare(new _(de,fe))}function X(ae,de,fe){return B(ae,de,fe)>0}function oe(ae,de,fe){return B(ae,de,fe)<0}function J(ae,de,fe){return B(ae,de,fe)===0}function ie(ae,de,fe){return B(ae,de,fe)!==0}function re(ae,de,fe){return B(ae,de,fe)>=0}function ue(ae,de,fe){return B(ae,de,fe)<=0}function he(ae,de,fe,be){var Ie;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae===fe;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae!==fe;break;case"":case"=":case"==":Ie=J(ae,fe,be);break;case"!=":Ie=ie(ae,fe,be);break;case">":Ie=X(ae,fe,be);break;case">=":Ie=re(ae,fe,be);break;case"<":Ie=oe(ae,fe,be);break;case"<=":Ie=ue(ae,fe,be);break;default:throw new TypeError("Invalid operator: "+de)}return Ie}function ve(ae,de){if(ae instanceof ve){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,de);k("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ae,de){return j(de,ae)},e.major=function(ae,de){return new _(ae,de).major},e.minor=function(ae,de){return new _(ae,de).minor},e.patch=function(ae,de){return new _(ae,de).patch},e.compare=B,e.compareLoose=function(ae,de){return B(ae,de,!0)},e.rcompare=function(ae,de,fe){return B(de,ae,fe)},e.sort=function(ae,de){return ae.sort(function(fe,be){return e.compare(fe,be,de)})},e.rsort=function(ae,de){return ae.sort(function(fe,be){return e.rcompare(fe,be,de)})},e.gt=X,e.lt=oe,e.eq=J,e.neq=ie,e.gte=re,e.lte=ue,e.cmp=he,e.Comparator=ve;var ye={};function Ce(ae,de){if(ae instanceof Ce)return ae.loose===de?ae:new Ce(ae.raw,de);if(ae instanceof ve)return new Ce(ae.value,de);if(!(this instanceof Ce))return new Ce(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Pe(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ue(ae,de,fe,be,Ie,Me,De,$e,Ae,Te,Ne,Z,le){return((de=Pe(fe)?"":Pe(be)?">="+fe+".0.0":Pe(Ie)?">="+fe+"."+be+".0":">="+de)+" "+($e=Pe(Ae)?"":Pe(Te)?"<"+(+Ae+1)+".0.0":Pe(Ne)?"<"+Ae+"."+(+Te+1)+".0":Z?"<="+Ae+"."+Te+"."+Ne+"-"+Z:"<="+$e)).trim()}function We(ae,de){for(var fe=0;fe<ae.length;fe++)if(!ae[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<ae.length;fe++)if(k(ae[fe].semver),ae[fe].semver!==ye&&ae[fe].semver.prerelease.length>0){var be=ae[fe].semver;if(be.major===de.major&&be.minor===de.minor&&be.patch===de.patch)return!0}return!1}return!0}function Be(ae,de,fe){try{de=new Ce(de,fe)}catch{return!1}return de.test(ae)}function qe(ae,de,fe,be){var Ie,Me,De,$e,Ae;switch(ae=new _(ae,be),de=new Ce(de,be),fe){case">":Ie=X,Me=ue,De=oe,$e=">",Ae=">=";break;case"<":Ie=oe,Me=re,De=X,$e="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Be(ae,de,be))return!1;for(var Te=0;Te<de.set.length;++Te){var Ne=de.set[Te],Z=null,le=null;if(Ne.forEach(function(ge){ge.semver===ye&&(ge=new ve(">=0.0.0")),Z=Z||ge,le=le||ge,Ie(ge.semver,Z.semver,be)?Z=ge:De(ge.semver,le.semver,be)&&(le=ge)}),Z.operator===$e||Z.operator===Ae||(!le.operator||le.operator===$e)&&Me(ae,le.semver)||le.operator===Ae&&De(ae,le.semver))return!1}return!0}ve.prototype.parse=function(ae){var de=this.loose?b[q]:b[W],fe=ae.match(de);if(!fe)throw new TypeError("Invalid comparator: "+ae);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new _(fe[2],this.loose):this.semver=ye},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return k("Comparator.test",ae,this.loose),this.semver===ye||(typeof ae=="string"&&(ae=new _(ae,this.loose)),he(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,de){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Ce(ae.value,de),Be(this.value,fe,de);if(ae.operator==="")return fe=new Ce(this.value,de),Be(ae.semver,fe,de);var be=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Me=this.semver.version===ae.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),$e=he(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ae=he(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return be||Ie||Me&&De||$e||Ae},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),k("range",ae,de);var fe=de?b[ee]:b[K];ae=ae.replace(fe,Ue),k("hyphen replace",ae),ae=ae.replace(b[x],"$1$2$3"),k("comparator trim",ae,b[x]),ae=(ae=(ae=ae.replace(b[O],"$1~")).replace(b[H],"$1^")).split(/\s+/).join(" ");var be=de?b[q]:b[W],Ie=ae.split(" ").map(function(Me){return function(De,$e){return k("comp",De),De=function(Ae,Te){return Ae.trim().split(/\s+/).map(function(Ne){return function(Z,le){k("caret",Z,le);var ge=le?b[te]:b[Y];return Z.replace(ge,function(Se,pe,Ee,Re,ke){var Le;return k("caret",Z,Se,pe,Ee,Re,ke),Pe(pe)?Le="":Pe(Ee)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Pe(Re)?Le=pe==="0"?">="+pe+"."+Ee+".0 <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+".0 <"+(+pe+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=pe==="0"?Ee==="0"?">="+pe+"."+Ee+"."+Re+ke+" <"+pe+"."+Ee+"."+(+Re+1):">="+pe+"."+Ee+"."+Re+ke+" <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+"."+Re+ke+" <"+(+pe+1)+".0.0"):(k("no pr"),Le=pe==="0"?Ee==="0"?">="+pe+"."+Ee+"."+Re+" <"+pe+"."+Ee+"."+(+Re+1):">="+pe+"."+Ee+"."+Re+" <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+"."+Re+" <"+(+pe+1)+".0.0"),k("caret return",Le),Le})}(Ne,Te)}).join(" ")}(De,$e),k("caret",De),De=function(Ae,Te){return Ae.trim().split(/\s+/).map(function(Ne){return function(Z,le){var ge=le?b[N]:b[L];return Z.replace(ge,function(Se,pe,Ee,Re,ke){var Le;return k("tilde",Z,Se,pe,Ee,Re,ke),Pe(pe)?Le="":Pe(Ee)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Pe(Re)?Le=">="+pe+"."+Ee+".0 <"+pe+"."+(+Ee+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=">="+pe+"."+Ee+"."+Re+ke+" <"+pe+"."+(+Ee+1)+".0"):Le=">="+pe+"."+Ee+"."+Re+" <"+pe+"."+(+Ee+1)+".0",k("tilde return",Le),Le})}(Ne,Te)}).join(" ")}(De,$e),k("tildes",De),De=function(Ae,Te){return k("replaceXRanges",Ae,Te),Ae.split(/\s+/).map(function(Ne){return function(Z,le){Z=Z.trim();var ge=le?b[R]:b[v];return Z.replace(ge,function(Se,pe,Ee,Re,ke,Le){k("xRange",Z,Se,pe,Ee,Re,ke,Le);var _e=Pe(Ee),Fe=_e||Pe(Re),ze=Fe||Pe(ke);return pe==="="&&ze&&(pe=""),_e?Se=pe===">"||pe==="<"?"<0.0.0":"*":pe&&ze?(Fe&&(Re=0),ze&&(ke=0),pe===">"?(pe=">=",Fe?(Ee=+Ee+1,Re=0,ke=0):ze&&(Re=+Re+1,ke=0)):pe==="<="&&(pe="<",Fe?Ee=+Ee+1:Re=+Re+1),Se=pe+Ee+"."+Re+"."+ke):Fe?Se=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(Se=">="+Ee+"."+Re+".0 <"+Ee+"."+(+Re+1)+".0"),k("xRange return",Se),Se})}(Ne,Te)}).join(" ")}(De,$e),k("xrange",De),De=function(Ae,Te){return k("replaceStars",Ae,Te),Ae.trim().replace(b[ce],"")}(De,$e),k("stars",De),De}(Me,de)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(be)})),Ie=Ie.map(function(Me){return new ve(Me,de)})},Ce.prototype.intersects=function(ae,de){if(!(ae instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return ae.set.some(function(Ie){return Ie.every(function(Me){return be.intersects(Me,de)})})})})},e.toComparators=function(ae,de){return new Ce(ae,de).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new _(ae,this.loose));for(var de=0;de<this.set.length;de++)if(We(this.set[de],ae))return!0;return!1},e.satisfies=Be,e.maxSatisfying=function(ae,de,fe){var be=null,Ie=null;try{var Me=new Ce(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(be&&Ie.compare(De)!==-1||(Ie=new _(be=De,fe)))}),be},e.minSatisfying=function(ae,de,fe){var be=null,Ie=null;try{var Me=new Ce(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(be&&Ie.compare(De)!==1||(Ie=new _(be=De,fe)))}),be},e.validRange=function(ae,de){try{return new Ce(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,fe){return qe(ae,de,"<",fe)},e.gtr=function(ae,de,fe){return qe(ae,de,">",fe)},e.outside=qe,e.prerelease=function(ae,de){var fe=V(ae,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ae,de,fe){return ae=new Ce(ae,fe),de=new Ce(de,fe),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof _)return ae;if(typeof ae!="string")return null;var de=ae.match(b[M]);return de==null?null:V((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,n,k=Q.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function b(C){if(D===setTimeout)return setTimeout(C,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(C,0);try{return D(C,0)}catch{try{return D.call(null,C,0)}catch{return D.call(this,C,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch{D=T}try{n=typeof clearTimeout=="function"?clearTimeout:A}catch{n=A}})();var P,I=[],E=!1,w=-1;function m(){E&&P&&(E=!1,P.length?I=P.concat(I):w=-1,I.length&&y())}function y(){if(!E){var C=b(m);E=!0;for(var p=I.length;p;){for(P=I,I=[];++w<p;)P&&P[w].run();w=-1,p=I.length}P=null,E=!1,function(g){if(n===clearTimeout)return clearTimeout(g);if((n===A||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(g);try{n(g)}catch{try{return n.call(null,g)}catch{return n.call(this,g)}}}(C)}}function d(C,p){this.fun=C,this.array=p}function S(){}k.nextTick=function(C){var p=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)p[g-1]=arguments[g];I.push(new d(C,p)),I.length!==1||E||b(y)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(C){return[]},k.binding=function(C){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(C){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[113],se([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(b,P,I){this.level=b,this.key=P,this.value=I,this.forward=[]}}const k=void 0;class T{constructor(b,P=2**16){this.comparator=b,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(P)|0),this._header=new n(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,k,k)}has(b){return Boolean(T._search(this,b,this.comparator))}get(b){return T._search(this,b,this.comparator)?.value}set(b,P){return T._insert(this,b,P,this.comparator)&&(this._size+=1),this}delete(b){const P=T._delete(this,b,this.comparator);return P&&(this._size-=1),P}forEach(b,P){let I=this._header.forward[0];for(;I;)b.call(P,I.value,I.key,this),I=I.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",P=this._header.forward[0];for(;P;)b+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return b}static _search(b,P,I){let E=b._header;for(let w=b._level-1;w>=0;w--)for(;E.forward[w]&&I(E.forward[w].key,P)<0;)E=E.forward[w];if(E=E.forward[0],E&&I(E.key,P)===0)return E}static _insert(b,P,I,E){const w=[];let m=b._header;for(let y=b._level-1;y>=0;y--){for(;m.forward[y]&&E(m.forward[y].key,P)<0;)m=m.forward[y];w[y]=m}if(m=m.forward[0],m&&E(m.key,P)===0)return m.value=I,!1;{const y=T._randomLevel(b);if(y>b._level){for(let d=b._level;d<y;d++)w[d]=b._header;b._level=y}m=new n(y,P,I);for(let d=0;d<y;d++)m.forward[d]=w[d].forward[d],w[d].forward[d]=m;return!0}}static _randomLevel(b,P=.5){let I=1;for(;Math.random()<P&&I<b._maxLevel;)I+=1;return I}static _delete(b,P,I){const E=[];let w=b._header;for(let m=b._level-1;m>=0;m--){for(;w.forward[m]&&I(w.forward[m].key,P)<0;)w=w.forward[m];E[m]=w}if(w=w.forward[0],!w||I(w.key,P)!==0)return!1;for(let m=0;m<b._level&&E[m].forward[m]===w;m++)E[m].forward[m]=w.forward[m];for(;b._level>0&&b._header.forward[b._level-1]===k;)b._level-=1;return!0}}e.SkipList=T}),define(ne[41],se([0,1,10,2]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const c=f;return c?typeof c.read=="function":!1}e.isReadable=k;function T(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=T;function A(f){const c=f;return c?T(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function b(f,c){return new P(f,c)}e.newWriteableStream=b;class P{constructor(c,s){this.reducer=c,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(s=>s(c))}emitError(c){this.listeners.error.length===0?(0,D.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(s=>s(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,s){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(c,s){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const t=r.indexOf(s);t>=0&&r.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(f,c){const s=[];let r;for(;(r=f.read())!==null;)s.push(r);return c(s)}e.consumeReadable=I;function E(f,c,s){const r=[];let t;for(;(t=f.read())!==null&&r.length<s;)r.push(t);return t===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t!="undefined"){const i=t;return t=void 0,i}return f.read()}}}e.peekReadable=E;function w(f,c){return new Promise((s,r)=>{const t=[];m(f,{onData:i=>{c&&t.push(i)},onError:i=>{c?r(i):s(void 0)},onEnd:()=>{s(c?c(t):void 0)}})})}e.consumeStream=w;function m(f,c){let s=!1;return f.on("error",r=>{s||c.onError(r)}),f.on("end",()=>{s||c.onEnd()}),f.on("data",r=>{s||c.onData(r)}),(0,n.toDisposable)(()=>s=!0)}e.listenStream=m;function y(f,c){return new Promise((s,r)=>{const t=new n.DisposableStore,i=[],o=h=>{if(i.push(h),i.length>c)return t.dispose(),f.pause(),s({stream:f,buffer:i,ended:!1})},l=h=>r(h),a=()=>s({stream:f,buffer:i,ended:!0});t.add((0,n.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),t.add((0,n.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),t.add((0,n.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=y;function d(f,c){const s=b(c);return s.end(f),s}e.toStream=d;function S(){const f=b(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function C(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=C;function p(f,c,s){const r=b(s);return m(f,{onData:t=>r.write(c.data(t)),onError:t=>r.error(c.error?c.error(t):t),onEnd:()=>r.end()}),r}e.transform=p;function g(f,c,s){let r=!1;return{read:()=>{const t=c.read();return r?t:(r=!0,t!==null?s([f,t]):f)}}}e.prefixedReadable=g;function u(f,c,s){let r=!1;const t=b(s);return m(c,{onData:i=>r?t.write(i):(r=!0,t.write(s([f,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(f)),t.end()}}),t}e.prefixedStream=u}),define(ne[16],se([0,1,41]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let k,T;class A{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return n?new A(Buffer.allocUnsafe(h)):new A(new Uint8Array(h))}static wrap(h){return n&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new A(h)}static fromString(h,v){return!(v?.dontUseNodeBuffer||!1)&&n?new A(Buffer.from(h)):(k||(k=new TextEncoder),new A(k.encode(h)))}static fromByteArray(h){const v=A.alloc(h.length);for(let R=0,M=h.length;R<M;R++)v.buffer[R]=h[R];return v}static concat(h,v){if(typeof v=="undefined"){v=0;for(let F=0,O=h.length;F<O;F++)v+=h[F].byteLength}const R=A.alloc(v);let M=0;for(let F=0,O=h.length;F<O;F++){const L=h[F];R.set(L,M),M+=L.byteLength}return R}clone(){const h=A.alloc(this.byteLength);return h.set(this),h}toString(){return n?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(h,v){return new A(this.buffer.subarray(h,v))}set(h,v){if(h instanceof A)this.buffer.set(h.buffer,v);else if(h instanceof Uint8Array)this.buffer.set(h,v);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),v);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return I(this.buffer,h)}writeUInt32BE(h,v){E(this.buffer,h,v)}readUInt32LE(h){return w(this.buffer,h)}writeUInt32LE(h,v){m(this.buffer,h,v)}readUInt8(h){return y(this.buffer,h)}writeUInt8(h,v){d(this.buffer,h,v)}}e.VSBuffer=A;function b(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=b;function P(a,h,v){a[v+0]=h&255,h=h>>>8,a[v+1]=h&255}e.writeUInt16LE=P;function I(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=I;function E(a,h,v){a[v+3]=h,h=h>>>8,a[v+2]=h,h=h>>>8,a[v+1]=h,h=h>>>8,a[v]=h}e.writeUInt32BE=E;function w(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=w;function m(a,h,v){a[v+0]=h&255,h=h>>>8,a[v+1]=h&255,h=h>>>8,a[v+2]=h&255,h=h>>>8,a[v+3]=h&255}e.writeUInt32LE=m;function y(a,h){return a[h]}e.readUInt8=y;function d(a,h,v){a[v]=h}e.writeUInt8=d;function S(a){return D.consumeReadable(a,h=>A.concat(h))}e.readableToBuffer=S;function C(a){return D.toReadable(a)}e.bufferToReadable=C;function p(a){return D.consumeStream(a,h=>A.concat(h))}e.streamToBuffer=p;async function g(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await p(a.stream)])}e.bufferedStreamToBuffer=g;function u(a){return D.toStream(a,h=>A.concat(h))}e.bufferToStream=u;function f(a){return D.transform(a,{data:h=>typeof h=="string"?A.fromString(h):A.wrap(h)},h=>A.concat(h))}e.streamToBufferReadableStream=f;function c(a){return D.newWriteableStream(h=>A.concat(h),a)}e.newWriteableBufferStream=c;function s(a,h){return D.prefixedReadable(a,h,v=>A.concat(v))}e.prefixedBufferReadable=s;function r(a,h){return D.prefixedStream(a,h,v=>A.concat(v))}e.prefixedBufferStream=r;function t(a){let h=0,v=0,R=0;const M=new Uint8Array(Math.floor(a.length/4*3)),F=L=>{switch(v){case 3:M[R++]=h|L,v=0;break;case 2:M[R++]=h|L>>>2,h=L<<6,v=3;break;case 1:M[R++]=h|L>>>4,h=L<<4,v=2;break;default:h=L<<2,v=1}};for(let L=0;L<a.length;L++){const N=a.charCodeAt(L);if(N>=65&&N<=90)F(N-65);else if(N>=97&&N<=122)F(N-97+26);else if(N>=48&&N<=57)F(N-48+52);else if(N===43||N===45)F(62);else if(N===47||N===95)F(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${a[L]}`)}}const O=R;for(;v>0;)F(0);return A.wrap(M).slice(0,O)}e.decodeBase64=t;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},h=!0,v=!1){const R=v?o:i;let M="";const F=a.byteLength%3;let O=0;for(;O<a.byteLength-F;O+=3){const L=a[O+0],N=a[O+1],$=a[O+2];M+=R[L>>>2],M+=R[(L<<4|N>>>4)&63],M+=R[(N<<2|$>>>6)&63],M+=R[$&63]}if(F===1){const L=a[O+0];M+=R[L>>>2],M+=R[L<<4&63],h&&(M+="==")}else if(F===2){const L=a[O+0],N=a[O+1];M+=R[L>>>2],M+=R[(L<<4|N>>>4)&63],M+=R[N<<2&63],h&&(M+="=")}return M}e.encodeBase64=l}),define(ne[14],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(r){return typeof r=="string"}e.isString=D;function n(r){return Array.isArray(r)&&r.every(t=>D(t))}e.isStringArray=n;function k(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=k;function T(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=T;function A(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=A;function b(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=b;function P(r){return r===!0||r===!1}e.isBoolean=P;function I(r){return typeof r=="undefined"}e.isUndefined=I;function E(r){return!w(r)}e.isDefined=E;function w(r){return I(r)||r===null}e.isUndefinedOrNull=w;function m(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=m;function y(r){if(w(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=y;function d(...r){const t=[];for(let i=0;i<r.length;i++){const o=r[i];if(w(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(o)}return t}e.assertAllDefined=d;const S=Object.prototype.hasOwnProperty;function C(r){if(!k(r))return!1;for(const t in r)if(S.call(r,t))return!1;return!0}e.isEmptyObject=C;function p(r){return typeof r=="function"}e.isFunction=p;function g(...r){return r.length>0&&r.every(p)}e.areFunctions=g;function u(r,t){const i=Math.min(r.length,t.length);for(let o=0;o<i;o++)f(r[o],t[o])}e.validateConstraints=u;function f(r,t){if(D(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(p(t)){try{if(r instanceof t)return}catch{}if(!w(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function c(r){return r===null?void 0:r}e.withNullAsUndefined=c;function s(r){return typeof r=="undefined"?null:r}e.withUndefinedAsNull=s}),define(ne[31],se([0,1,14]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const g=Array.isArray(p)?[]:{};return Object.keys(p).forEach(u=>{p[u]&&typeof p[u]=="object"?g[u]=n(p[u]):g[u]=p[u]}),g}e.deepClone=n;function k(p){if(!p||typeof p!="object")return p;const g=[p];for(;g.length>0;){const u=g.shift();Object.freeze(u);for(const f in u)if(T.call(u,f)){const c=u[f];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.isTypedArray)(c)&&g.push(c)}}return p}e.deepFreeze=k;const T=Object.prototype.hasOwnProperty;function A(p,g){return b(p,g,new Set)}e.cloneAndChange=A;function b(p,g,u){if((0,D.isUndefinedOrNull)(p))return p;const f=g(p);if(typeof f!="undefined")return f;if(Array.isArray(p)){const c=[];for(const s of p)c.push(b(s,g,u));return c}if((0,D.isObject)(p)){if(u.has(p))throw new Error("Cannot clone recursive data-structure");u.add(p);const c={};for(const s in p)T.call(p,s)&&(c[s]=b(p[s],g,u));return u.delete(p),c}return p}function P(p,g,u=!0){return(0,D.isObject)(p)?((0,D.isObject)(g)&&Object.keys(g).forEach(f=>{f in p?u&&((0,D.isObject)(p[f])&&(0,D.isObject)(g[f])?P(p[f],g[f],u):p[f]=g[f]):p[f]=g[f]}),p):g}e.mixin=P;function I(p,g){if(p===g)return!0;if(p==null||g===null||g===void 0||typeof p!=typeof g||typeof p!="object"||Array.isArray(p)!==Array.isArray(g))return!1;let u,f;if(Array.isArray(p)){if(p.length!==g.length)return!1;for(u=0;u<p.length;u++)if(!I(p[u],g[u]))return!1}else{const c=[];for(f in p)c.push(f);c.sort();const s=[];for(f in g)s.push(f);if(s.sort(),!I(c,s))return!1;for(u=0;u<c.length;u++)if(!I(p[c[u]],g[c[u]]))return!1}return!0}e.equals=I;function E(p){const g=new Set;return JSON.stringify(p,(u,f)=>{if((0,D.isObject)(f)||Array.isArray(f)){if(g.has(f))return"[Circular]";g.add(f)}return f})}e.safeStringify=E;function w(p,g){const u=Object.create(null);return!p||!g||Object.keys(g).forEach(c=>{const s=p[c],r=g[c];I(s,r)||(u[c]=r)}),u}e.distinct=w;function m(p,g){const u=g.toLowerCase(),f=Object.keys(p).find(c=>c.toLowerCase()===u);return f?p[f]:p[g]}e.getCaseInsensitive=m;function y(p,g){const u=Object.create(null);for(const[f,c]of Object.entries(p))g(f,c)&&(u[f]=c);return u}e.filter=y;function d(p){let g=[],u=Object.getPrototypeOf(p);for(;Object.prototype!==u;)g=g.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return g}e.getAllPropertyNames=d;function S(p){const g=[];for(const u of d(p))typeof p[u]=="function"&&g.push(u);return g}e.getAllMethodNames=S;function C(p,g){const u=c=>function(){const s=Array.prototype.slice.call(arguments,0);return g(c,s)},f={};for(const c of p)f[c]=u(c);return f}e.createProxyObject=C}),define(ne[30],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(k){return D.test(k)}e.isUUID=n,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let P=0;P<b.length;P++)b[P]=Math.floor(Math.random()*256);return b};const T=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));return function(){k(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let P=0,I="";return I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I}}()}),define(ne[114],se([0,1,37]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const b=A.replace(/\-/g,":").toLowerCase();return!n.has(b)}function T(){const A=(0,D.networkInterfaces)();for(const b in A){const P=A[b];if(P){for(const{mac:I}of P)if(k(I))return I}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(ne[115],se([0,1,76]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(b,P,I,E=1){let w=!1;return new Promise(m=>{const y=setTimeout(()=>{if(!w)return w=!0,m(0)},I);k(b,P,E,d=>{if(!w)return w=!0,clearTimeout(y),m(d)})})}e.findFreePort=n;function k(b,P,I,E){if(P===0)return E(0);const w=new D.Socket;w.once("connect",()=>(A(w),k(b+I,P-1,I,E))),w.once("data",()=>{}),w.once("error",m=>(A(w),m.code!=="ECONNREFUSED"?k(b+I,P-1,I,E):E(b))),w.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(b,P,I){let E=!1,w,m=1;const y=D.createServer({pauseOnConnect:!0});function d(S,C){E||(E=!0,y.removeAllListeners(),y.close(),w&&clearTimeout(w),C(S))}return new Promise(S=>{w=setTimeout(()=>{d(0,S)},I),y.on("listening",()=>{d(b,S)}),y.on("error",C=>{C&&(C.code==="EADDRINUSE"||C.code==="EACCES")&&m<P?(b++,m++,y.listen(b,"127.0.0.1")):d(0,S)}),y.on("close",()=>{d(0,S)}),y.listen(b,"127.0.0.1")})}e.findFreePortFaster=T;function A(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(P){console.error(P)}}}),define(ne[116],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function n(T){return T instanceof k?!0:T instanceof Error&&T.name===D&&T.message===D}e.isOfflineError=n;class k extends Error{constructor(){super(D);this.name=this.message}}e.OfflineError=k}),define(ne[117],se([0,1,16,10,116]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(P,I){if(!navigator.onLine)throw new k.OfflineError;P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((w,m)=>{E.open(P.type||"GET",P.url||"",!0,P.user,P.password),A(E,P),E.responseType="arraybuffer",E.onerror=y=>m(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=y=>{w({res:{statusCode:E.status,headers:b(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=y=>m(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(E.timeout=P.timeout),E.send(P.data),I.onCancellationRequested(()=>{E.abort(),m((0,n.canceled)())})})}e.request=T;function A(P,I){if(I.headers){e:for(const E in I.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(E,I.headers[E])}}}function b(P){const I=Object.create(null);for(const E of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const w=E.indexOf(":");I[E.substr(0,w).trim().toLowerCase()]=E.substr(w+1).trim()}return I}}),define(ne[118],se([11,12]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[61],se([0,1,118]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,k=n*60,T=k*24,A=T*7,b=T*30,P=T*365;function I(w,m,y){typeof w!="number"&&(w=w.getTime());const d=Math.round((new Date().getTime()-w)/1e3);if(d<-30)return(0,D.localize)(0,null,I(new Date().getTime()+d*1e3,!1));if(d<30)return(0,D.localize)(1,null);let S;return d<n?(S=d,m?S===1?y?(0,D.localize)(2,null,S):(0,D.localize)(3,null,S):y?(0,D.localize)(4,null,S):(0,D.localize)(5,null,S):S===1?y?(0,D.localize)(6,null,S):(0,D.localize)(7,null,S):y?(0,D.localize)(8,null,S):(0,D.localize)(9,null,S)):d<k?(S=Math.floor(d/n),m?S===1?y?(0,D.localize)(10,null,S):(0,D.localize)(11,null,S):y?(0,D.localize)(12,null,S):(0,D.localize)(13,null,S):S===1?y?(0,D.localize)(14,null,S):(0,D.localize)(15,null,S):y?(0,D.localize)(16,null,S):(0,D.localize)(17,null,S)):d<T?(S=Math.floor(d/k),m?S===1?y?(0,D.localize)(18,null,S):(0,D.localize)(19,null,S):y?(0,D.localize)(20,null,S):(0,D.localize)(21,null,S):S===1?y?(0,D.localize)(22,null,S):(0,D.localize)(23,null,S):y?(0,D.localize)(24,null,S):(0,D.localize)(25,null,S)):d<A?(S=Math.floor(d/T),m?S===1?(0,D.localize)(26,null,S):(0,D.localize)(27,null,S):S===1?(0,D.localize)(28,null,S):(0,D.localize)(29,null,S)):d<b?(S=Math.floor(d/A),m?S===1?y?(0,D.localize)(30,null,S):(0,D.localize)(31,null,S):y?(0,D.localize)(32,null,S):(0,D.localize)(33,null,S):S===1?y?(0,D.localize)(34,null,S):(0,D.localize)(35,null,S):y?(0,D.localize)(36,null,S):(0,D.localize)(37,null,S)):d<P?(S=Math.floor(d/b),m?S===1?y?(0,D.localize)(38,null,S):(0,D.localize)(39,null,S):y?(0,D.localize)(40,null,S):(0,D.localize)(41,null,S):S===1?y?(0,D.localize)(42,null,S):(0,D.localize)(43,null,S):y?(0,D.localize)(44,null,S):(0,D.localize)(45,null,S)):(S=Math.floor(d/P),m?S===1?y?(0,D.localize)(46,null,S):(0,D.localize)(47,null,S):y?(0,D.localize)(48,null,S):(0,D.localize)(49,null,S):S===1?y?(0,D.localize)(50,null,S):(0,D.localize)(51,null,S):y?(0,D.localize)(52,null,S):(0,D.localize)(53,null,S))}e.fromNow=I;function E(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(ne[119],se([11,12]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[38],se([0,1,18,14,119]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(w,m){return m&&(w.stack||w.stacktrace)?k.localize(0,null,b(w),A(w.stack)||A(w.stacktrace)):b(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function b(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function P(w=null,m=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const y=D.coalesce(w),d=P(y[0],m);return y.length>1?k.localize(4,null,d,y.length):d}if(n.isString(w))return w;if(w.detail){const y=w.detail;if(y.error)return T(y.error,m);if(y.exception)return T(y.exception,m)}return w.stack?T(w,m):w.message?w.message:k.localize(5,null)}e.toErrorMessage=P;function I(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=I;function E(w,m){let y;return typeof w=="string"?y=new Error(w):y=w,y.actions=m,y}e.createErrorWithActions=E}),define(ne[120],se([11,12]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[121],se([0,1,120]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function n(k){switch(k){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=n}),define(ne[122],se([11,12]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ne[4],se([0,1,122]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const n="en";let k=!1,T=!1,A=!1,b=!1,P=!1,I=!1,E=!1,w=!1,m=!1,y,d=n,S,C;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const g=typeof p?.versions?.electron=="string",u=g&&p?.type==="renderer";if(typeof navigator=="object"&&!u)C=navigator.userAgent,k=C.indexOf("Windows")>=0,T=C.indexOf("Macintosh")>=0,w=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=C.indexOf("Linux")>=0,I=!0,y=D.getConfiguredDefaultLocale(D.localize(0,null))||n,d=y;else if(typeof p=="object"){k=p.platform==="win32",T=p.platform==="darwin",A=p.platform==="linux",b=A&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,E=g,m=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=n,d=n;const a=p.env.VSCODE_NLS_CONFIG;if(a)try{const h=JSON.parse(a),v=h.availableLanguages["*"];y=h.locale,d=v||n,S=h._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var f;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function c(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let s=0;T?s=1:k?s=3:A&&(s=2),e.isWindows=k,e.isMacintosh=T,e.isLinux=A,e.isLinuxSnap=b,e.isNative=P,e.isElectron=E,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=w,e.isCI=m,e.platform=s,e.userAgent=C,e.language=d;var r;(function(a){function h(){return e.language}a.value=h;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=v;function R(){return e.language==="en"}a.isDefault=R})(r=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let R=0,M=a.length;R<M;R++){const F=a[R];if(F.id===v.data.vscodeScheduleAsyncWork){a.splice(R,1),F.callback();return}}});let h=0;return v=>{const R=++h;a.push({id:R,callback:v}),e.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||w?2:k?1:3;let i=!0,o=!1;function l(){if(!o){o=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,i=new Uint16Array(a.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const k=D.globals.vscode.process;n={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ne[9],se([0,1,36]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,k=97,T=90,A=122,b=46,P=47,I=92,E=58,w=63;class m extends Error{constructor(f,c,s){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const t=f.indexOf(".")!==-1?"property":"argument";let i=`The "${f}" ${t} ${r} of type ${c}`;i+=`. Received type ${typeof s}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function y(u,f){if(typeof u!="string")throw new m(f,"string",u)}function d(u){return u===P||u===I}function S(u){return u===P}function C(u){return u>=n&&u<=T||u>=k&&u<=A}function p(u,f,c,s){let r="",t=0,i=-1,o=0,l=0;for(let a=0;a<=u.length;++a){if(a<u.length)l=u.charCodeAt(a);else{if(s(l))break;l=P}if(s(l)){if(!(i===a-1||o===1))if(o===2){if(r.length<2||t!==2||r.charCodeAt(r.length-1)!==b||r.charCodeAt(r.length-2)!==b){if(r.length>2){const h=r.lastIndexOf(c);h===-1?(r="",t=0):(r=r.slice(0,h),t=r.length-1-r.lastIndexOf(c)),i=a,o=0;continue}else if(r.length!==0){r="",t=0,i=a,o=0;continue}}f&&(r+=r.length>0?`${c}..`:"..",t=2)}else r.length>0?r+=`${c}${u.slice(i+1,a)}`:r=u.slice(i+1,a),t=a-i-1;i=a,o=0}else l===b&&o!==-1?++o:o=-1}return r}function g(u,f){if(f===null||typeof f!="object")throw new m("pathObject","Object",f);const c=f.dir||f.root,s=f.base||`${f.name||""}${f.ext||""}`;return c?c===f.root?`${c}${s}`:`${c}${u}${s}`:s}e.win32={resolve(...u){let f="",c="",s=!1;for(let r=u.length-1;r>=-1;r--){let t;if(r>=0){if(t=u[r],y(t,"path"),t.length===0)continue}else f.length===0?t=D.cwd():(t=D.env[`=${f}`]||D.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==f.toLowerCase()&&t.charCodeAt(2)===I)&&(t=`${f}\\`));const i=t.length;let o=0,l="",a=!1;const h=t.charCodeAt(0);if(i===1)d(h)&&(o=1,a=!0);else if(d(h))if(a=!0,d(t.charCodeAt(1))){let v=2,R=v;for(;v<i&&!d(t.charCodeAt(v));)v++;if(v<i&&v!==R){const M=t.slice(R,v);for(R=v;v<i&&d(t.charCodeAt(v));)v++;if(v<i&&v!==R){for(R=v;v<i&&!d(t.charCodeAt(v));)v++;(v===i||v!==R)&&(l=`\\\\${M}\\${t.slice(R,v)}`,o=v)}}}else o=1;else C(h)&&t.charCodeAt(1)===E&&(l=t.slice(0,2),o=2,i>2&&d(t.charCodeAt(2))&&(a=!0,o=3));if(l.length>0)if(f.length>0){if(l.toLowerCase()!==f.toLowerCase())continue}else f=l;if(s){if(f.length>0)break}else if(c=`${t.slice(o)}\\${c}`,s=a,a&&f.length>0)break}return c=p(c,!s,"\\",d),s?`${f}\\${c}`:`${f}${c}`||"."},normalize(u){y(u,"path");const f=u.length;if(f===0)return".";let c=0,s,r=!1;const t=u.charCodeAt(0);if(f===1)return S(t)?"\\":u;if(d(t))if(r=!0,d(u.charCodeAt(1))){let o=2,l=o;for(;o<f&&!d(u.charCodeAt(o));)o++;if(o<f&&o!==l){const a=u.slice(l,o);for(l=o;o<f&&d(u.charCodeAt(o));)o++;if(o<f&&o!==l){for(l=o;o<f&&!d(u.charCodeAt(o));)o++;if(o===f)return`\\\\${a}\\${u.slice(l)}\\`;o!==l&&(s=`\\\\${a}\\${u.slice(l,o)}`,c=o)}}}else c=1;else C(t)&&u.charCodeAt(1)===E&&(s=u.slice(0,2),c=2,f>2&&d(u.charCodeAt(2))&&(r=!0,c=3));let i=c<f?p(u.slice(c),!r,"\\",d):"";return i.length===0&&!r&&(i="."),i.length>0&&d(u.charCodeAt(f-1))&&(i+="\\"),s===void 0?r?`\\${i}`:i:r?`${s}\\${i}`:`${s}${i}`},isAbsolute(u){y(u,"path");const f=u.length;if(f===0)return!1;const c=u.charCodeAt(0);return d(c)||f>2&&C(c)&&u.charCodeAt(1)===E&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let f,c;for(let t=0;t<u.length;++t){const i=u[t];y(i,"path"),i.length>0&&(f===void 0?f=c=i:f+=`\\${i}`)}if(f===void 0)return".";let s=!0,r=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++r;const t=c.length;t>1&&d(c.charCodeAt(1))&&(++r,t>2&&(d(c.charCodeAt(2))?++r:s=!1))}if(s){for(;r<f.length&&d(f.charCodeAt(r));)r++;r>=2&&(f=`\\${f.slice(r)}`)}return e.win32.normalize(f)},relative(u,f){if(y(u,"from"),y(f,"to"),u===f)return"";const c=e.win32.resolve(u),s=e.win32.resolve(f);if(c===s||(u=c.toLowerCase(),f=s.toLowerCase(),u===f))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===I;)r++;let t=u.length;for(;t-1>r&&u.charCodeAt(t-1)===I;)t--;const i=t-r;let o=0;for(;o<f.length&&f.charCodeAt(o)===I;)o++;let l=f.length;for(;l-1>o&&f.charCodeAt(l-1)===I;)l--;const a=l-o,h=i<a?i:a;let v=-1,R=0;for(;R<h;R++){const F=u.charCodeAt(r+R);if(F!==f.charCodeAt(o+R))break;F===I&&(v=R)}if(R!==h){if(v===-1)return s}else{if(a>h){if(f.charCodeAt(o+R)===I)return s.slice(o+R+1);if(R===2)return s.slice(o+R)}i>h&&(u.charCodeAt(r+R)===I?v=R:R===2&&(v=3)),v===-1&&(v=0)}let M="";for(R=r+v+1;R<=t;++R)(R===t||u.charCodeAt(R)===I)&&(M+=M.length===0?"..":"\\..");return o+=v,M.length>0?`${M}${s.slice(o,l)}`:(s.charCodeAt(o)===I&&++o,s.slice(o,l))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const f=e.win32.resolve(u);if(f.length<=2)return u;if(f.charCodeAt(0)===I){if(f.charCodeAt(1)===I){const c=f.charCodeAt(2);if(c!==w&&c!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(C(f.charCodeAt(0))&&f.charCodeAt(1)===E&&f.charCodeAt(2)===I)return`\\\\?\\${f}`;return u},dirname(u){y(u,"path");const f=u.length;if(f===0)return".";let c=-1,s=0;const r=u.charCodeAt(0);if(f===1)return d(r)?u:".";if(d(r)){if(c=s=1,d(u.charCodeAt(1))){let o=2,l=o;for(;o<f&&!d(u.charCodeAt(o));)o++;if(o<f&&o!==l){for(l=o;o<f&&d(u.charCodeAt(o));)o++;if(o<f&&o!==l){for(l=o;o<f&&!d(u.charCodeAt(o));)o++;if(o===f)return u;o!==l&&(c=s=o+1)}}}}else C(r)&&u.charCodeAt(1)===E&&(c=f>2&&d(u.charCodeAt(2))?3:2,s=c);let t=-1,i=!0;for(let o=f-1;o>=s;--o)if(d(u.charCodeAt(o))){if(!i){t=o;break}}else i=!1;if(t===-1){if(c===-1)return".";t=c}return u.slice(0,t)},basename(u,f){f!==void 0&&y(f,"ext"),y(u,"path");let c=0,s=-1,r=!0,t;if(u.length>=2&&C(u.charCodeAt(0))&&u.charCodeAt(1)===E&&(c=2),f!==void 0&&f.length>0&&f.length<=u.length){if(f===u)return"";let i=f.length-1,o=-1;for(t=u.length-1;t>=c;--t){const l=u.charCodeAt(t);if(d(l)){if(!r){c=t+1;break}}else o===-1&&(r=!1,o=t+1),i>=0&&(l===f.charCodeAt(i)?--i==-1&&(s=t):(i=-1,s=o))}return c===s?s=o:s===-1&&(s=u.length),u.slice(c,s)}for(t=u.length-1;t>=c;--t)if(d(u.charCodeAt(t))){if(!r){c=t+1;break}}else s===-1&&(r=!1,s=t+1);return s===-1?"":u.slice(c,s)},extname(u){y(u,"path");let f=0,c=-1,s=0,r=-1,t=!0,i=0;u.length>=2&&u.charCodeAt(1)===E&&C(u.charCodeAt(0))&&(f=s=2);for(let o=u.length-1;o>=f;--o){const l=u.charCodeAt(o);if(d(l)){if(!t){s=o+1;break}continue}r===-1&&(t=!1,r=o+1),l===b?c===-1?c=o:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||r===-1||i===0||i===1&&c===r-1&&c===s+1?"":u.slice(c,r)},format:g.bind(null,"\\"),parse(u){y(u,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return f;const c=u.length;let s=0,r=u.charCodeAt(0);if(c===1)return d(r)?(f.root=f.dir=u,f):(f.base=f.name=u,f);if(d(r)){if(s=1,d(u.charCodeAt(1))){let v=2,R=v;for(;v<c&&!d(u.charCodeAt(v));)v++;if(v<c&&v!==R){for(R=v;v<c&&d(u.charCodeAt(v));)v++;if(v<c&&v!==R){for(R=v;v<c&&!d(u.charCodeAt(v));)v++;v===c?s=v:v!==R&&(s=v+1)}}}}else if(C(r)&&u.charCodeAt(1)===E){if(c<=2)return f.root=f.dir=u,f;if(s=2,d(u.charCodeAt(2))){if(c===3)return f.root=f.dir=u,f;s=3}}s>0&&(f.root=u.slice(0,s));let t=-1,i=s,o=-1,l=!0,a=u.length-1,h=0;for(;a>=s;--a){if(r=u.charCodeAt(a),d(r)){if(!l){i=a+1;break}continue}o===-1&&(l=!1,o=a+1),r===b?t===-1?t=a:h!==1&&(h=1):t!==-1&&(h=-1)}return o!==-1&&(t===-1||h===0||h===1&&t===o-1&&t===i+1?f.base=f.name=u.slice(i,o):(f.name=u.slice(i,t),f.base=u.slice(i,o),f.ext=u.slice(t,o))),i>0&&i!==s?f.dir=u.slice(0,i-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let f="",c=!1;for(let s=u.length-1;s>=-1&&!c;s--){const r=s>=0?u[s]:D.cwd();y(r,"path"),r.length!==0&&(f=`${r}/${f}`,c=r.charCodeAt(0)===P)}return f=p(f,!c,"/",S),c?`/${f}`:f.length>0?f:"."},normalize(u){if(y(u,"path"),u.length===0)return".";const f=u.charCodeAt(0)===P,c=u.charCodeAt(u.length-1)===P;return u=p(u,!f,"/",S),u.length===0?f?"/":c?"./":".":(c&&(u+="/"),f?`/${u}`:u)},isAbsolute(u){return y(u,"path"),u.length>0&&u.charCodeAt(0)===P},join(...u){if(u.length===0)return".";let f;for(let c=0;c<u.length;++c){const s=u[c];y(s,"path"),s.length>0&&(f===void 0?f=s:f+=`/${s}`)}return f===void 0?".":e.posix.normalize(f)},relative(u,f){if(y(u,"from"),y(f,"to"),u===f||(u=e.posix.resolve(u),f=e.posix.resolve(f),u===f))return"";const c=1,s=u.length,r=s-c,t=1,i=f.length-t,o=r<i?r:i;let l=-1,a=0;for(;a<o;a++){const v=u.charCodeAt(c+a);if(v!==f.charCodeAt(t+a))break;v===P&&(l=a)}if(a===o)if(i>o){if(f.charCodeAt(t+a)===P)return f.slice(t+a+1);if(a===0)return f.slice(t+a)}else r>o&&(u.charCodeAt(c+a)===P?l=a:a===0&&(l=0));let h="";for(a=c+l+1;a<=s;++a)(a===s||u.charCodeAt(a)===P)&&(h+=h.length===0?"..":"/..");return`${h}${f.slice(t+l)}`},toNamespacedPath(u){return u},dirname(u){if(y(u,"path"),u.length===0)return".";const f=u.charCodeAt(0)===P;let c=-1,s=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===P){if(!s){c=r;break}}else s=!1;return c===-1?f?"/":".":f&&c===1?"//":u.slice(0,c)},basename(u,f){f!==void 0&&y(f,"ext"),y(u,"path");let c=0,s=-1,r=!0,t;if(f!==void 0&&f.length>0&&f.length<=u.length){if(f===u)return"";let i=f.length-1,o=-1;for(t=u.length-1;t>=0;--t){const l=u.charCodeAt(t);if(l===P){if(!r){c=t+1;break}}else o===-1&&(r=!1,o=t+1),i>=0&&(l===f.charCodeAt(i)?--i==-1&&(s=t):(i=-1,s=o))}return c===s?s=o:s===-1&&(s=u.length),u.slice(c,s)}for(t=u.length-1;t>=0;--t)if(u.charCodeAt(t)===P){if(!r){c=t+1;break}}else s===-1&&(r=!1,s=t+1);return s===-1?"":u.slice(c,s)},extname(u){y(u,"path");let f=-1,c=0,s=-1,r=!0,t=0;for(let i=u.length-1;i>=0;--i){const o=u.charCodeAt(i);if(o===P){if(!r){c=i+1;break}continue}s===-1&&(r=!1,s=i+1),o===b?f===-1?f=i:t!==1&&(t=1):f!==-1&&(t=-1)}return f===-1||s===-1||t===0||t===1&&f===s-1&&f===c+1?"":u.slice(f,s)},format:g.bind(null,"/"),parse(u){y(u,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return f;const c=u.charCodeAt(0)===P;let s;c?(f.root="/",s=1):s=0;let r=-1,t=0,i=-1,o=!0,l=u.length-1,a=0;for(;l>=s;--l){const h=u.charCodeAt(l);if(h===P){if(!o){t=l+1;break}continue}i===-1&&(o=!1,i=l+1),h===b?r===-1?r=l:a!==1&&(a=1):r!==-1&&(a=-1)}if(i!==-1){const h=t===0&&c?1:t;r===-1||a===0||a===1&&r===i-1&&r===t+1?f.base=f.name=u.slice(h,i):(f.name=u.slice(h,r),f.base=u.slice(h,i),f.ext=u.slice(r,i))}return t>0?f.dir=u.slice(0,t-1):c&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[123],se([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(E){const w=(0,D.extname)(E),m=n[w.toLowerCase()];return m!==void 0?m:A(E)}e.getMediaOrTextMime=T;function A(E){const w=(0,D.extname)(E);return k[w.toLowerCase()]}e.getMediaMime=A;function b(E){for(const w in k)if(k[w]===E)return w}e.getExtensionForMimeType=b;const P=/^(.+)\/(.+?)(;.+)?$/;function I(E,w){const m=P.exec(E);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:w?void 0:E}e.normalizeMimeType=I}),define(ne[77],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(b,...P){const I=P.reduce((m,y)=>(m[y]=!0,m),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!I[m]).forEach(m=>{for(let y=0;y<E.length;y++)if(m.search(E[y])!==-1){delete b[m];break}})}e.sanitizeProcessEnvironment=T;function A(b){!b||(delete b.DEBUG,D.isMacintosh&&delete b.DYLD_LIBRARY_PATH,D.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ne[124],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class k{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ne[3],se([0,1,10,74,2,112,124]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const b=!1,P=!1;var I;(function(l){l.None=()=>k.Disposable.None;function a(U){if(P){const{onListenerDidAdd:j}=U,B=d.create();let X=0;U.onListenerDidAdd=()=>{++X==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),j?.()}}}function h(U){return(j,B=null,X)=>{let oe=!1,J;return J=U(ie=>{if(!oe)return J?J.dispose():oe=!0,j.call(B,ie)},null,X),oe&&J.dispose(),J}}l.once=h;function v(U,j,B){return N((X,oe=null,J)=>U(ie=>X.call(oe,j(ie)),null,J),B)}l.map=v;function R(U,j,B){return N((X,oe=null,J)=>U(ie=>{j(ie),X.call(oe,ie)},null,J),B)}l.forEach=R;function M(U,j,B){return N((X,oe=null,J)=>U(ie=>j(ie)&&X.call(oe,ie),null,J),B)}l.filter=M;function F(U){return U}l.signal=F;function O(...U){return(j,B=null,X)=>(0,k.combinedDisposable)(...U.map(oe=>oe(J=>j.call(B,J),null,X)))}l.any=O;function L(U,j,B,X){let oe=B;return v(U,J=>(oe=j(oe,J),oe),X)}l.reduce=L;function N(U,j){let B;const X={onFirstListenerAdd(){B=U(oe.fire,oe)},onLastListenerRemove(){B?.dispose()}};j||a(X);const oe=new C(X);return j?.add(oe),oe.event}function $(U,j,B=100,X=!1,oe,J){let ie,re,ue,he=0;const ve={leakWarningThreshold:oe,onFirstListenerAdd(){ie=U(Ce=>{he++,re=j(re,Ce),X&&!ue&&(ye.fire(re),re=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Pe=re;re=void 0,ue=void 0,(!X||he>1)&&ye.fire(Pe),he=0},B)})},onLastListenerRemove(){ie.dispose()}};J||a(ve);const ye=new C(ve);return J?.add(ye),ye.event}l.debounce=$;function H(U,j=(X,oe)=>X===oe,B){let X=!0,oe;return M(U,J=>{const ie=X||!j(J,oe);return X=!1,oe=J,ie},B)}l.latch=H;function Y(U,j,B){return[l.filter(U,j,B),l.filter(U,X=>!j(X),B)]}l.split=Y;function te(U,j=!1,B=[]){let X=B.slice(),oe=U(re=>{X?X.push(re):ie.fire(re)});const J=()=>{X?.forEach(re=>ie.fire(re)),X=null},ie=new C({onFirstListenerAdd(){oe||(oe=U(re=>ie.fire(re)))},onFirstListenerDidAdd(){X&&(j?setTimeout(J):J())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return ie.event}l.buffer=te;class q{constructor(j){this.event=j,this.disposables=new k.DisposableStore}map(j){return new q(v(this.event,j,this.disposables))}forEach(j){return new q(R(this.event,j,this.disposables))}filter(j){return new q(M(this.event,j,this.disposables))}reduce(j,B){return new q(L(this.event,j,B,this.disposables))}latch(){return new q(H(this.event,void 0,this.disposables))}debounce(j,B=100,X=!1,oe){return new q($(this.event,j,B,X,oe,this.disposables))}on(j,B,X){return this.event(j,B,X)}once(j,B,X){return h(this.event)(j,B,X)}dispose(){this.disposables.dispose()}}function W(U){return new q(U)}l.chain=W;function x(U,j,B=X=>X){const X=(...re)=>ie.fire(B(...re)),oe=()=>U.on(j,X),J=()=>U.removeListener(j,X),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:J});return ie.event}l.fromNodeEventEmitter=x;function K(U,j,B=X=>X){const X=(...re)=>ie.fire(B(...re)),oe=()=>U.addEventListener(j,X),J=()=>U.removeEventListener(j,X),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:J});return ie.event}l.fromDOMEventEmitter=K;function ee(U){return new Promise(j=>h(U)(j))}l.toPromise=ee;function ce(U,j){return j(void 0),U(B=>j(B))}l.runAndSubscribe=ce;function z(U,j){let B=null;function X(J){B?.dispose(),B=new k.DisposableStore,j(J,B)}X(void 0);const oe=U(J=>X(J));return(0,k.toDisposable)(()=>{oe.dispose(),B?.dispose()})}l.runAndSubscribeWithStore=z;class V{constructor(j,B){this.obs=j,this._counter=0,this._hasChanged=!1;const X={onFirstListenerAdd:()=>{j.addObserver(this)},onLastListenerRemove:()=>{j.removeObserver(this)}};B||a(X),this.emitter=new C(X),B&&B.add(this.emitter)}beginUpdate(j){this._counter++}handleChange(j,B){this._hasChanged=!0}endUpdate(j){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function _(U,j){return new V(U,j).emitter.event}l.fromObservable=_})(I=e.Event||(e.Event={}));class E{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${E._idPool++}`}start(a){this._stopWatch=new A.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let w=-1;function m(l){const a=w;return w=l,{dispose(){w=a}}}e.setGlobalLeakWarningThreshold=m;class y{constructor(a,h=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,h){let v=w;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||h<v)return;this._stacks||(this._stacks=new Map);const R=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,R+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let M,F=0;for(const[O,L]of this._stacks)(!M||F<L)&&(M=O,F=L);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${F}):`),console.warn(M)}return()=>{const M=this._stacks.get(a.value)||0;this._stacks.set(a.value,M-1)}}}class d{constructor(a){this.value=a}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(a,h,v){this.callback=a,this.callbackThis=h,this.stack=v,this.subscription=new k.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class C{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=w>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const h of a)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,h,v)=>{this._listeners||(this._listeners=new T.LinkedList);const R=this._listeners.isEmpty();R&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let M,F;this._leakageMon&&this._listeners.size>=30&&(F=d.create(),M=this._leakageMon.check(F,this._listeners.size+1)),b&&(F=F??d.create());const O=new S(a,h,F),L=this._listeners.push(O);R&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,h);const N=O.subscription.set(()=>{M?.(),this._disposed||(L(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return v instanceof k.DisposableStore?v.add(N):Array.isArray(v)&&v.push(N),N}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const h of this._listeners)this._deliveryQueue.push(this,h,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=C;class p{constructor(){this._queue=new T.LinkedList}get size(){return this._queue.size}push(a,h,v){this._queue.push(new u(a,h,v))}clear(a){const h=new T.LinkedList;for(const v of this._queue)v.emitter!==a&&h.push(v);this._queue=h}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(h){(0,D.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=p;class g extends p{clear(a){this._queue.clear()}}class u{constructor(a,h,v){this.emitter=a,this.listener=h,this.event=v}}class f extends C{async fireAsync(a,h,v){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const R of this._listeners)this._asyncDeliveryQueue.push([R,a]);for(;this._asyncDeliveryQueue.size>0&&!h.isCancellationRequested;){const[R,M]=this._asyncDeliveryQueue.shift(),F=[],O={...M,token:h,waitUntil:L=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");v&&(L=v(L,R.callback)),F.push(L)}};try{R.invoke(O)}catch(L){(0,D.onUnexpectedError)(L);continue}Object.freeze(F),await Promise.allSettled(F).then(L=>{for(const N of L)N.status==="rejected"&&(0,D.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=f;class c extends C{constructor(a){super(a);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=c;class s extends c{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=s;class r extends C{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(h=>super.fire(h)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const h={event:a,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const v=()=>{this.hasListeners&&this.unhook(h);const R=this.events.indexOf(h);this.events.splice(R,1)};return(0,k.toDisposable)((0,n.once)(v))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(h=>this.emitter.fire(h))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.buffers=[]}wrapEvent(a){return(h,v,R)=>a(M=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>h.call(v,M)):h.call(v,M)},void 0,R)}bufferEvents(a){const h=[];this.buffers.push(h);const v=a();return this.buffers.pop(),h.forEach(R=>R()),v}}e.EventBufferer=i;class o{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=k.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ne[21],se([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(b,P){const I=setTimeout(b.bind(P),0);return{dispose(){clearTimeout(I)}}});var k;(function(b){function P(I){return I===b.None||I===b.Cancelled||I instanceof T?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}b.isCancellationToken=P,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(k=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(P){this._token=void 0,this._parentListener=void 0,this._parentListener=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=k.Cancelled}dispose(P=!1){P&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(ne[125],se([0,1,21]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new D.CancellationTokenSource,P=this.task(b.token);return this.result={promise:P,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=n;class k{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const P=JSON.stringify(b);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.fn(b)),this.lastCache}}e.LRUCachedFunction=k;class T{constructor(b){this.fn=b,this._map=new Map}get cachedValues(){return this._map}get(b){if(this._map.has(b))return this._map.get(b);const P=this.fn(b);return this._map.set(b,P),P}}e.CachedFunction=T}),define(ne[78],se([0,1,3,2]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=A=>({onDidChange:D.Event.None,value:A});e.staticObservableValue=k;class T extends n.Disposable{constructor(b){super();this._value=b,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(b){b!==this._value&&(this._value=b,this.changeEmitter.fire(b))}}e.MutableObservableValue=T}),define(ne[24],se([0,1,125,111]),function(Q,e,D,n){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function b(Z,...le){return le.length===0?Z:Z.replace(A,function(ge,Se){const pe=parseInt(Se,10);return isNaN(pe)||pe<0||pe>=le.length?ge:le[pe]})}e.format=b;const P=/{([^}]+)}/g;function I(Z,le){return Z.replace(P,(ge,Se)=>le[Se]??ge)}e.format2=I;function E(Z){return Z.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=E;function w(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function m(Z,le){let ge=0;const Se=le.charCodeAt(0);for(let pe=Z.length-1;pe>=0;pe--)Z.charCodeAt(pe)===Se&&ge++;return ge}e.count=m;function y(Z,le,ge="\u2026"){return Z.length<=le?Z:`${Z.substr(0,le)}${ge}`}e.truncate=y;function d(Z,le=" "){const ge=S(Z,le);return C(ge,le)}e.trim=d;function S(Z,le){if(!Z||!le)return Z;const ge=le.length;if(ge===0||Z.length===0)return Z;let Se=0;for(;Z.indexOf(le,Se)===Se;)Se=Se+ge;return Z.substring(Se)}e.ltrim=S;function C(Z,le){if(!Z||!le)return Z;const ge=le.length,Se=Z.length;if(ge===0||Se===0)return Z;let pe=Se,Ee=-1;for(;Ee=Z.lastIndexOf(le,pe-1),!(Ee===-1||Ee+ge!==pe);){if(Ee===0)return"";pe=Ee}return Z.substring(0,pe)}e.rtrim=C;function p(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function g(Z){return Z.replace(/\*/g,"")}e.stripWildcards=g;function u(Z,le,ge={}){if(!Z)throw new Error("Cannot create regex from empty string");le||(Z=w(Z)),ge.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let Se="";return ge.global&&(Se+="g"),ge.matchCase||(Se+="i"),ge.multiline&&(Se+="m"),ge.unicode&&(Se+="u"),new RegExp(Z,Se)}e.createRegExp=u;function f(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function c(Z){return!!Z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function s(Z){return(Z.global?"g":"")+(Z.ignoreCase?"i":"")+(Z.multiline?"m":"")+(Z.unicode?"u":"")}e.regExpFlags=s;function r(Z){return Z.split(/\r\n|\r|\n/)}e.splitLines=r;function t(Z){for(let le=0,ge=Z.length;le<ge;le++){const Se=Z.charCodeAt(le);if(Se!==32&&Se!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function i(Z,le=0,ge=Z.length){for(let Se=le;Se<ge;Se++){const pe=Z.charCodeAt(Se);if(pe!==32&&pe!==9)return Z.substring(le,Se)}return Z.substring(le,ge)}e.getLeadingWhitespace=i;function o(Z,le=Z.length-1){for(let ge=le;ge>=0;ge--){const Se=Z.charCodeAt(ge);if(Se!==32&&Se!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function l(Z,le,ge){const Se=[];let pe=0;for(const Ee of Z.matchAll(le)){if(Se.push(Z.slice(pe,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");pe=Ee.index+Ee[0].length,Se.push(ge(Ee[0],...Ee.slice(1),Ee.index,Z,Ee.groups))}return Se.push(Z.slice(pe)),Promise.all(Se).then(Ee=>Ee.join(""))}e.replaceAsync=l;function a(Z,le){return Z<le?-1:Z>le?1:0}e.compare=a;function h(Z,le,ge=0,Se=Z.length,pe=0,Ee=le.length){for(;ge<Se&&pe<Ee;ge++,pe++){const Le=Z.charCodeAt(ge),_e=le.charCodeAt(pe);if(Le<_e)return-1;if(Le>_e)return 1}const Re=Se-ge,ke=Ee-pe;return Re<ke?-1:Re>ke?1:0}e.compareSubstring=h;function v(Z,le){return R(Z,le,0,Z.length,0,le.length)}e.compareIgnoreCase=v;function R(Z,le,ge=0,Se=Z.length,pe=0,Ee=le.length){for(;ge<Se&&pe<Ee;ge++,pe++){let Le=Z.charCodeAt(ge),_e=le.charCodeAt(pe);if(Le===_e)continue;if(Le>=128||_e>=128)return h(Z.toLowerCase(),le.toLowerCase(),ge,Se,pe,Ee);F(Le)&&(Le-=32),F(_e)&&(_e-=32);const Fe=Le-_e;if(Fe!==0)return Fe}const Re=Se-ge,ke=Ee-pe;return Re<ke?-1:Re>ke?1:0}e.compareSubstringIgnoreCase=R;function M(Z){return Z>=48&&Z<=57}e.isAsciiDigit=M;function F(Z){return Z>=97&&Z<=122}e.isLowerAsciiLetter=F;function O(Z){return Z>=65&&Z<=90}e.isUpperAsciiLetter=O;function L(Z,le){return Z.length===le.length&&R(Z,le)===0}e.equalsIgnoreCase=L;function N(Z,le){const ge=le.length;return le.length>Z.length?!1:R(Z,le,0,ge)===0}e.startsWithIgnoreCase=N;function $(Z,le){const ge=Math.min(Z.length,le.length);let Se;for(Se=0;Se<ge;Se++)if(Z.charCodeAt(Se)!==le.charCodeAt(Se))return Se;return ge}e.commonPrefixLength=$;function H(Z,le){const ge=Math.min(Z.length,le.length);let Se;const pe=Z.length-1,Ee=le.length-1;for(Se=0;Se<ge;Se++)if(Z.charCodeAt(pe-Se)!==le.charCodeAt(Ee-Se))return Se;return ge}e.commonSuffixLength=H;function Y(Z){return 55296<=Z&&Z<=56319}e.isHighSurrogate=Y;function te(Z){return 56320<=Z&&Z<=57343}e.isLowSurrogate=te;function q(Z,le){return(Z-55296<<10)+(le-56320)+65536}e.computeCodePoint=q;function W(Z,le,ge){const Se=Z.charCodeAt(ge);if(Y(Se)&&ge+1<le){const pe=Z.charCodeAt(ge+1);if(te(pe))return q(Se,pe)}return Se}e.getNextCodePoint=W;function x(Z,le){const ge=Z.charCodeAt(le-1);if(te(ge)&&le>1){const Se=Z.charCodeAt(le-2);if(Y(Se))return q(Se,ge)}return ge}class K{constructor(le,ge=0){this._str=le,this._len=le.length,this._offset=ge}get offset(){return this._offset}setOffset(le){this._offset=le}prevCodePoint(){const le=x(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=W(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=K;class ee{constructor(le,ge=0){this._iterator=new K(le,ge)}get offset(){return this._iterator.offset}nextGraphemeLength(){const le=be.getInstance(),ge=this._iterator,Se=ge.offset;let pe=le.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ee=ge.offset,Re=le.getGraphemeBreakType(ge.nextCodePoint());if(de(pe,Re)){ge.setOffset(Ee);break}pe=Re}return ge.offset-Se}prevGraphemeLength(){const le=be.getInstance(),ge=this._iterator,Se=ge.offset;let pe=le.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ee=ge.offset,Re=le.getGraphemeBreakType(ge.prevCodePoint());if(de(Re,pe)){ge.setOffset(Ee);break}pe=Re}return Se-ge.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ee;function ce(Z,le){return new ee(Z,le).nextGraphemeLength()}e.nextCharLength=ce;function z(Z,le){return new ee(Z,le).prevGraphemeLength()}e.prevCharLength=z;function V(Z,le){le>0&&te(Z.charCodeAt(le))&&le--;const ge=le+ce(Z,le);return[ge-z(Z,ge),ge]}e.getCharContainingOffset=V;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function U(Z){return _.test(Z)}e.containsRTL=U;const j=/^[\t\n\r\x20-\x7E]*$/;function B(Z){return j.test(Z)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(Z){return e.UNUSUAL_LINE_TERMINATORS.test(Z)}e.containsUnusualLineTerminators=X;function oe(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}e.isFullWidthCharacter=oe;function J(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}e.isEmojiImprecise=J;function ie(Z,le){if(Z.length<le)return Z;const ge=/\b/g;let Se=0;for(;ge.test(Z)&&!(Z.length-ge.lastIndex<le);)Se=ge.lastIndex,ge.lastIndex+=1;return Z.substring(Se).replace(/^\s/,"")}e.lcut=ie;const re=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,he=/\x1b\[0?m/g;function ve(Z){return Z&&(Z=Z.replace(re,""),Z=Z.replace(ue,""),Z=Z.replace(he,"")),Z}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ye(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ye;function Ce(Z){return ye(Z)?Z.substr(1):Z}e.stripUTF8BOM=Ce;function Pe(Z,le){if(!Z||!le||Z.length<le.length)return!1;const ge=le.length,Se=Z.toLowerCase();let pe=0,Ee=-1;for(;pe<ge;){const Re=Se.indexOf(le[pe],Ee+1);if(Re<0)return!1;Ee=Re,pe++}return!0}e.fuzzyContains=Pe;function Ue(Z,le=!1){return Z?(le&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}e.containsUppercaseCharacter=Ue;function We(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}e.uppercaseFirstLetter=We;function Be(Z,le=1){if(le===0)return"";let ge=-1;do ge=Z.indexOf(`
`,ge+1),le--;while(le>0&&ge>=0);return ge===-1?Z:(Z[ge-1]==="\r"&&ge--,Z.substr(0,ge))}e.getNLines=Be;function qe(Z){const le=90-65+1;return Z=Z%(2*le),Z<le?String.fromCharCode(97+Z):String.fromCharCode(65+Z-le)}e.singleLetterHash=qe;function ae(Z){return be.getInstance().getGraphemeBreakType(Z)}e.getGraphemeBreakType=ae;function de(Z,le){return Z===0?le!==5&&le!==7:Z===2&&le===3?!1:Z===4||Z===2||Z===3||le===4||le===2||le===3?!0:!(Z===8&&(le===8||le===9||le===11||le===12)||(Z===11||Z===9)&&(le===9||le===10)||(Z===12||Z===10)&&le===10||le===5||le===13||le===7||Z===1||Z===13&&le===14||Z===6&&le===6)}var fe;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class be{constructor(){this._data=Ie()}static getInstance(){return be._INSTANCE||(be._INSTANCE=new be),be._INSTANCE}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const ge=this._data,Se=ge.length/3;let pe=1;for(;pe<=Se;)if(le<ge[3*pe])pe=2*pe;else if(le>ge[3*pe+1])pe=2*pe+1;else return ge[3*pe+2];return 0}}be._INSTANCE=null;function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(Z,le){if(Z===0)return 0;const ge=De(Z,le);if(ge!==void 0)return ge;const Se=new K(le,Z);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Me;function De(Z,le){const ge=new K(le,Z);let Se=ge.prevCodePoint();for(;$e(Se)||Se===65039||Se===8419;){if(ge.offset===0)return;Se=ge.prevCodePoint()}if(!J(Se))return;let pe=ge.offset;return pe>0&&ge.prevCodePoint()===8205&&(pe=ge.offset),pe}function $e(Z){return 127995<=Z&&Z<=127999}var Ae;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.noBreakWhitespace="\xA0";class Te{constructor(le){this.confusableDictionary=le}static getInstance(le){return Te.cache.get(Array.from(le))}static getLocales(){return Te._locales.getValue()}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Te,k=Te,Te.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Te.cache=new D.LRUCachedFunction(Z=>{function le(_e){const Fe=new Map;for(let ze=0;ze<_e.length;ze+=2)Fe.set(_e[ze],_e[ze+1]);return Fe}function ge(_e,Fe){const ze=new Map(_e);for(const[Qe,it]of Fe)ze.set(Qe,it);return ze}function Se(_e,Fe){if(!_e)return Fe;const ze=new Map;for(const[Qe,it]of _e)Fe.has(Qe)&&ze.set(Qe,it);return ze}const pe=k.ambiguousCharacterData.getValue();let Ee=Z.filter(_e=>!_e.startsWith("_")&&_e in pe);Ee.length===0&&(Ee=["_default"]);let Re;for(const _e of Ee){const Fe=le(pe[_e]);Re=Se(Re,Fe)}const ke=le(pe._common),Le=ge(ke,Re);return new Te(Le)}),Te._locales=new n.Lazy(()=>Object.keys(Te.ambiguousCharacterData.getValue()).filter(Z=>!Z.startsWith("_")));class Ne{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ne.getRawData())),this._data}static isInvisibleCharacter(le){return Ne.getData().has(le)}static get codePoints(){return Ne.getData()}}e.InvisibleCharacters=Ne,Ne._data=void 0}),define(ne[46],se([0,1,9,4,24,14]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function b(o){return o.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=b;function P(o){return o.indexOf("/")===-1&&(o=b(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=P;function I(o,l=D.posix.sep){if(!o)return"";const a=o.length,h=o.charCodeAt(0);if(A(h)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let R=3;const M=R;for(;R<a&&!A(o.charCodeAt(R));R++);if(M!==R&&!A(o.charCodeAt(R+1))){for(R+=1;R<a;R++)if(A(o.charCodeAt(R)))return o.slice(0,R+1).replace(/[\\/]/g,l)}}return l}else if(p(h)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+l:o.slice(0,2);let v=o.indexOf("://");if(v!==-1){for(v+=3;v<a;v++)if(A(o.charCodeAt(v)))return o.slice(0,v+1)}return""}e.getRoot=I;function E(o){if(!n.isWindows||!o||o.length<5)return!1;let l=o.charCodeAt(0);if(l!==92||(l=o.charCodeAt(1),l!==92))return!1;let a=2;const h=a;for(;a<o.length&&(l=o.charCodeAt(a),l!==92);a++);return!(h===a||(l=o.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=E;const w=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,l=n.isWindows){const a=l?w:m;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||l&&y.test(o)||o==="."||o===".."||l&&o[o.length-1]==="."||l&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function S(o,l,a){const h=o===l;return!a||h?h:!o||!l?!1:(0,k.equalsIgnoreCase)(o,l)}e.isEqual=S;function C(o,l,a,h=D.sep){if(o===l)return!0;if(!o||!l||l.length>o.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(o,l))return!1;if(l.length===o.length)return!0;let R=l.length;return l.charAt(l.length-1)===h&&R--,o.charAt(R)===h}return l.charAt(l.length-1)!==h&&(l+=h),o.indexOf(l)===0}e.isEqualOrParent=C;function p(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=p;function g(o,l){return n.isWindows&&o.endsWith(":")&&(o+=D.sep),(0,D.isAbsolute)(o)||(o=(0,D.join)(l,o)),o=(0,D.normalize)(o),n.isWindows?(o=(0,k.rtrim)(o,D.sep),o.endsWith(":")&&(o+=D.sep)):(o=(0,k.rtrim)(o,D.sep),o||(o=D.sep)),o}e.sanitizeFilePath=g;function u(o){const l=(0,D.normalize)(o);return n.isWindows?o.length>3?!1:f(l)&&(o.length===2||l.charCodeAt(2)===92):l===D.posix.sep}e.isRootOrDriveLetter=u;function f(o,l=n.isWindows){return l?p(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function c(o){return f(o)?o[0]:void 0}e.getDriveLetter=c;function s(o,l,a){return l.length>o.length?-1:o===l?0:(a&&(o=o.toLowerCase(),l=l.toLowerCase()),o.indexOf(l))}e.indexOfPath=s;function r(o){const l=o.split(":");let a,h,v;for(const R of l){const M=Number(R);(0,T.isNumber)(M)?h===void 0?h=M:v===void 0&&(v=M):a=a?[a,R].join(":"):R}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:v!==void 0?v:h!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(o,l,a=8){let h="";for(let R=0;R<a;R++)h+=t.charAt(Math.floor(Math.random()*t.length));let v;return l?v=`${l}-${h}`:v=h,o?(0,D.join)(o,v):v}e.randomPath=i}),define(ne[62],se([0,1,24]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(p){return k(p,0)}e.hash=n;function k(p,g){switch(typeof p){case"object":return p===null?T(349,g):Array.isArray(p)?P(p,g):I(p,g);case"string":return b(p,g);case"boolean":return A(p,g);case"number":return T(p,g);case"undefined":return T(937,g);default:return T(617,g)}}e.doHash=k;function T(p,g){return(g<<5)-g+p|0}e.numberHash=T;function A(p,g){return T(p?433:863,g)}function b(p,g){g=T(149417,g);for(let u=0,f=p.length;u<f;u++)g=T(p.charCodeAt(u),g);return g}e.stringHash=b;function P(p,g){return g=T(104579,g),p.reduce((u,f)=>k(f,u),g)}function I(p,g){return g=T(181387,g),Object.keys(p).sort().reduce((u,f)=>(u=b(f,u),k(p[f],u)),g)}class E{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=k(g,this._value),this._value}}e.Hasher=E;var w;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function m(p,g,u=32){const f=u-g,c=~((1<<f)-1);return(p<<g|(c&p)>>>f)>>>0}function y(p,g=0,u=p.byteLength,f=0){for(let c=0;c<u;c++)p[g+c]=f}function d(p,g,u="0"){for(;p.length<g;)p=u+p;return p}function S(p,g=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),g/4)}e.toHexString=S;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const u=g.length;if(u===0)return;const f=this._buff;let c=this._buffLen,s=this._leftoverHighSurrogate,r,t;for(s!==0?(r=s,t=-1,s=0):(r=g.charCodeAt(0),t=0);;){let i=r;if(D.isHighSurrogate(r))if(t+1<u){const o=g.charCodeAt(t+1);D.isLowSurrogate(o)?(t++,i=D.computeCodePoint(r,o)):i=65533}else{s=r;break}else D.isLowSurrogate(r)&&(i=65533);if(c=this._push(f,c,i),t++,t<u)r=g.charCodeAt(t);else break}this._buffLen=c,this._leftoverHighSurrogate=s}_push(g,u,f){return f<128?g[u++]=f:f<2048?(g[u++]=192|(f&1984)>>>6,g[u++]=128|(f&63)>>>0):f<65536?(g[u++]=224|(f&61440)>>>12,g[u++]=128|(f&4032)>>>6,g[u++]=128|(f&63)>>>0):(g[u++]=240|(f&1835008)>>>18,g[u++]=128|(f&258048)>>>12,g[u++]=128|(f&4032)>>>6,g[u++]=128|(f&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=C._bigBlock32,u=this._buffDV;for(let a=0;a<64;a+=4)g.setUint32(a,u.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,m(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let f=this._h0,c=this._h1,s=this._h2,r=this._h3,t=this._h4,i,o,l;for(let a=0;a<80;a++)a<20?(i=c&s|~c&r,o=1518500249):a<40?(i=c^s^r,o=1859775393):a<60?(i=c&s|c&r|s&r,o=2400959708):(i=c^s^r,o=3395469782),l=m(f,5)+i+t+o+g.getUint32(a*4,!1)&4294967295,t=r,r=s,s=m(c,30),c=f,f=l;this._h0=this._h0+f&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[34],se([0,1,18,24]),function(Q,e,D,n){"use strict";var k,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(t,i,o){let l=t.get(i);return l===void 0&&(l=o,t.set(i,l)),l}e.getOrSet=b;function P(t){const i=[];return t.forEach((o,l)=>{i.push(`${l} => ${o}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=P;function I(t){const i=[];return t.forEach(o=>{i.push(o)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=I;class E{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),l=this._value.charCodeAt(this._pos);return o-l}value(){return this._value[this._pos]}}e.StringIterator=E;class w{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class m{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let o=i.length-1;o>=0;o--,this._valueLen--){const l=this._value.charCodeAt(o);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var y;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(y||(y={}));class d{constructor(i,o){this._ignorePathCasing=i,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(t){t[t.Left=-1]="Left",t[t.Mid=0]="Mid",t[t.Right=1]="Right"})(C||(C={}));class p{constructor(i){this._iter=i}static forUris(i=()=>!1,o=()=>!1){return new p(new d(i,o))}static forPaths(i=!1){return new p(new m(void 0,!i))}static forStrings(){return new p(new E)}static forConfigKeys(){return new p(new w)}clear(){this._root=void 0}fill(i,o){if(o){const l=o.slice(0);(0,D.shuffle)(l);for(const a of l)this.set(a,i)}else{const l=i.slice(0);(0,D.shuffle)(l);for(const a of l)this.set(a[0],a[1])}}set(i,o){const l=this._iter.reset(i);let a;this._root||(this._root=new S,this._root.segment=l.value());const h=[];for(a=this._root;;){const R=l.cmp(a.segment);if(R>0)a.left||(a.left=new S,a.left.segment=l.value()),h.push([-1,a]),a=a.left;else if(R<0)a.right||(a.right=new S,a.right.segment=l.value()),h.push([1,a]),a=a.right;else if(l.hasNext())l.next(),a.mid||(a.mid=new S,a.mid.segment=l.value()),h.push([0,a]),a=a.mid;else break}const v=a.value;a.value=o,a.key=i;for(let R=h.length-1;R>=0;R--){const M=h[R][1];M.updateHeight();const F=M.balanceFactor();if(F<-1||F>1){const O=h[R][0],L=h[R+1][0];if(O===1&&L===1)h[R][1]=M.rotateLeft();else if(O===-1&&L===-1)h[R][1]=M.rotateRight();else if(O===1&&L===-1)M.right=h[R+1][1]=h[R+1][1].rotateRight(),h[R][1]=M.rotateLeft();else if(O===-1&&L===1)M.left=h[R+1][1]=h[R+1][1].rotateLeft(),h[R][1]=M.rotateRight();else throw new Error;if(R>0)switch(h[R-1][0]){case-1:h[R-1][1].left=h[R][1];break;case 1:h[R-1][1].right=h[R][1];break;case 0:h[R-1][1].mid=h[R][1];break}else this._root=h[0][1]}}return v}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let l=this._root;for(;l;){const a=o.cmp(l.segment);if(a>0)l=l.left;else if(a<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else break}return l}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const l=this._iter.reset(i),a=[];let h=this._root;for(;h;){const v=l.cmp(h.segment);if(v>0)a.push([-1,h]),h=h.left;else if(v<0)a.push([1,h]),h=h.right;else if(l.hasNext())l.next(),a.push([0,h]),h=h.mid;else break}if(!!h){if(o?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const v=this._min(h.right),{key:R,value:M,segment:F}=v;this._delete(v.key,!1),h.key=R,h.value=M,h.segment=F}else{const v=h.left??h.right;if(a.length>0){const[R,M]=a[a.length-1];switch(R){case-1:M.left=v;break;case 0:M.mid=v;break;case 1:M.right=v;break}}else this._root=v}for(let v=a.length-1;v>=0;v--){const R=a[v][1];R.updateHeight();const M=R.balanceFactor();if(M>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),a[v][1]=R.rotateLeft()):M<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),a[v][1]=R.rotateRight()),v>0)switch(a[v-1][0]){case-1:a[v-1][1].left=a[v][1];break;case 1:a[v-1][1].right=a[v][1];break;case 0:a[v-1][1].mid=a[v][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let l=this._root,a;for(;l;){const h=o.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(o.hasNext())o.next(),a=l.value||a,l=l.mid;else break}return l&&l.value||a}findSuperstr(i){const o=this._iter.reset(i);let l=this._root;for(;l;){const a=o.cmp(l.segment);if(a>0)l=l.left;else if(a<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(i){for(const[o,l]of this)i(l,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const o=[];return this._dfsEntries(i,o),o[Symbol.iterator]()}_dfsEntries(i,o){!i||(i.left&&this._dfsEntries(i.left,o),i.value&&o.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,o),i.right&&this._dfsEntries(i.right,o))}_isBalanced(){const i=o=>{if(!o)return!0;const l=o.balanceFactor();return l<-1||l>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=p;class g{constructor(i,o){this.uri=i,this.value=o}}class u{constructor(i,o){this[k]="ResourceMap",i instanceof u?(this.map=new Map(i.map),this.toKey=o??u.defaultToKey):(this.map=new Map,this.toKey=i??u.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),new g(i,o)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o!="undefined"&&(i=i.bind(o));for(const[l,a]of this.map)i(a.value,a.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=u,u.defaultToKey=t=>t.toString();class f{constructor(i,o){this[T]="ResourceSet",!i||typeof i=="function"?this._map=new u(i):(this._map=new u(o),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,o){this._map.forEach((l,a)=>i.call(o,a,a,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class s{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const l=this._map.get(i);if(!!l)return o!==0&&this.touch(l,o),l.value}set(i,o,l=0){let a=this._map.get(i);if(a)a.value=o,l!==0&&this.touch(a,l);else{switch(a={key:i,value:o,next:void 0,previous:void 0},l){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const l=this._state;let a=this._head;for(;a;){if(o?i.bind(o)(a.value,a.key,this):i(a.value,a.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,o=this._state;let l=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const h={value:l.key,done:!1};return l=l.next,h}else return{value:void 0,done:!0}}};return a}values(){const i=this,o=this._state;let l=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const h={value:l.value,done:!1};return l=l.next,h}else return{value:void 0,done:!0}}};return a}entries(){const i=this,o=this._state;let l=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const h={value:[l.key,l.value],done:!1};return l=l.next,h}else return{value:void 0,done:!0}}};return a}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,l=this.size;for(;o&&l>i;)this._map.delete(o.key),o=o.next,l--;this._head=o,this._size=l,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,l=i.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const l=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(l.previous=a,a.next=l),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const l=i.next,a=i.previous;i===this._head?(l.previous=void 0,this._head=l):(l.previous=a,a.next=l),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,l)=>{i.push([l,o])}),i}fromJSON(i){this.clear();for(const[o,l]of i)this.set(o,l)}}e.LinkedMap=s;class r extends s{constructor(i,o=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r}),define(ne[79],se([0,1,34]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new D.LRUCache(1e4);function k(I){return P(I,"NFC",n)}e.normalizeNFC=k;const T=new D.LRUCache(1e4);function A(I){return P(I,"NFD",T)}e.normalizeNFD=A;const b=/[^\u0000-\u0080]/;function P(I,E,w){if(!I)return I;const m=w.get(I);if(m)return m;let y;return b.test(I)?y=I.normalize(E):y=I,w.set(I,y),y}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(E){return A(E).replace(I,"")}}()}),define(ne[80],se([0,1,24]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(n||(n={})),function(k){const T="error",A="warning",b="warn",P="info",I="ignore";function E(m){return m?D.equalsIgnoreCase(T,m)?k.Error:D.equalsIgnoreCase(A,m)||D.equalsIgnoreCase(b,m)?k.Warning:D.equalsIgnoreCase(P,m)?k.Info:k.Ignore:k.Ignore}k.fromValue=E;function w(m){switch(m){case k.Error:return T;case k.Warning:return A;case k.Info:return P;default:return I}}k.toString=w}(n||(n={})),e.default=n}),define(ne[7],se([0,1,9,4]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function b(t,i){if(!t.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!k.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!T.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(t,i){return!t&&!i?"file":t}function I(t,i){switch(t){case"https":case"http":case"file":i?i[0]!==w&&(i=w+i):i=w;break}return i}const E="",w="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(i,o,l,a,h,v=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=P(i,v),this.authority=o||E,this.path=I(this.scheme,l||E),this.query=a||E,this.fragment=h||E,b(this,v))}static isUri(i){return i instanceof y?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:l,path:a,query:h,fragment:v}=i;return o===void 0?o=this.scheme:o===null&&(o=E),l===void 0?l=this.authority:l===null&&(l=E),a===void 0?a=this.path:a===null&&(a=E),h===void 0?h=this.query:h===null&&(h=E),v===void 0?v=this.fragment:v===null&&(v=E),o===this.scheme&&l===this.authority&&a===this.path&&h===this.query&&v===this.fragment?this:new S(o,l,a,h,v)}static parse(i,o=!1){const l=m.exec(i);return l?new S(l[2]||E,r(l[4]||E),r(l[5]||E),r(l[7]||E),r(l[9]||E),o):new S(E,E,E,E,E)}static file(i){let o=E;if(n.isWindows&&(i=i.replace(/\\/g,w)),i[0]===w&&i[1]===w){const l=i.indexOf(w,2);l===-1?(o=i.substring(2),i=w):(o=i.substring(2,l),i=i.substring(l)||w)}return new S("file",o,i,E,E)}static from(i){const o=new S(i.scheme,i.authority,i.path,i.query,i.fragment);return b(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return n.isWindows&&i.scheme==="file"?l=y.file(D.win32.join(u(i,!0),...o)).path:l=D.posix.join(i.path,...o),i.with({path:l})}toString(i=!1){return f(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof y)return i;{const o=new S(i);return o._formatted=i.external,o._fsPath=i._sep===d?i.fsPath:null,o}}else return i}}e.URI=y;const d=n.isWindows?1:void 0;class S extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=d),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(t,i){let o,l=-1;for(let a=0;a<t.length;a++){const h=t.charCodeAt(a);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||i&&h===47)l!==-1&&(o+=encodeURIComponent(t.substring(l,a)),l=-1),o!==void 0&&(o+=t.charAt(a));else{o===void 0&&(o=t.substr(0,a));const v=C[h];v!==void 0?(l!==-1&&(o+=encodeURIComponent(t.substring(l,a)),l=-1),o+=v):l===-1&&(l=a)}}return l!==-1&&(o+=encodeURIComponent(t.substring(l))),o!==void 0?o:t}function g(t){let i;for(let o=0;o<t.length;o++){const l=t.charCodeAt(o);l===35||l===63?(i===void 0&&(i=t.substr(0,o)),i+=C[l]):i!==void 0&&(i+=t[o])}return i!==void 0?i:t}function u(t,i){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?i?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=u;function f(t,i){const o=i?g:p;let l="",{scheme:a,authority:h,path:v,query:R,fragment:M}=t;if(a&&(l+=a,l+=":"),(h||a==="file")&&(l+=w,l+=w),h){let F=h.indexOf("@");if(F!==-1){const O=h.substr(0,F);h=h.substr(F+1),F=O.indexOf(":"),F===-1?l+=o(O,!1):(l+=o(O.substr(0,F),!1),l+=":",l+=o(O.substr(F+1),!1)),l+="@"}h=h.toLowerCase(),F=h.indexOf(":"),F===-1?l+=o(h,!1):(l+=o(h.substr(0,F),!1),l+=h.substr(F))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const F=v.charCodeAt(1);F>=65&&F<=90&&(v=`/${String.fromCharCode(F+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const F=v.charCodeAt(0);F>=65&&F<=90&&(v=`${String.fromCharCode(F+32)}:${v.substr(2)}`)}l+=o(v,!0)}return R&&(l+="?",l+=o(R,!1)),M&&(l+="#",l+=i?M:p(M,!1)),l}function c(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+c(t.substr(3)):t}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(s)?t.replace(s,i=>c(i)):t}}),define(ne[126],se([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(I){const E=I;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=n;function k(I){const E=[];let w;try{const m=JSON.parse(I.arguments),y=m[m.length-1];y&&y.__$stack&&(m.pop(),w=y.__$stack),E.push(...m)}catch{E.push("Unable to log remote console arguments",I.arguments)}return{args:E,stack:w}}e.parse=k;function T(I){if(typeof I!="string")return T(k(I).stack);const E=I;if(E){const w=A(E),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=T;function A(I){if(!I)return I;const E=I.indexOf(`
`);return E===-1?I:I.substring(0,E)}function b(I,E){const{args:w,stack:m}=k(I),y=typeof w[0]=="string"&&w.length===1;let d=A(m);d&&(d=`(${d.trim()})`);let S=[];if(typeof w[0]=="string"?d&&y?S=[`%c[${E}] %c${w[0]} %c${d}`,P("blue"),P(""),P("grey")]:S=[`%c[${E}] %c${w[0]}`,P("blue"),P(""),...w.slice(1)]:S=[`%c[${E}]%`,P("blue"),...w],d&&!y&&S.push(d),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,S)}e.log=b;function P(I){return`color: ${I}`}}),define(ne[63],se([0,1,16,24,7]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(I){return JSON.stringify(I,b)}e.stringify=T;function A(I){let E=JSON.parse(I);return E=P(E),E}e.parse=A;function b(I,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,n.regExpFlags)(E)}:E}function P(I,E=0){if(!I||E>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return k.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof D.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let w=0;w<I.length;++w)I[w]=P(I[w],E+1);else for(const w in I)Object.hasOwnProperty.call(I,w)&&(I[w]=P(I[w],E+1))}return I}e.revive=P}),define(ne[20],se([0,1,4,7]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${k.vscodeRemoteResource}`}set(P,I,E){this._hosts[P]=I,this._ports[P]=E}setConnectionToken(P,I){this._connectionTokens[P]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const I=P.authority;let E=this._hosts[I];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const w=this._ports[I],m=this._connectionTokens[I];let y=`path=${encodeURIComponent(P.path)}`;return typeof m=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${E}:${w}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new T;class A{asBrowserUri(P,I){const E=this.toUri(P,I);return E.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===k.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${k.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?E.with({scheme:k.vscodeFileResource,authority:E.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(P,I){const E=this.toUri(P,I);return E.scheme===k.vscodeFileResource?E.with({scheme:k.file,authority:E.authority!==A.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(P,I){return n.URI.isUri(P)?P:n.URI.parse(I.toUrl(P))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(ne[17],se([0,1,46,20,9,4,24,7]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(y){return(0,b.uriToFsPath)(y,!0)}e.originalFSPath=P;class I{constructor(d){this._ignorePathCasing=d}compare(d,S,C=!1){return d===S?0:(0,A.compare)(this.getComparisonKey(d,C),this.getComparisonKey(S,C))}isEqual(d,S,C=!1){return d===S?!0:!d||!S?!1:this.getComparisonKey(d,C)===this.getComparisonKey(S,C)}getComparisonKey(d,S=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,S,C=!1){if(d.scheme===S.scheme){if(d.scheme===n.Schemas.file)return D.isEqualOrParent(P(d),P(S),this._ignorePathCasing(d))&&d.query===S.query&&(C||d.fragment===S.fragment);if((0,e.isEqualAuthority)(d.authority,S.authority))return D.isEqualOrParent(d.path,S.path,this._ignorePathCasing(d),"/")&&d.query===S.query&&(C||d.fragment===S.fragment)}return!1}joinPath(d,...S){return b.URI.joinPath(d,...S)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let S;return d.scheme===n.Schemas.file?S=b.URI.file(k.dirname(P(d))).path:(S=k.posix.dirname(d.path),d.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),S="/")),d.with({path:S})}normalizePath(d){if(!d.path.length)return d;let S;return d.scheme===n.Schemas.file?S=b.URI.file(k.normalize(P(d))).path:S=k.posix.normalize(d.path),d.with({path:S})}relativePath(d,S){if(d.scheme!==S.scheme||!(0,e.isEqualAuthority)(d.authority,S.authority))return;if(d.scheme===n.Schemas.file){const g=k.relative(P(d),P(S));return T.isWindows?D.toSlashes(g):g}let C=d.path||"/";const p=S.path||"/";if(this._ignorePathCasing(d)){let g=0;for(const u=Math.min(C.length,p.length);g<u&&!(C.charCodeAt(g)!==p.charCodeAt(g)&&C.charAt(g).toLowerCase()!==p.charAt(g).toLowerCase());g++);C=p.substr(0,g)+C.substr(g)}return k.posix.relative(C,p)}resolvePath(d,S){if(d.scheme===n.Schemas.file){const C=b.URI.file(k.resolve(P(d),S));return d.with({authority:C.authority,path:C.path})}return S=D.toPosixPath(S),d.with({path:k.posix.resolve(d.path,S)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,S){return d===S||d!==void 0&&S!==void 0&&(0,A.equalsIgnoreCase)(d,S)}hasTrailingPathSeparator(d,S=k.sep){if(d.scheme===n.Schemas.file){const C=P(d);return C.length>D.getRoot(C).length&&C[C.length-1]===S}else{const C=d.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,S=k.sep){return(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,S=k.sep){let C=!1;if(d.scheme===n.Schemas.file){const p=P(d);C=p!==void 0&&p.length===D.getRoot(p).length&&p[p.length-1]===S}else{S="/";const p=d.path;C=p.length===1&&p.charCodeAt(p.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path+"/"}):d}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(y=>y.scheme===n.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new I(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(y,d){const S=[];for(let C=0;C<y.length;C++){const p=d(y[C]);y.some((g,u)=>u===C?!1:(0,e.isEqualOrParent)(p,d(g)))||S.push(y[C])}return S}e.distinctParents=E;var w;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(S){const C=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(u=>{const[f,c]=u.split(":");f&&c&&C.set(f,c)});const g=S.path.substring(0,S.path.indexOf(";"));return g&&C.set(y.META_DATA_MIME,g),C}y.parseMetaData=d})(w=e.DataUri||(e.DataUri={}));function m(y,d,S){if(d){let C=y.path;return C&&C[0]!==k.posix.sep&&(C=k.posix.sep+C),y.with({scheme:S,authority:d,path:C})}return y.with({scheme:S})}e.toLocalResource=m}),define(ne[6],se([0,1,21,10,3,2,17,4]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(V){return!!V&&typeof V.then=="function"}e.isThenable=P;function I(V){const _=new D.CancellationTokenSource,U=V(_.token),j=new Promise((B,X)=>{const oe=_.token.onCancellationRequested(()=>{oe.dispose(),_.dispose(),X(new n.CancellationError)});Promise.resolve(U).then(J=>{oe.dispose(),_.dispose(),B(J)},J=>{oe.dispose(),_.dispose(),X(J)})});return new class{cancel(){_.cancel()}then(B,X){return j.then(B,X)}catch(B){return this.then(void 0,B)}finally(B){return j.finally(B)}}}e.createCancelablePromise=I;function E(V,_,U){return new Promise((j,B)=>{const X=_.onCancellationRequested(()=>{X.dispose(),j(U)});V.then(j,B).finally(()=>X.dispose())})}e.raceCancellation=E;function w(V,_){return new Promise((U,j)=>{const B=_.onCancellationRequested(()=>{B.dispose(),j(new n.CancellationError)});V.then(U,j).finally(()=>B.dispose())})}e.raceCancellationError=w;async function m(V){let _=-1;const U=V.map((B,X)=>B.then(oe=>(_=X,oe))),j=await Promise.race(U);return V.forEach((B,X)=>{X!==_&&B.cancel()}),j}e.raceCancellablePromises=m;function y(V,_,U){let j;const B=setTimeout(()=>{j?.(void 0),U?.()},_);return Promise.race([V.finally(()=>clearTimeout(B)),new Promise(X=>j=X)])}e.raceTimeout=y;function d(V){return new Promise((_,U)=>{const j=V();P(j)?j.then(_,U):_(j)})}e.asPromise=d;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(U,U).then(j)})}return new Promise((U,j)=>{this.queuedPromise.then(U,j)})}return this.activePromise=_(),new Promise((U,j)=>{this.activePromise.then(B=>{this.activePromise=null,U(B)},B=>{this.activePromise=null,j(B)})})}}e.Throttler=S;class C{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=C;class p{constructor(){this.promiseMap=new Map}queue(_,U){const B=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(_)===B&&this.promiseMap.delete(_)});return this.promiseMap.set(_,B),B}}e.SequencerByKey=p;const g=(V,_)=>{let U=!0;const j=setTimeout(()=>{U=!1,_()},V);return{isTriggered:()=>U,dispose:()=>{clearTimeout(j),U=!1}}},u=V=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,V())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(_){this.defaultDelay=_,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,U=this.defaultDelay){this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,X)=>{this.doResolve=B,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}}));const j=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===e.MicrotaskDelay?u(j):g(U,j),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class c{constructor(_){this.delayer=new f(_),this.throttler=new S}trigger(_,U){return this.delayer.trigger(()=>this.throttler.queue(_),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class s{constructor(){this._isOpen=!1,this._promise=new Promise((_,U)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class r extends s{constructor(_){super();this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function t(V,_){return _?new Promise((U,j)=>{const B=setTimeout(()=>{X.dispose(),U()},V),X=_.onCancellationRequested(()=>{clearTimeout(B),X.dispose(),j(new n.CancellationError)})}):I(U=>t(V,U))}e.timeout=t;function i(V,_=0){const U=setTimeout(V,_);return(0,T.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=i;function o(V){const _=[];let U=0;const j=V.length;function B(){return U<j?V[U++]():null}function X(oe){oe!=null&&_.push(oe);const J=B();return J?J.then(X):Promise.resolve(_)}return Promise.resolve(null).then(X)}e.sequence=o;function l(V,_=j=>!!j,U=null){let j=0;const B=V.length,X=()=>{if(j>=B)return Promise.resolve(U);const oe=V[j++];return Promise.resolve(oe()).then(ie=>_(ie)?Promise.resolve(ie):X())};return X()}e.first=l;function a(V,_=j=>!!j,U=null){if(V.length===0)return Promise.resolve(U);let j=V.length;const B=()=>{j=-1;for(const X of V)X.cancel?.()};return new Promise((X,oe)=>{for(const J of V)J.then(ie=>{--j>=0&&_(ie)?(B(),X(ie)):j===0&&X(U)}).catch(ie=>{--j>=0&&(B(),oe(ie))})})}e.firstParallel=a;class h{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(_){return this._size++,new Promise((U,j)=>{this.outstandingPromises.push({factory:_,c:U,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const U=_.factory();U.then(_.c,_.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class v extends h{constructor(){super(1)}}e.Queue=v;class R{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const _=new W;return this.drainers.add(_),_.p}isDrained(){for(const[,_]of this.queues)if(_.size>0)return!1;return!0}queueFor(_,U=A.extUri){const j=U.getComparisonKey(_);let B=this.queues.get(j);return B||(B=new v,k.Event.once(B.onDrained)(()=>{B?.dispose(),this.queues.delete(j),this.onDidQueueDrain()}),this.queues.set(j,B)),B}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const _ of this.drainers)_.complete();this.drainers.clear()}dispose(){for(const[,_]of this.queues)_.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=R;class M{constructor(_,U){this._token=-1,typeof _=="function"&&typeof U=="number"&&this.setIfNotSet(_,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},U)}setIfNotSet(_,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},U))}}e.TimeoutTimer=M;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setInterval(()=>{_()},U)}}e.IntervalTimer=F;class O{constructor(_,U){this.timeoutToken=-1,this.runner=_,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=O;class L{constructor(_,U){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=L;class N extends O{constructor(_,U){super(_,U);this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner?.(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class $ extends T.Disposable{constructor(_,U){super();this.options=_,this.handler=U,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.options.maxBufferedWork)return!1}else if(this.pending+_.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(..._),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,b.setTimeout0)(()=>{if(_)return;const U=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(V,_)=>{const U=requestIdleCallback(V,typeof _=="number"?{timeout:_}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(U))}}}}();class H{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function Y(V,_,U){let j;for(let B=0;B<U;B++)try{return await V()}catch(X){j=X,await t(_)}throw j}e.retry=Y;class te{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(_,U,j){return this._pending={taskId:_,cancel:()=>j?.(),promise:U},U.then(()=>this.donePending(_),()=>this.donePending(_)),U}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let U,j;const B=new Promise((X,oe)=>{U=X,j=oe});this._next={run:_,promise:B,promiseResolve:U,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=te;class q{constructor(_,U=()=>Date.now()){this.interval=_,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const _=this.nowFn();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,U)=>{this.completeCallback=_,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(_){return new Promise(U=>{this.completeCallback(_),this.resolved=!0,U()})}error(_){return new Promise(U=>{this.errorCallback(_),this.rejected=!0,U()})}cancel(){new Promise(_=>{this.errorCallback(new n.CancellationError),this.rejected=!0,_()})}}e.DeferredPromise=W;var x;(function(V){async function _(j){let B;const X=await Promise.all(j.map(oe=>oe.then(J=>J,J=>{B||(B=J)})));if(typeof B!="undefined")throw B;return X}V.settled=_;function U(j){return new Promise(async(B,X)=>{try{await j(B,X)}catch(oe){X(oe)}})}V.withAsyncBody=U})(x=e.Promises||(e.Promises={}));var K;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(K||(K={}));class ee{constructor(_){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const U={emitOne:j=>this.emitOne(j),emitMany:j=>this.emitMany(j),reject:j=>this.reject(j)};try{await Promise.resolve(_(U)),this.resolve()}catch(j){this.reject(j)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}static fromArray(_){return new ee(U=>{U.emitMany(_)})}static fromPromise(_){return new ee(async U=>{U.emitMany(await _)})}static fromPromises(_){return new ee(async U=>{await Promise.all(_.map(async j=>U.emitOne(await j)))})}static merge(_){return new ee(async U=>{await Promise.all(_.map(async j=>{for await(const B of j)U.emitOne(B)}))})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(_<this._results.length)return{done:!1,value:this._results[_++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(_,U){return new ee(async j=>{for await(const B of _)j.emitOne(U(B))})}map(_){return ee.map(this,_)}static filter(_,U){return new ee(async j=>{for await(const B of _)U(B)&&j.emitOne(B)})}filter(_){return ee.filter(this,_)}static coalesce(_){return ee.filter(_,U=>!!U)}coalesce(){return ee.coalesce(this)}static async toPromise(_){const U=[];for await(const j of _)U.push(j);return U}toPromise(){return ee.toPromise(this)}emitOne(_){this._state===0&&(this._results.push(_),this._onStateChanged.fire())}emitMany(_){this._state===0&&(this._results=this._results.concat(_),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(_){this._state===0&&(this._state=2,this._error=_,this._onStateChanged.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class ce extends ee{constructor(_,U){super(U);this._source=_}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function z(V){const _=new D.CancellationTokenSource,U=V(_.token);return new ce(_,async j=>{const B=_.token.onCancellationRequested(()=>{B.dispose(),_.dispose(),j.reject(new n.CancellationError)});try{for await(const X of U){if(_.token.isCancellationRequested)return;j.emitOne(X)}B.dispose(),_.dispose()}catch(X){B.dispose(),_.dispose(),j.reject(X)}})}e.createCancelableAsyncIterable=z}),define(ne[81],se([0,1,18,6,46,34,9,4,24]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",w="[^/\\\\]",m=/\//g;function y(W,x){switch(W){case 0:return"";case 1:return`${w}*?`;default:return`(?:${E}|${w}+${E}${x?`|${E}${w}+`:""})*?`}}function d(W,x){if(!W)return[];const K=[];let ee=!1,ce=!1,z="";for(const V of W){switch(V){case x:if(!ee&&!ce){K.push(z),z="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}z+=V}return z&&K.push(z),K}e.splitGlobAware=d;function S(W){if(!W)return"";let x="";const K=d(W,e.GLOB_SPLIT);if(K.every(ee=>ee===e.GLOBSTAR))x=".*";else{let ee=!1;K.forEach((ce,z)=>{if(ce===e.GLOBSTAR){if(ee)return;x+=y(2,z===K.length-1)}else{let V=!1,_="",U=!1,j="";for(const B of ce){if(B!=="}"&&V){_+=B;continue}if(U&&(B!=="]"||!j)){let X;B==="-"?X=B:(B==="^"||B==="!")&&!j?X="^":B===e.GLOB_SPLIT?X="":X=(0,P.escapeRegExpCharacters)(B),j+=X;continue}switch(B){case"{":V=!0;continue;case"[":U=!0;continue;case"}":{x+=`(?:${d(_,",").map(J=>S(J)).join("|")})`,V=!1,_="";break}case"]":{x+="["+j+"]",U=!1,j="";break}case"?":x+=w;continue;case"*":x+=y(1);continue;default:x+=(0,P.escapeRegExpCharacters)(B)}}z<K.length-1&&(K[z+1]!==e.GLOBSTAR||z+2<K.length)&&(x+=E)}ee=ce===e.GLOBSTAR})}return x}const C=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new T.LRUCache(1e4),r=function(){return!1},t=function(){return null};function i(W,x){if(!W)return t;let K;typeof W!="string"?K=W.pattern:K=W,K=K.trim();const ee=`${K}_${!!x.trimForExclusions}`;let ce=s.get(ee);if(ce)return o(ce,W);let z;return C.test(K)?ce=a(K.substr(4),K):(z=p.exec(l(K,x)))?ce=h(z[1],K):(x.trimForExclusions?u:g).test(K)?ce=v(K,x):(z=f.exec(l(K,x)))?ce=R(z[1].substr(1),K,!0):(z=c.exec(l(K,x)))?ce=R(z[1],K,!1):ce=M(K),s.set(ee,ce),o(ce,W)}function o(W,x){if(typeof x=="string")return W;const K=function(ee,ce){return(0,k.isEqualOrParent)(ee,x.base,!b.isLinux)?W(ee.substr(x.base.length+1),ce):null};return K.allBasenames=W.allBasenames,K.allPaths=W.allPaths,K.basenames=W.basenames,K.patterns=W.patterns,K}function l(W,x){return x.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function a(W,x){return function(K,ee){return typeof K=="string"&&K.endsWith(W)?x:null}}function h(W,x){const K=`/${W}`,ee=`\\${W}`,ce=function(V,_){return typeof V!="string"?null:_?_===W?x:null:V===W||V.endsWith(K)||V.endsWith(ee)?x:null},z=[W];return ce.basenames=z,ce.patterns=[x],ce.allBasenames=z,ce}function v(W,x){const K=te(W.slice(1,-1).split(",").map(_=>i(_,x)).filter(_=>_!==t),W),ee=K.length;if(!ee)return t;if(ee===1)return K[0];const ce=function(_,U){for(let j=0,B=K.length;j<B;j++)if(K[j](_,U))return W;return null},z=K.find(_=>!!_.allBasenames);z&&(ce.allBasenames=z.allBasenames);const V=K.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return V.length&&(ce.allPaths=V),ce}function R(W,x,K){const ee=A.sep===A.posix.sep,ce=ee?W:W.replace(m,A.sep),z=A.sep+ce,V=A.posix.sep+W;let _;return K?_=function(U,j){return typeof U=="string"&&(U===ce||U.endsWith(z)||!ee&&(U===W||U.endsWith(V)))?x:null}:_=function(U,j){return typeof U=="string"&&(U===ce||!ee&&U===W)?x:null},_.allPaths=[(K?"*/":"./")+W],_}function M(W){try{const x=new RegExp(`^${S(W)}$`);return function(K){return x.lastIndex=0,typeof K=="string"&&x.test(K)?W:null}}catch{return t}}function F(W,x,K){return!W||typeof x!="string"?!1:O(W)(x,void 0,K)}e.match=F;function O(W,x={}){if(!W)return r;if(typeof W=="string"||L(W)){const K=i(W,x);if(K===t)return r;const ee=function(ce,z){return!!K(ce,z)};return K.allBasenames&&(ee.allBasenames=K.allBasenames),K.allPaths&&(ee.allPaths=K.allPaths),ee}return H(W,x)}e.parse=O;function L(W){const x=W;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=L;function N(W){return W.allBasenames||[]}e.getBasenameTerms=N;function $(W){return W.allPaths||[]}e.getPathTerms=$;function H(W,x){const K=te(Object.getOwnPropertyNames(W).map(_=>Y(_,W[_],x)).filter(_=>_!==t)),ee=K.length;if(!ee)return t;if(!K.some(_=>!!_.requiresSiblings)){if(ee===1)return K[0];const _=function(B,X){let oe;for(let J=0,ie=K.length;J<ie;J++){const re=K[J](B,X);if(typeof re=="string")return re;(0,n.isThenable)(re)&&(oe||(oe=[]),oe.push(re))}return oe?(async()=>{for(const J of oe){const ie=await J;if(typeof ie=="string")return ie}return null})():null},U=K.find(B=>!!B.allBasenames);U&&(_.allBasenames=U.allBasenames);const j=K.reduce((B,X)=>X.allPaths?B.concat(X.allPaths):B,[]);return j.length&&(_.allPaths=j),_}const ce=function(_,U,j){let B,X;for(let oe=0,J=K.length;oe<J;oe++){const ie=K[oe];ie.requiresSiblings&&j&&(U||(U=(0,A.basename)(_)),B||(B=U.substr(0,U.length-(0,A.extname)(_).length)));const re=ie(_,U,B,j);if(typeof re=="string")return re;(0,n.isThenable)(re)&&(X||(X=[]),X.push(re))}return X?(async()=>{for(const oe of X){const J=await oe;if(typeof J=="string")return J}return null})():null},z=K.find(_=>!!_.allBasenames);z&&(ce.allBasenames=z.allBasenames);const V=K.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return V.length&&(ce.allPaths=V),ce}function Y(W,x,K){if(x===!1)return t;const ee=i(W,K);if(ee===t)return t;if(typeof x=="boolean")return ee;if(x){const ce=x.when;if(typeof ce=="string"){const z=(V,_,U,j)=>{if(!j||!ee(V,_))return null;const B=ce.replace("$(basename)",U),X=j(B);return(0,n.isThenable)(X)?X.then(oe=>oe?W:null):X?W:null};return z.requiresSiblings=!0,z}}return ee}function te(W,x){const K=W.filter(_=>!!_.basenames);if(K.length<2)return W;const ee=K.reduce((_,U)=>{const j=U.basenames;return j?_.concat(j):_},[]);let ce;if(x){ce=[];for(let _=0,U=ee.length;_<U;_++)ce.push(x)}else ce=K.reduce((_,U)=>{const j=U.patterns;return j?_.concat(j):_},[]);const z=function(_,U){if(typeof _!="string")return null;if(!U){let B;for(B=_.length;B>0;B--){const X=_.charCodeAt(B-1);if(X===47||X===92)break}U=_.substr(B)}const j=ee.indexOf(U);return j!==-1?ce[j]:null};z.basenames=ee,z.patterns=ce,z.allBasenames=ee;const V=W.filter(_=>!_.basenames);return V.push(z),V}function q(W,x){return(0,D.equals)(W,x,(K,ee)=>typeof K=="string"&&typeof ee=="string"?K===ee:typeof K!="string"&&typeof ee!="string"?K.base===ee.base&&K.pattern===ee.pattern:!1)}e.patternsEquals=q}),define(ne[127],se([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(E){return E.toJSON()}class k{constructor(w){this._uriTransformer=w}transformIncoming(w){const m=this._uriTransformer.transformIncoming(w);return m===w?w:n(D.URI.from(m))}transformOutgoing(w){const m=this._uriTransformer.transformOutgoing(w);return m===w?w:n(D.URI.from(m))}transformOutgoingURI(w){const m=this._uriTransformer.transformOutgoing(w);return m===w?w:D.URI.from(m)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function T(E,w,m){if(!E||m>200)return null;if(typeof E=="object"){if(E instanceof D.URI)return w.transformOutgoing(E);for(const y in E)if(Object.hasOwnProperty.call(E,y)){const d=T(E[y],w,m+1);d!==null&&(E[y]=d)}}return null}function A(E,w){const m=T(E,w,0);return m===null?E:m}e.transformOutgoingURIs=A;function b(E,w,m,y){if(!E||y>200)return null;if(typeof E=="object"){if(E.$mid===1)return m?D.URI.revive(w.transformIncoming(E)):w.transformIncoming(E);for(const d in E)if(Object.hasOwnProperty.call(E,d)){const S=b(E[d],w,m,y+1);S!==null&&(E[d]=S)}}return null}function P(E,w){const m=b(E,w,!1,0);return m===null?E:m}e.transformIncomingURIs=P;function I(E,w){const m=b(E,w,!0,0);return m===null?E:m}e.transformAndReviveIncomingURIs=I}),define(ne[128],se([0,1,37,10,34,30,114]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,w=0;const m=(0,D.networkInterfaces)();for(const y in m){const d=m[y];if(d)for(const{mac:S,internal:C}of d)C||(w+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(E+=1))}this._value=w>0?E/w:0}return this._value}};let b;async function P(){return b||(b=(async()=>await I()||T.generateUuid())()),b}e.getMachineId=P;async function I(){try{const E=await new Promise((m,y)=>{Q(["crypto"],m,y)}),w=(0,A.getMac)();return E.createHash("sha256").update(w,"utf8").digest("hex")}catch(E){n.onUnexpectedError(E);return}}}),define(ne[27],se([0,1,53,37,269,6,46,79,9,4,17,7]),function(Q,e,D,n,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function y(H,Y=m.UNLINK){if((0,A.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");return Y===m.UNLINK?S(H):d(H)}async function d(H){try{const Y=(0,A.randomPath)((0,n.tmpdir)());try{await D.promises.rename(H,Y)}catch{return S(H)}S(Y).catch(te=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function S(H){return(0,k.promisify)(D.rm)(H,{recursive:!0,force:!0,maxRetries:3})}function C(H){if((0,A.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=C;async function p(H,Y){return f(await(Y?g(H):(0,k.promisify)(D.readdir)(H)))}async function g(H){try{return await(0,k.promisify)(D.readdir)(H,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const Y=[],te=await p(H);for(const q of te){let W=!1,x=!1,K=!1;try{const ee=await e.Promises.lstat((0,P.join)(H,q));W=ee.isFile(),x=ee.isDirectory(),K=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Y.push({name:q,isFile:()=>W,isDirectory:()=>x,isSymbolicLink:()=>K})}return Y}function u(H){return f(D.readdirSync(H))}e.readdirSync=u;function f(H){return H.map(Y=>typeof Y=="string"?I.isMacintosh?(0,b.normalizeNFC)(Y):Y:(Y.name=I.isMacintosh?(0,b.normalizeNFC)(Y.name):Y.name,Y))}async function c(H){const Y=await p(H),te=[];for(const q of Y)await r.existsDirectory((0,P.join)(H,q))&&te.push(q);return te}function s(H,Y=1e3){return new Promise(te=>{let q=!1;const W=setInterval(()=>{q||(q=!0,D.access(H,x=>{q=!1,x&&(clearInterval(W),te(void 0))}))},Y)})}e.whenDeleted=s;var r;(function(H){async function Y(W){let x;try{if(x=await e.Promises.lstat(W),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(I.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw ee}throw K}}H.stat=Y;async function te(W){try{const{stat:x,symbolicLink:K}=await H.stat(W);return x.isFile()&&K?.dangling!==!0}catch{}return!1}H.existsFile=te;async function q(W){try{const{stat:x,symbolicLink:K}=await H.stat(W);return x.isDirectory()&&K?.dangling!==!0}catch{}return!1}H.existsDirectory=q})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new T.ResourceQueue;function i(H,Y,te){return t.queueFor(w.URI.file(H),E.extUriBiasedIgnorePathCase).queue(()=>{const q=v(te);return new Promise((W,x)=>a(H,Y,q,K=>K?x(K):W()))})}let o=!0;function l(H){o=H}e.configureFlushOnWrite=l;function a(H,Y,te,q){if(!o)return D.writeFile(H,Y,{mode:te.mode,flag:te.flag},q);D.open(H,te.flag,te.mode,(W,x)=>{if(W)return q(W);D.writeFile(x,Y,K=>{if(K)return D.close(x,()=>q(K));D.fdatasync(x,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),l(!1)),D.close(x,ce=>q(ce))))})})}function h(H,Y,te){const q=v(te);if(!o)return D.writeFileSync(H,Y,{mode:q.mode,flag:q.flag});const W=D.openSync(H,q.flag,q.mode);try{D.writeFileSync(W,Y);try{D.fdatasyncSync(W)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),l(!1)}}finally{D.closeSync(W)}}e.writeFileSync=h;function v(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function R(H,Y){if(H!==Y)try{await e.Promises.rename(H,Y)}catch(te){if(H.toLowerCase()!==Y.toLowerCase()&&te.code==="EXDEV"||H.endsWith("."))await M(H,Y,{preserveSymlinks:!1}),await y(H,m.MOVE);else throw te}}async function M(H,Y,te){return O(H,Y,{root:{source:H,target:Y},options:te,handledSourcePaths:new Set})}const F=511;async function O(H,Y,te){if(te.handledSourcePaths.has(H))return;te.handledSourcePaths.add(H);const{stat:q,symbolicLink:W}=await r.stat(H);if(W){if(te.options.preserveSymlinks)try{return await $(H,Y,te)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(W.dangling)return}return q.isDirectory()?L(H,Y,q.mode&F,te):N(H,Y,q.mode&F)}async function L(H,Y,te,q){await e.Promises.mkdir(Y,{recursive:!0,mode:te});const W=await p(H);for(const x of W)await O((0,P.join)(H,x),(0,P.join)(Y,x),q)}async function N(H,Y,te){await e.Promises.copyFile(H,Y),await e.Promises.chmod(Y,te)}async function $(H,Y,te){let q=await e.Promises.readlink(H);(0,A.isEqualOrParent)(q,te.root.source,!I.isLinux)&&(q=(0,P.join)(te.root.target,q.substr(te.root.source.length+1))),await e.Promises.symlink(q,Y)}e.Promises=new class{get access(){return(0,k.promisify)(D.access)}get stat(){return(0,k.promisify)(D.stat)}get lstat(){return(0,k.promisify)(D.lstat)}get utimes(){return(0,k.promisify)(D.utimes)}get read(){return(H,Y,te,q,W)=>new Promise((x,K)=>{D.read(H,Y,te,q,W,(ee,ce,z)=>ee?K(ee):x({bytesRead:ce,buffer:z}))})}get readFile(){return(0,k.promisify)(D.readFile)}get write(){return(H,Y,te,q,W)=>new Promise((x,K)=>{D.write(H,Y,te,q,W,(ee,ce,z)=>ee?K(ee):x({bytesWritten:ce,buffer:z}))})}get appendFile(){return(0,k.promisify)(D.appendFile)}get fdatasync(){return(0,k.promisify)(D.fdatasync)}get truncate(){return(0,k.promisify)(D.truncate)}get rename(){return(0,k.promisify)(D.rename)}get copyFile(){return(0,k.promisify)(D.copyFile)}get open(){return(0,k.promisify)(D.open)}get close(){return(0,k.promisify)(D.close)}get symlink(){return(0,k.promisify)(D.symlink)}get readlink(){return(0,k.promisify)(D.readlink)}get chmod(){return(0,k.promisify)(D.chmod)}get mkdir(){return(0,k.promisify)(D.mkdir)}get unlink(){return(0,k.promisify)(D.unlink)}get rmdir(){return(0,k.promisify)(D.rmdir)}get realpath(){return(0,k.promisify)(D.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return y}get move(){return R}get copy(){return M}}}),define(ne[129],se([0,1,53,9,4,24,27]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(m){if(k.isLinux)return m;const y=(0,n.dirname)(m);if(m===y)return m;const d=((0,n.basename)(m)||m).toLowerCase();try{const C=(0,A.readdirSync)(y).filter(p=>p.toLowerCase()===d);if(C.length===1){const p=b(y);if(p)return(0,n.join)(p,C[0])}else if(C.length>1){const p=C.indexOf(d);if(p>=0){const g=b(y);if(g)return(0,n.join)(g,C[p])}}}catch{}return null}e.realcaseSync=b;async function P(m){if(k.isLinux)return m;const y=(0,n.dirname)(m);if(m===y)return m;const d=((0,n.basename)(m)||m).toLowerCase();try{const C=(await A.Promises.readdir(y)).filter(p=>p.toLowerCase()===d);if(C.length===1){const p=await P(y);if(p)return(0,n.join)(p,C[0])}else if(C.length>1){const p=C.indexOf(d);if(p>=0){const g=await P(y);if(g)return(0,n.join)(g,C[p])}}}catch{}return null}e.realcase=P;async function I(m){try{return await A.Promises.realpath(m)}catch{const d=w(m);return await A.Promises.access(d,D.constants.R_OK),d}}e.realpath=I;function E(m){try{return D.realpathSync(m)}catch{const d=w(m);return D.accessSync(d,D.constants.R_OK),d}}e.realpathSync=E;function w(m){return(0,T.rtrim)((0,n.normalize)(m),n.sep)}}),define(ne[82],se([0,1,37,9,27]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var P;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(P||(P={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class w{constructor(c,s,r){this.exePath=c,this.displayName=s,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:f=!1}={}){return f?I===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:f=!1,findPreview:c=!1}={}){const s=m({useAlternateBitness:f});if(!s)return null;const r=n.join(s,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const a of await k.Promises.readdir(r)){let h=-1;if(c){const R=a.indexOf("-");if(R<0)continue;const M=a.substring(0,R);if(!T.test(M)||a.substring(R+1)!=="preview")continue;h=parseInt(M,10)}else{if(!T.test(a))continue;h=parseInt(a,10)}if(h<=t)continue;const v=n.join(r,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(v)||(i=v,t=h)}if(!i)return null;const o=s.includes("x86")?" (x86)":"",l=c?" Preview":"";return new w(i,`PowerShell${l}${o}`,!0)}async function d({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:s,pwshMsixName:r}=f?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(c))if(s.test(t)){const i=n.join(c,t,"pwsh.exe");return new w(i,r)}return null}function S(){const f=n.join(D.homedir(),".dotnet","tools","pwsh.exe");return new w(f,".NET Core PowerShell Global Tool")}function C(){const f=n.join(process.env.windir,I===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(f,"Windows PowerShell",!0)}async function*p(){let f=await y();f&&(yield f),f=await y({useAlternateBitness:!0}),f&&(yield f),f=await d(),f&&(yield f),f=S(),f&&(yield f),f=await y({findPreview:!0}),f&&(yield f),f=await d({findPreview:!0}),f&&(yield f),f=await y({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=C(),f&&(yield f)}async function*g(){for await(const f of p())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=g;async function u(){for await(const f of g())return f;return null}e.getFirstAvailablePowerShellInstallation=u}),define(ne[83],se([0,1,9,4,36,77,14,27]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function P(w=k.env){return w.comspec||"cmd.exe"}e.getWindowsShell=P;function I(w){let m=[],y=!1;const d=function(S){if(y){m.push(S);return}(!w.send(S,p=>{if(p&&console.error(p),y=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(u=>d(u))}})||n.isWindows)&&(y=!0)};return{send:d}}e.createQueuedSender=I;var E;(function(w){async function m(y,d,S){if(D.isAbsolute(y))return y;if(d===void 0&&(d=k.cwd()),D.dirname(y)!=="."||(S===void 0&&A.isString(k.env.PATH)&&(S=k.env.PATH.split(D.delimiter)),S===void 0||S.length===0))return D.join(d,y);async function p(g){if(await b.Promises.exists(g)){let u;try{u=await b.Promises.stat(g)}catch(f){f.message.startsWith("EACCES")&&(u=await b.Promises.lstat(g))}return u?!u.isDirectory():!1}return!1}for(const g of S){let u;if(D.isAbsolute(g)?u=D.join(g,y):u=D.join(d,g,y),await p(u))return u;let f=u+".com";if(await p(f)||(f=u+".exe",await p(f)))return f}return D.join(d,y)}w.findExecutable=m})(E=e.win32||(e.win32={}))}),define(ne[130],se([0,1,54,20]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((b,P)=>{let I;const E=new Map;function w(y,d,S,C,p){const g=E.get(d);if(y===A||g){const u={name:m(S),cmd:S,pid:y,ppid:d,load:C,mem:p};E.set(y,u),y===A&&(I=u),g&&(g.children||(g.children=[]),g.children.push(u),g.children.length>1&&(g.children=g.children.sort((f,c)=>f.pid-c.pid)))}}function m(y){const d=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,C=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,u=/--crashes-directory/,f=/\\pipe\\winpty-control/,c=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(u.exec(y))return"electron-crash-reporter";if(f.exec(y))return"winpty-process";if(c.exec(y))return"console-window-host (Windows internal process)";let r=s.exec(y);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(y)?"shared-process":S.exec(y)?"issue-reporter":C.exec(y)?"process-explorer":"window";if(r[1]==="utility"){if(p.exec(y))return"utility-network-service";if(g.exec(y))return"extension-host"}return r[1]}const t=/[a-zA-Z-]+\.js/g;let i="";do r=t.exec(y),r&&(i+=r+" ");while(r);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,S)=>{Q(["windows-process-tree"],d,S)}).then(d=>{d.getProcessList(A,S=>{if(!S){P(new Error(`Root process ${A} not found`));return}d.getProcessCpuUsage(S,C=>{const p=new Map;C.forEach(g=>{const u=y(g.commandLine||"");p.set(g.pid,{name:m(u),cmd:u,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),I=p.get(A),I?(p.forEach(g=>{const u=p.get(g.ppid);u&&(u.children||(u.children=[]),u.children.push(g))}),p.forEach(g=>{g.children&&(g.children=g.children.sort((u,f)=>u.pid-f.pid))}),b(I)):P(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[I];const S=[];for(;d.length;){const p=d.shift();p&&(S.push(p.pid),p.children&&(d=d.concat(p.children)))}let C=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);C+=" "+S.join(" "),(0,D.exec)(C,{},(p,g,u)=>{if(p||u)P(p||new Error(u.toString()));else{const f=g.toString().split(`
`);for(let c=0;c<S.length;c++){const s=E.get(S[c]);s.load=parseFloat(f[c])}if(!I){P(new Error(`Root process ${A} not found`));return}b(I)}})};(0,D.exec)("which ps",{},(d,S,C)=>{if(d||C)if(process.platform!=="linux")P(d||new Error(C.toString()));else{const p=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,D.exec)(p,{},(g,u,f)=>{g||f?P(g||new Error(f.toString())):(T(u,w),y())})}else{const p=S.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${p} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,f,c)=>{u||c&&!c.includes("screen size is bogus")?P(u||new Error(c.toString())):(T(f,w),process.platform==="linux"?y():I?b(I):P(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function T(A,b){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=A.toString().split(`
`);for(const E of I){const w=P.exec(E.trim());w&&w.length===6&&b(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(ne[131],se([0,1,37,4,82,83]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(y,d){return y===1?n.isWindows?w():T.getWindowsShell(d):I(y,d)}e.getSystemShell=A;function b(y,d){return y===1?n.isWindows?m(d):T.getWindowsShell(d):I(y,d)}e.getSystemShellSync=b;let P=null;function I(y,d){if(n.isLinux&&y===2||n.isMacintosh&&y===3)return"/bin/bash";if(!P){let S;if(n.isWindows)S="/bin/bash";else{if(S=d.SHELL,!S)try{S=(0,D.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}P=S}return P}let E=null;async function w(){return E||(E=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),E}function m(y){if(E)return E;const d=n.isWindows&&parseFloat((0,D.release)())>=10,S=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${y.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?C:T.getWindowsShell(y)}});var me=this&&this.__decorate||function(Q,e,D,n){var k=arguments.length,T=k<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,D):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Q,e,D,n);else for(var b=Q.length-1;b>=0;b--)(A=Q[b])&&(T=(k<3?A(T):k>3?A(e,D,T):A(e,D))||T);return k>3&&T&&Object.defineProperty(e,D,T),T};define(ne[39],se([0,1,18,6,16,21,60,10,3,2,63,24,14]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function C(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(p||(p={}));class g{constructor(x){this.buffer=x,this.pos=0}read(x){const K=this.buffer.slice(this.pos,this.pos+x);return this.pos+=K.byteLength,K}}class u{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var f;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(f||(f={}));function c(W){const x=k.VSBuffer.alloc(4);return x.writeUInt32BE(W,0),x}function s(W){return W.read(4).readUInt32BE(0)}function r(W){const x=k.VSBuffer.alloc(1);return x.writeUInt8(W,0),x}const t={Undefined:r(f.Undefined),String:r(f.String),Buffer:r(f.Buffer),VSBuffer:r(f.VSBuffer),Array:r(f.Array),Object:r(f.Object)},i=typeof Buffer!="undefined";function o(W,x){if(typeof x=="undefined")W.write(t.Undefined);else if(typeof x=="string"){const K=k.VSBuffer.fromString(x);W.write(t.String),W.write(c(K.byteLength)),W.write(K)}else if(i&&Buffer.isBuffer(x)){const K=k.VSBuffer.wrap(x);W.write(t.Buffer),W.write(c(K.byteLength)),W.write(K)}else if(x instanceof k.VSBuffer)W.write(t.VSBuffer),W.write(c(x.byteLength)),W.write(x);else if(Array.isArray(x)){W.write(t.Array),W.write(c(x.length));for(const K of x)o(W,K)}else{const K=k.VSBuffer.fromString(JSON.stringify(x));W.write(t.Object),W.write(c(K.byteLength)),W.write(K)}}function l(W){switch(W.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return W.read(s(W)).toString();case f.Buffer:return W.read(s(W)).buffer;case f.VSBuffer:return W.read(s(W));case f.Array:{const K=s(W),ee=[];for(let ce=0;ce<K;ce++)ee.push(l(W));return ee}case f.Object:return JSON.parse(W.read(s(W)).toString())}}class a{constructor(x,K,ee=null,ce=1e3){this.protocol=x,this.ctx=K,this.logger=ee,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(x,K){this.channels.set(x,K),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const K=this.send([x.type]);this.logger?.logOutgoing(K,0,1,C(x.type));return}case 201:case 202:case 204:case 203:{const K=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(K,x.id,1,C(x.type),x.data);return}}}send(x,K=void 0){const ee=new u;return o(ee,x),o(ee,K),this.sendBuffer(ee.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const K=new g(x),ee=l(K),ce=l(K),z=ee[0];switch(z){case 100:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${d(z)}: ${ee[2]}.${ee[3]}`,ce),this.onPromise({type:z,id:ee[1],channelName:ee[2],name:ee[3],arg:ce});case 102:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${d(z)}: ${ee[2]}.${ee[3]}`,ce),this.onEventListen({type:z,id:ee[1],channelName:ee[2],name:ee[3],arg:ce});case 101:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:ee[1]});case 103:return this.logger?.logIncoming(x.byteLength,ee[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:ee[1]})}}onPromise(x){const K=this.channels.get(x.channelName);if(!K){this.collectPendingRequest(x);return}const ee=new T.CancellationTokenSource;let ce;try{ce=K.call(this.ctx,x.name,x.arg,ee.token)}catch(_){ce=Promise.reject(_)}const z=x.id;ce.then(_=>{this.sendResponse({id:z,data:_,type:201}),this.activeRequests.delete(x.id)},_=>{_ instanceof Error?this.sendResponse({id:z,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:z,data:_,type:203}),this.activeRequests.delete(x.id)});const V=(0,I.toDisposable)(()=>ee.cancel());this.activeRequests.set(x.id,V)}onEventListen(x){const K=this.channels.get(x.channelName);if(!K){this.collectPendingRequest(x);return}const ee=x.id,z=K.listen(this.ctx,x.name,x.arg)(V=>this.sendResponse({id:ee,data:V,type:204}));this.activeRequests.set(x.id,z)}disposeActiveRequest(x){const K=this.activeRequests.get(x.id);K&&(K.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let K=this.pendingRequests.get(x.channelName);K||(K=[],this.pendingRequests.set(x.channelName,K));const ee=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:x,timeoutTimer:ee})}flushPendingRequests(x){const K=this.pendingRequests.get(x);if(K){for(const ee of K)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var h;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(x,K=null){this.protocol=x,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new P.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=K}getChannel(x){const K=this;return{call(ee,ce,z){return K.isDisposed?Promise.reject(new b.CancellationError):K.requestPromise(x,ee,ce,z)},listen(ee,ce){return K.isDisposed?P.Event.None:K.requestEvent(x,ee,ce)}}}requestPromise(x,K,ee,ce=T.CancellationToken.None){const z=this.lastRequestId++,_={id:z,type:100,channelName:x,name:K,arg:ee};if(ce.isCancellationRequested)return Promise.reject(new b.CancellationError);let U;return new Promise((B,X)=>{if(ce.isCancellationRequested)return X(new b.CancellationError);const oe=()=>{const ue=he=>{switch(he.type){case 201:this.handlers.delete(z),B(he.data);break;case 202:{this.handlers.delete(z);const ve=new Error(he.data.message);ve.stack=he.data.stack,ve.name=he.data.name,X(ve);break}case 203:this.handlers.delete(z),X(he.data);break}};this.handlers.set(z,ue),this.sendRequest(_)};let J=null;this.state===p.Idle?oe():(J=(0,n.createCancelablePromise)(ue=>this.whenInitialized()),J.then(()=>{J=null,oe()}));const ie=()=>{J?(J.cancel(),J=null):this.sendRequest({id:z,type:101}),X(new b.CancellationError)},re=ce.onCancellationRequested(ie);U=(0,I.combinedDisposable)((0,I.toDisposable)(ie),re),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(x,K,ee){const ce=this.lastRequestId++,V={id:ce,type:102,channelName:x,name:K,arg:ee};let _=null;const U=new P.Emitter({onFirstListenerAdd:()=>{_=(0,n.createCancelablePromise)(B=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(U),this.sendRequest(V)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(U),this.sendRequest({id:ce,type:103}))}}),j=B=>U.fire(B.data);return this.handlers.set(ce,j),U.event}sendRequest(x){switch(x.type){case 100:case 102:{const K=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(K,x.id,0,`${d(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const K=this.send([x.type,x.id]);this.logger?.logOutgoing(K,x.id,0,d(x.type));return}}}send(x,K=void 0){const ee=new u;return o(ee,x),o(ee,K),this.sendBuffer(ee.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const K=new g(x),ee=l(K),ce=l(K),z=ee[0];switch(z){case 200:return this.logger?.logIncoming(x.byteLength,0,0,C(z)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(x.byteLength,ee[1],0,C(z),ce),this.onResponse({type:ee[0],id:ee[1],data:ce})}}onResponse(x){if(x.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}me([A.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class R{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new P.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new P.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:K,onDidClientDisconnect:ee})=>{P.Event.once(K.onMessage)(z=>{const V=new g(z),_=l(V),U=new a(K,_),j=new v(K);this.channels.forEach((X,oe)=>U.registerChannel(oe,X));const B={channelServer:U,channelClient:j,ctx:_};this._connections.add(B),this._onDidAddConnection.fire(B),ee(()=>{U.dispose(),j.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const x=[];return this._connections.forEach(K=>x.push(K)),x}getChannel(x,K){const ee=this;return{call(ce,z,V){let _;if((0,m.isFunction)(K)){const j=(0,D.getRandomElement)(ee.connections.filter(K));_=j?Promise.resolve(j):P.Event.toPromise(P.Event.filter(ee.onDidAddConnection,K))}else _=K.routeCall(ee,ce,z);const U=_.then(j=>j.channelClient.getChannel(x));return F(U).call(ce,z,V)},listen(ce,z){if((0,m.isFunction)(K))return ee.getMulticastEvent(x,K,ce,z);const V=K.routeEvent(ee,ce,z).then(_=>_.channelClient.getChannel(x));return F(V).listen(ce,z)}}}getMulticastEvent(x,K,ee,ce){const z=this;let V=new I.DisposableStore;const _=new P.Emitter({onFirstListenerAdd:()=>{V=new I.DisposableStore;const U=new P.EventMultiplexer,j=new Map,B=oe=>{const ie=oe.channelClient.getChannel(x).listen(ee,ce),re=U.add(ie);j.set(oe,re)},X=oe=>{const J=j.get(oe);!J||(J.dispose(),j.delete(oe))};z.connections.filter(K).forEach(B),P.Event.filter(z.onDidAddConnection,K)(B,void 0,V),z.onDidRemoveConnection(X,void 0,V),U.event(_.fire,_,V),V.add(U)},onLastListenerRemove:()=>{V.dispose()}});return _.event}registerChannel(x,K){this.channels.set(x,K),this._connections.forEach(ee=>{ee.channelServer.registerChannel(x,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class M{constructor(x,K,ee=null){const ce=new u;o(ce,K),x.send(ce.buffer),this.channelClient=new v(x,ee),this.channelServer=new a(x,K,ee)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,K){this.channelServer.registerChannel(x,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=M;function F(W){return{call(x,K,ee){return W.then(ce=>ce.call(x,K,ee))},listen(x,K){const ee=new P.Relay;return W.then(ce=>ee.input=ce.listen(x,K)),ee.event}}}e.getDelayedChannel=F;function O(W){let x=!1;return{call(K,ee,ce){return x?W.call(K,ee,ce):(0,n.timeout)(0).then(()=>x=!0).then(()=>W.call(K,ee,ce))},listen(K,ee){if(x)return W.listen(K,ee);const ce=new P.Relay;return(0,n.timeout)(0).then(()=>x=!0).then(()=>ce.input=W.listen(K,ee)),ce.event}}}e.getNextTickChannel=O;class L{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const K of x.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await P.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=L;var N;(function(W){function x(z,V){const _=z,U=V&&V.disableMarshalling,j=new Map;for(const B in _)ee(B)&&j.set(B,P.Event.buffer(_[B],!0));return new class{listen(B,X,oe){const J=j.get(X);if(J)return J;if(ce(X)){const ie=_[X];if(typeof ie=="function")return ie.call(_,oe)}throw new Error(`Event not found: ${X}`)}call(B,X,oe){const J=_[X];if(typeof J=="function"){if(!U&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,E.revive)(oe[ie]);return J.apply(_,oe)}throw new Error(`Method not found: ${X}`)}}}W.fromService=x;function K(z,V){const _=V&&V.disableMarshalling;return new Proxy({},{get(U,j){if(typeof j=="string")return V?.properties?.has(j)?V.properties.get(j):ce(j)?function(B){return z.listen(j,B)}:ee(j)?z.listen(j):async function(...B){let X;V&&!(0,m.isUndefinedOrNull)(V.context)?X=[V.context,...B]:X=B;const oe=await z.call(j,X);return _?oe:(0,E.revive)(oe)};throw new Error(`Property not found: ${String(j)}`)}})}W.toService=K;function ee(z){return z[0]==="o"&&z[1]==="n"&&w.isUpperAsciiLetter(z.charCodeAt(2))}function ce(z){return/^onDynamic/.test(z)&&w.isUpperAsciiLetter(z.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const x=W.toString();if(x!=="[object Object]")return x}return W}function Y(W){return Array.isArray(W)?W.map(H):H(W)}function te(W,x,K,ee,ce,z,V){V=Y(V);const _=$[ce],U=_[ee%_.length];let j=[`%c[${W}]%c[${String(x).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(z)?(j=j.concat(V),j.push(")")):j.push(V),console.log.apply(console,j)}e.logWithColors=te;class q{constructor(x,K){this._outgoingPrefix=x,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,K,ee,ce,z){this._totalOutgoing+=x,te(this._outgoingPrefix,this._totalOutgoing,x,K,ee,ce,z)}logIncoming(x,K,ee,ce,z){this._totalIncoming+=x,te(this._incomingPrefix,this._totalIncoming,x,K,ee,ce,z)}}e.IPCLogger=q}),define(ne[132],se([0,1,16,3,39]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(P){this.port=P,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",I=>D.VSBuffer.wrap(I.data)),P.start()}send(P){this.port.postMessage(P.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends k.IPCClient{constructor(P,I){const E=new T(P);super(E,I);this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=A}),define(ne[84],se([0,1,16,3,2,39]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let l=0;function a(v,R){if(!o.has(v)){const M=String(++l);o.set(v,M)}return o.get(v)}function h(v,R,M,F){if(!i.enableDiagnostics)return;const O=a(v,R);if(F instanceof D.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const L=D.VSBuffer.alloc(F.byteLength);L.set(F),i.records.push({timestamp:Date.now(),id:O,label:R,type:M,buff:L})}else i.records.push({timestamp:Date.now(),id:O,label:R,type:M,data:F})}i.traceSocketEvent=h})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var P;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function E(){return I||(I=D.VSBuffer.alloc(0)),I}class w{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,l){if(o===0)return E();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=o),R}if(this._chunks[0].byteLength>o){const R=this._chunks[0].slice(0,o);return l&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),R}const a=D.VSBuffer.alloc(o);let h=0,v=0;for(;o>0;){const R=this._chunks[v];if(R.byteLength>o){const M=R.slice(0,o);a.set(M,h),h+=o,l&&(this._chunks[v]=R.slice(o),this._totalLength-=o),o-=o}else a.set(R,h),h+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):v++,o-=R.byteLength}return a}}e.ChunkStream=w;var m;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(m||(m={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(o,l,a,h){this.type=o,this.id=l,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class C extends k.Disposable{constructor(o){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,h=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new S(a,h,v,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=D.VSBuffer.alloc(13);l.writeUInt8(o.type,0),l.writeUInt32BE(o.id,1),l.writeUInt32BE(o.ack,5),l.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(l,o.data)}_bufferAdd(o,l){const a=this._totalLength===0;return this._data.push(o,l),this._totalLength+=o.byteLength+l.byteLength,a}_bufferTake(){const o=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,l){this._bufferAdd(o,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class g extends k.Disposable{constructor(o){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new C(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new S(1,0,0,o))}}e.Protocol=g;class u extends T.IPCClient{constructor(o,l,a=null){super(o,l,a);this.protocol=o}static fromSocket(o,l){return new u(new g(o),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=u;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class c{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let o=0,l=this._first;for(;l;)l=l.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let l=0,a=this._first;for(;a;)o[l++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const l=new c(o);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class r{constructor(){this.lastRuns=[];const o=Date.now();for(let l=0;l<r._HISTORY_LENGTH;l++)this.lastRuns[l]=o-1e3*l;setInterval(()=>{for(let l=r._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const o=Date.now(),l=(1+r._HISTORY_LENGTH)*1e3;let a=0;for(let h=0;h<r._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=l&&a++;return 1-a/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class t{constructor(o,l=null,a=r.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),l&&this._socketReader.acceptChunk(l)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new S(5,0,0,E());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new S(7,0,0,E());this._socketWriter.write(o)}sendResume(){const o=new S(8,0,0,E());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,E());this._socketWriter.write(o);const l=this._outgoingUnackMsg.toArray();for(let a=0,h=l.length;a<h;a++)this._socketWriter.write(l[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new S(6,0,0,E())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let a=0,h=l.length;a<h;a++)this._socketWriter.write(l[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new S(1,l,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const l=new S(2,0,0,o);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),l=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&a>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:a});return}const v=Math.max(2e4-l,2e4-a,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},v)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,E());this._socketWriter.write(o)}}e.PersistentProtocol=t}),define(ne[133],se([0,1,85,3,39,132]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends k.IPCServer{static getOnDidClientConnect(){const P=n.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(I,E)=>E);return n.Event.map(P,I=>{const{port1:E,port2:w}=new MessageChannel,y={protocol:new T.Protocol(E),onDidClientDisconnect:n.Event.fromDOMEventEmitter(E,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",I,[w]),y})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(ne[64],se([0,1,54,6,16,21,126,10,3,2,31,83,77,39]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(p){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=d;class S{constructor(p,g){this.modulePath=p,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new n.Delayer(u),this.child=null,this._client=null}getChannel(p){const g=this;return{call(u,f,c){return g.requestPromise(p,u,f,c)},listen(u,f){return g.requestEvent(p,u,f)}}}requestPromise(p,g,u,f=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(p),s=(0,n.createCancelablePromise)(i=>c.call(g,u,i)),r=f.onCancellationRequested(()=>s.cancel()),t=(0,I.toDisposable)(()=>s.cancel());return this.activeRequests.add(t),s.finally(()=>{r.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(p,g,u){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let f;const c=new P.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(p).listen(g,u)(c.fire,c),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,m.removeDangerousEnvVariables)(g.env),this.child=(0,D.fork)(this.modulePath,p,g);const u=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,A.isRemoteConsoleLog)(o)){(0,A.log)(o,`IPC Library: ${this.options.serverName}`);return}u.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const c=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,s=o=>this.child&&this.child.connected&&c.send(o.buffer.toString("base64")),r=u.event,t={send:s,onMessage:r};this._client=new y.ChannelClient(t);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,l)=>{process.removeListener("exit",i),this.activeRequests.forEach(a=>(0,I.dispose)(a)),this.activeRequests.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:l})})}return this._client}getCachedChannel(p){let g=this.channels.get(p);return g||(g=this.client.getChannel(p),this.channels.set(p,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(ne[134],se([0,1,16,10,3,2,9,4,30,39,84]),function(Q,e,D,n,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class m{constructor(a,h=""){this.debugLabel=h,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=v=>{if(this.traceSocketEvent("error",{code:v?.code,message:v?.message}),v){if(v.code==="EPIPE")return;(0,n.onUnexpectedError)(v)}},this.socket.on("error",this._errorListener)}traceSocketEvent(a,h){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,h)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(a){const h=v=>{this.traceSocketEvent("read",v),a(D.VSBuffer.wrap(v))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(a){const h=v=>{this.traceSocketEvent("close",{hadError:v}),a({type:0,hadError:v,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(a){const h=()=>{this.traceSocketEvent("nodeEndReceived"),a()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(a){if(!this.socket.destroyed)try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,n.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,n.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const v=()=>{this.socket.off("close",v),this.socket.off("end",v),this.socket.off("error",v),this.socket.off("timeout",v),this.socket.off("drain",v),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",v),this.socket.on("end",v),this.socket.on("error",v),this.socket.on("timeout",v),this.socket.on("drain",v)})}}e.NodeSocket=m;var y;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var d;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(d||(d={}));class S extends T.Disposable{constructor(a,h,v,R){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:v?.byteLength||0,recordInflateBytes:R}),this._flowManager=this._register(new C(this,h,v,R,this._onData,(M,F)=>this._write(M,F))),this._register(this._flowManager.onError(M=>{console.error(M),(0,n.onUnexpectedError)(M),this._onClose.fire({type:0,hadError:!0,error:M})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(M=>this._acceptChunk(M))),this._register(this.socket.onClose(M=>this._onClose.fire(M)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,h){this.socket.traceSocketEvent(a,h)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,h){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let v=2;a.byteLength<126?v+=0:a.byteLength<2**16?v+=2:v+=8;const R=D.VSBuffer.alloc(v);if(h?R.writeUInt8(194,0):R.writeUInt8(130,0),a.byteLength<126)R.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){R.writeUInt8(126,1);let M=1;R.writeUInt8(a.byteLength>>>8&255,++M),R.writeUInt8(a.byteLength>>>0&255,++M)}else{R.writeUInt8(127,1);let M=1;R.writeUInt8(0,++M),R.writeUInt8(0,++M),R.writeUInt8(0,++M),R.writeUInt8(0,++M),R.writeUInt8(a.byteLength>>>24&255,++M),R.writeUInt8(a.byteLength>>>16&255,++M),R.writeUInt8(a.byteLength>>>8&255,++M),R.writeUInt8(a.byteLength>>>0&255,++M)}this.socket.write(D.VSBuffer.concat([R,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const h=this._incomingData.peek(this._state.readLen),v=h.readUInt8(0),R=(v&128)>>>7,M=(v&64)>>>6,F=h.readUInt8(1),O=(F&128)>>>7,L=F&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(L===126?2:0)+(L===127?8:0),this._state.fin=R,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(M)),this._state.firstFrameOfMessage=Boolean(R),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const h=this._incomingData.read(this._state.readLen),v=h.readUInt8(1),R=(v&128)>>>7;let M=v&127,F=1;M===126?M=h.readUInt8(++F)*2**8+h.readUInt8(++F):M===127&&(M=h.readUInt8(++F)*0+h.readUInt8(++F)*0+h.readUInt8(++F)*0+h.readUInt8(++F)*0+h.readUInt8(++F)*2**24+h.readUInt8(++F)*2**16+h.readUInt8(++F)*2**8+h.readUInt8(++F));let O=0;R&&(O=h.readUInt8(++F)*2**24+h.readUInt8(++F)*2**16+h.readUInt8(++F)*2**8+h.readUInt8(++F)),this._state.state=3,this._state.readLen=M,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const h=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),u(h,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(h,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class C extends T.Disposable{constructor(a,h,v,R,M,F){super();this._tracer=a,this._onData=M,this._writeFn=F,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,h?(this._zlibInflateStream=this._register(new p(this._tracer,R,v,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const h=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(h,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,h){return new Promise((v,R)=>{a.write(h),a.flush(M=>v(M))})}acceptFrame(a,h,v){this._readQueue.push({data:a,isCompressed:h,isLastFrameOfMessage:v}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const h=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(h)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,h,v){return new Promise((R,M)=>{a.write(h),v&&a.write(D.VSBuffer.fromByteArray([0,0,255,255])),a.flush(F=>R(F))})}}class p extends T.Disposable{constructor(a,h,v,R){super();this._tracer=a,this._recordInflateBytes=h,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=w().zlib.createInflateRaw(R),this._zlibInflate.on("error",M=>{this._tracer.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibInflate.on("data",M=>{this._tracer.traceSocketEvent("zlibInflateData",M),this._pendingInflateData.push(D.VSBuffer.wrap(M))}),v&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",v.buffer),this._zlibInflate.write(v.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const h=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(h)})}}class g extends T.Disposable{constructor(a,h){super();this._tracer=a,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=w().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",v=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:v?.message,code:v?.code}),this._onError.fire(v)}),this._zlibDeflate.on("data",v=>{this._tracer.traceSocketEvent("zlibDeflateData",v),this._pendingDeflateData.push(D.VSBuffer.wrap(v))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let h=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,h=h.slice(0,h.byteLength-4),a(h)})}}function u(l,a){if(a===0)return;const h=l.byteLength>>>2;for(let L=0;L<h;L++){const N=l.readUInt32BE(L*4);l.writeUInt32BE(N^a,L*4)}const v=h*4,R=l.byteLength-v,M=a>>>24&255,F=a>>>16&255,O=a>>>8&255;R>=1&&l.writeUInt8(l.readUInt8(v)^M,v),R>=2&&l.writeUInt8(l.readUInt8(v+1)^F,v+1),R>=3&&l.writeUInt8(l.readUInt8(v+2)^O,v+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function c(){const l=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):a=(0,A.join)(w().os.tmpdir(),`vscode-ipc-${l}.sock`),r(a),a}e.createRandomIPCHandle=c;function s(l,a,h){const v=w().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${v}-${h}-${a}-sock`;let R;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?R=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${v.substr(0,8)}-${h}-${a}.sock`):R=(0,A.join)(l,`${h}-${a}.sock`),r(R),R}e.createStaticIPCHandle=s;function r(l){const a=f[b.platform];typeof a=="number"&&l.length>=a&&console.warn(`WARNING: IPC handle "${l}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends I.IPCServer{constructor(a){super(t.toClientConnectionEvent(a));this.server=a}static toClientConnectionEvent(a){const h=k.Event.fromNodeEventEmitter(a,"connection");return k.Event.map(h,v=>({protocol:new E.Protocol(new m(v,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(v,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function i(l){return new Promise((a,h)=>{const v=w().net.createServer();v.on("error",h),v.listen(l,()=>{v.removeListener("error",h),a(new t(v))})})}e.serve=i;function o(l,a){return new Promise((h,v)=>{const R=w().net.createConnection(l,()=>{R.removeListener("error",v),h(E.Client.fromSocket(new m(R,`ipc-client${a}`),a))});R.once("error",v)})}e.connect=o}),define(ne[86],se([0,1,6,3,2,14]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function b(w){const m=w;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var P;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(P=e.StorageState||(e.StorageState={}));class I extends k.Disposable{constructor(m,y=Object.create(null)){super();this.database=m,this.options=y,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((y,d)=>this.accept(d,y)),m.deleted?.forEach(y=>this.accept(y,void 0))}accept(m,y){if(this.state===P.Closed)return;let d=!1;(0,T.isUndefinedOrNull)(y)?d=this.cache.delete(m):this.cache.get(m)!==y&&(this.cache.set(m,y),d=!0),d&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,y){const d=this.cache.get(m);return(0,T.isUndefinedOrNull)(d)?y:d}getBoolean(m,y){const d=this.get(m);return(0,T.isUndefinedOrNull)(d)?y:d==="true"}getNumber(m,y){const d=this.get(m);return(0,T.isUndefinedOrNull)(d)?y:parseInt(d,10)}async set(m,y){if(this.state===P.Closed)return;if((0,T.isUndefinedOrNull)(y))return this.delete(m);const d=String(y);if(this.cache.get(m)!==d)return this.cache.set(m,d),this.pendingInserts.set(m,d),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===P.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((y,d)=>this.items.set(d,y)),m.delete?.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=E}),define(ne[135],se([11,12]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ne[136],se([11,12]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[137],se([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[138],se([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[139],se([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[140],se([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[141],se([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[142],se([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[143],se([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[144],se([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[145],se([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[146],se([11,12]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[147],se([11,12]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[148],se([11,12]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[149],se([11,12]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[150],se([11,12]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[151],se([11,12]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[152],se([11,12]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[153],se([11,12]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[154],se([11,12]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[155],se([11,12]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[156],se([11,12]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[157],se([11,12]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[158],se([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[159],se([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[160],se([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[161],se([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[162],se([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[163],se([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[164],se([11,12]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ne[87],se([0,1,61,60,20,9,36,17,7]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(S,C,p){this._args=S,this.paths=C,this.productService=p,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,T.dirname)(k.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return P.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(P.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=A.env.VSCODE_PORTABLE;return S?P.URI.file((0,T.join)(S,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,T.resolve)(S):(0,T.normalize)((0,T.join)(k.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,T.resolve)(S):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,T.resolve)(S);const C=A.env.VSCODE_EXTENSIONS;if(C)return C;const p=A.env.VSCODE_PORTABLE;return p?(0,T.join)(p,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(C=>/^[^:/?#]+?:\/\//.test(C)?P.URI.parse(C):P.URI.file((0,T.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?P.URI.parse(S):P.URI.file((0,T.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return P.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return P.URI.file((0,T.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=A.env.VSCODE_PORTABLE;return S?P.URI.file((0,T.join)(S,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}me([n.memoize],I.prototype,"appRoot",null),me([n.memoize],I.prototype,"userHome",null),me([n.memoize],I.prototype,"userDataPath",null),me([n.memoize],I.prototype,"appSettingsHome",null),me([n.memoize],I.prototype,"tmpDir",null),me([n.memoize],I.prototype,"cacheHome",null),me([n.memoize],I.prototype,"stateResource",null),me([n.memoize],I.prototype,"userRoamingDataHome",null),me([n.memoize],I.prototype,"userDataSyncHome",null),me([n.memoize],I.prototype,"userDataSyncLogResource",null),me([n.memoize],I.prototype,"editSessionsLogResource",null),me([n.memoize],I.prototype,"sync",null),me([n.memoize],I.prototype,"machineSettingsResource",null),me([n.memoize],I.prototype,"workspaceStorageHome",null),me([n.memoize],I.prototype,"localHistoryHome",null),me([n.memoize],I.prototype,"keyboardLayoutResource",null),me([n.memoize],I.prototype,"argvResource",null),me([n.memoize],I.prototype,"isExtensionDevelopment",null),me([n.memoize],I.prototype,"untitledWorkspacesHome",null),me([n.memoize],I.prototype,"installSourcePath",null),me([n.memoize],I.prototype,"builtinExtensionsPath",null),me([n.memoize],I.prototype,"extensionsPath",null),me([n.memoize],I.prototype,"extensionDevelopmentLocationURI",null),me([n.memoize],I.prototype,"extensionDevelopmentKind",null),me([n.memoize],I.prototype,"extensionTestsLocationURI",null),me([n.memoize],I.prototype,"debugExtensionHost",null),me([n.memoize],I.prototype,"serviceMachineIdResource",null),me([n.memoize],I.prototype,"telemetryLogResource",null),me([n.memoize],I.prototype,"disableWorkspaceTrust",null),me([n.memoize],I.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=I;function E(d,S){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,S,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=E;function w(d,S){return y(d["inspect-search"],d["inspect-brk-search"],5876,S,d.extensionEnvironment)}e.parseSearchPort=w;function m(d,S){return y(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,S,d.extensionEnvironment)}e.parsePtyHostPort=m;function y(d,S,C,p,g,u){const c=Number(S||d)||(p?null:C),s=c?Boolean(!!S):!1;let r;if(u)try{r=JSON.parse(u)}catch{}return{port:c,break:s,debugId:g,env:r}}}),define(ne[165],se([0,1,270,4,137]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},"profile-temp":{type:"boolean",cat:"o",description:(0,k.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},category:{type:"string",cat:"e",description:(0,k.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(23,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(24,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function b(d,S,C=A){const p={},g=["_"],u=[];for(const r in S){const t=S[r];t.alias&&(p[r]=t.alias),t.type==="string"||t.type==="string[]"?(g.push(r),t.deprecates&&g.push(...t.deprecates)):t.type==="boolean"&&(u.push(r),t.deprecates&&u.push(...t.deprecates))}const f=D(d,{string:g,boolean:u,alias:p}),c={},s=f;c._=f._.map(r=>String(r)).filter(r=>r.length>0),delete s._;for(const r in S){const t=S[r];t.alias&&delete s[t.alias];let i=s[r];if(t.deprecates)for(const o of t.deprecates)s.hasOwnProperty(o)&&(i||(i=s[o],i&&C.onDeprecatedOption(o,t.deprecationMessage||(0,k.localize)(36,null,r))),delete s[o]);if(typeof i!="undefined"){if(t.type==="string[]"){if(Array.isArray(i)||(i=[i]),!t.allowEmptyValue){const o=i.filter(l=>l.length>0);o.length!==i.length&&(C.onEmptyValue(r),i=o.length>0?o:void 0)}}else t.type==="string"&&(Array.isArray(i)?(i=i.pop(),C.onMultipleValues(r,i)):!i&&!t.allowEmptyValue&&(C.onEmptyValue(r),i=void 0));c[r]=i,t.deprecationMessage&&C.onDeprecatedOption(r,t.deprecationMessage)}delete s[r]}for(const r in s)C.onUnknownOption(r);return c}e.parseArgs=b;function P(d,S){let C="";return S.args&&(Array.isArray(S.args)?C=` <${S.args.join("> <")}>`:C=` <${S.args}>`),S.alias?`-${S.alias} --${d}${C}`:`--${d}${C}`}function I(d,S){let C=0;const p=[];for(const c in d){const s=d[c],r=P(c,s);C=Math.max(C,r.length),p.push([r,s.description])}const g=C+2+1;if(S-g<25)return p.reduce((c,s)=>c.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const u=S-g-1,f=[];for(const c of p){const s=c[0],r=w(c[1],u),t=E(g-s.length-2);f.push("  "+s+t+r[0]);for(let i=1;i<r.length;i++)f.push(E(g)+r[i])}return f}e.formatOptions=I;function E(d){return" ".repeat(d)}function w(d,S){const C=[];for(;d.length;){const p=d.length<S?d.length:d.lastIndexOf(" ",S),g=d.slice(0,p).trim();d=d.slice(p),C.push(g)}return C}function m(d,S,C,p,g){const u=process.stdout.isTTY&&process.stdout.columns||80,f=g?.noInputFiles!==!0?`[${(0,k.localize)(37,null)}...]`:"",c=[`${d} ${C}`];c.push(""),c.push(`${(0,k.localize)(38,null)}: ${S} [${(0,k.localize)(39,null)}]${f}`),c.push(""),g?.noPipe!==!0&&(n.isWindows?c.push((0,k.localize)(40,null,S)):c.push((0,k.localize)(41,null,S)),c.push(""));const s={};for(const r in p){const t=p[r];if(t.description&&t.cat){let i=s[t.cat];i||(s[t.cat]=i={}),i[r]=t}}for(const r in s){const t=r,i=s[t];i&&(c.push(T[t]),c.push(...I(i,u)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=m;function y(d,S){return`${d||(0,k.localize)(42,null)}
${S||(0,k.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=y}),define(ne[166],se([0,1,271,138,165]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function A(m,y){const d={onUnknownOption:C=>{console.warn((0,n.localize)(0,null,C))},onMultipleValues:(C,p)=>{console.warn((0,n.localize)(1,null,C,p))},onEmptyValue:C=>{console.warn((0,n.localize)(2,null,C))},onDeprecatedOption:(C,p)=>{console.warn((0,n.localize)(3,null,C,p))}},S=(0,k.parseArgs)(m,k.OPTIONS,y?d:void 0);return S.goto&&S._.forEach(C=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,n.localize)(4,null))),S["max-memory"]&&D(parseInt(S["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),S}function b(m){const y=m.findIndex(d=>!/^-/.test(d));if(y>-1)return[...m.slice(0,y),...m.slice(y+1)]}function P(m){let[,...y]=m;process.env.VSCODE_DEV&&(y=b(y)||[]);const d=!w(process.env);return A(y,d)}e.parseMainProcessArgv=P;function I(m){const[,,...y]=m;return A(y,!0)}e.parseCLIProcessArgv=I;function E(m,...y){const d=m.indexOf("--");return d===-1?m.push(...y):m.splice(d,0,...y),m}e.addArg=E;function w(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function Q(e,D,n,k){function T(b){const P=A(b),I=[P];return e.isAbsolute(P)||I.unshift(k),e.resolve(...I)}function A(b){const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,n);const E=b["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(w,"AppData","Roaming")}break;case"darwin":I=e.join(D.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,n)}return{getUserDataPath:T}}if(typeof define=="function")define(ne[167],se([0,272,37,20,17,36]),function(e,D,n,k,T,A){const b=T.dirname(k.FileAccess.asFileUri("",e)),P=e.__$__nodeRequire(T.joinPath(b,"package.json").fsPath);return Q(D,n,P.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),n=require("os");module.exports=Q(D,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[168],se([0,1,37,87,167]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends n.AbstractNativeEnvironmentService{constructor(b,P){super(b,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,k.getUserDataPath)(b)},P)}}e.NativeEnvironmentService=T}),define(ne[169],se([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,b=/^\s*url\s*=\s*(.+\S)\s*$/mg,P=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function I(C){const p=C.match(A);return p?p[1]:null}function E(C){if(C.indexOf("://")===-1){const p=C.match(n);return p?I(p[2]):null}try{const p=D.URI.parse(C);if(p.authority)return I(p.authority)}catch{}return null}function w(C,p){const g=new Set;let u;for(;u=b.exec(C);){const c=E(u[1]);c&&g.add(c)}const f=new Set(p);return Array.from(g).map(c=>f.has(c)?c:c.replace(P,"a"))}e.getDomainsOfRemotes=w;function m(C){const p=C.match(T);return p?p[2]:null}function y(C,p,g){return C&&p?(g&&p.endsWith(".git")&&(p=p.substr(0,p.length-4)),p.indexOf("/")===0?`${C}${p}`:`${C}/${p}`):null}function d(C,p){if(C.indexOf("://")===-1){const g=C.match(k);if(g)return y(g[2],g[3],p)}try{const g=D.URI.parse(C);if(g.authority)return y(m(g.authority),g.path,p)}catch{}return null}function S(C,p=!1){const g=[];let u;for(;u=b.exec(C);){const f=d(u[1],p);f&&g.push(f)}return g}e.getRemotes=S}),define(ne[170],se([0,1,14,141]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(A,b,P){try{T(A,b,P)}catch{}return A}e.localizeManifest=k;function T(A,b,P){const I=(E,w,m)=>{const y=E[w];if((0,D.isString)(y)){const d=y,S=d.length;if(S>1&&d[0]==="%"&&d[S-1]==="%"){const C=d.substr(1,S-2);let p=b[C];p===void 0&&P&&(p=P[C]);const g=typeof p=="string"?p:p.message;if(g!==void 0){const u=P?.[C],f=typeof u=="string"?u:u?.message;if(m&&(w==="title"||w==="category")&&f&&f!==g){const c={value:g,original:f};E[w]=c}else E[w]=g}else console.warn(`[${A.name}]: ${(0,n.localize)(0,null,C)}`)}}else if((0,D.isObject)(y))for(const d in y)y.hasOwnProperty(d)&&(d==="commands"?I(y,d,!0):I(y,d,m));else if(Array.isArray(y))for(let d=0;d<y.length;d++)I(y,d,m)};for(const E in A)A.hasOwnProperty(E)&&I(A,E)}}),define(ne[171],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,b,P){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,b,P])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class n{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,b){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(b[0],b[1],b[2],b[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ne[65],se([0,1,17,80,146,55]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function P(p){return p=p.trim(),p==="*"||A.test(p)}e.isValidVersionStr=P;function I(p){if(!P(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=p.match(A);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=I;function E(p){if(!p)return null;const g=p.majorBase,u=p.majorMustEqual,f=p.minorBase;let c=p.minorMustEqual;const s=p.patchBase;let r=p.patchMustEqual;p.hasCaret&&(g===0||(c=!1),r=!1);let t=0;if(p.preRelease){const i=b.exec(p.preRelease);if(i){const[,o,l,a]=i;t=Date.UTC(Number(o),Number(l)-1,Number(a))}}return{majorBase:g,majorMustEqual:u,minorBase:f,minorMustEqual:c,patchBase:s,patchMustEqual:r,isMinimum:p.hasGreaterEquals,notBefore:t}}e.normalizeVersion=E;function w(p,g,u){let f;typeof p=="string"?f=E(I(p)):f=p;let c;g instanceof Date?c=g.getTime():typeof g=="string"&&(c=new Date(g).getTime());let s;if(typeof u=="string"?s=E(I(u)):s=u,!f||!s)return!1;const r=f.majorBase,t=f.minorBase,i=f.patchBase;let o=s.majorBase,l=s.minorBase,a=s.patchBase;const h=s.notBefore;let v=s.majorMustEqual,R=s.minorMustEqual,M=s.patchMustEqual;return s.isMinimum?r>o?!0:r<o?!1:t>l?!0:t<l||c&&c<h?!1:i>=a:(r===1&&o===0&&(!v||!R||!M)&&(o=1,l=0,a=0,v=!0,R=!1,M=!1),r<o?!1:r>o?!v:t<l?!1:t>l?!R:i<a?!1:i>a?!M:!(c&&c<h))}e.isValidVersion=w;function m(p,g,u,f,c){const s=[];if(typeof f.publisher!="undefined"&&typeof f.publisher!="string")return s.push([n.default.Error,k.localize(0,null)]),s;if(typeof f.name!="string")return s.push([n.default.Error,k.localize(1,null,"name")]),s;if(typeof f.version!="string")return s.push([n.default.Error,k.localize(2,null,"version")]),s;if(!f.engines)return s.push([n.default.Error,k.localize(3,null,"engines")]),s;if(typeof f.engines.vscode!="string")return s.push([n.default.Error,k.localize(4,null,"engines.vscode")]),s;if(typeof f.extensionDependencies!="undefined"&&!C(f.extensionDependencies))return s.push([n.default.Error,k.localize(5,null,"extensionDependencies")]),s;if(typeof f.activationEvents!="undefined"){if(!C(f.activationEvents))return s.push([n.default.Error,k.localize(6,null,"activationEvents")]),s;if(typeof f.main=="undefined"&&typeof f.browser=="undefined")return s.push([n.default.Error,k.localize(7,null,"activationEvents","main")]),s}if(typeof f.extensionKind!="undefined"&&typeof f.main=="undefined"&&s.push([n.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main!="undefined"){if(typeof f.main!="string")return s.push([n.default.Error,k.localize(9,null,"main")]),s;{const i=(0,D.joinPath)(u,f.main);(0,D.isEqualOrParent)(i,u)||s.push([n.default.Warning,k.localize(10,null,i.path,u.path)])}if(typeof f.activationEvents=="undefined")return s.push([n.default.Error,k.localize(11,null,"activationEvents","main")]),s}if(typeof f.browser!="undefined"){if(typeof f.browser!="string")return s.push([n.default.Error,k.localize(12,null,"browser")]),s;{const i=(0,D.joinPath)(u,f.browser);(0,D.isEqualOrParent)(i,u)||s.push([n.default.Warning,k.localize(13,null,i.path,u.path)])}if(typeof f.activationEvents=="undefined")return s.push([n.default.Error,k.localize(14,null,"activationEvents","browser")]),s}if(!T.valid(f.version))return s.push([n.default.Error,k.localize(15,null)]),s;const r=[];if(!y(p,g,f,c,r))for(const i of r)s.push([n.default.Error,i]);return s}e.validateExtensionManifest=m;function y(p,g,u,f,c){return f||typeof u.main=="undefined"&&typeof u.browser=="undefined"?!0:S(p,g,u.engines.vscode,c)}e.isValidExtensionVersion=y;function d(p,g,u){return p==="*"||S(g,u,p)}e.isEngineValid=d;function S(p,g,u,f=[]){const c=E(I(u));if(!c)return f.push(k.localize(16,null,u)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return f.push(k.localize(17,null,u)),!1}else if(!c.majorMustEqual)return f.push(k.localize(18,null,u)),!1;return w(p,g,c)?!0:(f.push(k.localize(19,null,p,u)),!1)}function C(p){if(!Array.isArray(p))return!1;for(let g=0,u=p.length;g<u;g++)if(typeof p[g]!="string")return!1;return!0}}),define(ne[47],se([0,1,16,30]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(T,A,b){let P=b&&b.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const E=(await A.readFile(T.serviceMachineIdResource)).value.toString();P=(0,n.isUUID)(E)?E:null}catch{P=null}if(!P){P=(0,n.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(P))}catch{}}return b?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=k}),define(ne[56],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(k,T=[],A=!1){this.ctor=k,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(ne[88],se([0,1,56]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function k(A,b,P){b instanceof D.SyncDescriptor||(b=new D.SyncDescriptor(b,[],P)),n.push([A,b])}e.registerSingleton=k;function T(){return n}e.getSingletonServiceDescriptors=T}),define(ne[172],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class n{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const b=this.lookupOrInsertNode(T),P=this.lookupOrInsertNode(A);b.outgoing.set(this._hashFn(A),P),P.incoming.set(this._hashFn(T),b)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(const b of this._nodes.values())b.outgoing.delete(A),b.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let b=this._nodes.get(A);return b||(b=new D(T),this._nodes.set(A,b)),b}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[A,b]of this._nodes)T.push(`${A}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this._nodes){const b=new Set([T]),P=this._findCycle(A,b);if(P)return P}}_findCycle(T,A){for(const[b,P]of T.outgoing){if(A.has(b))return[...A,b].join(" -> ");A.add(b);const I=this._findCycle(P,A);if(I)return I;A.delete(b)}}}e.Graph=n}),define(ne[5],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function b(P){return P[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=b})(D=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function n(A,b,P){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:A,index:P}):(b[D.DI_DEPENDENCIES]=[{id:A,index:P}],b[D.DI_TARGET]=b)}function k(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const b=function(P,I,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(b,P,E)};return b.toString=()=>A,D.serviceIds.set(A,b),b}e.createDecorator=k;function T(A){return A}e.refineServiceDecorator=T}),define(ne[173],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[19],se([0,1,14,7,5]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function T(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationOverrides=T;function A(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=A;var b;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function I(p,g){const u=Object.create(null);for(const f in p)E(u,f,p[f],g);return u}e.toValuesTree=I;function E(p,g,u,f){const c=g.split("."),s=c.pop();let r=p;for(let t=0;t<c.length;t++){const i=c[t];let o=r[i];switch(typeof o){case"undefined":o=r[i]=Object.create(null);break;case"object":break;default:f(`Ignoring ${g} as ${c.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[s]=u}catch{f(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(r)}`)}else f(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=E;function w(p,g){const u=g.split(".");m(p,u)}e.removeFromValueTree=w;function m(p,g){const u=g.shift();if(g.length===0){delete p[u];return}if(Object.keys(p).indexOf(u)!==-1){const f=p[u];typeof f=="object"&&!Array.isArray(f)&&(m(f,g),Object.keys(f).length===0&&delete p[u])}}function y(p,g,u){function f(r,t){let i=r;for(const o of t){if(typeof i!="object"||i===null)return;i=i[o]}return i}const c=g.split("."),s=f(p,c);return typeof s=="undefined"?u:s}e.getConfigurationValue=y;function d(p,g,u){Object.keys(g).forEach(f=>{f!=="__proto__"&&(f in p?D.isObject(p[f])&&D.isObject(g[f])?d(p[f],g[f],u):u&&(p[f]=g[f]):p[f]=g[f])})}e.merge=d;function S(p,g,u){const f=p.inspect(g),c=p.inspect(u);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:f.defaultValue}e.getMigratedSettingValue=S;function C(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=C}),define(ne[174],se([0,1,4,24,5]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",D.isEdge),T.set("isFirefox",D.isFirefox),T.set("isChrome",D.isChrome),T.set("isSafari",D.isSafari);const A=Object.prototype.hasOwnProperty;var b;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return w.INSTANCE}static true(){return m.INSTANCE}static has(L){return y.create(L)}static equals(L,N){return d.create(L,N)}static notEquals(L,N){return p.create(L,N)}static regex(L,N){return t.create(L,N)}static in(L,N){return S.create(L,N)}static notIn(L,N){return C.create(L,N)}static not(L){return g.create(L)}static and(...L){return l.create(L,null)}static or(...L){return a.create(L,null,!0)}static greater(L,N){return f.create(L,N)}static greaterEquals(L,N){return c.create(L,N)}static smaller(L,N){return s.create(L,N)}static smallerEquals(L,N){return r.create(L,N)}static deserialize(L,N=!1){if(!!L)return this._deserializeOrExpression(L,N)}static _deserializeOrExpression(L,N){const $=L.split("||");return a.create($.map(H=>this._deserializeAndExpression(H,N)),null,!0)}static _deserializeAndExpression(L,N){const $=L.split("&&");return l.create($.map(H=>this._deserializeOne(H,N)),null)}static _deserializeOne(L,N){if(L=L.trim(),L.indexOf("!=")>=0){const $=L.split("!=");return p.create($[0].trim(),this._deserializeValue($[1],N))}if(L.indexOf("==")>=0){const $=L.split("==");return d.create($[0].trim(),this._deserializeValue($[1],N))}if(L.indexOf("=~")>=0){const $=L.split("=~");return t.create($[0].trim(),this._deserializeRegexValue($[1],N))}if(L.indexOf(" not in ")>=0){const $=L.split(" not in ");return C.create($[0].trim(),$[1].trim())}if(L.indexOf(" in ")>=0){const $=L.split(" in ");return S.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const $=L.split(">=");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const $=L.split(">");return f.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const $=L.split("<=");return r.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const $=L.split("<");return s.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(L)?g.create(L.substr(1).trim()):y.create(L)}static _deserializeValue(L,N){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const $=/^'([^']*)'$/.exec(L);return $?$[1].trim():L}static _deserializeRegexValue(L,N){if((0,n.isFalsyOrWhitespace)(L)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=L.indexOf("/"),H=L.lastIndexOf("/");if($===H||$<0){if(N)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const Y=L.slice($+1,H),te=L[H+1]==="i"?"i":"";try{return new RegExp(Y,te)}catch(q){if(N)throw new Error(`bad regexp-value '${L}', parse error: ${q}`);return console.warn(`bad regexp-value '${L}', parse error: ${q}`),null}}}e.ContextKeyExpr=P;function I(O,L){const N=O?O.substituteConstants():void 0,$=L?L.substituteConstants():void 0;return!N&&!$?!0:!N||!$?!1:N.equals($)}e.expressionsAreEqualWithConstantSubstitution=I;function E(O,L){return O.cmp(L)}class w{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class m{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class y{constructor(L,N){this.key=L,this.negated=N,this.type=2}static create(L,N=null){const $=T.get(L);return typeof $=="boolean"?$?m.INSTANCE:w.INSTANCE:new y(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:v(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?m.INSTANCE:w.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class d{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=4}static create(L,N,$=null){if(typeof N=="boolean")return N?y.create(L,$):g.create(L,$);const H=T.get(L);return typeof H=="boolean"?N===(H?"true":"false")?m.INSTANCE:w.INSTANCE:new d(L,N,$)}cmp(L){return L.type!==this.type?this.type-L.type:R(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const N=L?"true":"false";return this.value===N?m.INSTANCE:w.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class S{constructor(L,N){this.key=L,this.valueKey=N,this.type=10,this.negated=null}static create(L,N){return new S(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:R(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const N=L.getValue(this.valueKey),$=L.getValue(this.key);return Array.isArray(N)?N.includes($):typeof $=="string"&&typeof N=="object"&&N!==null?A.call(N,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class C{constructor(L,N){this.key=L,this.valueKey=N,this.type=11,this._negated=S.create(L,N)}static create(L,N){return new C(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:this._negated.cmp(L._negated)}equals(L){return L.type===this.type?this._negated.equals(L._negated):!1}substituteConstants(){return this}evaluate(L){return!this._negated.evaluate(L)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(L){return L.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=C;class p{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=5}static create(L,N,$=null){if(typeof N=="boolean")return N?g.create(L,$):y.create(L,$);const H=T.get(L);return typeof H=="boolean"?N===(H?"true":"false")?w.INSTANCE:m.INSTANCE:new p(L,N,$)}cmp(L){return L.type!==this.type?this.type-L.type:R(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const N=L?"true":"false";return this.value===N?w.INSTANCE:m.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class g{constructor(L,N){this.key=L,this.negated=N,this.type=3}static create(L,N=null){const $=T.get(L);return typeof $=="boolean"?$?w.INSTANCE:m.INSTANCE:new g(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:v(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?w.INSTANCE:m.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function u(O,L){if(typeof O=="string"){const N=parseFloat(O);isNaN(N)||(O=N)}return typeof O=="string"||typeof O=="number"?L(O):w.INSTANCE}class f{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=12}static create(L,N,$=null){return u(N,H=>new f(L,H,$))}cmp(L){return L.type!==this.type?this.type-L.type:R(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class c{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=13}static create(L,N,$=null){return u(N,H=>new c(L,H,$))}cmp(L){return L.type!==this.type?this.type-L.type:R(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class s{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=14}static create(L,N,$=null){return u(N,H=>new s(L,H,$))}cmp(L){return L.type!==this.type?this.type-L.type:R(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class r{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=15}static create(L,N,$=null){return u(N,H=>new r(L,H,$))}cmp(L){return L.type!==this.type?this.type-L.type:R(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class t{constructor(L,N){this.key=L,this.regexp=N,this.type=7,this.negated=null}static create(L,N){return new t(L,N)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const N=this.regexp?this.regexp.source:"",$=L.regexp?L.regexp.source:"";return N<$?-1:N>$?1:0}equals(L){if(L.type===this.type){const N=this.regexp?this.regexp.source:"",$=L.regexp?L.regexp.source:"";return this.key===L.key&&N===$}return!1}substituteConstants(){return this}evaluate(L){const N=L.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class i{constructor(L){this._actual=L,this.type=8}static create(L){return new i(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new i(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function o(O){let L=null;for(let N=0,$=O.length;N<$;N++){const H=O[N].substituteConstants();if(O[N]!==H&&L===null){L=[];for(let Y=0;Y<N;Y++)L[Y]=O[Y]}L!==null&&(L[N]=H)}return L===null?O:L}class l{constructor(L,N){this.expr=L,this.negated=N,this.type=6}static create(L,N){return l._normalizeArr(L,N)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let N=0,$=this.expr.length;N<$;N++){const H=E(this.expr[N],L.expr[N]);if(H!==0)return H}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].equals(L.expr[N]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:l.create(L,this.negated)}evaluate(L){for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].evaluate(L))return!1;return!0}static _normalizeArr(L,N){const $=[];let H=!1;for(const Y of L)if(!!Y){if(Y.type===1){H=!0;continue}if(Y.type===0)return w.INSTANCE;if(Y.type===6){$.push(...Y.expr);continue}$.push(Y)}if($.length===0&&H)return m.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(E);for(let Y=1;Y<$.length;Y++)$[Y-1].equals($[Y])&&($.splice(Y,1),Y--);if($.length===1)return $[0];for(;$.length>1;){const Y=$[$.length-1];if(Y.type!==9)break;$.pop();const te=$.pop(),q=$.length===0,W=a.create(Y.expr.map(x=>l.create([x,te],null)),null,q);W&&($.push(W),$.sort(E))}return $.length===1?$[0]:new l($,N)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const N of this.expr)L.push(...N.keys());return L}map(L){return new l(this.expr.map(N=>N.map(L)),null)}negate(){if(!this.negated){const L=[];for(const N of this.expr)L.push(N.negate());this.negated=a.create(L,this,!0)}return this.negated}}class a{constructor(L,N){this.expr=L,this.negated=N,this.type=9}static create(L,N,$){return a._normalizeArr(L,N,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let N=0,$=this.expr.length;N<$;N++){const H=E(this.expr[N],L.expr[N]);if(H!==0)return H}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].equals(L.expr[N]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:a.create(L,this.negated,!1)}evaluate(L){for(let N=0,$=this.expr.length;N<$;N++)if(this.expr[N].evaluate(L))return!0;return!1}static _normalizeArr(L,N,$){let H=[],Y=!1;if(L){for(let te=0,q=L.length;te<q;te++){const W=L[te];if(!!W){if(W.type===0){Y=!0;continue}if(W.type===1)return m.INSTANCE;if(W.type===9){H=H.concat(W.expr);continue}H.push(W)}}if(H.length===0&&Y)return w.INSTANCE;H.sort(E)}if(H.length!==0){if(H.length===1)return H[0];for(let te=1;te<H.length;te++)H[te-1].equals(H[te])&&(H.splice(te,1),te--);if(H.length===1)return H[0];if($){for(let te=0;te<H.length;te++)for(let q=te+1;q<H.length;q++)M(H[te],H[q])&&(H.splice(q,1),q--);if(H.length===1)return H[0]}return new a(H,N)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const N of this.expr)L.push(...N.keys());return L}map(L){return new a(this.expr.map(N=>N.map(L)),null)}negate(){if(!this.negated){const L=[];for(const N of this.expr)L.push(N.negate());for(;L.length>1;){const N=L.shift(),$=L.shift(),H=[];for(const te of F(N))for(const q of F($))H.push(l.create([te,q],null));const Y=L.length===0;L.unshift(a.create(H,null,Y))}this.negated=L[0]}return this.negated}}class h extends y{constructor(L,N,$){super(L,null);this._defaultValue=N,typeof $=="object"?h._info.push({...$,key:L}):$!==!0&&h._info.push({key:L,description:$,type:N!=null?typeof N:void 0})}static all(){return h._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return d.create(this.key,L)}notEqualsTo(L){return p.create(this.key,L)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(O,L){return O<L?-1:O>L?1:0}function R(O,L,N,$){return O<N?-1:O>N?1:L<$?-1:L>$?1:0}function M(O,L){if(L.type===6&&O.type!==9&&O.type!==6){for(const H of L.expr)if(O.equals(H))return!0}const N=O.negate(),$=F(N).concat(F(L));$.sort(E);for(let H=0;H<$.length;H++){const te=$[H].negate();for(let q=H+1;q<$.length;q++){const W=$[q];if(te.equals(W))return!0}}return!1}e.implies=M;function F(O){return O.type===9?O.expr:[O]}}),define(ne[89],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function n(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=n;class k{async getPerformanceInfo(A,b){return{}}async getSystemInfo(A,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,b){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(ne[90],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[15],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],se([0,1,140,5]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function T(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function A(p,g){switch(p){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function b(p,g){return g==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function P(p,g,u){return b(g,u)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===u?!0:I(u).includes(p)}e.isTargetPlatformCompatible=P;function I(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function E(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=E;var w;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var m;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var y;(function(p){p.Install="install",p.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var d;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var S;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class C extends Error{constructor(g,u){super(g);this.code=u,this.name=u}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,n.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,n.createDecorator)("IExtensionManagementCLIService")}),define(ne[175],se([0,1,3,2,63,31,7,127,29]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(C,p){return A.URI.revive(p?p.transformIncoming(C):C)}function E(C,p){return p?p.transformOutgoingURI(C):C}function w(C,p){p=p||b.DefaultURITransformer;const g=C.manifest;return{...(0,b.transformAndReviveIncomingURIs)({...C,manifest:void 0},p),manifest:g}}function m(C,p){return p?(0,T.cloneAndChange)(C,g=>g instanceof A.URI?p.transformOutgoingURI(g):void 0):C}class y{constructor(p,g){this.service=p,this.getUriTransformer=g,this.onInstallExtension=D.Event.buffer(p.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(p.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(p.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(p.onDidUninstallExtension,!0)}listen(p,g){const u=this.getUriTransformer(p);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,f=>f.map(c=>({...c,local:c.local?m(c.local,u):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(p,g,u){const f=this.getUriTransformer(p);switch(g){case"zip":return this.service.zip(w(u[0],f)).then(c=>E(c,f));case"unzip":return this.service.unzip(I(u[0],f));case"install":return this.service.install(I(u[0],f),(0,k.revive)(u[1]));case"getManifest":return this.service.getManifest(I(u[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(u[0]);case"installFromGallery":return this.service.installFromGallery(u[0],(0,k.revive)(u[1]));case"uninstall":return this.service.uninstall(w(u[0],f),(0,k.revive)(u[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(w(u[0],f));case"getInstalled":return this.service.getInstalled(u[0],A.URI.revive(u[1])).then(c=>c.map(s=>m(s,f)));case"getMetadata":return this.service.getMetadata(w(u[0],f));case"updateMetadata":return this.service.updateMetadata(w(u[0],f),u[1]).then(c=>m(c,f));case"updateExtensionScope":return this.service.updateExtensionScope(w(u[0],f),u[1]).then(c=>m(c,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class d extends n.Disposable{constructor(p){super();this.channel=p,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(u=>({...u,local:u.local?w(u.local,null):u.local,source:this.isUriComponents(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:A.URI.revive(g.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(p){const g=await this.getTargetPlatform();return p.allTargetPlatforms.some(u=>(0,P.isTargetPlatformCompatible)(u,p.allTargetPlatforms,g))}zip(p){return Promise.resolve(this.channel.call("zip",[p]).then(g=>A.URI.revive(g)))}unzip(p){return Promise.resolve(this.channel.call("unzip",[p]))}install(p,g){return Promise.resolve(this.channel.call("install",[p,g])).then(u=>w(u,null))}getManifest(p){return Promise.resolve(this.channel.call("getManifest",[p]))}installFromGallery(p,g){return Promise.resolve(this.channel.call("installFromGallery",[p,g])).then(u=>w(u,null))}uninstall(p,g){return Promise.resolve(this.channel.call("uninstall",[p,g]))}reinstallFromGallery(p){return Promise.resolve(this.channel.call("reinstallFromGallery",[p]))}getInstalled(p=null,g){return Promise.resolve(this.channel.call("getInstalled",[p,g])).then(u=>u.map(f=>w(f,null)))}getMetadata(p){return Promise.resolve(this.channel.call("getMetadata",[p]))}updateMetadata(p,g){return Promise.resolve(this.channel.call("updateMetadata",[p,g])).then(u=>w(u,null))}updateExtensionScope(p,g){return Promise.resolve(this.channel.call("updateExtensionScope",[p,g])).then(u=>w(u,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class S{constructor(p){this.service=p}listen(p,g){throw new Error("Invalid listen")}call(p,g,u){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(ne[91],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function k(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],se([0,1,34,9,24,14,7,148,5]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function I(q){return q.create===!0}e.isFileOpenForWriteOptions=I;var E;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var w;(function(q){q[q.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var m;(function(q){q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=y;function d(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=d;function S(q){return!!(q.capabilities&32768)}e.hasFileCloneCapability=S;function C(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function p(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=p;function g(q){return!!(q.capabilities&2048)}e.hasFileReadCapability=g;function u(q){return y(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=u;var f;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(W,x){super(W);this.code=x}}e.FileSystemProviderError=c;function s(q,W){const x=new c(q.toString(),W);return t(x,W),x}e.createFileSystemProviderError=s;function r(q){return q||s((0,b.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=r;function t(q,W){return q.name=W?`${W} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=t;function i(q){if(!q)return f.Unknown;if(q instanceof c)return q.code;const W=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!W)return f.Unknown;switch(W[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=i;function o(q){if(q instanceof M)return q.fileOperationResult;switch(i(q)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var l;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class a{constructor(W,x,K){this.resource=W,this.operation=x,this.target=K}isOperation(W){return this.operation===W}}e.FileOperationEvent=a;var h;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class v{constructor(W,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=W;const K=new Map;for(const ee of W){const ce=K.get(ee.type);switch(ce?ce.push([ee.resource,ee]):K.set(ee.type,[[ee.resource,ee]]),ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}}for(const[ee,ce]of K)switch(ee){case 1:this.added=D.TernarySearchTree.forUris(()=>x),this.added.fill(ce);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>x),this.updated.fill(ce);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>x),this.deleted.fill(ce);break}}contains(W,...x){return this.doContains(W,{includeChildren:!1},...x)}affects(W,...x){return this.doContains(W,{includeChildren:!0},...x)}doContains(W,x,...K){if(!W)return!1;const ee=K.length>0;return!!((!ee||K.includes(1))&&(this.added?.get(W)||x.includeChildren&&this.added?.findSuperstr(W))||(!ee||K.includes(0))&&(this.updated?.get(W)||x.includeChildren&&this.updated?.findSuperstr(W))||(!ee||K.includes(2))&&(this.deleted?.findSubstr(W)||x.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=v;function R(q,W,x){return!q||!W||q===W||W.length>q.length?!1:(W.charAt(W.length-1)!==n.sep&&(W+=n.sep),x?(0,k.startsWithIgnoreCase)(q,W):q.indexOf(W)===0)}e.isParent=R;class M extends Error{constructor(W,x,K){super(W);this.fileOperationResult=x,this.options=K}}e.FileOperationError=M;class F extends M{constructor(W,x,K){super(W,2,K);this.stat=x}}e.NotModifiedSinceFileOperationError=F;var O;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=N;async function $(q,W){if(!W.hasProvider(A.URI.from({scheme:q.scheme})))return new Promise(x=>{const K=W.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===q.scheme&&ee.added&&(K.dispose(),x())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(W){return(0,T.isNumber)(W)||(W=0),W<H.KB?(0,b.localize)(1,null,W.toFixed(0)):W<H.MB?(0,b.localize)(2,null,(W/H.KB).toFixed(2)):W<H.GB?(0,b.localize)(3,null,(W/H.MB).toFixed(2)):W<H.TB?(0,b.localize)(4,null,(W/H.GB).toFixed(2)):(0,b.localize)(5,null,(W/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var Y;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function te(q){return{maxFileSize:q===0?300*H.MB:16*H.GB,maxHeapSize:q===0?700*H.MB:2*700*H.MB}}e.getPlatformLimits=te});var G=this&&this.__param||function(Q,e){return function(D,n){e(D,n,Q)}};define(ne[176],se([0,1,177,41,13]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(b){this.fileService=b}async checksum(b){const P=(await this.fileService.readFileStream(b)).value;return new Promise((I,E)=>{const w=(0,D.createHash)("md5");(0,n.listenStream)(P,{onData:m=>w.update(m.buffer),onError:m=>E(m),onEnd:()=>I(w.digest("base64").replace(/=+$/,""))})})}};T=me([G(0,k.IFileService)],T),e.ChecksumService=T}),define(ne[178],se([0,1,16,38,10,3,2,41,7,30,13]),function(Q,e,D,n,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends A.Disposable{constructor(y,d){super();this.channel=y,this.extraCapabilities=d,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,I.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,d){const{buffer:S}=await this.channel.call("readFile",[y,d]);return S}readFileStream(y,d,S){const C=(0,b.newWriteableStream)(g=>D.VSBuffer.concat(g.map(u=>D.VSBuffer.wrap(u))).buffer),p=this.channel.listen("readFileStream",[y,d])(g=>{if(g instanceof D.VSBuffer)C.write(g.buffer);else{if(g==="end")C.end();else{let u=g;u instanceof Error||(u=(0,E.createFileSystemProviderError)((0,n.toErrorMessage)(u),E.FileSystemProviderErrorCode.Unknown)),C.error(u),C.end()}p.dispose()}});return S.onCancellationRequested(()=>{C.error((0,k.canceled)()),C.end(),p.dispose()}),C}writeFile(y,d,S){return this.channel.call("writeFile",[y,D.VSBuffer.wrap(d),S])}open(y,d){return this.channel.call("open",[y,d])}close(y){return this.channel.call("close",[y])}async read(y,d,S,C,p){const[g,u]=await this.channel.call("read",[y,d,p]);return S.set(g.buffer.slice(0,u),C),u}write(y,d,S,C,p){return this.channel.call("write",[y,d,D.VSBuffer.wrap(S),C,p])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,d){return this.channel.call("delete",[y,d])}rename(y,d,S){return this.channel.call("rename",[y,d,S])}copy(y,d,S){return this.channel.call("copy",[y,d,S])}cloneFile(y,d){return this.channel.call("cloneFile",[y,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const d=y;this._onDidChange.fire(d.map(S=>({resource:P.URI.revive(S.resource),type:S.type})))}else{const d=y;this._onDidWatchError.fire(d)}}))}watch(y,d){const S=(0,I.generateUuid)();return this.channel.call("watch",[this.sessionId,S,y,d]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=w}),define(ne[92],se([0,1,16,10,149,13]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(E,w,m,y,d,S){let C;try{await b(E,w,m,y,d,S)}catch(p){C=p}finally{C&&d.errorTransformer&&(C=d.errorTransformer(C)),typeof C!="undefined"&&m.error(C),m.end()}}e.readFileIntoStream=A;async function b(E,w,m,y,d,S){P(S);const C=await E.open(w,{create:!1});try{P(S);let p=0,g=0,u=d&&typeof d.length=="number"?d.length:void 0,f=D.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,s=0;do g=await E.read(C,c,f.buffer,s,f.byteLength-s),c+=g,s+=g,p+=g,typeof u=="number"&&(u-=g),s===f.byteLength&&(await m.write(y(f)),f=D.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),s=0);while(g>0&&(typeof u!="number"||u>0)&&P(S)&&I(p,d));if(s>0){let r=s;typeof u=="number"&&(r=Math.min(s,u)),m.write(y(f.slice(0,r)))}}catch(p){throw(0,T.ensureFileSystemProviderError)(p)}finally{await E.close(C)}}function P(E){if(E.isCancellationRequested)throw(0,n.canceled)();return!0}function I(E,w){if(w?.limits){if(typeof w.limits.memory=="number"&&E>w.limits.memory)throw(0,T.createFileSystemProviderError)((0,k.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&E>w.limits.size)throw(0,T.createFileSystemProviderError)((0,k.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],se([0,1,81,2,9,4,7,13]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(p){return p.recursive===!0}e.isRecursiveWatchRequest=P;class I extends n.Disposable{constructor(g,u,f,c){super();this.onFileChanges=g,this.onLogMessage=u,this.verboseLogging=f,this.options=c,this.watcherDisposables=this._register(new n.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new n.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),g.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),g.add(this.watcher.onDidError(u=>this.onError(u)))}onError(g){this.options.restartOnError?this.restartCounter<I.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=I,I.MAX_RESTARTS=5;class E extends I{constructor(g,u,f){super(g,u,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class w extends I{constructor(g,u,f){super(g,u,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function m(p){return p.map(g=>({type:g.type,resource:A.URI.file(g.path)}))}e.toFileChanges=m;function y(p){const g=new C;for(const u of p)g.processEvent(u);return g.coalesce()}e.coalesceEvents=y;function d(p,g){return typeof g=="string"&&!g.startsWith(D.GLOBSTAR)&&!(0,k.isAbsolute)(g)?{base:p,pattern:g}:g}e.normalizeWatcherPattern=d;function S(p,g){const u=[];for(const f of g)u.push((0,D.parse)(d(p,f)));return u}e.parseWatcherPatterns=S;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return T.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const u=this.mapPathToChange.get(this.toKey(g));let f=!1;if(u){const c=u.type,s=g.type;u.path!==g.path&&(g.type===2||g.type===1)?f=!0:c===1&&s===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(u)):c===2&&s===1?u.type=0:c===1&&s===0||(u.type=s)}else f=!0;f&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],u=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(g.push(f),!1):!0).sort((f,c)=>f.path.length-c.path.length).filter(f=>u.some(c=>(0,b.isParent)(f.path,c,!T.isLinux))?!1:(u.push(f.path),!0)).concat(g)}}}),define(ne[179],se([0,1,53,6,21,46,2,79,9,4,129,27,57]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends A.Disposable{constructor(C,p,g,u){super();this.request=C,this.onDidFilesChange=p,this.onLogMessage=g,this.verboseLogging=u,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,m.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,m.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await w.Promises.stat(C);this._register(await this.doWatch(C,p.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(C)}}async normalizePath(C){let p=C.path;try{p=await w.Promises.realpath(C.path),C.path===p&&(p=await(0,E.realcase)(C.path)??C.path),C.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${p})`)}catch{}return p}async doWatch(C,p){if(I.isMacintosh&&(0,T.isEqualOrParent)(C,"/Volumes/",!0))return this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const g=new k.CancellationTokenSource(this.cts.token),u=new A.DisposableStore;try{const f=(0,P.basename)(C),c=(0,D.watch)(C);u.add((0,A.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${C}'`);const s=new Set;if(p)try{for(const t of await w.Promises.readdir(C))s.add(t)}catch(t){this.error(t)}const r=new Map;u.add((0,A.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),c.on("error",(t,i)=>{this.error(`Failed to watch ${C} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),c.on("change",(t,i)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${i}`);let o="";if(i&&(o=i.toString(),I.isMacintosh&&(o=(0,b.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(p)if(t==="rename"){r.get(o)?.dispose();const l=setTimeout(async()=>{if(r.delete(o),o===f&&!await w.Promises.exists(C)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,P.join)(C,o));if(g.token.isCancellationRequested)return;let h;a?s.has(o)?h=0:(h=1,s.add(o)):(s.delete(o),h=2),this.onFileChange({path:(0,P.join)(this.request.path,o),type:h})},y.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,A.toDisposable)(()=>clearTimeout(l)))}else{let l;s.has(o)?l=0:(l=1,s.add(o)),this.onFileChange({path:(0,P.join)(this.request.path,o),type:l})}else if(t==="rename"||o!==f){const l=setTimeout(async()=>{const a=await w.Promises.exists(C);g.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),u.add(await this.doWatch(C,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);u.clear(),u.add((0,A.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await w.Promises.exists(C)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${C} for changes using fs.watch() (${f.toString()})`)}return(0,A.toDisposable)(()=>{g.dispose(!0),u.dispose()})}async onFileChange(C,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),!p&&this.excludes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${C.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${C.path}`):this.fileChangesBuffer.push(C);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,m.coalesceEvents)(g);if(u.length>0){if(this.verboseLogging)for(const c of u)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(u)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(C){if(I.isLinux)return w.Promises.exists(C);try{const p=(0,P.basename)(C);return(await w.Promises.readdir((0,P.dirname)(C))).some(u=>u===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function d(S,C,p,g,u=512){const f=await w.Promises.open(S,"r"),c=Buffer.allocUnsafe(u),s=new k.CancellationTokenSource(g);let r,t=!1;const i={path:S,excludes:[],recursive:!1},o=new y(i,l=>{(async()=>{for(const{type:a}of l)if(a===0){if(t)return;t=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:h}=await w.Promises.read(f,c,0,u,null);if(!h||s.token.isCancellationRequested)break;C(c.slice(0,h))}}catch(h){r=new Error(h),s.dispose(!0)}finally{t=!1}}})()});return await o.ready,p(),new Promise((l,a)=>{s.token.onCancellationRequested(async()=>{o.dispose();try{await w.Promises.close(f)}catch(h){r=new Error(h)}r?a(r):l()})})}e.watchFileContents=d}),define(ne[180],se([0,1,3,81,2,4,179]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(I){const E=this.normalizeRequests(I),w=E.filter(y=>{const d=this.watchers.get(y.path);return d?!(0,n.patternsEquals)(d.request.excludes,y.excludes)||!(0,n.patternsEquals)(d.request.includes,y.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:y})=>!E.find(d=>d.path===y.path&&(0,n.patternsEquals)(d.excludes,y.excludes)&&(0,n.patternsEquals)(d.includes,y.includes))).map(({request:y})=>y.path);w.length&&this.trace(`Request to start watching: ${w.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const y of m)this.stopWatching(y);for(const y of w)this.startWatching(y)}startWatching(I){const E=new A.NodeJSFileWatcherLibrary(I,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),w={request:I,instance:E};this.watchers.set(I.path,w)}async stop(){for(const[I]of this.watchers)this.stopWatching(I);this.watchers.clear()}stopWatching(I){const E=this.watchers.get(I);E&&(this.watchers.delete(I),E.instance.dispose())}normalizeRequests(I){const E=new Map;for(const w of I){const m=T.isLinux?w.path:w.path.toLowerCase();E.set(m,w)}return Array.from(E.values())}async setVerboseLogging(I){this.verboseLogging=I;for(const[,E]of this.watchers)E.instance.setVerboseLogging(I)}trace(I){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(I)})}toMessage(I,E){return E?`[File Watcher (node.js)] ${I} (path: ${E.request.path})`:`[File Watcher (node.js)] ${I}`}}e.NodeJSWatcher=b}),define(ne[181],se([0,1,57,180]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends D.AbstractNonRecursiveWatcherClient{constructor(A,b,P){super(A,b,P);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ne[182],se([0,1,20,39,64,57]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(P,I,E){super(P,I,E);this.init()}createWatcher(P){const I=P.add(new k.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(I.onDidProcessExit(({code:E,signal:w})=>this.onError(`terminated by itself with code ${E}, signal: ${w}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(I.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ne[93],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...k){this._entries=new Map;for(const[T,A]of k)this.set(T,A)}set(k,T){const A=this._entries.get(k);return this._entries.set(k,T),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=D}),define(ne[183],se([0,1,6,10,56,172,5,93]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class I extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class E{constructor(d=new b.ServiceCollection,S=!1,C){this._activeInstantiations=new Set,this._services=d,this._strict=S,this._parent=C,this._services.set(A.IInstantiationService,this)}createChild(d){return new E(d,this._strict,this)}invokeFunction(d,...S){const C=m.traceInvocation(d);let p=!1;try{return d({get:u=>{if(p)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(u,C);if(!f)throw new Error(`[invokeFunction] unknown service '${u}'`);return f}},...S)}finally{p=!0,C.stop()}}createInstance(d,...S){let C,p;return d instanceof k.SyncDescriptor?(C=m.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(S),C)):(C=m.traceCreation(d),p=this._createInstance(d,S,C)),C.stop(),p}_createInstance(d,S=[],C){const p=A._util.getServiceDependencies(d).sort((f,c)=>f.index-c.index),g=[];for(const f of p){const c=this._getOrCreateServiceInstance(f.id,C);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${f.id}.`,!1),g.push(c)}const u=p.length>0?p[0].index:S.length;if(S.length!==u){console.trace(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${S.length} static arguments`);const f=u-S.length;f>0?S=S.concat(new Array(f)):S=S.slice(0,u)}return new d(...[...S,...g])}_setServiceInstance(d,S){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,S);else if(this._parent)this._parent._setServiceInstance(d,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const S=this._services.get(d);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):S}_getOrCreateServiceInstance(d,S){const C=this._getServiceInstanceOrDescriptor(d);return C instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,C,S.branch(d,!0)):(S.branch(d,!1),C)}_safeCreateAndCacheServiceInstance(d,S,C){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,S,C)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,S,C){const p=new T.Graph(f=>f.id.toString());let g=0;const u=[{id:d,desc:S,_trace:C}];for(;u.length;){const f=u.pop();if(p.lookupOrInsertNode(f),g++>1e3)throw new I(p);for(const c of A._util.getServiceDependencies(f.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(c.id);if(s||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),s instanceof k.SyncDescriptor){const r={id:c.id,desc:s,_trace:f._trace.branch(c.id,!0)};p.insertEdge(f,r),u.push(r)}}}for(;;){const f=p.roots();if(f.length===0){if(!p.isEmpty())throw new I(p);break}for(const{data:c}of f){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,r)}p.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,S,C=[],p,g){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(S,C,p,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,S,C,p,g);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(d,S=[],C,p){if(C){const g=new D.IdleValue(()=>this._createInstance(d,S,p));return new Proxy(Object.create(null),{get(u,f){if(f in u)return u[f];const c=g.value;let s=c[f];return typeof s!="function"||(s=s.bind(c),u[f]=s),s},set(u,f,c){return g.value[f]=c,!0}})}else return this._createInstance(d,S,p)}_throwIfStrict(d,S){if(S&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=E;var w;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(w||(w={}));class m{constructor(d,S){this.type=d,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return P?new m(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(d){return P?new m(0,d.name):m._None}branch(d,S){const C=new m(2,d.toString());return this._dep.push([d,S,C]),C}stop(){const d=Date.now()-this._start;m._totals+=d;let S=!1;function C(g,u){const f=[],c=new Array(g+1).join("	");for(const[s,r,t]of u._dep)if(r&&t){S=!0,f.push(`${c}CREATES -> ${s}`);const i=C(g+1,t);i&&f.push(i)}else f.push(`${c}uses -> ${s}`);return f.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(d>2||S)&&console.log(p.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(ne[184],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(k,T){this.server=k,this.router=T}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,T){this.server.registerChannel(k,T)}}e.MessagePortMainProcessService=D}),define(ne[94],se([0,1,39,56,88,5]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(y,d,S){const C=S.getChannel(y);return b(d)?new d.channelClientCtor(C):D.ProxyChannel.toService(C,d?.proxyOptions)}}function b(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let P=class extends A{constructor(y,d,S){super(y,d,S)}};P=me([G(2,e.IMainProcessService)],P);function I(m,y,d){(0,k.registerSingleton)(m,new n.SyncDescriptor(P,[y,d],d?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=I,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let E=class extends A{constructor(y,d,S){super(y,d,S)}};E=me([G(2,e.ISharedProcessService)],E);function w(m,y,d){(0,k.registerSingleton)(m,new n.SyncDescriptor(E,[y,d],d?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=w}),define(ne[66],se([0,1,21,2,4,151,29,5]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let P=class extends n.Disposable{constructor(E){super();this.extensionGalleryService=E}async getAvailableLanguages(){const E=new D.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let w;try{w=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const y=w.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(S=>S.startsWith("lp-"))).map(d=>{const S=d.properties.localizedLanguages?.[0],C=this.getLocale(d);return{...this.createQuickPickItem(C,S,d),extensionId:d.identifier.id,galleryExtension:d}});return y.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),y}getLocale(E){return E.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(E,w,m){const y=w??E;let d;if(y!==E&&(d=`(${E})`),E.toLowerCase()===k.language.toLowerCase()&&(d??(d=""),d+=(0,T.localize)(0,null)),m?.installCount){d??(d="");const S=m.installCount;let C;S>1e6?C=`${Math.floor(S/1e5)/10}M`:S>1e3?C=`${Math.floor(S/1e3)}K`:C=String(S),d+=` $(cloud-download) ${C}`}return{id:E,label:y,description:d}}};P=me([G(0,A.IExtensionGalleryService)],P),e.LanguagePackBaseService=P}),define(ne[185],se([0,1,2,66]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=me([G(0,n.ILanguagePackService)],k),e.LocalizationsUpdater=k}),define(ne[8],se([0,1,38,3,2,4,5]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function b(){return new Date().toISOString()}var P;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(P=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=P.Info;function I(r,t,i){switch(t){case P.Trace:r.trace(i);break;case P.Debug:r.debug(i);break;case P.Info:r.info(i);break;case P.Warning:r.warn(i);break;case P.Error:r.error(i);break;case P.Critical:r.critical(i);break;default:throw new Error("Invalid log level")}}e.log=I;function E(r){let t="";for(let i=0;i<r.length;i++){let o=r[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(i>0?" ":"")+o}return t}e.format=E;class w extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class m extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(P.Trace)&&this.log(P.Trace,E([t,...i]))}debug(t,...i){this.checkLogLevel(P.Debug)&&this.log(P.Debug,E([t,...i]))}info(t,...i){this.checkLogLevel(P.Info)&&this.log(P.Info,E([t,...i]))}warn(t,...i){this.checkLogLevel(P.Warning)&&this.log(P.Warning,E([t,...i]))}error(t,...i){if(this.checkLogLevel(P.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(P.Error,E(o))}else this.log(P.Error,E([t,...i]))}critical(t,...i){this.checkLogLevel(P.Critical)&&this.log(P.Critical,E([t,...i]))}flush(){}}e.AbstractMessageLogger=m;class y extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...i){this.getLevel()<=P.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,t,...i):console.log(`[main ${b()}]`,t,...i))}debug(t,...i){this.getLevel()<=P.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,t,...i):console.log(`[main ${b()}]`,t,...i))}info(t,...i){this.getLevel()<=P.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,t,...i):console.log(`[main ${b()}]`,t,...i))}warn(t,...i){this.getLevel()<=P.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,t,...i):console.warn(`[main ${b()}]`,t,...i))}error(t,...i){this.getLevel()<=P.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,t,...i):console.error(`[main ${b()}]`,t,...i))}critical(t,...i){this.getLevel()<=P.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,t,...i):console.error(`[main ${b()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class d extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=P.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=P.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=P.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=P.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=P.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=P.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=d;class S extends w{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=P.Trace&&this.adapter.log(P.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=P.Debug&&this.adapter.log(P.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=P.Info&&this.adapter.log(P.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=P.Warning&&this.adapter.log(P.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=P.Error&&this.adapter.log(P.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=P.Critical&&this.adapter.log(P.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=P.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class C extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const o of this.logServices)o.trace(t,...i)}debug(t,...i){for(const o of this.logServices)o.debug(t,...i)}info(t,...i){for(const o of this.logServices)o.info(t,...i)}warn(t,...i){for(const o of this.logServices)o.warn(t,...i)}error(t,...i){for(const o of this.logServices)o.error(t,...i)}critical(t,...i){for(const o of this.logServices)o.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=C;class p extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=p;class g extends k.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,i){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,i?.always?P.Trace:this.logLevel,i),this.loggers.set(t.toString(),o),i?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class u{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(t){}getLevel(){return P.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=u;function f(r){if(r.verbose)return P.Trace;if(typeof r.logLevel=="string"){const t=c(r.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function c(r){switch(r){case"trace":return P.Trace;case"debug":return P.Debug;case"info":return P.Info;case"warn":return P.Warning;case"error":return P.Error;case"critical":return P.Critical;case"off":return P.Off}}e.parseLogLevel=c;function s(r){switch(r){case P.Trace:return"trace";case P.Debug:return"debug";case P.Info:return"info";case P.Warning:return"warn";case P.Error:return"error";case P.Critical:return"critical";case P.Off:return"off"}}e.LogLevelToString=s}),define(ne[186],se([0,1,6,10,2,9,27,15,8]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let I=class extends k.Disposable{constructor(w,m){super();this.environmentService=w,this.logService=m,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,T.basename)(this.environmentService.logsPath),m=(0,T.dirname)(this.environmentService.logsPath),S=(await A.Promises.readdir(m)).filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter(p=>p!==w),C=S.slice(0,Math.max(0,S.length-9));C.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${C.join(", ")}'`),await Promise.all(C.map(p=>A.Promises.rm((0,T.join)(m,p)))))}catch(w){(0,n.onUnexpectedError)(w)}}};I=me([G(0,b.IEnvironmentService),G(1,P.ILogService)],I),e.LogsDataCleaner=I}),define(ne[187],se([0,1,6,10,2,9,27,15,8]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let I=class ft extends k.Disposable{constructor(w,m,y){super();this.backupWorkspacesPath=w,this.environmentService=m,this.logService=y,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const w=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),y=JSON.parse(w).emptyWorkspaceInfos.map(S=>S.backupFolder),d=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(d.map(async S=>{S.length===ft.NON_EMPTY_WORKSPACE_ID_LENGTH||S===ft.EXTENSION_DEV_EMPTY_WINDOW_ID||y.indexOf(S)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(w){(0,n.onUnexpectedError)(w)}}};I.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,I.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",I=me([G(1,b.INativeEnvironmentService),G(2,P.ILogService)],I),e.StorageDataCleaner=I}),define(ne[188],se([0,1,18,6,10,3,2,9,57,8]),function(Q,e,D,n,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends A.Disposable{constructor(m,y){super();this.logService=m,this.options=y,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(m,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,y):this.watchNonRecursive(m,y)}watchUniversal(m,y){const d={path:this.toFilePath(m),excludes:y.excludes,includes:y.includes,recursive:y.recursive},S=(0,D.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,k.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,P.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const y of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const y of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(y)&&m.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,y){const d={path:this.toFilePath(m),excludes:y.excludes,includes:y.includes,recursive:!1},S=(0,D.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,k.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,P.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,b.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(ne[189],se([0,1,18,6,16,21,3,62,51,2,34,20,190,17,41,147,13,92,8]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends I.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,s){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${c}`);const r=new I.DisposableStore;return this.provider.set(c,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:s}),r.add(s.onDidChangeFile(t=>this._onDidFilesChange.fire(new C.FileChangesEvent(t,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&r.add(s.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),r.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:c}))),(0,I.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:s}),this.provider.delete(c),(0,I.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){s.push(r)}}),!this.provider.has(c)&&await n.Promises.settled(s)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,s){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&s)}listCapabilities(){return P.Iterable.map(this.provider,([c,s])=>({scheme:c,capabilities:s.capabilities}))}async withProvider(c){if(!(0,y.isAbsolutePath)(c))throw new C.FileOperationError((0,S.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const s=this.provider.get(c.scheme);if(!s){const r=new Error;throw r.name="ENOPRO",r.message=(0,S.localize)(1,null,c.toString()),r}return s}async withReadProvider(c){const s=await this.withProvider(c);if((0,C.hasOpenReadWriteCloseCapability)(s)||(0,C.hasReadWriteCapability)(s)||(0,C.hasFileReadStreamCapability)(s)||(0,C.hasFileReadCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream, FileOpenReadWriteClose nor Readonly capability which is needed for the read operation.`)}async withWriteProvider(c){const s=await this.withProvider(c);if((0,C.hasOpenReadWriteCloseCapability)(s)||(0,C.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,s){try{return await this.doResolveFile(c,s)}catch(r){throw(0,C.toFileSystemProviderErrorCode)(r)===C.FileSystemProviderErrorCode.FileNotFound?new C.FileOperationError((0,S.localize)(2,null,this.resourceForError(c)),1):(0,C.ensureFileSystemProviderError)(r)}}async doResolveFile(c,s){const r=await this.withProvider(c),t=this.isPathCaseSensitive(r),i=s?.resolveTo,o=s?.resolveSingleChildDescendants,l=s?.resolveMetadata,a=await r.stat(c);let h;return this.toFileStat(r,c,a,void 0,!!l,(v,R)=>(h||(h=E.TernarySearchTree.forUris(()=>!t),h.set(c,!0),i&&h.fill(!0,i)),h.get(v.resource)||h.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&o?R===1:!1))}async toFileStat(c,s,r,t,i,o){const{providerExtUri:l}=this.getExtUri(c),a={resource:s,name:l.basename(s),isFile:(r.type&C.FileType.File)!=0,isDirectory:(r.type&C.FileType.Directory)!=0,isSymbolicLink:(r.type&C.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&C.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,C.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(a.isDirectory&&o(a,t)){try{const h=await c.readdir(s),v=await n.Promises.settled(h.map(async([R,M])=>{try{const F=l.joinPath(s,R),O=i?await c.stat(F):{type:M};return await this.toFileStat(c,F,O,h.length,i,o)}catch(F){return this.logService.trace(F),null}}));a.children=(0,D.coalesce)(v)}catch(h){this.logService.trace(h),a.children=[]}return a}return a}async resolveAll(c){return n.Promises.settled(c.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(c){const s=await this.withProvider(c),r=await s.stat(c);return this.toFileStat(s,c,r,void 0,!0,()=>!1)}async exists(c){const s=await this.withProvider(c);try{return!!await s.stat(c)}catch{return!1}}async canCreateFile(c,s){try{await this.doValidateCreateFile(c,s)}catch(r){return r}return!0}async doValidateCreateFile(c,s){if(!s?.overwrite&&await this.exists(c))throw new C.FileOperationError((0,S.localize)(3,null,this.resourceForError(c)),3,s)}async createFile(c,s=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const t=await this.writeFile(c,s);return this._onDidRunOperation.fire(new C.FileOperationEvent(c,0,t)),t}async writeFile(c,s,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(t);try{await this.validateWriteFile(t,c,r)||await this.mkdirp(t,i.dirname(c));let l;if((0,C.hasReadWriteCapability)(t)&&!(s instanceof k.VSBuffer))if((0,d.isReadableStream)(s)){const a=await(0,d.peekStream)(s,3);a.ended?l=k.VSBuffer.concat(a.buffer):l=a}else l=(0,d.peekReadable)(s,a=>k.VSBuffer.concat(a),3);else l=s;!(0,C.hasOpenReadWriteCloseCapability)(t)||(0,C.hasReadWriteCapability)(t)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(t,c,r,l):await this.doWriteBuffered(t,c,r,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l),this._onDidRunOperation.fire(new C.FileOperationEvent(c,4))}catch(o){throw new C.FileOperationError((0,S.localize)(4,null,this.resourceForError(c),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,s,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(s)));let i;try{i=await c.stat(s)}catch{return}if((i.type&C.FileType.Directory)!=0)throw new C.FileOperationError((0,S.localize)(6,null,this.resourceForError(s)),0,r);if(this.throwIfFileIsReadonly(s,i),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==C.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&r.mtime<i.mtime&&r.etag!==(0,C.etag)({mtime:r.mtime,size:i.size}))throw new C.FileOperationError((0,S.localize)(7,null),3,r);return i}async readFile(c,s,r){const t=await this.withReadProvider(c);return s?.atomic?this.doReadFileAtomic(t,c,s,r):this.doReadFile(t,c,s,r)}async doReadFileAtomic(c,s,r,t){return new Promise((i,o)=>{this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(c,s,r,t);i(l)}catch(l){o(l)}})})}async doReadFile(c,s,r,t){const i=await this.doReadFileStream(c,s,{...r,preferUnbuffered:!0},t);return{...i,value:await(0,k.streamToBuffer)(i.value)}}async readFileStream(c,s,r){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,s,r)}async doReadFileStream(c,s,r,t){const i=new T.CancellationTokenSource(t),o=this.validateReadFile(s,r).then(a=>a,a=>{throw i.cancel(),a});let l;try{return typeof r?.etag=="string"&&r.etag!==C.ETAG_DISABLED&&await o,r?.atomic&&(0,C.hasFileAtomicReadCapability)(c)||!((0,C.hasOpenReadWriteCloseCapability)(c)||(0,C.hasFileReadStreamCapability)(c))||(0,C.hasReadWriteCapability)(c)&&r?.preferUnbuffered?l=this.readFileUnbuffered(c,s,r):(0,C.hasFileReadStreamCapability)(c)?l=this.readFileStreamed(c,s,i.token,r):l=this.readFileBuffered(c,s,i.token,r),{...await o,value:l}}catch(a){l&&await(0,d.consumeStream)(l);const h=(0,S.localize)(8,null,this.resourceForError(s),(0,C.ensureFileSystemProviderError)(a).toString());throw a instanceof C.NotModifiedSinceFileOperationError?new C.NotModifiedSinceFileOperationError(h,a.stat,r):new C.FileOperationError(h,(0,C.toFileOperationResult)(a),r)}}readFileStreamed(c,s,r,t=Object.create(null)){const i=c.readFileStream(s,t,r);return(0,d.transform)(i,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new C.FileOperationError((0,S.localize)(9,null,this.resourceForError(s),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),t)},o=>k.VSBuffer.concat(o))}readFileBuffered(c,s,r,t=Object.create(null)){const i=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(c,s,i,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new C.FileOperationError((0,S.localize)(10,null,this.resourceForError(s),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),t)},r),i}readFileUnbuffered(c,s,r){const t=(0,d.newWriteableStream)(i=>k.VSBuffer.concat(i));return(async()=>{try{let i;r?.atomic&&(0,C.hasFileAtomicReadCapability)(c)?i=await c.readFile(s,{atomic:!0}):i=await c.readFile(s),typeof r?.position=="number"&&(i=i.slice(r.position)),typeof r?.length=="number"&&(i=i.slice(0,r.length)),this.validateReadFileLimits(s,i.byteLength,r),t.end(k.VSBuffer.wrap(i))}catch(i){t.error(i),t.end()}})(),t}async validateReadFile(c,s){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new C.FileOperationError((0,S.localize)(11,null,this.resourceForError(c)),0,s);if(typeof s?.etag=="string"&&s.etag!==C.ETAG_DISABLED&&s.etag===r.etag)throw new C.NotModifiedSinceFileOperationError((0,S.localize)(12,null),r,s);return this.validateReadFileLimits(c,r.size,s),r}validateReadFileLimits(c,s,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&s>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&s>r.limits.size&&(t=7),typeof t=="number")throw new C.FileOperationError((0,S.localize)(13,null,this.resourceForError(c)),t)}}async canMove(c,s,r){return this.doCanMoveCopy(c,s,"move",r)}async canCopy(c,s,r){return this.doCanMoveCopy(c,s,"copy",r)}async doCanMoveCopy(c,s,r,t){if(c.toString()!==s.toString())try{const i=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,c,o,s,r,t)}catch(i){return i}return!0}async move(c,s,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(t,c,i,s,"move",!!r),l=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,o==="move"?2:3,l)),l}async copy(c,s,r){const t=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(t,c,i,s,"copy",!!r),l=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,o==="copy"?3:2,l)),l}async doMoveCopy(c,s,r,t,i,o){if(s.toString()===t.toString())return i;const{exists:l,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,s,r,t,i,o);if(l&&!a&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),i==="copy"){if(c===r&&(0,C.hasFileFolderCopyCapability)(c))await c.copy(s,t,{overwrite:o});else{const h=await this.resolve(s);h.isDirectory?await this.doCopyFolder(c,h,r,t):await this.doCopyFile(c,s,r,t)}return i}else return c===r?(await c.rename(s,t,{overwrite:o}),i):(await this.doMoveCopy(c,s,r,t,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(c,s,r,t){if((0,C.hasOpenReadWriteCloseCapability)(c)&&(0,C.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,s,r,t);if((0,C.hasOpenReadWriteCloseCapability)(c)&&(0,C.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,s,r,t);if((0,C.hasReadWriteCapability)(c)&&(0,C.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,s,r,t);if((0,C.hasReadWriteCapability)(c)&&(0,C.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,s,r,t)}async doCopyFolder(c,s,r,t){await r.mkdir(t),Array.isArray(s.children)&&await n.Promises.settled(s.children.map(async i=>{const o=this.getExtUri(r).providerExtUri.joinPath(t,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),r,o):this.doCopyFile(c,i.resource,r,o)}))}async doValidateMoveCopy(c,s,r,t,i,o){let l=!1;if(c===r){const{providerExtUri:h,isPathCaseSensitive:v}=this.getExtUri(c);if(v||(l=h.isEqual(s,t)),l&&i==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(s),this.resourceForError(t)));if(!l&&h.isEqualOrParent(t,s))throw new Error((0,S.localize)(15,null,this.resourceForError(s),this.resourceForError(t)))}const a=await this.exists(t);if(a&&!l){if(!o)throw new C.FileOperationError((0,S.localize)(16,null,this.resourceForError(s),this.resourceForError(t)),4);if(c===r){const{providerExtUri:h}=this.getExtUri(c);if(h.isEqualOrParent(s,t))throw new Error((0,S.localize)(17,null,this.resourceForError(s),this.resourceForError(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:l}}getExtUri(c){const s=this.isPathCaseSensitive(c);return{providerExtUri:s?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(s,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,0,r)),r}async mkdirp(c,s){const r=[],{providerExtUri:t}=this.getExtUri(c);for(;!t.isEqual(s,t.dirname(s));)try{if(((await c.stat(s)).type&C.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(s)));break}catch(i){if((0,C.toFileSystemProviderErrorCode)(i)!==C.FileSystemProviderErrorCode.FileNotFound)throw i;r.push(t.basename(s)),s=t.dirname(s)}for(let i=r.length-1;i>=0;i--){s=t.joinPath(s,r[i]);try{await c.mkdir(s)}catch(o){if((0,C.toFileSystemProviderErrorCode)(o)!==C.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,s){try{await this.doValidateDelete(c,s)}catch(r){return r}return!0}async doValidateDelete(c,s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!s?.useTrash&&!(r.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(c)));let i;try{i=await r.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new C.FileOperationError((0,S.localize)(20,null,this.resourceForError(c)),1);if(!!!s?.recursive){const l=await this.resolve(c);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(c)))}return r}async del(c,s){const r=await this.doValidateDelete(c,s),t=!!s?.useTrash,i=!!s?.recursive;await r.delete(c,{recursive:i,useTrash:t}),this._onDidRunOperation.fire(new C.FileOperationEvent(c,1))}async cloneFile(c,s){const r=await this.withProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(r===t&&this.getExtUri(r).providerExtUri.isEqual(c,s))return;if(r===t&&(0,C.hasFileCloneCapability)(r))return r.cloneFile(c,s);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s));const i=this.writeQueue.queueFor(c,this.getExtUri(r).providerExtUri);return r===t&&(0,C.hasFileFolderCopyCapability)(r)?i.queue(()=>r.copy(c,s,{overwrite:!0})):i.queue(()=>this.doCopyFile(r,c,t,s))}watch(c,s={recursive:!1,excludes:[]}){const r=new I.DisposableStore;let t=!1,i=()=>{t=!0};return r.add((0,I.toDisposable)(()=>i())),(async()=>{try{const o=await this.doWatch(c,s);t?(0,I.dispose)(o):i=()=>(0,I.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(c,s){const r=await this.withProvider(c),t=(0,b.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(c),s]);let i=this.activeWatchers.get(t);return i||(i={count:0,disposable:r.watch(c,s)},this.activeWatchers.set(t,i)),i.count+=1,(0,I.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,I.dispose)(i.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,I.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,s,r,t){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(s,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(t)||(0,d.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(c,i,t):await this.doWriteReadableBufferedQueued(c,i,t)}catch(o){throw(0,C.ensureFileSystemProviderError)(o)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,s,r){let t=0,i;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,s,o,o.byteLength,t,0),t+=o.byteLength}if(r.ended)return;i=r.stream}else i=r;return new Promise((o,l)=>{(0,d.listenStream)(i,{onData:async a=>{i.pause();try{await this.doWriteBuffer(c,s,a,a.byteLength,t,0)}catch(h){return l(h)}t+=a.byteLength,setTimeout(()=>i.resume())},onError:a=>l(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,s,r){let t=0,i;for(;(i=r.read())!==null;)await this.doWriteBuffer(c,s,i,i.byteLength,t,0),t+=i.byteLength}async doWriteBuffer(c,s,r,t,i,o){let l=0;for(;l<t;)l+=await c.write(s,i+l,r.buffer,o+l,t-l)}async doWriteUnbuffered(c,s,r,t){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,s,r,t))}async doWriteUnbufferedQueued(c,s,r,t){let i;t instanceof k.VSBuffer?i=t:(0,d.isReadableStream)(t)?i=await(0,k.streamToBuffer)(t):(0,d.isReadableBufferedStream)(t)?i=await(0,k.bufferedStreamToBuffer)(t):i=(0,k.readableToBuffer)(t),await c.writeFile(s,i.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,s,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,s,r,t))}async doPipeBufferedQueued(c,s,r,t){let i,o;try{i=await c.open(s,{create:!1}),o=await r.open(t,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,h=0,v=0;do v=await c.read(i,a,l.buffer,h,l.byteLength-h),await this.doWriteBuffer(r,o,l,v,a,h),a+=v,h+=v,h===l.byteLength&&(h=0);while(v>0)}catch(l){throw(0,C.ensureFileSystemProviderError)(l)}finally{await n.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,s,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,s,r,t))}async doPipeUnbufferedQueued(c,s,r,t){return r.writeFile(t,await c.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,s,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,s,r,t))}async doPipeUnbufferedToBufferedQueued(c,s,r,t){const i=await r.open(t,{create:!0,unlock:!1});try{const o=await c.readFile(s);await this.doWriteBuffer(r,i,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,C.ensureFileSystemProviderError)(o)}finally{await r.close(i)}}async doPipeBufferedToUnbuffered(c,s,r,t){const i=await(0,k.streamToBuffer)(this.readFileBuffered(c,s,T.CancellationToken.None));await this.doWriteUnbuffered(r,t,void 0,i)}throwIfFileSystemIsReadonly(c,s){if(c.capabilities&2048)throw new C.FileOperationError((0,S.localize)(22,null,this.resourceForError(s)),6);return c}throwIfFileIsReadonly(c,s){if((s.permissions??0)&C.FilePermission.Readonly)throw new C.FileOperationError((0,S.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===w.Schemas.file?c.fsPath:c.toString(!0)}};u=me([G(0,g.ILogService)],u),e.FileService=u}),define(ne[191],se([0,1,53,273,6,34,16,3,46,2,9,4,17,41,27,150,13,92,188,38,182,181]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g,u,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(r)}`)}})();class s extends g.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i);this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new T.ResourceMap(o=>m.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:o}=await d.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(t){try{const i=await d.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(t,l.name))).type:a=this.toType(l),o.push([l.name,a])}catch(a){this.logService.trace(a)}})),o}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let o;return i?.dangling?o=C.FileType.Unknown:t.isFile()?o=C.FileType.File:t.isDirectory()?o=C.FileType.Directory:o=C.FileType.Unknown,i&&(o|=C.FileType.SymbolicLink),o}async createResourceLock(t){const i=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const l=new k.Barrier;return this.resourceLocks.set(t,l),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,I.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===l&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(t,i){let o;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const l=this.toFilePath(t);return await d.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{o?.dispose()}}readFileStream(t,i,o){const l=(0,y.newWriteableStream)(a=>A.VSBuffer.concat(a.map(h=>A.VSBuffer.wrap(h))).buffer);return(0,p.readFileIntoStream)(this,t,l,a=>a.buffer,{...i,bufferSize:256*1024},o),l}async writeFile(t,i,o){let l;try{const a=this.toFilePath(t);if(!o.create||!o.overwrite){if(await d.Promises.exists(a)){if(!o.overwrite)throw(0,C.createFileSystemProviderError)((0,S.localize)(0,null),C.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,C.createFileSystemProviderError)((0,S.localize)(1,null),C.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(l,0,i,0,i.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(t,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(t){s.canFlush=t}async open(t,i){const o=this.toFilePath(t);let l;(0,C.isFileOpenForWriteOptions)(i)&&(l=await this.createResourceLock(t));let a;try{if((0,C.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:v}=await d.SymlinkSupport.stat(o);v.mode&128||await d.Promises.chmod(o,v.mode|128)}catch(v){this.logService.trace(v)}let h;if((0,C.isFileOpenForWriteOptions)(i)){if(w.isWindows)try{await d.Promises.truncate(o,0),h="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}h||(h="w")}else h="r";a=await d.Promises.open(o,h)}catch(h){throw l?.dispose(),(0,C.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(a,0),(0,C.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,t),l){const h=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,l),h&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),h.dispose())}return a}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&s.canFlush)try{await d.Promises.fdatasync(t)}catch(o){s.configureFlushOnWrite(!1),this.logService.error(o)}return await d.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,o,l,a){const h=this.normalizePos(t,i);let v=null;try{v=(await d.Promises.read(t,o,l,a,h)).bytesRead}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(t,h,v)}return v}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,o){const l=this.mapHandleToPos.get(t);typeof l=="number"&&(typeof i=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,l+o):this.mapHandleToPos.delete(t)))}async write(t,i,o,l,a){return(0,k.retry)(()=>this.doWrite(t,i,o,l,a),100,3)}async doWrite(t,i,o,l,a){const h=this.normalizePos(t,i);let v=null;try{v=(await d.Promises.write(t,o,l,a,h)).bytesWritten}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),R)}finally{this.updatePos(t,h,v)}return v}async mkdir(t){try{await d.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const o=this.toFilePath(t);i.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,i,o){const l=this.toFilePath(t),a=this.toFilePath(i);if(l!==a)try{await this.validateTargetDeleted(t,i,"move",o.overwrite),await d.Promises.move(l,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(2,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(t,i,o){const l=this.toFilePath(t),a=this.toFilePath(i);if(l!==a)try{await this.validateTargetDeleted(t,i,"copy",o.overwrite),await d.Promises.copy(l,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(3,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(t,i,o,l){const a=this.toFilePath(t),h=this.toFilePath(i);let v=!1;if(!!(this.capabilities&1024)||(v=(0,P.isEqual)(a,h,!0)),v&&o==="copy")throw(0,C.createFileSystemProviderError)((0,S.localize)(4,null),C.FileSystemProviderErrorCode.FileExists);if(!v&&await d.Promises.exists(h)){if(!l)throw(0,C.createFileSystemProviderError)((0,S.localize)(5,null),C.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,o){const l=this.toFilePath(t),a=this.toFilePath(i),h=!!(this.capabilities&1024);if((0,P.isEqual)(l,a,!h))return;const v=new I.DisposableStore;try{const[R,M]=await Promise.all([this.createResourceLock(t),this.createResourceLock(i)]);v.add(R),v.add(M),o&&await d.Promises.mkdir((0,E.dirname)(a),{recursive:!0}),await d.Promises.copyFile(l,a)}catch(R){if(R.code==="ENOENT"&&!o)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(R)}finally{v.dispose()}}createUniversalWatcher(t,i,o){return new f.UniversalWatcherClient(l=>t(l),l=>i(l),o)}createNonRecursiveWatcher(t,i,o){return new c.NodeJSWatcherClient(l=>t(l),l=>i(l),o)}toFileSystemProviderError(t){if(t instanceof C.FileSystemProviderError)return t;let i;switch(t.code){case"ENOENT":i=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=C.FileSystemProviderErrorCode.NoPermissions;break;default:i=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(t,i)}async toFileSystemProviderWriteError(t,i){let o=this.toFileSystemProviderError(i);if(t&&o.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await d.SymlinkSupport.stat(this.toFilePath(t));l.mode&128||(o=(0,C.createFileSystemProviderError)(i,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return o}}e.DiskFileSystemProvider=s,s.canFlush=!0}),define(ne[95],se([0,1,3,7,8]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(m){this.service=m,this.onDidChangeLogLevel=D.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(m,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=T;class A{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){A.setLevel(this.channel,m)}static setLevel(m,y){return m.call("setLevel",y)}}e.LogLevelChannelClient=A;class b{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,y){throw new Error(`Event not found: ${y}`)}async call(m,y,d){switch(y){case"createLogger":this.createLogger(n.URI.revive(d[0]),d[1]);return;case"log":return this.log(n.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(m,y){this.loggers.set(m.toString(),this.loggerService.createLogger(m,y))}consoleLog(m,y){let d=console.log;switch(m){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(m,y){const d=this.loggers.get(m.toString());if(!d)throw new Error("Create the logger before logging");for(const[S,C]of y)(0,k.log)(d,S,C)}}e.LoggerChannel=b;class P extends k.AbstractLoggerService{constructor(m,y,d){super(m,y);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(m,y)=>{this.channel.call("consoleLog",[m,y])}})}doCreateLogger(m,y,d){return new I(this.channel,m,y,d)}}e.LoggerChannelClient=P;class I extends k.AbstractMessageLogger{constructor(m,y,d,S){super(S?.always);this.channel=m,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,y){const d=[[m,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(m){this.channel.call("log",[this.file,m])}}class E extends k.LogService{constructor(m,y){super(y);this.parent=m,this._register(m.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=E}),define(ne[67],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[58],se([0,1,3,51,2,5]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class A extends k.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(I){const E=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...I,...this.policyDefinitions},E!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(I),n.Iterable.reduce(this.policies.entries(),(w,[m,y])=>({...w,[m]:y}),{})}getPolicyValue(I){return this.policies.get(I)}serialize(){return n.Iterable.reduce(Object.entries(this.policyDefinitions),(I,[E,w])=>({...I,[E]:{definition:w,value:this.policies.get(E)}}),{})}}e.AbstractPolicyService=A;class b{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(ne[192],se([0,1,3,2,58]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(P){this.service=P,this.disposables=new n.DisposableStore}listen(P,I){switch(I){case"onDidChange":return D.Event.map(this.service.onDidChange,E=>E.reduce((w,m)=>({...w,[m]:this.service.getPolicyValue(m)??null}),{}),this.disposables)}throw new Error(`Event not found: ${I}`)}call(P,I,E){switch(I){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(E)}throw new Error(`Call not found: ${I}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class A extends k.AbstractPolicyService{constructor(P,I){super();this.channel=I;for(const E in P){const{definition:w,value:m}=P[E];this.policyDefinitions[E]=w,m!==void 0&&this.policies.set(E,m)}this.channel.listen("onDidChange")(E=>{for(const w in E){const m=E[w];m===null?this.policies.delete(w):this.policies.set(w,m)}this._onDidChange.fire(Object.keys(E))})}async initializePolicies(P){const I=await this.channel.call("registerPolicyDefinitions",P);for(const E in I)this.policies.set(E,I[E])}}e.PolicyChannelClient=A}),define(ne[96],se([0,1,20,4,36,17]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const b=n.globals.vscode.context.configuration();if(b)A=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const b=(0,T.dirname)(D.FileAccess.asFileUri("",Q));A=Q.__$__nodeRequire((0,T.joinPath)(b,"product.json").fsPath);const P=Q.__$__nodeRequire((0,T.joinPath)(b,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:P.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(ne[25],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[193],se([0,1,6,10,2,9,27,8,25]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let I=class extends k.Disposable{constructor(w,m,y){super();this.productService=m,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},30*1e3)).schedule()}async cleanUpCodeCaches(w){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),y=(0,T.dirname)(w),d=(0,T.basename)(w),S=await A.Promises.readdir(y);await Promise.all(S.map(async C=>{if(C===d)return;const p=(0,T.join)(y,C),g=await A.Promises.stat(p);if(g.isDirectory()&&m-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${C}.`),A.Promises.rm(p)}))}catch(m){(0,n.onUnexpectedError)(m)}}};I=me([G(1,P.IProductService),G(2,b.ILogService)],I),e.CodeCacheCleaner=I}),define(ne[194],se([0,1,6,10,2,9,27,15,8,25]),function(Q,e,D,n,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let E=class extends k.Disposable{constructor(m,y,d){super();this.environmentService=m,this.logService=y,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),y=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(y)){const u=y[g];m[`${u.hash}.${g}`]=!0}const d=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(d))return;const C=await A.Promises.readdir(d);for(const g of C){if(m[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await A.Promises.rm((0,T.join)(d,g))}const p=Date.now();for(const g of Object.keys(m)){const u=(0,T.join)(d,g),f=await A.Promises.readdir(u);for(const c of f){if(c==="tcf.json")continue;const s=(0,T.join)(u,c),r=await A.Promises.stat(s);r.isDirectory()&&p-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(g,c)}`),await A.Promises.rm(s))}}}catch(m){(0,n.onUnexpectedError)(m)}}};E=me([G(0,b.INativeEnvironmentService),G(1,P.ILogService),G(2,I.IProductService)],E),e.LanguagePackCachedDataCleaner=E}),define(ne[195],se([0,1,9,5]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var k;(function(T){function A(b,P="noAbsolutePaths"){for(const I of b.nodes)I.callFrame&&I.callFrame.url&&((0,D.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(I.callFrame.url))&&(I.callFrame.url=(0,D.join)(P,(0,D.basename)(I.callFrame.url)));return b}T.rewriteAbsolutePaths=A})(k=e.Utils||(e.Utils={}))}),define(ne[196],se([0,1,30]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(T){const b=await(await new Promise((I,E)=>{Q(["v8-inspect-profiler"],I,E)})).startProfiling({port:T.port,checkForPaused:!0}),P=(0,D.generateUuid)();return this._sessions.set(P,b),P}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const b=await A.stop();return this._sessions.delete(T),b.profile}}e.InspectProfilingService=n}),define(ne[40],se([0,1,110,14]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,b){D.ok(n.isString(A)),D.ok(n.isObject(b)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,b)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(ne[97],se([0,1,3,40]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(P,I){this.schemasById[k(P)]=I,this._onDidChangeSchema.fire(P)}notifySchemaChanged(P){this._onDidChangeSchema.fire(P)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;n.Registry.add(e.Extensions.JSONContribution,A)}),define(ne[42],se([0,1,18,3,14,136,19,97,40]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=P.Registry.as(b.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const t=this.doRegisterConfigurations(s,r);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(s){const r=this.doDeregisterConfigurations(s);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:s,remove:r}){const t=[];t.push(...this.doDeregisterConfigurations(r)),t.push(...this.doRegisterConfigurations(s,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(s){const r=[],t=[];for(const{overrides:i,source:o}of s)for(const l in i)if(r.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.configurationDefaultsOverrides.get(l),h=a?.valuesSources??new Map;if(o)for(const F of Object.keys(i[l]))h.set(F,o);const v={...a?.value||{},...i[l]};this.configurationDefaultsOverrides.set(l,{source:o,value:v,valuesSources:h});const R=(0,A.getLanguageTagSettingPlainKey)(l),M={type:"object",default:v,description:T.localize(1,null,R),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:k.isString(o)?void 0:o,defaultValueSource:o};t.push(...S(l)),this.configurationProperties[l]=M,this.defaultLanguageConfigurationOverridesNode.properties[l]=M}else{this.configurationDefaultsOverrides.set(l,{value:i[l],source:o});const a=this.configurationProperties[l];a&&(this.updatePropertyDefaultValue(l,a),this.updateSchema(l,a))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:t,source:i}of s)for(const o in t){const l=this.configurationDefaultsOverrides.get(o),a=k.isString(i)?i:i?.id,h=k.isString(l?.source)?l?.source:l?.source?.id;if(a===h)if(r.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const v=this.configurationProperties[o];v&&(this.updatePropertyDefaultValue(o,v),this.updateSchema(o,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const r of s)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,r){const t=[];return s.forEach(i=>{t.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),t}doDeregisterConfigurations(s){const r=[],t=i=>{if(i.properties)for(const o in i.properties){r.push(o);const l=this.configurationProperties[o];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,i.properties[o])}i.allOf?.forEach(o=>t(o))};for(const i of s){t(i);const o=this.configurationContributors.indexOf(i);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(s,r=!0,t,i,o=3){o=k.isUndefinedOrNull(s.scope)?o:s.scope;const l=[],a=s.properties;if(a)for(const v in a){const R=a[v];if(r&&u(v,R)){delete a[v];continue}if(R.source=t,R.defaultDefaultValue=a[v].default,this.updatePropertyDefaultValue(v,R),e.OVERRIDE_PROPERTY_REGEX.test(v)?R.scope=void 0:(R.scope=k.isUndefinedOrNull(R.scope)?o:R.scope,R.restricted=k.isUndefinedOrNull(R.restricted)?!!i?.includes(v):R.restricted),a[v].hasOwnProperty("included")&&!a[v].included){this.excludedConfigurationProperties[v]=a[v],delete a[v];continue}else this.configurationProperties[v]=a[v],a[v].policy?.name&&this.policyConfigurations.set(a[v].policy.name,v);!a[v].deprecationMessage&&a[v].markdownDeprecationMessage&&(a[v].deprecationMessage=a[v].markdownDeprecationMessage),l.push(v)}const h=s.allOf;if(h)for(const v of h)l.push(...this.validateAndRegisterProperties(v,r,t,i,o));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const r=t=>{const i=t.properties;if(i)for(const l in i)this.updateSchema(l,i[l]);t.allOf?.forEach(r)};r(s)}updateSchema(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.resourceLanguageSettingsSchema.properties[s]=r;break}}removeFromSchema(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const r=`[${s}]`,t={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,r){const t=this.configurationDefaultsOverrides.get(s);let i=t?.value,o=t?.source;k.isUndefined(i)&&(i=r.defaultDefaultValue,o=void 0),k.isUndefined(i)&&(i=p(r.type)),r.default=i,r.defaultValueSource=o}}const y="\\[([^\\]]+)\\]",d=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(c){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=d.exec(c);for(;r?.length;){const t=r[1].trim();t&&s.push(t),r=d.exec(c)}}return(0,D.distinct)(s)}e.overrideIdentifiersFromKey=S;function C(c){return c.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=C;function p(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const g=new m;P.Registry.add(e.Extensions.Configuration,g);function u(c,s){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?T.localize(7,null,c):g.getConfigurationProperties()[c]!==void 0?T.localize(8,null,c):s.policy?.name&&g.getPolicyConfigurations().get(s.policy?.name)!==void 0?T.localize(9,null,c,s.policy?.name,g.getPolicyConfigurations().get(s.policy?.name)):null:T.localize(6,null)}e.validateProperty=u;function f(){const c=[],s=g.getConfigurationProperties();for(const r of Object.keys(s))c.push([r,s[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=f}),define(ne[68],se([0,1,18,3,35,2,34,31,14,7,19,42,40]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(r={},t=[],i=[]){this._contents=r,this._keys=t,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,E.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,t){const i=this.getContentsForOverrideIdentifer(t);return i?r?(0,E.getConfigurationValue)(i,r):i:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const i of this.overrides)i.identifiers.includes(r)&&t.push(...i.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return D.distinct(r)}override(r){let t=this.overrideConfigurations.get(r);return t||(t=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,t)),t}merge(...r){const t=b.deepClone(this.contents),i=b.deepClone(this.overrides),o=[...this.keys];for(const l of r)if(!l.isEmpty()){this.mergeContents(t,l.contents);for(const a of l.overrides){const[h]=i.filter(v=>D.equals(v.identifiers,a.identifiers));h?(this.mergeContents(h.contents,a.contents),h.keys.push(...a.keys),h.keys=D.distinct(h.keys)):i.push(b.deepClone(a))}for(const a of l.keys)o.indexOf(a)===-1&&o.push(a)}return new y(t,o,i)}freeze(){return this.frozen=!0,this}clone(){return new y(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}createOverrideConfigurationModel(r){const t=this.getContentsForOverrideIdentifer(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const i={};for(const o of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[o];const a=t[o];a&&(typeof l=="object"&&typeof a=="object"?(l=b.deepClone(l),this.mergeContents(l,a)):l=a),i[o]=l}return new y(i,this.keys,this.overrides)}mergeContents(r,t){for(const i of Object.keys(t)){if(i in r&&P.isObject(r[i])&&P.isObject(t[i])){this.mergeContents(r[i],t[i]);continue}r[i]=b.deepClone(t[i])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?b.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let t=null,i=null;const o=l=>{l&&(i?this.mergeContents(i,l):i=b.deepClone(l))};for(const l of this.overrides)D.equals(l.identifiers,[r])?t=l.contents:l.identifiers.includes(r)&&o(l.contents);return o(t),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.addKey(r),(0,E.addToValueTree)(this.contents,r,t,i=>{throw new Error(i)})}removeValue(r){this.removeKey(r)&&(0,E.removeFromValueTree)(this.contents,r)}addKey(r){let t=this.keys.length;for(let i=0;i<t;i++)r.indexOf(this.keys[i])===0&&(t=i);this.keys.splice(t,1,r)}removeKey(r){const t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=y;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,t){if(!P.isUndefinedOrNull(r)){const i=this.doParseContent(r);this.parseRaw(i,t)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,t){this._raw=r;const{contents:i,keys:o,overrides:l,restricted:a}=this.doParseRaw(r,t);this._configurationModel=new y(i,o,l),this._restrictedConfigurations=a||[]}doParseContent(r){let t={},i=null,o=[];const l=[],a=[];function h(R){Array.isArray(o)?o.push(R):i!==null&&(o[i]=R)}const v={onObjectBegin:()=>{const R={};h(R),l.push(o),o=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const R=[];h(R),l.push(o),o=R,i=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:h,onError:(R,M,F)=>{a.push({error:R,offset:M,length:F})}};if(r)try{k.visit(r,v),t=o[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return t}doParseRaw(r,t){const i=m.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,i,!0,t);r=o.raw;const l=(0,E.toValuesTree)(r,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),a=Object.keys(r),h=this.toOverrides(r,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:l,keys:a,overrides:h,restricted:o.restricted}}filter(r,t,i,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const l={},a=[];for(const h in r)if(w.OVERRIDE_PROPERTY_REGEX.test(h)&&i){const v=this.filter(r[h],t,!1,o);l[h]=v.raw,a.push(...v.restricted)}else{const v=t[h],R=v?typeof v.scope!="undefined"?v.scope:3:void 0;v?.restricted&&a.push(h),(R===void 0||o.scopes===void 0||o.scopes.includes(R))&&(o.skipRestricted&&v?.restricted||(l[h]=r[h]))}return{raw:l,restricted:a}}toOverrides(r,t){const i=[];for(const o of Object.keys(r))if(w.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const a in r[o])l[a]=r[o][a];i.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,E.toValuesTree)(l,t)})}return i}}e.ConfigurationModelParser=d;class S extends T.Disposable{constructor(r,t,i,o){super();this.userSettingsResource=r,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&i.isEqual(l.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class C{constructor(r,t,i,o,l=new y,a=new y,h=new A.ResourceMap,v=new y,R=new A.ResourceMap,M=!0){this._defaultConfiguration=r,this._policyConfiguration=t,this._applicationConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=l,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=v,this._memoryConfigurationByResource=R,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,t,i){return this.getConsolidatedConfigurationModel(r,t,i).getValue(r)}updateValue(r,t,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=new y,this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(r):o.setValue(r,t),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,t,i){const o=this.getConsolidatedConfigurationModel(r,t,i),l=this.getFolderConfigurationModelForResource(t.resource,i),a=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,h=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),v=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),R=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(r),M=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),F=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),L=i?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,N=l?t.overrideIdentifier?l.freeze().override(t.overrideIdentifier).getValue(r):l.freeze().getValue(r):void 0,$=t.overrideIdentifier?a.override(t.overrideIdentifier).getValue(r):a.getValue(r),H=o.getValue(r),Y=D.distinct(o.overrides.map(te=>te.identifiers).flat()).filter(te=>o.getOverrideValue(r,te)!==void 0);return{defaultValue:h,policyValue:v,applicationValue:R,userValue:M,userLocalValue:F,userRemoteValue:O,workspaceValue:L,workspaceFolderValue:N,memoryValue:$,value:H,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,policy:v!==void 0?{value:v}:void 0,application:R!==void 0?{value:R,override:t.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:l?.freeze().getValue(r),override:t.overrideIdentifier?l?.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:a.getValue(r),override:t.overrideIdentifier?a.getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Y.length?Y:void 0}}keys(r){const t=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,t){this._folderConfigurations.set(r,t),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const i=[];if(!t){const{added:o,updated:l,removed:a}=f(this._defaultConfiguration,r);t=[...o,...l,...a]}for(const o of t)for(const l of(0,w.overrideIdentifiersFromKey)(o)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(l),h=r.getKeysForOverrideIdentifier(l),v=[...h.filter(R=>a.indexOf(R)===-1),...a.filter(R=>h.indexOf(R)===-1),...a.filter(R=>!b.equals(this._defaultConfiguration.override(l).getValue(R),r.override(l).getValue(R)))];i.push([l,v])}return this.updateDefaultConfiguration(r),{keys:t,overrides:i}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:i,removed:o}=f(this._policyConfiguration,r),l=[...t,...i,...o];return l.length&&this.updatePolicyConfiguration(r),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:i,removed:o,overrides:l}=f(this.applicationConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:l}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:i,removed:o,overrides:l}=f(this.localUserConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:i,removed:o,overrides:l}=f(this.remoteUserConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:i,removed:o,overrides:l}=f(this.workspaceConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:l}}compareAndUpdateFolderConfiguration(r,t){const i=this.folderConfigurations.get(r),{added:o,updated:l,removed:a,overrides:h}=f(i,t),v=[...o,...l,...a];return(v.length||!i)&&this.updateFolderConfiguration(r,t),{keys:v,overrides:h}}compareAndDeleteFolderConfiguration(r){const t=this.folderConfigurations.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:i,updated:o,removed:l,overrides:a}=f(t,void 0);return{keys:[...i,...o,...l],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,t,i){let o=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:r},t){let i=this.getWorkspaceConsolidatedConfiguration();if(t&&r){const o=t.getFolder(r);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const l=this._memoryConfigurationByResource.get(r);l&&(i=i.merge(l))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let t=this._foldersConsolidatedConfigurations.get(r);if(!t){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(t=i.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(r,t)):t=i}return t}getFolderConfigurationModelForResource(r,t){if(t&&r){const i=t.getFolder(r);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,t)=>{const{contents:i,overrides:o,keys:l}=this._folderConfigurations.get(t);return r.push([t,{contents:i,overrides:o,keys:l}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(i=>r.add(i))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>t.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>t.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o))),[...t.values()]}static parse(r){const t=this.parseConfigurationModel(r.defaults),i=this.parseConfigurationModel(r.policy),o=this.parseConfigurationModel(r.application),l=this.parseConfigurationModel(r.user),a=this.parseConfigurationModel(r.workspace),h=r.folders.reduce((v,R)=>(v.set(I.URI.revive(R[0]),this.parseConfigurationModel(R[1])),v),new A.ResourceMap);return new C(t,i,o,l,new y,a,h,new y,new A.ResourceMap,!1)}static parseConfigurationModel(r){return new y(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=C;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,t=new Map;for(const o of s)o.keys.forEach(l=>r.add(l)),o.overrides.forEach(([l,a])=>{const h=(0,A.getOrSet)(t,l,new Set);a.forEach(v=>h.add(v))});const i=[];return t.forEach((o,l)=>i.push([l,[...o.values()]])),{keys:[...r.values()],overrides:i}}e.mergeChanges=p;class g{constructor(r,t,i,o){this.change=r,this.previous=t,this.currentConfiguraiton=i,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;r.keys.forEach(h=>l.add(h)),r.overrides.forEach(([,h])=>h.forEach(v=>l.add(v))),this.affectedKeys=[...l.values()];const a=new y;this.affectedKeys.forEach(h=>a.setValue(h,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(t){const i=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,t,this.currentWorkspace);return!b.equals(i,o)}return!0}return!1}doesAffectedKeysTreeContains(r,t){let i=(0,E.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof i=="object"&&(o=Object.keys(i)[0]);){if(r=r[o],!r)return!1;i=i[o]}return!0}}e.ConfigurationChangeEvent=g;class u extends g{constructor(r,t,i,o){super({keys:r.allKeys(),overrides:[]},void 0,r,t);this.source=i,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=u;function f(s,r){const{added:t,removed:i,updated:o}=c(r,s),l=[],a=s?.getAllOverrideIdentifiers()||[],h=r?.getAllOverrideIdentifiers()||[];if(r){const v=h.filter(R=>!a.includes(R));for(const R of v)l.push([R,r.getKeysForOverrideIdentifier(R)])}if(s){const v=a.filter(R=>!h.includes(R));for(const R of v)l.push([R,s.getKeysForOverrideIdentifier(R)])}if(r&&s){for(const v of a)if(h.includes(v)){const R=c({contents:s.getOverrideValue(void 0,v)||{},keys:s.getKeysForOverrideIdentifier(v)},{contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)});l.push([v,[...R.added,...R.removed,...R.updated]])}}return{added:t,removed:i,updated:o,overrides:l}}function c(s,r){const t=s?r?s.keys.filter(l=>r.keys.indexOf(l)===-1):[...s.keys]:[],i=r?s?r.keys.filter(l=>s.keys.indexOf(l)===-1):[...r.keys]:[],o=[];if(s&&r){for(const l of r.keys)if(s.keys.indexOf(l)!==-1){const a=(0,E.getConfigurationValue)(r.contents,l),h=(0,E.getConfigurationValue)(s.contents,l);b.equals(a,h)||o.push(l)}}return{added:t,removed:i,updated:o}}}),define(ne[197],se([0,1,18,3,2,31,14,19,68,42,8,58,40]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends k.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(m.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:u})=>this.onDidUpdateConfiguration(g,u))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,u){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=y;class d extends P.ConfigurationModel{constructor(g={}){const u=m.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(u),c=Object.create(null),s=[];for(const r in u){const t=g[r],i=t!==void 0?t:u[r].default;(0,b.addToValueTree)(c,r,i,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(c))I.OVERRIDE_PROPERTY_REGEX.test(r)&&s.push({identifiers:(0,I.overrideIdentifiersFromKey)(r),keys:Object.keys(c[r]),contents:(0,b.toValuesTree)(c[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(c,f,s)}}e.DefaultConfigurationModel=d;class S{constructor(){this.onDidChangeConfiguration=n.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let C=class extends k.Disposable{constructor(g,u,f){super();this.defaultConfiguration=g,this.policyService=u,this.logService=f,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const u={},f=[],c=m.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const s of g){const r=c[s];if(!r){f.push(s);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}f.push(s),u[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(u)||await this.policyService.registerPolicyDefinitions(u),f}onDidChangePolicies(g){const u=m.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),f=(0,D.coalesce)(g.map(c=>u.get(c)));this.update(f,!0)}update(g,u){const f=m.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),c=[],s=this._configurationModel.isEmpty();for(const r of g){const t=f[r]?.policy?.name;if(t){const i=this.policyService.getPolicyValue(t);(s?i!==void 0:!(0,T.equals)(this._configurationModel.getValue(r),i))&&c.push([r,i])}else this._configurationModel.getValue(r)!==void 0&&c.push([r,void 0])}if(c.length){const r=this._configurationModel;this._configurationModel=new P.ConfigurationModel;for(const t of r.keys)this._configurationModel.setValue(t,r.getValue(t));for(const[t,i]of c)i===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,i);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};C=me([G(1,w.IPolicyService),G(2,E.ILogService)],C),e.PolicyConfiguration=C}),define(ne[198],se([0,1,6,3,2,17,19,68,197,58]),function(Q,e,D,n,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends k.Disposable{constructor(m,y,d,S){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new P.DefaultConfiguration),this.policyConfiguration=d instanceof I.NullPolicyService?new P.NullPolicyConfiguration:this._register(new P.PolicyConfiguration(this.defaultConfiguration,d,S)),this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,y)),this.configuration=new b.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:C,properties:p})=>this.onDidDefaultConfigurationChange(C,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(C=>this.onDidPolicyConfigurationChange(C))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,y,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new b.Configuration(m,y,new b.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(m,y){const d=typeof m=="string"?m:void 0,S=(0,A.isConfigurationOverrides)(m)?m:(0,A.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,S,void 0)}updateValue(m,y,d,S){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(d,y,2)}onDidDefaultConfigurationChange(m,y){const d=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(m,y);this.trigger(S,d,7)}onDidPolicyConfigurationChange(m){const y=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(d,y,7)}trigger(m,y,d){const S=new b.ConfigurationChangeEvent(m,{data:y},this.configuration);S.source=d,S.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(ne[199],se([0,1,10,5]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends D.ErrorNoTelemetry{constructor(b,P=k.Unknown,I){super(b);this._message=b,this._code=P,this._detail=I,this.isHandled=P===k.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(b){return b instanceof T&&b._code===k.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof T&&b._code===k.NoResolverFound}static isHandled(b){return b instanceof T&&b.isHandled}}e.RemoteAuthorityResolverError=T}),define(ne[98],se([0,1,20]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function n(I){return I.scheme===D.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=n;function k(I){if(!I)return;const E=I.indexOf("+");return E<0?I:I.substr(0,E)}e.getRemoteName=k;function T(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=T;function A(I){const{host:E,port:w}=P(I);if(typeof w=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:w}}e.parseAuthorityWithPort=A;function b(I,E){let{host:w,port:m}=P(I);return typeof m=="undefined"&&(m=E),{host:w,port:m}}e.parseAuthorityWithOptionalPort=b;function P(I){const E=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const w=I.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const m=I.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:I,port:void 0}}}),define(ne[43],se([0,1,24,5,98]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=T;function A(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var P;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,C){if(typeof S=="undefined"||S===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof S=="string"||typeof C=="string"){const p=typeof S=="string"?S:S.value,g=typeof C=="string"?C:C.value;return D.equalsIgnoreCase(p,g)}return S._lower===C._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=I;function E(d){return w(d)}e.isApplicationScopedExtension=E;function w(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function m(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function y(d,S){if(S){const C=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return d.activationEvents?.indexOf(C)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[32],se([0,1,24,29,43,4,7,10,36]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,D.compareIgnoreCase)(r.id,t.id)===0}e.areSameExtensions=I;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{constructor(t,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=t.id}static create(t){const i=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,i,o)}static parse(t){const i=E.exec(t);return i&&i[1]&&i[2]?new w({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?I(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=w;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const t=m.exec(r);return t&&t[1]?[S(t[1]),t[2]]:[S(r),void 0]}e.getIdAndVersion=y;function d(r,t){return`${r}.${t}`}e.getExtensionId=d;function S(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function C(r,t){return S(d(r,t))}e.getGalleryExtensionId=C;function p(r,t){const i=[],o=l=>{for(const a of i)if(a.some(h=>I(t(h),t(l))))return a;return null};for(const l of r){const a=o(l);a?a.push(l):i.push([l])}return i}e.groupByExtension=p;function g(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function u(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=u,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(r,t){const i=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&i.every(a=>!I(a.identifier,{id:l}))){const a=r.filter(h=>I(h.identifier,{id:l}));a.length===1&&(i.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=f;async function c(r,t){if(!T.isLinux)return!1;let i;try{i=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){t.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(l))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function s(r,t){const i=await c(r,t),o=(0,n.getTargetPlatform)(i?"alpine":T.platform,P.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(ne[48],se([0,1,6,16,2,34,7,32,13,5,8]),function(Q,e,D,n,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,I.createDecorator)("IExtensionsProfileScannerService");let w=class extends k.Disposable{constructor(y,d){super();this.fileService=y,this.logService=d,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(y){return this.withProfileExtensions(y)}addExtensionsToProfile(y,d){return this.withProfileExtensions(d,S=>(S=S.filter(C=>y.some(([p])=>!(0,b.areSameExtensions)(C.identifier,p.identifier))),S.push(...y.map(([C,p])=>({identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:p}))),S))}removeExtensionFromProfile(y,d){return this.withProfileExtensions(d,S=>S.filter(C=>!(0,b.areSameExtensions)(C.identifier,y)))}async withProfileExtensions(y,d){return this.getResourceAccessQueue(y).queue(async()=>{let S=[];try{const C=await this.fileService.readFile(y),p=JSON.parse(C.value.toString());for(const g of p){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}S.push({identifier:g.identifier,location:A.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}if(d){S=d(S);const C=S.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(y,n.VSBuffer.fromString(JSON.stringify(C)))}return S})}getResourceAccessQueue(y){let d=this.resourcesAccessQueueMap.get(y);return d||(d=new D.Queue,this.resourcesAccessQueueMap.set(y,d)),d}};w=me([G(0,P.IFileService),G(1,E.ILogService)],w),e.ExtensionsProfileScannerService=w}),define(ne[200],se([0,1,21,32]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function k(T,A,b,P,I){try{const E=await T.getExtensionsControlManifest();if(!E.deprecated)return;const w=await T.getInstalled(1);for(const[m,y]of Object.entries(E.deprecated)){if(!y?.extension)continue;const{id:d,autoMigrate:S,preRelease:C}=y.extension;if(!S)continue;const p=w.find(u=>(0,n.areSameExtensions)(u.identifier,{id:m}));if(!p)continue;const g=(await A.getExtensions([{id:d,preRelease:C}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!g){I.info(`Skipping migrating '${p.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{I.info(`Migrating '${p.identifier.id}' extension to '${d}' extension...`);const u=!P.getDisabledExtensions().some(c=>(0,n.areSameExtensions)(c,p.identifier));await T.uninstall(p),I.info(`Uninstalled the unsupported extension '${p.identifier.id}'`);let f=w.find(c=>(0,n.areSameExtensions)(c.identifier,{id:d}));(!f||!f.isPreReleaseVersion&&u)&&(f=await T.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:p.isMachineScoped,operation:4}),I.info(`Installed the pre-release extension '${f.identifier.id}'`),u||(await P.disableExtension(f.identifier),I.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${p.identifier.id}' is disabled`)),S.storage&&(b.addToMigrationList((0,n.getExtensionId)(p.manifest.publisher,p.manifest.name),(0,n.getExtensionId)(f.manifest.publisher,f.manifest.name)),I.info("Added pre-release extension to the storage migration list"))),I.info(`Migrated '${p.identifier.id}' extension to '${d}' extension.`)}catch(u){I.error(u)}}}catch(E){I.error(E)}}e.migrateUnsupportedExtensions=k}),define(ne[201],se([0,1,6,10,2,4,17,55,7,30,27,15,29,32,13,8]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let C=class extends k.Disposable{constructor(g,u,f,c){super();this.fileService=u,this.extensionGalleryService=f,this.logService=c,this.extensionsDownloadDir=P.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,u){await this.cleanUpPromise;const f=this.getName(g),c=(0,A.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(c)){const s=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(g,s,u);try{await this.rename(s,c,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(s)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,s.path),r}}return c}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,u,f){try{await E.Promises.rename(g.fsPath,u.fsPath)}catch(c){if(T.isWindows&&c&&c.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${g} to ${u} with 'EPERM' error. Trying again...`),this.rename(g,u,f);throw c}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const u=[],f=[];for(const r of g.children){const t=y.ExtensionKey.parse(r.name);t&&f.push([t,r])}const c=(0,y.groupByExtension)(f,([r])=>r),s=[];for(const r of c)r.sort((t,i)=>b.rcompare(t[0].version,i[0].version)),u.push(...r.slice(1).map(t=>t[1].resource)),s.push(r[0][1]);s.sort((r,t)=>r.mtime-t.mtime),u.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(u.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?y.ExtensionKey.create(g).toString().toLowerCase():(0,I.generateUuid)()}};C=me([G(0,w.INativeEnvironmentService),G(1,d.IFileService),G(2,m.IExtensionGalleryService),G(3,S.ILogService)],C),e.ExtensionsDownloader=C}),define(ne[202],se([0,1,2,9,27,43]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(P,I){super();this.environmentService=P,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(I.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(I.onDidUninstallExtension(E=>this.onDidUnInstallExtension(E)))}onDidInstallExtensions(P){P.some(I=>!!I.local)&&this.invalidate()}onDidUnInstallExtension(P){P.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(ne[203],se([0,1,177,18,6,2,20,9,27,15,29,32,8,66]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let d=class extends y.LanguagePackBaseService{constructor(g,u,f,c){super(f);this.extensionManagementService=g,this.logService=c,this.cache=this._register(new S(u,c)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),u=Object.keys(g).map(f=>{const c=g[f];return{...this.createQuickPickItem(f,c.label),extensionId:c.extensions[0].extensionIdentifier.id}});return u.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),u.sort((f,c)=>f.label.localeCompare(c.label)),u}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const u=await this.cache.getLanguagePacks();Object.keys(u).some(f=>u[f]&&u[f].extensions.some(c=>(0,w.areSameExtensions)(c.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,u]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(u);return!(0,n.equals)(Object.keys(g),Object.keys(f))}};d=me([G(0,E.IExtensionManagementService),G(1,I.INativeEnvironmentService),G(2,E.IExtensionGalleryService),G(3,m.ILogService)],d),e.NativeLanguagePackService=d;let S=class extends T.Disposable{constructor(g,u){super();this.logService=u,this.languagePacks={},this.languagePacksFilePath=(0,b.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(u=>{Object.keys(u).forEach(f=>delete u[f]),this.createLanguagePacksFromExtensions(u,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...u){for(const f of u)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,f);Object.keys(g).forEach(f=>this.updateHash(g[f]))}createLanguagePacksFromExtension(g,u){const f=u.identifier,c=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const s of c)if(u.location.scheme===A.Schemas.file&&C(s)){let r=g[s.languageId];r||(r={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},g[s.languageId]=r);const t=r.extensions.filter(i=>(0,w.areSameExtensions)(i.extensionIdentifier,f))[0];t?t.version=u.manifest.version:r.extensions.push({extensionIdentifier:f,version:u.manifest.version});for(const i of s.translations)r.translations[i.id]=(0,b.join)(u.location.fsPath,i.path)}}updateHash(g){if(g){const u=(0,D.createHash)("md5");for(const f of g.extensions)u.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);g.hash=u.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let u=null;return P.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(u=g(f),f)).then(f=>{for(const s of Object.keys(f))f[s]||delete f[s];this.languagePacks=f,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),P.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>u,f=>this.logService.error(f))})}};S=me([G(0,I.INativeEnvironmentService),G(1,m.ILogService)],S);function C(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const g of p.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ne[204],se([0,1,6,16,21,10,3,2,30,84,199,98]),function(Q,e,D,n,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const m=30*1e3;var y;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function d(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(z){const V=new k.CancellationTokenSource;return setTimeout(()=>V.cancel(),z),V.token}function C(z,V){if(z.isCancellationRequested||V.isCancellationRequested)return k.CancellationToken.Cancelled;const _=new k.CancellationTokenSource;return z.onCancellationRequested(()=>_.cancel()),V.onCancellationRequested(()=>_.cancel()),_.token}class p{constructor(V){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((_,U)=>{this._resolvePromise=_,this._rejectPromise=U}),V.isCancellationRequested?this._timeout():this._disposables.add(V.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(V){this._state==="pending"?this._disposables.add(V):V.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(V))}reject(V){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(V))}}function g(z,V){const _=new p(V);return _.registerDisposable(z.onControlMessage(U=>{const j=JSON.parse(U.toString()),B=W(j);B?_.reject(B):_.resolve(j)})),_.promise}function u(z,V,_,U,j,B,X,oe){const J=new p(oe);return V.connect(_,U,j,B,X,(ie,re)=>{J.didTimeout?(ie&&z.error(ie),re?.dispose()):ie||!re?J.reject(ie):J.resolve(re)}),J.promise}function f(z,V){const _=new p(V);return z.then(U=>{_.didTimeout||_.resolve(U)},U=>{_.didTimeout||_.reject(U)}),_.promise}async function c(z,V,_,U){const j=ee(z,V);z.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let B;try{B=await u(z.logService,z.socketFactory,z.host,z.port,(0,w.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${d(V)}-${z.reconnectionToken}`,U)}catch(re){throw z.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),z.logService.error(re),re}z.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let X,oe;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(B,null),X=z.reconnectionProtocol,oe=!1):(X=new I.PersistentProtocol(B,null),oe=!0),z.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const J=await f(z.signService.createNewMessage((0,P.generateUuid)()),U),ie={type:"auth",auth:z.connectionToken||"00000000000000000000",data:J.data};X.sendControl(n.VSBuffer.fromString(JSON.stringify(ie)));try{const re=await g(X,C(U,S(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(z.logService.trace(`${j} 4/6. received SignRequest control message.`),!await f(z.signService.validate(J,re.signedData),U)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const he=await f(z.signService.sign(re.data),U),ve={type:"connectionType",commit:z.commit,signedData:he,desiredConnectionType:V};return _&&(ve.args=_),z.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(n.VSBuffer.fromString(JSON.stringify(ve))),{protocol:X,ownsProtocol:oe}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(z.logService.error(`${j} the handshake timed out. Error:`),z.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${j} received error control message when negotiating connection. Error:`),z.logService.error(re)),oe&&q(X),re}}async function s(z,V,_,U){const j=Date.now(),B=ee(z,V),{protocol:X,ownsProtocol:oe}=await c(z,V,_,U),J=new p(U);return J.registerDisposable(X.onControlMessage(ie=>{const re=JSON.parse(ie.toString()),ue=W(re);ue?(z.logService.error(`${B} received error control message when negotiating connection. Error:`),z.logService.error(ue),oe&&q(X),J.reject(ue)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${ce(j)}!`),J.resolve({protocol:X,firstMessage:re}))})),J.promise}async function r(z,V){const{protocol:_}=await s(z,1,void 0,V);return{protocol:_}}async function t(z,V,_){const{protocol:U,firstMessage:j}=await s(z,2,V,_),B=j&&j.debugPort;return{protocol:U,debugPort:B}}async function i(z,V,_){const U=Date.now(),j=ee(z,3),{protocol:B}=await c(z,3,V,_);return z.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${ce(U)}!`),B}async function o(z,V,_){const{host:U,port:j,connectionToken:B}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:U,port:j,connectionToken:B,reconnectionToken:V,reconnectionProtocol:_,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function l(z,V,_){return h(z,async U=>{const{protocol:j}=await r(U,k.CancellationToken.None);return new Y(z,V,_,U.reconnectionToken,j)})}e.connectRemoteAgentManagement=l;async function a(z,V){return h(z,async _=>{const{protocol:U,debugPort:j}=await t(_,V,k.CancellationToken.None);return new te(z,V,_.reconnectionToken,U,j)})}e.connectRemoteAgentExtensionHost=a;async function h(z,V){const _=5;for(let U=1;;U++)try{const j=(0,P.generateUuid)(),B=await o(z,j,null);return await V(B)}catch(j){if(U<_)z.logService.error(`[remote-connection][attempt ${U}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(j);else throw z.logService.error(`[remote-connection][attempt ${U}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(j),H.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(j)),j}}async function v(z,V,_){const U=await o(z,(0,P.generateUuid)(),null);return await i(U,{host:V,port:_},k.CancellationToken.None)}e.connectRemoteAgentTunnel=v;function R(z){return(0,D.createCancelablePromise)(V=>new Promise((_,U)=>{const j=setTimeout(_,z*1e3);V.onCancellationRequested(()=>{clearTimeout(j),_()})}))}var M;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(M=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class F{constructor(V,_){this.reconnectionToken=V,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=F;class O{constructor(V,_,U,j){this.reconnectionToken=V,this.millisSinceLastIncomingData=_,this.durationSeconds=U,this.cancellableTimer=j,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class L{constructor(V,_,U){this.reconnectionToken=V,this.millisSinceLastIncomingData=_,this.attempt=U,this.type=2}}e.ReconnectionRunningEvent=L;class N{constructor(V,_,U){this.reconnectionToken=V,this.millisSinceLastIncomingData=_,this.attempt=U,this.type=4}}e.ConnectionGainEvent=N;class ${constructor(V,_,U,j){this.reconnectionToken=V,this.millisSinceLastIncomingData=_,this.attempt=U,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class H extends b.Disposable{constructor(V,_,U,j,B){super();this._connectionType=V,this._options=_,this.reconnectionToken=U,this.protocol=j,this._reconnectionFailureIsFatal=B,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(j.onSocketClose(X=>{const oe=K(this._connectionType,this.reconnectionToken,!0);X?X.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${X.hadError}).`),X.error&&this._options.logService.error(X.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this._options.logService.error(X.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(j.onSocketTimeout(X=>{const oe=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),H._instances.push(this),this._register((0,b.toDisposable)(()=>{const X=H._instances.indexOf(this);X>=0&&H._instances.splice(X,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(H._permanentFailureMillisSinceLastIncomingData,H._permanentFailureAttempt,H._permanentFailureHandled)}static triggerPermanentFailure(V,_,U){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=V,this._permanentFailureAttempt=_,this._permanentFailureHandled=U,this._instances.forEach(j=>j._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(V=>V._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(V=>V._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||H._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const V=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let U=-1;do{U++;const j=U<_.length?_[U]:_[_.length-1];try{if(j>0){const X=R(j);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,X)),this._options.logService.info(`${V} waiting for ${j} seconds before reconnecting...`);try{await X}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1)),this._options.logService.info(`${V} resolving connection...`);const B=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${V} connecting to ${B.host}:${B.port}...`),await this._reconnect(B,S(m)),this._options.logService.info(`${V} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(U>360){this._options.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this._options.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this._options.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((0,T.isCancellationError)(B)){this._options.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if(B instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,E.RemoteAuthorityResolverError.isHandled(B));break}this._options.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(V,_,U){this._reconnectionFailureIsFatal?H.triggerPermanentFailure(V,_,U):this._gotoPermanentFailure(V,_,U)}_gotoPermanentFailure(V,_,U){this._onDidStateChange.fire(new $(this.reconnectionToken,V,_,U)),q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=H,H._permanentFailure=!1,H._permanentFailureMillisSinceLastIncomingData=0,H._permanentFailureAttempt=0,H._permanentFailureHandled=!1,H._instances=[];class Y extends H{constructor(V,_,U,j,B){super(1,V,j,B,!0);this.client=this._register(new I.Client(B,{remoteAuthority:_,clientId:U},V.ipcLogger))}async _reconnect(V,_){await r(V,_)}}e.ManagementPersistentConnection=Y;class te extends H{constructor(V,_,U,j,B){super(2,V,U,j,!1);this._startArguments=_,this.debugPort=B}async _reconnect(V,_){await t(V,this._startArguments,_)}}e.ExtensionHostPersistentConnection=te;function q(z){try{z.acceptDisconnect();const V=z.getSocket();z.dispose(),V.dispose()}catch(V){(0,T.onUnexpectedError)(V)}}function W(z){if(z&&z.type==="error"){const V=new Error(`Connection error: ${z.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function x(z,V){for(;z.length<V;)z+=" ";return z}function K(z,V,_){return`[remote-connection][${x(d(z),13)}][${V.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function ee(z,V){return`${K(V,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function ce(z){return`${Date.now()-z} ms`}}),define(ne[205],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[206],se([0,1,76,134]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,T,A,b,P,I){const E=m=>I(m,void 0),w=D.createConnection({host:k,port:T},()=>{w.removeListener("error",E);const m=Buffer.alloc(16);for(let C=0;C<16;C++)m[C]=Math.round(Math.random()*256);const y=m.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${T}${A}?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];w.write(d.join(`\r
`)+`\r
\r
`);const S=C=>{C.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",S),I(void 0,new n.NodeSocket(w,P)))};w.on("data",S)});w.setNoDelay(!0),w.once("error",E)}}}),define(ne[207],se([0,1,117,19,8]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(b,P){this.configurationService=b,this.logService=P}async request(b,P){this.logService.trace("RequestService#request (browser) - begin",b.url),b.proxyAuthorization||(b.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const I=await(0,D.request)(b,P);return this.logService.trace("RequestService#request (browser) - success",b.url),I}catch(I){throw this.logService.error("RequestService#request (browser) - error",b.url,I),I}}async resolveProxy(b){}};T=me([G(0,n.IConfigurationService),G(1,k.ILogService)],T),e.RequestService=T}),define(ne[44],se([0,1,16,152,42,5,40]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function b(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=b;function P(S){return S.res.statusCode===204}async function I(S){return P(S)?null:(await(0,D.streamToBuffer)(S.stream)).toString()}e.asText=I;async function E(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);return I(S)}e.asTextOrError=E;async function w(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);if(P(S))return null;const p=(await(0,D.streamToBuffer)(S.stream)).toString();try{return JSON.parse(p)}catch(g){throw g.message+=`:
`+p,g}}e.asJson=w;function m(S){d(S)}e.updateProxyConfigurationsScope=m;let y;function d(S){const C=A.Registry.as(k.Extensions.Configuration),p=y;y={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},C.updateConfigurations({add:[y],remove:p?[p]:[]})}d(2)}),define(ne[208],se([0,1,21,20,13,44]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(P,I){this.requestService=P,this.fileService=I}async download(P,I,E=D.CancellationToken.None){if(P.scheme===n.Schemas.file||P.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(P,I);return}const w={type:"GET",url:P.toString(!0)},m=await this.requestService.request(w,E);if(m.res.statusCode===200)await this.fileService.writeFile(I,m.stream);else{const y=await(0,T.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${y}`)}}};A=me([G(0,T.IRequestService),G(1,k.IFileService)],A),e.DownloadService=A}),define(ne[209],se([0,1,18,21,2,17,169,13,8,25,44]),function(Q,e,D,n,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let w=class extends k.Disposable{constructor(y,d,S,C){super();this.fileService=y,this.productService=d,this.requestService=S,this.logService=C,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,p])=>this.allConfigBasedTips.set(p.configPath,p))}getConfigBasedTips(y){return this.getValidConfigBasedTips(y)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(y){const d=[];for(const[S,C]of this.allConfigBasedTips)if(!(C.configScheme&&C.configScheme!==y.scheme))try{const p=await this.fileService.readFile((0,T.joinPath)(y,S)),g=new Map;Object.entries(C.recommendations).forEach(([f,c])=>{if((0,D.isNonEmptyArray)(c.remotes))for(const s of c.remotes)g.set(s,{extensionId:f,extensionName:c.name,configName:C.configName,important:!!c.important,isExtensionPack:!!c.isExtensionPack,whenNotInstalled:c.whenNotInstalled});else d.push({extensionId:f,extensionName:c.name,configName:C.configName,important:!!c.important,isExtensionPack:!!c.isExtensionPack,whenNotInstalled:c.whenNotInstalled})});const u=(0,A.getDomainsOfRemotes)(p.value.toString(),[...g.keys()]);for(const f of u){const c=g.get(f);c&&d.push(c)}}catch{}return d}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const y=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(y.res.statusCode!==200)return[];const d=await(0,E.asJson)(y);return d?d.workspaceRecommendations||[]:[]}catch(y){return this.logService.error(y),[]}}};w=me([G(0,b.IFileService),G(1,I.IProductService),G(2,E.IRequestService),G(3,P.ILogService)],w),e.ExtensionTipsService=w}),define(ne[210],se([0,1,16,21]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(b){this.service=b}listen(b,P){throw new Error("Invalid listen")}call(b,P,I,E=n.CancellationToken.None){switch(P){case"request":return this.service.request(I[0],E).then(async({res:w,stream:m})=>{const y=await(0,D.streamToBuffer)(m);return[{statusCode:w.statusCode,headers:w.headers},y]});case"resolveProxy":return this.service.resolveProxy(I[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class T{constructor(b){this.channel=b}async request(b,P){const[I,E]=await this.channel.call("request",[b],P);return{res:I,stream:(0,D.bufferToStream)(E)}}async resolveProxy(b){return this.channel.call("resolveProxy",[b])}}e.RequestChannelClient=T}),define(ne[211],se([0,1,207,210]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class k{constructor(A,b,P){this.configurationService=b,this.logService=P,this.browserRequestService=new D.RequestService(b,P),this.mainRequestService=new n.RequestChannelClient(A.getChannel("request"))}request(A,b){return this.getRequestService().request(A,b)}async resolveProxy(A){return this.getRequestService().resolveProxy(A)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=k}),define(ne[99],se([0,1,62,5]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(T){return(0,D.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[212],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[213],se([0,1,85,6,21,3,2,20,30,8,99,212]),function(Q,e,D,n,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const C=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${C})`);const p=(0,E.hash)(S);this.processeDisposables.has(p)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${C})`),this.doDisposeWorker(S));const g=new k.CancellationTokenSource;let u,f,c;this.processeDisposables.set(p,i=>{g.dispose(!0),u?.terminate(S,k.CancellationToken.None),f?.close(),c?.close(),this.processeDisposables.delete(p);const o=this.processResolvers.get(p);o&&(this.processResolvers.delete(p),o({reason:i}))}),u=await this.getOrCreateWebWorker(S);const s=new Promise(i=>{this.processResolvers.set(p,i)});if(g.token.isCancellationRequested)return s;const{port1:r,port2:t}=new MessageChannel;return f=r,c=t,await u.spawn(S,c,g.token),g.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${C})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[f])),s}getOrCreateWebWorker(S){let C=this.workers.get(S.process.moduleId);if(!C){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const p=new y(S.process.type,this.logService);C=p.init(),p.onDidProcessSelfTerminate(({configuration:g,reason:u})=>{this.doDisposeWorker(g,u)}),this.workers.set(S.process.moduleId,C)}return C}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,C){const p=this.processeDisposables.get((0,E.hash)(S));p&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),p(C))}};m=me([G(0,I.ILogService)],m),e.SharedProcessWorkerService=m;class y extends A.Disposable{constructor(S,C){super();this.type=S,this.logService=C,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new n.DeferredPromise,C=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return C.onerror=p=>{this.logService.error(`SharedProcess: worker error (${this.type})`,p.message)},C.onmessageerror=p=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,p)},C.onmessage=p=>{const{id:g,message:u,configuration:f,nonce:c}=p.data;switch(g){case w.SharedProcessWorkerMessages.Ready:S.complete(C);break;case w.SharedProcessWorkerMessages.Ack:if(c){const s=this.mapMessageNonceToPendingMessageResolve.get(c);s&&(this.mapMessageNonceToPendingMessageResolve.delete(c),s())}break;case w.SharedProcessWorkerMessages.SelfTerminated:f&&u&&this._onDidProcessSelfTerminate.fire({configuration:f,reason:JSON.parse(u)});break;case w.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,u);break;case w.SharedProcessWorkerMessages.Info:u&&this.logService.info(u);break;case w.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,u);break;case w.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,u);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,p)}},C.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,C,p){const g=await this.workerReady;if(!C.isCancellationRequested)return new Promise(u=>{const f=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(f,u);const c={...S,nonce:f};p?g.postMessage(c,[p]):g.postMessage(c),C.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(f)&&u()})})}spawn(S,C,p){const g={id:w.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:b.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(g,p,C)}terminate(S,C){const p={id:w.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(p,C)}}}),define(ne[214],se([0,1,60,20,168]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.vscodeUserData})}}me([D.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(ne[215],se([0,1,54,9,153,21,38,10,4,30,131,166,6]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let d;async function S(p,g,u){return g["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(u)&&!g["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(u)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=m.Promises.withAsyncBody(async(f,c)=>{const s=new T.CancellationTokenSource,r=setTimeout(()=>{s.dispose(!0),c(new Error((0,k.localize)(0,null)))},y);try{f(await C(p,s.token))}catch(t){!(0,b.isCancellationError)(t)&&!s.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(t)))):f({})}finally{clearTimeout(r),s.dispose()}})),d)}e.getResolvedShellEnv=S;async function C(p,g){const u=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",u);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",f);const c=(0,I.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(c+"(.*)"+c),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",r);const t=await(0,E.getSystemShell)(P.OS,r);return p.trace("getUnixShellEnvironment#shell",t),new Promise((i,o)=>{if(g.isCancellationRequested)return o((0,b.canceled)());const l=(0,n.basename)(t);let a,h;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${v} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${v} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,l==="tcsh"?h=["-ic"]:h=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const R=(0,D.spawn)(t,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(R.kill(),o((0,b.canceled)()))),R.on("error",O=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(O)),o(O)});const M=[];R.stdout.on("data",O=>M.push(O));const F=[];R.stderr.on("data",O=>F.push(O)),R.on("close",(O,L)=>{const N=Buffer.concat(M).toString("utf8");p.trace("getUnixShellEnvironment#raw",N);const $=Buffer.concat(F).toString("utf8");if($.trim()&&p.trace("getUnixShellEnvironment#stderr",$),O||L)return o(new Error((0,k.localize)(2,null,O,L)));const H=s.exec(N),Y=H?H[1]:"{}";try{const te=JSON.parse(Y);u?te.ELECTRON_RUN_AS_NODE=u:delete te.ELECTRON_RUN_AS_NODE,f?te.ELECTRON_NO_ATTACH_CONSOLE=f:delete te.ELECTRON_NO_ATTACH_CONSOLE,delete te.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",te),i(te)}catch(te){p.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(te)),o(te)}})})}}),define(ne[100],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[216],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((k,T)=>Q(["vsda"],k,T))}async createNewMessage(k){try{const T=await this.vsda(),A=new T.validator;if(A){const b=String(D._nextId++);return this.validators.set(b,A),{id:b,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,T){if(!k.id)return!0;const A=this.validators.get(k.id);if(!A)return!1;this.validators.delete(k.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(k){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=D,D._nextId=1}),define(ne[217],se([0,1,3,2]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class k extends n.Disposable{constructor(E,w,m){super();this.channel=E,this.profile=w,this.workspace=m}async getItems(){const E={profile:this.profile,workspace:this.workspace},w=await this.channel.call("getItems",E);return new Map(w)}updateItems(E){const w={profile:this.profile,workspace:this.workspace};return E.insert&&(w.insert=Array.from(E.insert.entries())),E.delete&&(w.delete=Array.from(E.delete.values())),this.channel.call("updateItems",w)}}class T extends k{constructor(E,w){super(E,w,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(E=>this.onDidChangeStorage(E)))}onDidChangeStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class A extends T{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=A;class b extends T{constructor(E,w){super(E,w)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=b;class P extends k{constructor(E,w){super(E,void 0,w);this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P}),define(ne[101],se([0,1,4,36,7,30]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(I){if(D.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function b(I,E,w,m,y,d,S,C,p,g){const u=Object.create(null);u["common.machineId"]=S,u.sessionID=(0,T.generateUuid)()+Date.now(),u.commitHash=y,u.version=d,u["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,D.PlatformToString)(D.platform),u["common.nodePlatform"]=n.platform,u["common.nodeArch"]=m,u["common.product"]=g||"desktop",C&&(u["common.msftInternal"]=C);let f=0;const c=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),D.isLinuxSnap&&(u["common.snap"]="true");const s=A(w);s&&(u["common.platformDetail"]=s);try{const r=await I.readFile(k.URI.file(p));u["common.source"]=r.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=b;function P(I){const E=n.env.USERDNSDOMAIN;if(!E)return!1;const w=E.toLowerCase();return I.some(m=>w===m)}e.verifyMicrosoftInternalDomain=P}),define(ne[22],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[218],se([0,1,37,51,6,35,20,9,4,7,128,27,130,89,13,25,22]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function g(r,t){const i=`${r}::${t.join(":")}`,o=p.get(i);if(o)return o;const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,h=new Map,v=2e4;function R(F,O,L,N){const $=O.substring(F.length+1);return k.Promises.withAsyncBody(async H=>{let Y;try{Y=await w.Promises.readdir(O,{withFileTypes:!0})}catch{H();return}if(N.count>=v){N.count+=Y.length,N.maxReached=!0,H();return}let te=Y.length;if(te===0){H();return}let q=Y;N.count+Y.length>v&&(N.maxReached=!0,te=v-N.count,q=Y.slice(0,te)),N.count+=Y.length;for(const W of q)if(W.isDirectory()){if(L.includes(W.name)||await R(F,(0,b.join)(O,W.name),L,N),--te==0){H();return}}else{const x=W.name.lastIndexOf(".");if(x>=0){const K=W.name.substring(x+1);K&&a.set(K,(a.get(K)??0)+1)}for(const K of l)K.relativePathPattern?.test($)!==!1&&K.filePattern.test(W.name)&&h.set(K.tag,(h.get(K.tag)??0)+1);if(--te==0){H();return}}})}const M=k.Promises.withAsyncBody(async F=>{const O={count:0,maxReached:!1};await R(r,r,t,O);const L=await c(r);F({configFiles:u(h),fileTypes:u(a),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:L})});return p.set(i,M),M}e.collectWorkspaceStats=g;function u(r){return[...n.Iterable.map(r.entries(),([t,i])=>({name:t,count:i}))].sort((t,i)=>i.count-t.count)}function f(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(r.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),r}e.getMachineInfo=f;async function c(r){try{const t=new Map,i=(0,b.join)(r,".vscode","launch.json"),o=await w.Promises.readFile(i),l=[],a=(0,T.parse)(o.toString(),l);if(l.length)return console.log(`Unable to parse ${i}`),[];if((0,T.getNodeType)(a)==="object"&&a.configurations)for(const h of a.configurations){const v=h.type;v&&(t.has(v)?t.set(v,t.get(v)+1):t.set(v,1))}return u(t)}catch{return[]}}e.collectLaunchConfigs=c;let s=class{constructor(t,i){this.telemetryService=t,this.productService=i}formatMachineInfo(t){const i=[];return i.push(`OS Version:       ${t.os}`),i.push(`CPUs:             ${t.cpus}`),i.push(`Memory (System):  ${t.memory}`),i.push(`VM:               ${t.vmHint}`),i.join(`
`)}formatEnvironment(t){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const o=D.cpus();return o&&o.length>0&&i.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),i.push(`Memory (System):  ${(D.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${D.loadavg().map(l=>Math.round(l)).join(", ")}`),i.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${t.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(t,i){return Promise.all([(0,m.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async o=>{let[l,a]=o,h=this.formatProcessList(t,l);return i.forEach(v=>{if((0,y.isRemoteDiagnosticError)(v))h+=`
${v.errorMessage}`,a+=`
${v.errorMessage}`;else if(h+=`

Remote: ${v.hostName}`,v.processes&&(h+=`
${this.formatProcessList(t,v.processes)}`),v.workspaceMetadata){a+=`
|  Remote: ${v.hostName}`;for(const R of Object.keys(v.workspaceMetadata)){const M=v.workspaceMetadata[R];let F=`${M.fileCount} files`;M.maxFilesReached&&(F=`more than ${F}`),a+=`|    Folder (${R}): ${F}`,a+=this.formatWorkspaceStats(M)}}}),{processInfo:h,workspaceInfo:a}})}async getSystemInfo(t,i){const{memory:o,vmHint:l,os:a,cpus:h}=f(),v={os:a,memory:o,cpus:h,vmHint:l,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(v.load=`${D.loadavg().map(R=>Math.round(R)).join(", ")}`),P.isLinux&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(t,i){const o=[];return(0,m.listProcesses)(t.mainPID).then(async l=>(o.push(""),o.push(this.formatEnvironment(t)),o.push(""),o.push(this.formatProcessList(t,l)),t.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(t))),i.forEach(a=>{if((0,y.isRemoteDiagnosticError)(a))o.push(`
${a.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${a.hostName}`),o.push(this.formatMachineInfo(a.machineInfo)),a.processes&&o.push(this.formatProcessList(t,a.processes)),a.workspaceMetadata)for(const h of Object.keys(a.workspaceMetadata)){const v=a.workspaceMetadata[h];let R=`${v.fileCount} files`;v.maxFilesReached&&(R=`more than ${R}`),o.push(`Folder (${h}): ${R}`),o.push(this.formatWorkspaceStats(v))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(t){const i=[],o=60;let l=0;const a=(M,F)=>{const O=` ${M}(${F})`;l+O.length>o?(i.push(h),h="|                 ",l=h.length):l+=O.length,h+=O};let h="|      File types:";const v=10,R=t.fileTypes.length>v?v:t.fileTypes.length;for(let M=0;M<R;M++){const F=t.fileTypes[M];a(F.name,F.count)}if(i.push(h),t.configFiles.length>=0&&(h="|      Conf files:",l=0,t.configFiles.forEach(M=>{a(M.name,M.count)}),i.push(h)),t.launchConfigFiles.length>0){let M="|      Launch Configs:";t.launchConfigFiles.forEach(F=>{M+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),i.push(M)}return i.join(`
`)}expandGPUFeatures(t){const i=Math.max(...Object.keys(t).map(o=>o.length));return Object.keys(t).map(o=>`${o}:  ${" ".repeat(i-o.length)}  ${t[o]}`).join(`
                  `)}formatWorkspaceMetadata(t){const i=[],o=[];return t.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(i.push(`|  Window (${l.title})`),l.folderURIs.forEach(a=>{const h=I.URI.revive(a);if(h.scheme===A.Schemas.file){const v=h.fsPath;o.push(g(v,["node_modules",".git"]).then(R=>{let M=`${R.fileCount} files`;R.maxFilesReached&&(M=`more than ${M}`),i.push(`|    Folder (${(0,b.basename)(v)}): ${M}`),i.push(this.formatWorkspaceStats(R))}).catch(R=>{i.push(`|      Error: Unable to collect workspace stats for folder ${v} (${R.toString()})`)}))}else i.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(l=>i.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}formatProcessList(t,i){const o=new Map;t.windows.forEach(a=>o.set(a.pid,a.title));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(t.mainPID,o,l,i,0),l.join(`
`)}formatProcessItem(t,i,o,l,a){const h=a===0;let v;h?v=l.pid===t?`${this.productService.applicationName} main`:"remote agent":(v=`${"  ".repeat(a)} ${l.name}`,l.name==="window"&&(v=`${v} (${i.get(l.pid)})`));const R=process.platform==="win32"?l.mem:D.totalmem()*(l.mem/100);o.push(`${l.load.toFixed(0).padStart(5," ")}	${(R/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(l.children)&&l.children.forEach(M=>this.formatProcessItem(t,i,o,M,a+1))}async getWorkspaceFileExtensions(t){const i=new Set;for(const{uri:o}of t.folders){const l=I.URI.revive(o);if(l.scheme!==A.Schemas.file)continue;const a=l.fsPath;try{(await g(a,["node_modules",".git"])).fileTypes.forEach(v=>i.add(v.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(t){for(const{uri:i}of t.folders){const o=I.URI.revive(i);if(o.scheme!==A.Schemas.file)continue;const l=o.fsPath;try{const a=await g(l,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),a.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:h.name,count:h.count})}),a.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:h.name,count:h.count})}),a.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};s=me([G(0,C.ITelemetryService),G(1,S.IProductService)],s),e.DiagnosticsService=s}),define(ne[102],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:b,data:P}){return this.appenders.forEach(I=>I.log(b,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class n{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ne[49],se([0,1,31,78,14,19,101,22]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,n.staticObservableValue)(0)}publicLog(s,r){return Promise.resolve(void 0)}publicLog2(s,r){return this.publicLog(s,r)}publicLogError(s,r){return Promise.resolve(void 0)}publicLogError2(s,r){return this.publicLogError(s,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class I{async publicLog(s,r,t){}async publicLogError(s,r,t){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(c,s){return s.onDidChangeConfiguration(r=>{r.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(r.source),configurationKeys:p(r.sourceConfig)})})}e.configurationTelemetry=E;function w(c,s){return!(s.disableTelemetry||!c.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=w;function m(c){const s=c.getValue(b.TELEMETRY_SETTING_ID),r=c.getValue("telemetry.enableCrashReporter");if(c.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function y(c){const s={},r={},t={};C(c,t);for(let i in t){i=i.length>150?i.substr(i.length-149):i;const o=t[i];typeof o=="number"?r[i]=o:typeof o=="boolean"?r[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),s[i]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(s[i]=o)}return{properties:s,measurements:r}}e.validateTelemetryData=y;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function S(c){if(!c)return"none";for(const s of d)if(c.startsWith(`${s}+`))return s;return"other"}e.cleanRemoteAuthority=S;function C(c,s,r=0,t){if(!!c)for(const i of Object.getOwnPropertyNames(c)){const o=c[i],l=t?t+i:i;Array.isArray(o)?s[l]=(0,D.safeStringify)(o):o instanceof Date?s[l]=o.toISOString():(0,k.isObject)(o)?r<2?C(o,s,r+1,l+"."):s[l]=(0,D.safeStringify)(o):s[l]=o}}function p(c){if(!c)return[];const s=[];return g(s,"",c),s}function g(c,s,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(t=>g(c,s?`${s}.${t}`:t,r[t])):c.push(s)}function u(c,s){const r=c.msftInternalDomains||[],t=s.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(r)||t}e.isInternalTelemetry=u;function f(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=f}),define(ne[219],se([0,1,47,49]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(T,A,b,P,I,E,w){const m={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`},y=await(0,D.getServiceMachineId)(b,I,E),{sessionId:d}=await w.getTelemetryInfo();return(0,n.supportsTelemetry)(A,b)&&(0,n.getTelemetryLevel)(P)===3&&(m["X-Market-User-Id"]=y,m["VSCode-SessionId"]=d),m}e.resolveMarketplaceHeaders=k}),define(ne[220],se([0,1,10,31,49]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(P,I,E){const w=await new Promise((C,p)=>{Q(["@microsoft/1ds-core-js"],C,p)}),m=await new Promise((C,p)=>{Q(["@microsoft/1ds-post-js"],C,p)}),y=new w.AppInsightsCore,d=new m.PostChannel,S={instrumentationKey:P,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(E){S.extensionConfig={};const C={alwaysUseXhrOverride:!0,httpXHROverride:E};S.extensionConfig[d.identifier]=C}return y.initialize(S,[]),y.addTelemetryInitializer(C=>{I&&(C.ext=C.ext??{},C.ext.utc=C.ext.utc??{},C.ext.utc.flags=8462029)}),y}class b{constructor(I,E,w,m,y){this._isInternalTelemetry=I,this._eventPrefix=E,this._defaultData=w,this._xhrOverride=y,this.endPointUrl=T,this._defaultData||(this._defaultData={}),typeof m=="function"?this._aiCoreOrKey=m():this._aiCoreOrKey=m,this._asyncAiCore=null}_withAIClient(I){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){I(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=A(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(E=>{I(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(I,E){if(!this._aiCoreOrKey)return;E=(0,n.mixin)(E,this._defaultData),E=(0,k.validateTelemetryData)(E);const w=this._eventPrefix+"/"+I;try{this._withAIClient(m=>{m.pluginVersionString=E?.properties.version??"Unknown",m.track({name:w,baseData:{name:w,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(I=>{this._withAIClient(E=>{E.unload(!0,()=>{this._aiCoreOrKey=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=b}),define(ne[103],se([0,1,2,15,8,49]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(P,I,E=""){super();this.prefix=E;const w=P.getLogger(I.telemetryLogResource);w?this.logger=this._register(w):(this.logger=this._register(P.createLogger(I.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(P,I){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,T.validateTelemetryData)(I))}};A=me([G(0,k.ILoggerService),G(1,n.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(ne[104],se([0,1,2,31,78,4,24,154,19,42,96,25,40,22,49]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(g,u,f){this._configurationService=u,this._productService=f,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,u){this._experimentProperties[g]=u}_updateTelemetryLevel(){let g=(0,d.getTelemetryLevel)(this._configurationService);const u=this._productService.enabledTelemetryLevels;if(u){this._sendErrorTelemetry=this.sendErrorTelemetry?u.error:!1;const f=u.usage?3:u.error?2:0;g=Math.min(g,f)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,u=g.sessionID,f=g["common.machineId"],c=g["common.firstSessionDate"],s=g["common.msftInternal"];return{sessionId:u,machineId:f,firstSessionDate:c,msftInternal:s}}dispose(){this._disposables.dispose()}_log(g,u,f,c){return this.telemetryLevel.value<u?Promise.resolve(void 0):this._commonProperties.then(s=>{f=(0,n.mixin)(f,s),f=(0,n.mixin)(f,this._experimentProperties),f=(0,n.cloneAndChange)(f,r=>{if(typeof r=="string")return this._cleanupInfo(r,c)}),this._appenders.forEach(r=>r.log(g,f))},s=>{console.error(s)})}publicLog(g,u,f){return this._log(g,3,u,f)}publicLog2(g,u,f){return this.publicLog(g,u,f)}publicLogError(g,u){return this._sendErrorTelemetry?this._log(g,2,u,!0):Promise.resolve(void 0)}publicLogError2(g,u){return this.publicLogError(g,u)}_anonymizeFilePaths(g){let u=g;const f=[];for(const t of this._cleanupPatterns)for(;;){const i=t.exec(g);if(!i)break;f.push([i.index,t.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(u="";;){const t=s.exec(g);if(!t)break;!c.test(t[0])&&f.every(([i,o])=>t.index<i||t.index>=o)&&(u+=g.substring(r,t.index)+"<REDACTED: user-file-path>",r=s.lastIndex)}return r<g.length&&(u+=g.substr(r)),u}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const u=g.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of f)if(c.regex.test(u))return`<REDACTED: ${c.label}>`;return g}_cleanupInfo(g,u){let f=g;u&&(f=this._anonymizeFilePaths(f));for(const c of this._cleanupPatterns)f=f.replace(c,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=me([G(1,P.IConfigurationService),G(2,w.IProductService)],S),e.TelemetryService=S;function C(){const p=(0,b.localize)(0,null,E.default.nameLong),g=E.default.privacyStatementUrl?(0,b.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,b.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=T.isWeb?"":(0,b.localize)(3,null),f=(0,b.localize)(4,null),c=(0,b.localize)(5,null),s=(0,b.localize)(6,null),r=(0,b.localize)(7,null),t=`
|       | ${f} | ${c} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,b.localize)(8,null);return`
${p} ${g} ${u}

&nbsp;

${r}
${t}

&nbsp;

${i}
`}m.Registry.as(I.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,b.localize)(10,null),(0,b.localize)(11,null),(0,b.localize)(12,null),(0,b.localize)(13,null)],markdownDescription:C(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(I.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,b.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,b.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[221],se([0,1,274,220]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends n.AbstractOneDataSystemAppender{constructor(A,b,P,I){const E={sendPOST:(w,m)=>{const y={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const d=D.request(w.urlString,y,S=>{S.on("data",function(C){m(S.statusCode??200,S.headers,C.toString())}),S.on("error",function(C){m(0,{})})});d.write(w.data),d.end()}catch{m(0,{})}}};super(A,b,P,I,E)}}e.OneDataSystemAppender=k}),define(ne[222],se([0,1,20,64,19,15,8,25,22,102,103,104]),function(Q,e,D,n,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(d,S,C,p,g){this.configurationService=d,this.telemetryService=S,this.loggerService=C,this.environmentService=p,this.productService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(d){if(!this.customTelemetryServices.has(d.id)){const{machineId:S,sessionId:C}=await this.telemetryService.getTelemetryInfo(),p=Object.create(null);p["common.vscodemachineid"]=S,p["common.vscodesessionid"]=C;const g=[d.id,JSON.stringify(p),d.aiKey],f=new n.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new I.TelemetryAppenderClient(f),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${d.id}] `)];this.customTelemetryServices.set(d.id,new w.TelemetryService({appenders:c,sendErrorTelemetry:d.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(d.id)}async publicLog(d,S,C){await(await this.getCustomTelemetryService(d)).publicLog(S,C)}async publicLogError(d,S,C){await(await this.getCustomTelemetryService(d)).publicLogError(S,C)}};m=me([G(0,k.IConfigurationService),G(1,P.ITelemetryService),G(2,A.ILoggerService),G(3,T.IEnvironmentService),G(4,b.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(ne[223],se([0,1,6,21,3,2,8]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let b=class extends T.Disposable{constructor(I,E){super();this._logService=E,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=I===void 0?15e3:I}createRequest(I){return new Promise((E,w)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,E),this._onCreateRequest.fire({requestId:m,...I});const y=new n.CancellationTokenSource;(0,D.timeout)(this._timeout,y.token).then(()=>w(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,T.toDisposable)(()=>y.cancel())])})}acceptReply(I,E){const w=this._pendingRequests.get(I);w?(this._pendingRequests.delete(I),(0,T.dispose)(this._pendingRequestDisposables.get(I)||[]),this._pendingRequestDisposables.delete(I),w(E)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${I}`)}};b=me([G(1,A.ILogService)],b),e.RequestStore=b}),define(ne[105],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.SmoothScrolling="terminal.integrated.smoothScrolling"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(u){u.FileName="ptyhost"})(T=e.TerminalLogConstants||(e.TerminalLogConstants={}));var A;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(A=e.PosixShellType||(e.PosixShellType={}));var b;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(b=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var I;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.Log="log",u.Heartbeat="heartbeat"})(I=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var E;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var C;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(C=e.ProfileSource||(e.ProfileSource={}));var p;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(p=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[224],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[225],se([0,1,37,20,31,9,4,36,24,14,27]),function(Q,e,D,n,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let c=0;return f&&f.length===4&&(c=parseInt(f[3])),c}e.getWindowsBuildNumber=w;async function m(f,c,s,r=b.env,t=E.Promises.exists){if(T.isAbsolute(f))return await t(f)?f:void 0;if(c===void 0&&(c=b.cwd()),T.dirname(f)!=="."){const a=T.join(c,f);return await t(a)?a:void 0}const o=(0,k.getCaseInsensitive)(r,"PATH");if(s===void 0&&(0,I.isString)(o)&&(s=o.split(T.delimiter)),s===void 0||s.length===0){const a=T.join(c,f);return await t(a)?a:void 0}for(const a of s){let h;if(T.isAbsolute(a)?h=T.join(a,f):h=T.join(c,a,f),await t(h))return h;if(A.isWindows){let v=h+".com";if(await t(v)||(v=h+".exe",await t(v)))return v}}const l=T.join(c,f);return await t(l)?l:void 0}e.findExecutable=m;function y(f,c,s){if(!c.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration)return;const r=f.args,t=b.platform==="win32"?T.basename(f.executable).toLowerCase():T.basename(f.executable),i=T.dirname(n.FileAccess.asFileUri("",Q).fsPath);let o;const l={VSCODE_INJECTION:"1"};if(A.isWindows){if(t==="pwsh.exe")return!r||g(r)?o=e.shellIntegrationArgs.get(d.WindowsPwsh):p(r)&&(o=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),o?(o&&(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i,"")),{newArgs:o,envMixin:l}):void 0;s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(t){case"bash":return!r||r.length===0?o=e.shellIntegrationArgs.get(d.Bash):u(r)&&(l.VSCODE_SHELL_LOGIN="1",o=e.shellIntegrationArgs.get(d.Bash)),o?(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i),{newArgs:o,envMixin:l}):void 0;case"pwsh":return!r||g(r)?o=e.shellIntegrationArgs.get(d.Pwsh):p(r)&&(o=e.shellIntegrationArgs.get(d.PwshLogin)),o?(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i,""),{newArgs:o,envMixin:l}):void 0;case"zsh":{if(!r||r.length===0?o=e.shellIntegrationArgs.get(d.Zsh):u(r)?o=e.shellIntegrationArgs.get(d.ZshLogin):(r===e.shellIntegrationArgs.get(d.Zsh)||r===e.shellIntegrationArgs.get(d.ZshLogin))&&(o=r),!o)return;o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i);const a=T.join(D.tmpdir(),"vscode-zsh");l.ZDOTDIR=a;const h=[];return h.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:T.join(a,".zshrc")}),h.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:T.join(a,".zprofile")}),h.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:T.join(a,".zshenv")}),h.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:T.join(a,".zlogin")}),{newArgs:o,envMixin:l,filesToCopy:h}}}s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=y;var d;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],C=["-nol","-nologo"];function p(f){return typeof f=="string"?S.includes(f.toLowerCase()):f.length===1&&S.includes(f[0].toLowerCase())||f.length===2&&(S.includes(f[0].toLowerCase())||S.includes(f[1].toLowerCase()))&&(C.includes(f[0].toLowerCase())||C.includes(f[1].toLowerCase()))}function g(f){return typeof f=="string"?C.includes(f.toLowerCase()):f.length===0||f?.length===1&&C.includes(f[0].toLowerCase())}function u(f){return f==="string"&&S.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&S.includes(f[0].toLowerCase())}}),define(ne[226],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST_DARK="hcDark",T.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function n(T){return T===D.HIGH_CONTRAST_DARK||T===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=n;function k(T){return T===D.DARK||T===D.HIGH_CONTRAST_DARK}e.isDark=k}),define(ne[106],se([0,1,50,3,2,5,40,226]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var P;(function(C){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}C.isThemeColor=p})(P=e.ThemeColor||(e.ThemeColor={}));function I(C){return{id:C}}e.themeColorFromId=I;var E;(function(C){function p(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||P.isThemeColor(i.color))}C.isThemeIcon=p;const g=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function u(i){const o=g.exec(i);if(!o)return;const[,l]=o;return{id:l}}C.fromString=u;function f(i){return{id:i}}C.fromId=f;function c(i,o){let l=i.id;const a=l.lastIndexOf("~");return a!==-1&&(l=l.substring(0,a)),o&&(l=`${l}~${o}`),{id:l}}C.modify=c;function s(i){const o=i.id.lastIndexOf("~");if(o!==-1)return i.id.substring(o+1)}C.getModifier=s;function r(i,o){return i.id===o.id&&i.color?.id===o.color?.id}C.isEqual=r;function t(i,o){return{id:i.id,color:o?I(o):void 0}}C.asThemeIcon=t,C.asClassNameArray=D.CSSIcon.asClassNameArray,C.asClassName=D.CSSIcon.asClassName,C.asCSSSelector=D.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function w(C){switch(C){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const g=this.themingParticipants.indexOf(p);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const y=new m;A.Registry.add(e.Extensions.ThemingContribution,y);function d(C){return y.onColorThemeChange(C)}e.registerThemingParticipant=d;class S extends k.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,g){let u=this.theme.getColor(p);return u&&g&&(u=g(u,this.theme)),u?u.toString():null}}e.Themable=S}),define(ne[227],se([0,1,50,7,156,106]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(m,y){const d=[{name:null,description:(0,k.localize)(0,null)}];return d.push(...m.map(S=>({name:S.profileName,description:b(S)}))),y&&d.push(...y.map(S=>({name:S.title,description:P(S)}))),{values:d.map(S=>S.name),markdownDescriptions:d.map(S=>S.description)}}e.createProfileSchemaEnums=A;function b(m){let y=`$(${T.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:D.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?y+=`
- args: "${m.args}"`:y+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(y+=`
- overrideName: ${m.overrideName}`),m.color&&(y+=`
- color: ${m.color}`),m.env&&(y+=`
- env: ${JSON.stringify(m.env)}`),y}function P(m){return`$(${T.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:D.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function I(m,y){if(!m&&!y)return!0;if(typeof m=="string"&&typeof y=="string")return m===y;if(Array.isArray(m)&&Array.isArray(y)){if(m.length!==y.length)return!1;for(let d=0;d<m.length;d++)if(m[d]!==y[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=I;function E(m,y){if(!m&&!y)return!0;if(!m||!y)return!1;if(T.ThemeIcon.isThemeIcon(m)&&T.ThemeIcon.isThemeIcon(y))return m.id===y.id&&m.color===y.color;if(typeof m=="object"&&m&&"light"in m&&"dark"in m&&typeof y=="object"&&y&&"light"in y&&"dark"in y){const d=m,S=y;if((n.URI.isUri(d.light)||w(d.light))&&(n.URI.isUri(d.dark)||w(d.dark))&&(n.URI.isUri(S.light)||w(S.light))&&(n.URI.isUri(S.dark)||w(S.dark)))return d.light.path===S.light.path&&d.dark.path===S.dark.path}if(n.URI.isUri(m)&&n.URI.isUri(y)||w(m)||w(y)){const d=m,S=y;return d.path===S.path&&d.scheme===S.scheme}return!1}e.terminalIconsEqual=E;function w(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=w}),define(ne[228],se([0,1,50,155,42,40,227]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),f=>`$(${f.id})`)};const b={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),...e.terminalIconSchema},color:{description:(0,n.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...b}},I={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...b}},E=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),C={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...b}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...b}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...b}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...b}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function p(){T.Registry.as(k.Extensions.Configuration).registerConfiguration(C),u()}e.registerTerminalPlatformConfiguration=p;let g;function u(f,c){const s=T.Registry.as(k.Extensions.Configuration);let r;f&&(r=(0,A.createProfileSchemaEnums)(f?.profiles,c));const t=g;g={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?r?.values:void 0,markdownEnumDescriptions:f?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?r?.values:void 0,markdownEnumDescriptions:f?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?r?.values:void 0,markdownEnumDescriptions:f?.os===1?r?.markdownDescriptions:void 0}}},s.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=u}),define(ne[229],se([0,1,54,50,9,4,27,82,225,106]),function(Q,e,D,n,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let E,w=!0;function m(r,t,i,o,l=process.env,a,h,v,R){return a=a||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?y(i,a,l,h,o.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:o.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:o.getValue("terminal.integrated.defaultProfile.windows"),R,v):f(a,h,i,r&&typeof r=="object"?{...r}:o.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:o.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),R,v,l)}e.detectAvailableProfiles=m;async function y(r,t,i,o,l,a,h,v,R){const M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),F=`${process.env.windir}\\${M?"Sysnative":"System32"}`;let O=!1;(0,P.getWindowsBuildNumber)()>=16299&&(O=!0),await C(v);const L=new Map;r&&(L.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),L.set("Windows PowerShell",{path:`${F}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),L.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),L.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),L.set("Command Prompt",{path:`${F}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),c(a,L);const N=await d(L.entries(),h,t,i,o,R);if(r||!r&&l)try{const $=await g(`${F}\\${O?"wsl":"bash"}.exe`,h);for(const H of $)(!a||!(H.profileName in a))&&N.push(H)}catch{w&&(o?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return N}async function d(r,t,i,o=process.env,l,a){const h=[];for(const[v,R]of r){if(R===null)continue;let M,F,O;if("source"in R){const $=E?.get(R.source);if(!$)continue;M=$.paths,F=R.args||$.args,R.icon?O=S(R.icon):$.icon&&(O=$.icon)}else M=Array.isArray(R.path)?R.path:[R.path],F=T.isWindows||Array.isArray(R.args)?R.args:void 0,O=S(R.icon);const L=await a?.(M)||M.slice(),N=await s(v,t,L,i,o,F,R.env,R.overrideName,R.isAutoDetected,l);N?(N.isAutoDetected=R.isAutoDetected,N.icon=O,N.color=R.color,h.push(N)):l?.debug("Terminal profile not validated",v,M)}return l?.debug("Validated terminal profiles",h),h}function S(r){return typeof r=="string"?{id:r}:r}async function C(r){E&&!r||(E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),E.set("PowerShell",{profileName:"PowerShell",paths:r||await p(),icon:I.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function p(){const r=[];for await(const t of(0,b.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function g(r,t){const i=[],o=await new Promise((h,v)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(R,M)=>{if(R)return v("Problem occurred when getting wsl distros");h(M)})});if(!o)return[];const l=new RegExp(/[\r?\n]/),a=o.split(l).filter(h=>h.trim().length>0&&h!=="");for(const h of a){if(h===""||h.startsWith("docker-desktop"))continue;const v=`${h} (WSL)`,R={profileName:v,path:r,args:["-d",`${h}`],isDefault:v===t,icon:u(h),isAutoDetected:!1};i.push(R)}return i}function u(r){return r.includes("Ubuntu")?I.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):r.includes("Debian")?I.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):I.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function f(r,t,i,o,l,a,h,v){const R=new Map;if(i){const M=(await r.readFile("/etc/shells")).toString(),F=a||M.split(`
`).filter(L=>L.trim().indexOf("#")!==0&&L.trim().length>0),O=new Map;for(const L of F){let N=(0,k.basename)(L),$=O.get(N)||0;$++,$>1&&(N=`${N} (${$})`),O.set(N,$),R.set(N,{path:L,isAutoDetected:!0})}}return c(o,R),await d(R.entries(),l,r,v,t,h)}function c(r,t){if(!!r)for(const[i,o]of Object.entries(r))o===null||!("path"in o)&&!("source"in o)?t.delete(i):(o.icon=o.icon||t.get(i)?.icon,t.set(i,o))}async function s(r,t,i,o,l,a,h,v,R,M){if(i.length===0)return Promise.resolve(void 0);const F=i.shift();if(F==="")return s(r,t,i,o,l,a,h,v,R);const O={profileName:r,path:F,args:a,env:h,overrideName:v,isAutoDetected:R,isDefault:r===t};if((0,k.basename)(F)===F){const N=l.PATH?l.PATH.split(k.delimiter):void 0,$=await(0,P.findExecutable)(F,void 0,N,void 0,o.existsFile);return $?(O.path=$,O.isFromPath=!0,O):s(r,t,i,o,l,a)}return await o.existsFile((0,k.normalize)(F))?O:s(r,t,i,o,l,a,h,v,R)}}),define(ne[230],se([0,1,3,2,20,4,39,64,19,15,87,215,8,95,223,105,228,229]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let u=0,f=class extends n.Disposable{constructor(s,r,t,i){super();this._reconnectConstants=s,this._configurationService=r,this._environmentService=t,this._logService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,C.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:u,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,E.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?s.debugBrk=r.port:!r.break&&r.port&&(s.debug=r.port));const t=new b.Client(k.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,s);this._onPtyHostStart.fire(),A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const o=t.getChannel(S.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const l=A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(l.onProcessData(a=>this._onProcessData.fire(a))),this._register(l.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(l.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(l.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(l.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(l.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(l.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[t,l]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,r,t,i,o,l,a,h,v,R,M){const F=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),O=await this._proxy.createProcess(s,r,t,i,o,l,a,h,v,R,M);return clearTimeout(F),u=Math.max(u,O),O}updateTitle(s,r,t){return this._proxy.updateTitle(s,r,t)}updateIcon(s,r,t){return this._proxy.updateIcon(s,r,t)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s,r){return this._proxy.detachFromProcess(s,r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,r){return this._proxy.shutdown(s,r)}input(s,r){return this._proxy.input(s,r)}processBinary(s,r){return this._proxy.processBinary(s,r)}resize(s,r,t){return this._proxy.resize(s,r,t)}acknowledgeDataEvent(s,r){return this._proxy.acknowledgeDataEvent(s,r)}setUnicodeVersion(s,r){return this._proxy.setUnicodeVersion(s,r)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}installAutoReply(s,r){return this._proxy.installAutoReply(s,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(s){return this._proxy.uninstallAutoReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,r,t,i=!1){const o=await this._shellEnv;return(0,p.detectAvailableProfiles)(r,t,i,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}getRevivedPtyNewId(s){return this._proxy.getRevivedPtyNewId(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,r){return this._proxy.requestDetachInstance(s,r)}async acceptDetachInstanceReply(s,r){return this._proxy.acceptDetachInstanceReply(s,r)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s,r){return this._proxy.reviveTerminalProcesses(s,r)}async refreshProperty(s,r){return this._proxy.refreshProperty(s,r)}async updateProperty(s,r,t){return this._proxy.updateProperty(s,r,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:r})}async acceptPtyHostResolvedVariables(s,r){this._resolveVariablesRequestStore.acceptReply(s,r)}};f=me([G(1,P.IConfigurationService),G(2,I.IEnvironmentService),G(3,m.ILogService)],f),e.PtyHostService=f}),define(ne[69],se([0,1,3,4,5,8]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(S){S.Http="http",S.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var P;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const C=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!C)return{address:C[1],port:+C[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=w;function m(S,C){return C?C!==1&&S<1024:!n.isWindows&&S<1024}e.isPortPrivileged=m;class y{constructor(C,p,g){this.remoteAddress=C,this.localAddress=p,this._dispose=g,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=y;let d=class{constructor(C){this.logService=C,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(C){return this._tunnelProvider=C,C?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(C){this._canElevate=C.elevation,this._privacyOptions=C.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const C=[],p=Array.from(this._tunnels.values());for(const g of p){const u=Array.from(g.values());for(const f of u){const c=await f.value;c&&C.push(c)}}return C}async dispose(){for(const C of this._tunnels.values()){for(const{value:p}of C.values())await p.then(g=>g?.dispose());C.clear()}this._tunnels.clear()}openTunnel(C,p,g,u,f=!1,c,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${g} on local port ${u}.`),!C)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(C,p,g,u,f,c,s);return r?r.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(t);return(t.tunnelRemoteHost!==p||t.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(C){return{tunnelRemotePort:C.tunnelRemotePort,tunnelRemoteHost:C.tunnelRemoteHost,tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress,privacy:C.privacy,protocol:C.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${C.tunnelRemoteHost}:${C.tunnelRemotePort} `);const p=this._tunnels.get(C.tunnelRemoteHost);if(p){const g=p.get(C.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(C.tunnelRemoteHost,C.tunnelRemotePort,g))}}}}async tryDisposeTunnel(C,p,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${C}:${p}.`);const u=g.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(C)&&this._tunnels.get(C).delete(p),u}}async closeTunnel(C,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${C}:${p} `);const g=this._tunnels.get(C);if(g&&g.has(p)){const u=g.get(p);u.refcount=0,await this.tryDisposeTunnel(C,p,u)}}addTunnelToMap(C,p,g){this._tunnels.has(C)||this._tunnels.set(C,new Map),this._tunnels.get(C).set(p,{refcount:1,value:g})}async removeEmptyTunnelFromMap(C,p){const g=this._tunnels.get(C);g&&(await g.get(p)||g.delete(p),g.size===0&&this._tunnels.delete(C))}getTunnelFromMap(C,p){const g=[C];E(C)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(C)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const u=g.map(f=>this._tunnels.get(f));for(const f of u){const c=f?.get(p);if(c)return c}}canTunnel(C){return!!I(C)}createWithProvider(C,p,g,u,f,c,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${g} on local port ${u}.`);const r=g;this._factoryInProgress.add(r);const i={elevationRequired:f?m(u===void 0?g:u):!1},o={remoteAddress:{host:p,port:g},localAddressPort:u,privacy:c,public:c?c!==b.Private:void 0,protocol:s},l=C.forwardPort(o,i);return l?(this.addTunnelToMap(p,g,l),l.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),l}};d=me([G(0,T.ILogService)],d),e.AbstractTunnelService=d}),define(ne[231],se([0,1,8,69,2,10,6]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class b extends k.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(E){this._address=E,this._addressPromise&&(this._addressPromise.complete(E),this._addressPromise=null)}setTunnel(E){this._register(E)}}let P=class Ct extends k.Disposable{constructor(E,w){super();this._tunnelService=E,this._logService=w,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(E,w,m,y,d,S){const C=new b,p=await Promise.resolve(this._tunnelService.openTunnel(E,C,m,y,d,S));if(!p)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${y} (remote).`),C.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(w))throw this._disposedTunnels.delete(w),C.dispose(),await p.dispose(),(0,T.canceled)();return C.setTunnel(p),this._tunnels.set(w,C),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${p.localAddress} (local) to ${m}:${y} (remote).`),{tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress}}async setAddress(E,w){const m=this._tunnels.get(E);!m||m.setAddress(w)}async destroyTunnel(E){const w=this._tunnels.get(E);if(w){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this._tunnels.delete(E),await w.dispose();return}this._disposedTunnels.add(E)}};P._lastId=0,P=me([G(0,n.ISharedTunnelsService),G(1,D.ILogService)],P),e.SharedProcessTunnelService=P}),define(ne[232],se([0,1,76,115,206,6,2,19,8,25,204,69,100]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(g,u,f,c,s){let r;for(let t=3;t&&(r?.dispose(),r=await new d(g,u,f,c,s).waitForReady(),!(s&&n.BROWSER_RESTRICTED_PORTS[s]||!n.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));t--);return r}class d extends A.Disposable{constructor(u,f,c,s,r){super();this.defaultTunnelHost=f,this.suggestedLocalPort=r,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=u,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=t=>this._onConnection(t),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let u=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(u){u.pause();const f=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,E.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),s=c.getSocket().socket,r=c.readEntireBuffer();c.dispose(),r.byteLength>0&&u.write(r.buffer),u.on("end",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),s.end()}),u.on("close",()=>s.end()),u.on("error",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),s.destroy()}),s.on("end",()=>u.end()),s.on("close",()=>u.end()),s.on("error",()=>{u.destroy()}),u.pipe(s),s.pipe(u),u.localAddress&&this._socketsDispose.set(u.localAddress,()=>{u.end(),s.end()})}}let S=class extends w.AbstractTunnelService{constructor(u,f,c,s,r){super(f);this.socketFactory=u,this.signService=c,this.productService=s,this.configurationService=r}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,f,c,s,r,t,i){const o=this.getTunnelFromMap(f,c);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,c,s,r,t,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${c} on local port ${s}.`);const l={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},a=y(l,this.defaultTunnelHost,f,c,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,c,a),a}}};S=me([G(1,P.ILogService),G(2,m.ISignService),G(3,I.IProductService),G(4,b.IConfigurationService)],S),e.BaseTunnelService=S;let C=class extends S{constructor(u,f,c,s){super(k.nodeSocketFactory,u,f,c,s)}};C=me([G(0,P.ILogService),G(1,m.ISignService),G(2,I.IProductService),G(3,b.IConfigurationService)],C),e.TunnelService=C;let p=class extends A.Disposable{constructor(u,f,c,s){super();this.logService=u,this.productService=f,this.signService=c,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(u,f,c,s,r,t,i,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${s} on local port ${r}.`),!this._tunnelServices.has(u)){const l=new C(this.logService,this.signService,this.productService,this.configurationService);this._register(l),this._tunnelServices.set(u,l),l.onTunnelClosed(async()=>{(await l.tunnels).length===0&&(l.dispose(),this._tunnelServices.delete(u))})}return this._tunnelServices.get(u).openTunnel(f,c,s,r,t,i,o)}};p=me([G(0,P.ILogService),G(1,I.IProductService),G(2,m.ISignService),G(3,b.IConfigurationService)],p),e.SharedTunnelsService=p}),define(ne[33],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[233],se([0,1,3,2,7,15,32,13,8,33]),function(Q,e,D,n,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let E=class extends n.Disposable{constructor(m,y,d,S,C){super();this.extensionsManagementService=m,this.logService=S,this.uriIdentityService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(u=>u.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(g=>this.onInstallExtension(g))),this._register(m.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(m.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const p=k.URI.file(d.extensionsPath);this._register(y.watch(p)),this._register(D.Event.filter(y.onDidFilesChange,g=>g.rawChanges.some(u=>this.doesChangeAffects(u,p)))(()=>this.onDidChange()))}doesChangeAffects(m,y){return m.type!==1&&m.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(m.resource),y)?!1:this.uriIdentityService.extUri.isEqual(m.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(m.resource).startsWith(".")}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const y of m)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(y=>!(0,A.areSameExtensions)(y,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,A.areSameExtensions)(y,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(),y=m.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(C=>(0,A.areSameExtensions)(C,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),d=this.installedExtensions.filter(S=>this.installingExtensions.some(C=>(0,A.areSameExtensions)(C,S))?!1:m.every(C=>!(0,A.areSameExtensions)(C.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=m.map(S=>S.identifier),(y.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:d})}}};E=me([G(1,b.IFileService),G(2,T.INativeEnvironmentService),G(3,P.ILogService),G(4,I.IUriIdentityService)],E),e.ExtensionsWatcher=E}),define(ne[234],se([0,1,33,88,13,17,113,3,2]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class I{constructor(m){this.uri=m,this.time=I._clock++}touch(){return this.time=I._clock++,this}}I._clock=0;let E=class{constructor(m){this._fileService=m,this._dispooables=new P.DisposableStore,this._limit=2**16;const y=new Map,d=S=>{let C=y.get(S.scheme);return C===void 0&&(C=m.hasProvider(S)&&!this._fileService.hasCapability(S,1024),y.set(S.scheme,C)),C};this._dispooables.add(b.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(S=>{y.delete(S.scheme)})),this.extUri=new T.ExtUri(d),this._canonicalUris=new A.SkipList((S,C)=>this.extUri.compare(S,C,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,T.normalizePath)(m));const y=this._canonicalUris.get(m);return y?y.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new I(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((d,S)=>d[1].touch<S[1].touch?1:d[1].touch>S[1].touch?-1:0);I._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let d=0;d<y;d++)this._canonicalUris.set(m[d][0],m[d][1].touch())}};E=me([G(0,k.IFileService)],E),e.UriIdentityService=E,(0,n.registerSingleton)(D.IUriIdentityService,E,!0)}),define(ne[235],se([0,1,3,2,13,41,34,16]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends n.Disposable{constructor(E,w,m,y){super();this.fileSystemScheme=E,this.fileSystemProvider=w,this.userDataScheme=m,this.logService=y,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(d=>this.handleFileChanges(d)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,w){this.watchResources.set(E,E);const m=this.fileSystemProvider.watch(this.toFileSystemResource(E),w);return(0,n.toDisposable)(()=>{this.watchResources.delete(E),m.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,w,m){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(w),m)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,w,m){const y=(0,T.newWriteableStream)(d=>b.VSBuffer.concat(d.map(S=>b.VSBuffer.wrap(S))).buffer);return(async()=>{try{const d=await this.readFile(E);y.end(d)}catch(d){y.error(d),y.end()}})(),y}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,w,m){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),w,m)}delete(E,w){return this.fileSystemProvider.delete(this.toFileSystemResource(E),w)}copy(E,w,m){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(E),this.toFileSystemResource(w),m);throw new Error("copy not supported")}handleFileChanges(E){const w=[];for(const m of E){if(m.resource.scheme!==this.fileSystemScheme)continue;const y=this.toUserDataResource(m.resource);this.watchResources.findSubstr(y)&&w.push({resource:y,type:m.type})}w.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(w))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(ne[59],se([0,1,75]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(A,b,P,I){const E=(0,D.setProperty)(A,b,P,I)[0];return E&&(A=A.substring(0,E.offset)+E.content+A.substring(E.offset+E.length)),A}e.edit=n;function k(A,b,P){let I=P;for(;I>=0;){if(A.charAt(I)===b.charAt(b.length-1)&&b.length===1)return I+1;if(I--,b.length===2&&I>=0&&A.charAt(I)===b.charAt(0))return I+2}return 0}e.getLineStartOffset=k;function T(A,b,P){let I=P;for(;I>=0;)if(A.charAt(I)===b.charAt(b.length-1)&&b.length===1||(I++,b.length===2&&I>=0&&A.charAt(I)===b.charAt(1)))return I;return A.length-1}e.getLineEndOffset=T}),define(ne[236],se([0,1,31,55,14]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(m,y,d,S,C){const p=[],g=[],u=[];if(!y){const F=m.filter(({identifier:O})=>C.every(L=>L.toLowerCase()!==O.id.toLowerCase()));return{local:{added:p,removed:g,updated:u},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}m=m.map(E),y=y.map(E),d=d?d.map(E):null;const f=new Map,c=F=>{F.uuid&&f.set(F.id.toLowerCase(),F.uuid)};m.forEach(({identifier:F})=>c(F)),y.forEach(({identifier:F})=>c(F)),d?.forEach(({identifier:F})=>c(F));const s=F=>{const O=F.identifier.uuid||f.get(F.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${F.identifier.id.toLowerCase()}`},r=(F,O)=>(F.set(s(O),O),F),t=m.reduce(r,new Map),i=y.reduce(r,new Map),o=y.reduce((F,O)=>{const L=s(O);O=(0,D.deepClone)(O);const N=t.get(L);return N&&(N.installed&&(O.installed=!0),O.version||(O.version=N.version)),r(F,O)},new Map),l=d?d.reduce(r,new Map):null,a=S.reduce(r,new Map),h=C.reduce((F,O)=>{const L=f.get(O.toLowerCase());return F.add(L?`uuid:${L}`:`id:${O.toLowerCase()}`)},new Set),v=A(t,i,h);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const F=A(l,t,h),O=A(l,i,h),L=(N,$)=>{const H=t.get(N);if(H){const Y=i.get(N),te=$?Y:H;return{...te,version:Y.version&&(!H.installed||n.gt(Y.version,H.version))?Y.version:H.version,state:b(H,Y,l?.get(N)),preRelease:(0,k.isUndefined)(te.preRelease)?H.preRelease:H.installed?te.preRelease:Y.preRelease}}};for(const N of O.removed.values()){const $=t.get(N);$&&g.push($.identifier)}for(const N of O.added.values())if(F.added.has(N)){if(v.updated.has(N)){const $=L(N,!0);$&&(u.push(w($,N)),o.set(N,$))}}else{const $=i.get(N);$.installed&&p.push(w($,N))}for(const N of O.updated.values()){const $=L(N,!0);$&&(u.push(w($,N)),o.set(N,$))}for(const N of F.added.values())O.added.has(N)||o.set(N,t.get(N));for(const N of F.updated.values())if(!O.removed.has(N)&&!O.updated.has(N)){const $=L(N,!1);$&&(o.get(N)?.installed&&($.installed=!0),o.set(N,$))}for(const N of F.removed.values())!a.has(N)&&!O.updated.has(N)&&l?.get(N)?.installed&&o.delete(N)}const R=[],M=A(i,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(M.added.size>0||M.updated.size>0||M.removed.size>0)&&o.forEach((F,O)=>R.push(w(F,O))),{local:{added:p,removed:g,updated:u},remote:R.length?{added:[...M.added].map(F=>o.get(F)),updated:[...M.updated].map(F=>o.get(F)),removed:[...M.removed].map(F=>i.get(F)),all:R}:null}}e.merge=T;function A(m,y,d,{checkInstalledProperty:S,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const p=m?[...m.keys()].filter(s=>!d.has(s)):[],g=[...y.keys()].filter(s=>!d.has(s)),u=g.filter(s=>p.indexOf(s)===-1).reduce((s,r)=>(s.add(r),s),new Set),f=p.filter(s=>g.indexOf(s)===-1).reduce((s,r)=>(s.add(r),s),new Set),c=new Set;for(const s of p){if(f.has(s))continue;const r=m.get(s),t=y.get(s);(!t||r.disabled!==t.disabled||r.installed&&t.installed&&r.preRelease!==t.preRelease||!I(r.state,t.state)||C&&r.version!==t.version||S&&r.installed!==t.installed)&&c.add(s)}return{added:u,removed:f,updated:c}}function b(m,y,d){const S=m.state,C=y.state,p=d?.state;if(!y.version||S&&n.gt(m.version,y.version))return S;if(C&&n.gt(y.version,m.version)||!S)return C;if(!C)return S;const g=(0,D.deepClone)(S),u=p?P(p,C):{added:Object.keys(C).reduce((c,s)=>(c.add(s),c),new Set),removed:new Set,updated:new Set},f=p?P(p,S):{added:Object.keys(S).reduce((c,s)=>(c.add(s),c),new Set),removed:new Set,updated:new Set};for(const c of[...u.added.values(),...u.updated.values()])g[c]=C[c];for(const c of u.removed.values())f.updated.has(c)||delete g[c];return g}function P(m,y){const d=Object.keys(m),S=Object.keys(y),C=S.filter(u=>d.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),p=d.filter(u=>S.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),g=new Set;for(const u of d){if(p.has(u))continue;const f=m[u],c=y[u];(0,D.equals)(f,c)||g.add(u)}return{added:C,removed:p,updated:g}}function I(m={},y={}){const{added:d,removed:S,updated:C}=P(m,y);return d.size===0&&S.size===0&&C.size===0}function E(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function w(m,y){const d={identifier:{id:m.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0},preRelease:!!m.preRelease};return m.version&&(d.version=m.version),m.disabled&&(d.disabled=!0),m.installed&&(d.installed=!0),m.state&&(d.state=m.state),d}}),define(ne[107],se([0,1,18,19,5]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(b){this.configurationService=b}hasToNeverSyncExtension(b){return this.getConfiguredIgnoredExtensions().includes(b.toLowerCase())}hasToAlwaysSyncExtension(b){return this.getConfiguredIgnoredExtensions().includes(`-${b.toLowerCase()}`)}updateIgnoredExtensions(b,P){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return I=I.filter(E=>E!==b&&E!==`-${b}`),P&&I.push(b.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,2)}updateSynchronizedExtensions(b,P){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return I=I.filter(E=>E!==b&&E!==`-${b}`),P&&I.push(`-${b.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,2)}getIgnoredExtensions(b){const P=b.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),I=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),E=[],w=[];if(Array.isArray(I))for(const m of I)m.startsWith("-")?w.push(m.substring(1)):E.push(m);return(0,D.distinct)([...P,...E].filter(m=>w.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let b=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return b!==void 0||(b=this.configurationService.inspect("sync.ignoredExtensions").userValue,b!==void 0)?b:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};T=me([G(0,n.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(ne[237],se([0,1,18,35,31,174,59]),function(Q,e,D,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function b(f){return(0,n.parse)(f)||[]}e.parseKeybindings=b;async function P(f,c,s,r,t){const i=b(f),o=b(c),l=s?b(s):null,a=[...i,...o,...l||[]].map(Y=>Y.key),h=await t.resolveUserBindings(a),v=E(i,o,l,h);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const R=m(i),M=m(o),F=l?m(l):null,O=d(R,M,h),L=F?d(F,R,h):{added:[...R.keys()].reduce((Y,te)=>(Y.add(te),Y),new Set),removed:new Set,updated:new Set},N=F?d(F,M,h):{added:[...M.keys()].reduce((Y,te)=>(Y.add(te),Y),new Set),removed:new Set,updated:new Set},$=I(O,L,N);let H=f;for(const Y of $.removed.values())$.conflicts.has(Y)||(H=g(H,Y,r));for(const Y of $.added.values()){if($.conflicts.has(Y))continue;const te=M.get(Y);if(te.some(q=>q.command!==`-${Y}`&&v.conflicts.has(h[q.key]))){$.conflicts.add(Y);continue}H=p(H,te,r)}for(const Y of $.updated.values()){if($.conflicts.has(Y))continue;const te=M.get(Y);if(te.some(q=>q.command!==`-${Y}`&&v.conflicts.has(h[q.key]))){$.conflicts.add(Y);continue}H=u(H,Y,te,r)}return{mergeContent:H,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=P;function I(f,c,s){const r=new Set,t=new Set,i=new Set,o=new Set;for(const l of c.removed.values())s.updated.has(l)&&o.add(l);for(const l of s.removed.values())o.has(l)||(c.updated.has(l)?o.add(l):t.add(l));for(const l of c.added.values())o.has(l)||s.added.has(l)&&f.updated.has(l)&&o.add(l);for(const l of s.added.values())o.has(l)||(c.added.has(l)?f.updated.has(l)&&o.add(l):r.add(l));for(const l of c.updated.values())o.has(l)||s.updated.has(l)&&f.updated.has(l)&&o.add(l);for(const l of s.updated.values())o.has(l)||(c.updated.has(l)?f.updated.has(l)&&o.add(l):i.add(l));return{added:r,removed:t,updated:i,conflicts:o}}function E(f,c,s,r){const t=new Set,i=w(f,r),o=w(c,r),l=s?w(s,r):null,a=y(i,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const h=l?y(l,i):{added:[...i.keys()].reduce((L,N)=>(L.add(N),L),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const v=l?y(l,o):{added:[...o.keys()].reduce((L,N)=>(L.add(N),L),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:R,removed:M,updated:F,conflicts:O}=I(a,h,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:R,removed:M,updated:F,conflicts:O}}function w(f,c){const s=new Map;for(const r of f){const t=c[r.key];let i=s.get(t);i||(i=[],s.set(t,i)),i.push(r)}return s}function m(f){const c=new Map;for(const s of f){const r=s.command[0]==="-"?s.command.substring(1):s.command;let t=c.get(r);t||(t=[],c.set(r,t)),t.push(s)}return c}function y(f,c){const s=[...f.keys()],r=[...c.keys()],t=r.filter(l=>s.indexOf(l)===-1).reduce((l,a)=>(l.add(a),l),new Set),i=s.filter(l=>r.indexOf(l)===-1).reduce((l,a)=>(l.add(a),l),new Set),o=new Set;for(const l of s){if(i.has(l))continue;const a=f.get(l).map(v=>({...v,key:l})),h=c.get(l).map(v=>({...v,key:l}));(0,D.equals)(a,h,(v,R)=>C(v,R))||o.add(l)}return{added:t,removed:i,updated:o}}function d(f,c,s){const r=[...f.keys()],t=[...c.keys()],i=t.filter(a=>r.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),o=r.filter(a=>t.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),l=new Set;for(const a of r){if(o.has(a))continue;const h=f.get(a).map(R=>({...R,key:s[R.key]})),v=c.get(a).map(R=>({...R,key:s[R.key]}));S(h,v)||l.add(a)}return{added:i,removed:o,updated:l}}function S(f,c){return!(!(0,D.equals)(f.filter(({command:s})=>s[0]!=="-"),c.filter(({command:s})=>s[0]!=="-"),(s,r)=>C(s,r))||!(0,D.equals)(f.filter(({command:s})=>s[0]==="-"),c.filter(({command:s})=>s[0]==="-"),(s,r)=>C(s,r)))}function C(f,c){if(f.command!==c.command||f.key!==c.key)return!1;const s=T.ContextKeyExpr.deserialize(f.when),r=T.ContextKeyExpr.deserialize(c.when);return!(s&&!r||!s&&r||s&&r&&!s.equals(r)||!k.equals(f.args,c.args))}function p(f,c,s){for(const r of c)f=A.edit(f,[-1],r,s);return f}function g(f,c,s){const r=b(f);for(let t=r.length-1;t>=0;t--)(r[t].command===c||r[t].command===`-${c}`)&&(f=A.edit(f,[t],void 0,s));return f}function u(f,c,s,r){const t=b(f),i=t.findIndex(o=>o.command===c||o.command===`-${c}`);for(let o=t.length-1;o>=0;o--)(t[o].command===c||t[o].command===`-${c}`)&&(f=A.edit(f,[o],void 0,r));for(let o=s.length-1;o>=0;o--)f=A.edit(f,[i],s[o],r);return f}}),define(ne[238],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,A,b){const P={},I={},E=new Set;if(!A)return{local:{added:P,updated:I,removed:[...E.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const w=n(T,A);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:P,updated:I,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=n(b,T),y=n(b,A),d={},S={},C=new Set,p=new Set;for(const g of m.removed.values())y.updated.has(g)?P[g]=A[g]:C.add(g);for(const g of y.removed.values())p.has(g)||(m.updated.has(g)?p.add(g):E.add(g));for(const g of m.updated.values())p.has(g)||(y.updated.has(g)?w.updated.has(g)&&p.add(g):S[g]=T[g]);for(const g of y.updated.values())p.has(g)||(m.updated.has(g)?w.updated.has(g)&&p.add(g):T[g]!==void 0&&(I[g]=A[g]));for(const g of m.added.values())p.has(g)||(y.added.has(g)?w.updated.has(g)&&p.add(g):d[g]=T[g]);for(const g of y.added.values())p.has(g)||(m.added.has(g)?w.updated.has(g)&&p.add(g):P[g]=A[g]);return{local:{added:P,removed:[...E.values()],updated:I},remote:{added:d,removed:[...C.values()],updated:S},conflicts:[...p.values()]}}e.merge=D;function n(T,A){const b=T?Object.keys(T):[],P=A?Object.keys(A):[],I=P.filter(m=>b.indexOf(m)===-1).reduce((m,y)=>(m.add(y),m),new Set),E=b.filter(m=>P.indexOf(m)===-1).reduce((m,y)=>(m.add(y),m),new Set),w=new Set;for(const m of b){if(E.has(m))continue;const y=T[m],d=A[m];y!==d&&w.add(m)}return{added:I,removed:E,updated:w}}function k(T,A){const{added:b,removed:P,updated:I}=n(T,A);return b.size===0&&P.size===0&&I.size===0}e.areSame=k}),define(ne[26],se([0,1,18,17,14,162,42,29,5,97,40]),function(Q,e,D,n,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function w(){const l=E.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(a=>!!l[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=w;function m(){const l=E.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(l).filter(R=>!!l[R].ignoreSync),h=Object.keys(l).filter(R=>l[R].scope===2||l[R].scope===6),v=w();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...h,...v])}e.getDefaultIgnoredSettings=m,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const l="vscode://schemas/ignoredSettings",a=E.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:b.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=E.Registry.as(I.Extensions.JSONContribution),v=()=>{const R=w(),M=m().filter(N=>N!==e.CONFIGURATION_SYNC_STORE_KEY),F=Object.keys(A.allSettings.properties).filter(N=>M.indexOf(N)===-1),O=M.filter(N=>R.indexOf(N)===-1),L={items:{type:"string",enum:[...F,...O.map(N=>`-${N}`)]}};h.registerSchema(l,L)};return a.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=y;function d(l){return l&&(0,k.isObject)(l)&&(0,k.isString)(l.id)&&Array.isArray(l.scopes)}e.isAuthenticationProvider=d;var S;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function C(l,a,h){return h.joinPath(a.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=C,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function p(l){const a={};return a[e.HEADER_EXECUTION_ID]=l,a}e.createSyncHeaders=p;var g;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class u extends Error{constructor(a,h,v,R){super(a);this.code=h,this.resource=v,this.operationId=R,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=u;class f extends u{constructor(a,h,v,R,M){super(a,v,void 0,M);this.url=h,this.serverCode=R}}e.UserDataSyncStoreError=f;class c extends u{constructor(a,h){super(a,h)}}e.UserDataAutoSyncError=c,function(l){function a(h){if(h instanceof l)return h;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(v&&v[1]){const R=v[2]==="unknown"?void 0:v[2],M=v[3]==="unknown"?void 0:v[3];return new l(h.message,v[1],R,M)}return new l(h.message,"Unknown")}l.toUserDataSyncError=a}(u=e.UserDataSyncError||(e.UserDataSyncError={}));var s;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(s=e.SyncStatus||(e.SyncStatus={}));var r;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(l){return`sync.enable.${l}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(l,a){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,n.isEqualOrParent)(l,(0,n.joinPath)(a.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(ne[239],se([0,1,31,26]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(b,P,I,E,w){if(!P)return{remote:Object.keys(b).length>0?b:null,local:{added:{},removed:[],updated:{}}};const m=T(b,P);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=I?T(I,P):{added:Object.keys(P).reduce((g,u)=>(g.add(u),g),new Set),removed:new Set,updated:new Set},d=I?T(I,b):{added:Object.keys(b).reduce((g,u)=>(g.add(u),g),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},C=D.deepClone(P),p=!I;for(const g of d.added.values())g!==n.SYNC_SERVICE_URL_TYPE&&p&&y.added.has(g)||(C[g]=b[g]);for(const g of d.updated.values())C[g]=b[g];for(const g of d.removed.values())E.unregistered.includes(g)||delete C[g];for(const g of y.added.values()){const u=P[g];if(E.machine.includes(g)){w.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(I&&d.added.has(g))continue;const f=b[g];f&&f.value===u.value||g===n.SYNC_SERVICE_URL_TYPE&&p&&d.added.has(g)||(f?S.updated[g]=u:S.added[g]=u)}for(const g of y.updated.values()){const u=P[g];if(E.machine.includes(g)){w.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(g)||d.removed.has(g))continue;const f=b[g];f&&f.value===u.value||(S.updated[g]=u)}for(const g of y.removed.values()){if(E.machine.includes(g)){w.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}d.updated.has(g)||d.removed.has(g)||S.removed.push(g)}return{local:S,remote:A(C,P)?null:C}}e.merge=k;function T(b,P){const I=Object.keys(b),E=Object.keys(P),w=E.filter(d=>I.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),m=I.filter(d=>E.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),y=new Set;for(const d of I){if(m.has(d))continue;const S=b[d],C=P[d];D.equals(S,C)||y.add(d)}return{added:w,removed:m,updated:y}}function A(b,P){const{added:I,removed:E,updated:w}=T(b,P);return I.size===0&&E.size===0&&w.size===0}}),define(ne[240],se([0,1,18,35,75,52,31,59,26]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function I(a,h,v){let R=[];v?R=w(v):R=E(h);const M=[],F=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(R))for(const O of R)O.startsWith("-")?F.push(O.substring(1)):M.push(O);return(0,D.distinct)([...a,...M].filter(O=>F.indexOf(O)===-1))}e.getIgnoredSettings=I;function E(a){let h=a.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=a.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:a.getValue("settingsSync.ignoredSettings")||[]}function w(a){const h=(0,n.parse)(a);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function m(a,h){const v=(0,n.parse)(a)||{};let R="{}";for(const M of Object.keys(v)){const F=(0,k.setProperty)(R,[M],v[M],h);R=(0,k.applyEdits)(R,F)}return R}e.removeComments=m;function y(a,h,v,R){if(v.length){const M=l(h),F=(0,n.parse)(h)||{},O=(0,n.parse)(a);if(!O)return a;const L=[];for(const N of v){const $=F[N],H=O[N];$===void 0?a=b.edit(a,[N],void 0,R):H!==void 0?a=b.edit(a,[N],$,R):L.push(s(N,M))}L.sort((N,$)=>N.startOffset-$.startOffset),L.forEach(N=>a=g(N.setting.key,h,a,R))}return a}e.updateIgnoredSettings=y;function d(a,h,v,R,M,F){const O=y(a,h,R,F),L=v!==O,N=v!==h;if(!L&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(L&&!N)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(N&&!L)return{conflictsSettings:[],localContent:y(h,a,R,F),remoteContent:null,hasConflicts:!1};if(v===null&&C(a)){const B=S(a,h,R)?null:y(h,a,R,F);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let $=a,H=h;const Y=(0,n.parse)(a),te=(0,n.parse)(h),q=v?(0,n.parse)(v):null,W=R.reduce((B,X)=>(B.add(X),B),new Set),x=p(Y,te,W),K=p(q,Y,W),ee=p(q,te,W),ce=new Map,z=new Set,V=B=>{z.add(B);const X=M.filter(({key:oe})=>oe===B)[0];X?($=b.edit($,[B],X.value,F),H=b.edit(H,[B],X.value,F)):ce.set(B,{key:B,localValue:Y[B],remoteValue:te[B]})};for(const B of K.removed.values())ee.updated.has(B)?V(B):H=b.edit(H,[B],void 0,F);for(const B of ee.removed.values())z.has(B)||(K.updated.has(B)?V(B):$=b.edit($,[B],void 0,F));for(const B of K.updated.values())z.has(B)||(ee.updated.has(B)?x.updated.has(B)&&V(B):H=b.edit(H,[B],Y[B],F));for(const B of ee.updated.values())z.has(B)||(K.updated.has(B)?x.updated.has(B)&&V(B):$=b.edit($,[B],te[B],F));for(const B of K.added.values())z.has(B)||(ee.added.has(B)?x.updated.has(B)&&V(B):H=g(B,$,H,F));for(const B of ee.added.values())z.has(B)||(K.added.has(B)?x.updated.has(B)&&V(B):$=g(B,H,$,F));const _=ce.size>0||!S($,H,R),U=_||!S($,a,[]),j=_||!S(H,h,[]);return{localContent:U?$:null,remoteContent:j?H:null,conflictsSettings:[...ce.values()],hasConflicts:_}}e.merge=d;function S(a,h,v){if(a===h)return!0;const R=(0,n.parse)(a),M=(0,n.parse)(h),F=v.reduce((N,$)=>(N.add($),N),new Set),O=l(a).filter(N=>!(N.setting&&F.has(N.setting.key))),L=l(h).filter(N=>!(N.setting&&F.has(N.setting.key)));if(O.length!==L.length)return!1;for(let N=0;N<O.length;N++){const $=O[N],H=L[N];if($.setting&&H.setting){if($.setting.key!==H.setting.key||!A.equals(R[$.setting.key],M[$.setting.key]))return!1}else if(!$.setting&&!H.setting){if($.value!==H.value)return!1}else return!1}return!0}e.areSame=S;function C(a){return a?l(a).length===0:!0}e.isEmpty=C;function p(a,h,v){const R=a?Object.keys(a).filter(N=>!v.has(N)):[],M=Object.keys(h).filter(N=>!v.has(N)),F=M.filter(N=>R.indexOf(N)===-1).reduce((N,$)=>(N.add($),N),new Set),O=R.filter(N=>M.indexOf(N)===-1).reduce((N,$)=>(N.add($),N),new Set),L=new Set;if(a)for(const N of R){if(O.has(N))continue;const $=a[N],H=h[N];A.equals($,H)||L.add(N)}return{added:F,removed:O,updated:L}}function g(a,h,v,R){const M=(0,n.parse)(h),F=l(h),O=l(v),L=u(a,F,O);return f(v,a,M[a],L,O,R)}e.addSetting=g;function u(a,h,v){const R=h.findIndex(F=>F.setting?.key===a),M=h[R-1];if(M){if(M.setting){const O=s(M.setting.key,v);if(O)return{index:v.indexOf(O),insertAfter:!0}}else{const O=r(R,h);if(O){const L=s(O.setting.key,v);if(L){const N=t(v.indexOf(L),v),$=i(h,O,h[R]);if(N){const H=i(v,L,N),Y=o($,H);return Y?{index:v.indexOf(Y),insertAfter:!0}:{index:v.indexOf(N),insertAfter:!1}}else{const H=i(v,L,v[v.length-1]),Y=o($,H);return Y?{index:v.indexOf(Y),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const F=h[R+1];if(F)if(F.setting){const O=s(F.setting.key,v);if(O)return{index:v.indexOf(O),insertAfter:!1}}else{const O=t(R,h);if(O){const L=s(O.setting.key,v);if(L){const N=r(v.indexOf(L),v),$=i(h,h[R],O);if(N){const H=i(v,N,L),Y=o($.reverse(),H.reverse());return Y?{index:v.indexOf(Y),insertAfter:!1}:{index:v.indexOf(N),insertAfter:!0}}else{const H=i(v,v[0],L),Y=o($.reverse(),H.reverse());return Y?{index:v.indexOf(Y),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function f(a,h,v,R,M,F){let O;return R.index===-1?O=(0,k.setProperty)(a,[h],v,F):O=c(a,h,v,R,M,F).map(L=>(0,k.withFormatting)(a,L,F)[0]),(0,k.applyEdits)(a,O)}function c(a,h,v,R,M,F){const O=`${JSON.stringify(h)}: ${JSON.stringify(v)}`,L=(0,T.getEOL)(F,a),N=M[R.index];if(R.insertAfter){const $=[];if(N.setting)$.push({offset:N.endOffset,length:0,content:","+O});else{const H=t(R.index,M),Y=r(R.index,M),te=Y?.setting?.commaOffset;Y&&te===void 0&&$.push({offset:Y.endOffset,length:0,content:","});const q=te!==void 0&&te>N.endOffset;$.push({offset:q?te+1:N.endOffset,length:0,content:H?L+O+",":L+O})}return $}else{if(N.setting)return[{offset:N.startOffset,length:0,content:O+","}];const $=(M[R.index-1]&&!M[R.index-1].setting?L:"")+O+(t(R.index,M)?",":"")+L;return[{offset:N.startOffset,length:0,content:$}]}}function s(a,h){return h.filter(v=>v.setting?.key===a)[0]}function r(a,h){for(let v=a-1;v>=0;v--)if(h[v].setting)return h[v]}function t(a,h){for(let v=a+1;v<h.length;v++)if(h[v].setting)return h[v]}function i(a,h,v){const R=a.indexOf(h),M=a.indexOf(v);return a.filter((F,O)=>R<O&&O<M)}function o(a,h){if(a.length&&h.length){let v=0;for(;v<h.length&&v<a.length;v++)if(a[v].value!==h[v].value)return h[v-1];return h[v-1]}}function l(a){const h=[];let v=-1,R,M;const F={onObjectBegin:O=>{v++},onObjectProperty:(O,L,N)=>{v===0&&(R=L,M=O)},onObjectEnd:(O,L)=>{v--,v===0&&h.push({startOffset:R,endOffset:O+L,value:a.substring(R,O+L),setting:{key:M,commaOffset:void 0}})},onArrayBegin:(O,L)=>{v++},onArrayEnd:(O,L)=>{v--,v===0&&h.push({startOffset:R,endOffset:O+L,value:a.substring(R,O+L),setting:{key:M,commaOffset:void 0}})},onLiteralValue:(O,L,N)=>{v===0&&h.push({startOffset:R,endOffset:L+N,value:a.substring(R,L+N),setting:{key:M,commaOffset:void 0}})},onSeparator:(O,L,N)=>{if(v===0&&O===","){let $=h.length-1;for(;$>=0&&!h[$].setting;$--);const H=h[$];H&&h.splice($,1,{startOffset:H.startOffset,endOffset:H.endOffset,value:H.value,setting:{key:H.setting.key,commaOffset:L}})}},onComment:(O,L)=>{v===0&&h.push({startOffset:O,endOffset:O+L,value:a.substring(O,O+L)})}};return(0,n.visit)(a,F),h}}),define(ne[70],se([0,1,3,2,5,26]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let A=class extends n.Disposable{constructor(P,I){super();this.userDataSyncStoreService=P,this.logService=I,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(P.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(P.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(P){(P&&this._account?P.token!==this._account.token||P.authenticationProviderId!==this._account.authenticationProviderId:P!==this._account)&&(this._account=P,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(P))}};A=me([G(0,T.IUserDataSyncStoreService),G(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(ne[241],se([0,1,6,16,61,2,17,19,15,13,26]),function(Q,e,D,n,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends T.Disposable{constructor(y,d,S,C){super();this.environmentService=y,this.fileService=d,this.configurationService=S,this.logService=C,E.ALL_SYNC_RESOURCES.forEach(p=>this.cleanUpBackup(p))}async getAllRefs(y){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),S=await this.fileService.resolve(d);return S.children?S.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)})):[]}async resolveContent(y,d){if(!d){const S=await this.getAllRefs(y);S.length&&(d=S[S.length-1].ref)}if(d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,y,d);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(y,d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),C=(0,A.joinPath)(S,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(C,n.VSBuffer.fromString(d))}catch(p){this.logService.error(p)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(d))return}catch{return}const S=await this.fileService.resolve(d);if(S.children){const C=S.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),p=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=C.filter(f=>Date.now()-this.getCreationTime(f)>p);const u=C.length-g.length;u<10&&(g=g.slice(10-u)),await D.Promises.settled(g.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};w=me([G(0,P.IEnvironmentService),G(1,I.IFileService),G(2,b.IConfigurationService),G(3,E.IUserDataSyncLogService)],w),e.UserDataSyncBackupStoreService=w}),define(ne[242],se([0,1,2,7]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(m){this.service=m}listen(m,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(m,y,d){switch(y){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class T{constructor(m){this.service=m}listen(m,y){throw new Error(`Event not found: ${y}`)}call(m,y,d){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=A;class b{constructor(m){this.service=m}listen(m,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(m,y,d){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablements":return this.service.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=b;class P{constructor(m){this.service=m}listen(m,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(m,y,d){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class I{constructor(m){this.service=m}listen(m,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(m,y,d){switch(y){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I;class E extends D.Disposable{constructor(m){super();this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:n.URI.revive(m.url),type:m.type,defaultUrl:n.URI.revive(m.defaultUrl),insidersUrl:n.URI.revive(m.insidersUrl),stableUrl:n.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=E}),define(ne[243],se([0,1,15,8]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends n.AbstractLogger{constructor(A,b){super();this.logger=this._register(A.createLogger(b.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...b){this.logger.trace(A,...b)}debug(A,...b){this.logger.debug(A,...b)}info(A,...b){this.logger.info(A,...b)}warn(A,...b){this.logger.warn(A,...b)}error(A,...b){this.logger.error(A,...b)}critical(A,...b){this.logger.critical(A,...b)}flush(){this.logger.flush()}};k=me([G(0,n.ILoggerService),G(1,D.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(ne[244],se([0,1,3,2,7,26]),function(Q,e,D,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class A{constructor(E,w){this.service=E,this.logService=w,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(E,w){switch(w){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${w}`)}async call(E,w,m){try{return await this._call(E,w,m)}catch(y){throw this.logService.error(y),y}}async _call(E,w,m){switch(w){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(m[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(m[0],k.URI.revive(m[1]),m[2],m[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(m[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(m[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(m[0]);case"getAssociatedResources":return this.service.getAssociatedResources(m[0],{created:m[1].created,uri:k.URI.revive(m[1].uri)});case"getMachineId":return this.service.getMachineId(m[0],{created:m[1].created,uri:k.URI.revive(m[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(w.startsWith("manualSync/")){const y=w.substring("manualSync/".length),d=m[0],S=this.getManualSyncTask(d);switch(m=m.slice(1),y){case"preview":return S.preview();case"accept":return S.accept(k.URI.revive(m[0]),m[1]);case"merge":return S.merge(k.URI.revive(m[0]));case"discard":return S.discard(k.URI.revive(m[0]));case"discardConflicts":return S.discardConflicts();case"apply":return S.apply();case"pull":return S.pull();case"push":return S.push();case"stop":return S.stop();case"_getStatus":return S.status;case"dispose":return this.disposeManualSyncTask(S)}}throw new Error("Invalid call")}getManualSyncTask(E){const w=this.manualSyncTasks.get(this.createKey(E));if(!w)throw new Error(`Manual sync taks not found: ${E}`);return w.manualSyncTask}async createManualSyncTask(){const E=new n.DisposableStore,w=E.add(await this.service.createManualSyncTask());return E.add(w.onSynchronizeResources(m=>this.onManualSynchronizeResources.fire({manualSyncTaskId:w.id,data:m}))),this.manualSyncTasks.set(this.createKey(w.id),{manualSyncTask:w,disposables:E}),{id:w.id,manifest:w.manifest,status:w.status}}disposeManualSyncTask(E){E.dispose();const w=this.createKey(E.id);this.manualSyncTasks.get(w)?.disposables.dispose(),this.manualSyncTasks.delete(w)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=A;class b extends n.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(w,m,y){return E.call(w,m,y).then(null,d=>{throw T.UserDataSyncError.toUserDataSyncError(d)})},listen(w,m){return E.listen(w,m)}},this.channel.call("_getInitialData").then(([w,m,y])=>{this.updateStatus(w),this.updateConflicts(m),y&&this.updateLastSyncTime(y),this._register(this.channel.listen("onDidChangeStatus")(d=>this.updateStatus(d))),this._register(this.channel.listen("onDidChangeLastSyncTime")(d=>this.updateLastSyncTime(d)))}),this._register(this.channel.listen("onDidChangeConflicts")(w=>this.updateConflicts(w))),this._register(this.channel.listen("onSyncErrors")(w=>this._onSyncErrors.fire(w.map(([m,y])=>[m,T.UserDataSyncError.toUserDataSyncError(y)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:w,status:m}=await this.channel.call("createManualSyncTask"),y=this,d=new P(E,w,m,{async call(S,C,p){return y.channel.call(`manualSync/${S}`,[E,...Array.isArray(C)?C:[C]],p)},listen(S,C){return D.Event.map(D.Event.filter(y.channel.listen(`manualSync/${S}`,C),p=>!d.isDiposed()&&p.manualSyncTaskId===E),p=>p.data)}});return d}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,w,m,y){return this.channel.call("accept",[E,w,m,y])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:m,uri:y})=>({created:m,uri:k.URI.revive(y)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:m,uri:y})=>({created:m,uri:k.URI.revive(y)}))}async getAssociatedResources(E,w){return(await this.channel.call("getAssociatedResources",[E,w])).map(({resource:y,comparableResource:d})=>({resource:k.URI.revive(y),comparableResource:k.URI.revive(d)}))}async getMachineId(E,w){return this.channel.call("getMachineId",[E,w])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([w,m])=>[w,m.map(y=>({...y,baseResource:k.URI.revive(y.baseResource),localResource:k.URI.revive(y.localResource),remoteResource:k.URI.revive(y.remoteResource),previewResource:k.URI.revive(y.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=b;class P extends n.Disposable{constructor(E,w,m,y){super();this.id=E,this.manifest=w,this._disposed=!1,this._status=m;const d=this;this.channel={async call(S,C,p){try{const g=await y.call(S,C,p);return d.isDiposed()||(d._status=await y.call("_getStatus")),g}catch(g){throw T.UserDataSyncError.toUserDataSyncError(g)}},listen(S,C){return y.listen(S,C)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,w){const m=await this.channel.call("accept",[E,w]);return this.deserializePreviews(m)}async merge(E){const w=await this.channel.call("merge",[E]);return this.deserializePreviews(w)}async discard(E){const w=await this.channel.call("discard",[E]);return this.deserializePreviews(w)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([w,m])=>[w,{isLastSyncFromCurrentMachine:m.isLastSyncFromCurrentMachine,resourcePreviews:m.resourcePreviews.map(y=>({...y,baseResource:k.URI.revive(y.baseResource),localResource:k.URI.revive(y.localResource),remoteResource:k.URI.revive(y.remoteResource),previewResource:k.URI.revive(y.previewResource),acceptedResource:k.URI.revive(y.acceptedResource)}))}])}}}),define(ne[245],se([0,1,6,3,2]),function(Q,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends k.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:P,getActiveWindowId:I}){super();this.disposables=this._register(new k.DisposableStore),n.Event.latch(n.Event.any(b,P))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>I()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(ne[246],se([0,1,164,9,34,17,7,5,20]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function I(t){const i=t;return typeof i?.id=="string"&&A.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=I;function E(t){if(t.configuration)return{id:t.id,configPath:t.configuration};if(t.folders.length===1)return{id:t.id,uri:t.folders[0].uri}}e.toWorkspaceIdentifier=E;function w(t){const i=t;return typeof i?.id=="string"&&A.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=w;function m(t){const i=t;if(i?.uri)return{id:i.id,uri:A.URI.revive(i.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=m;var y;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function d(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=d;function S(t){const i=t;return!!(i&&typeof i=="object"&&A.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(i,o,l,a,h){this._id=i,this._transient=l,this._configuration=a,this._ignorePathCasing=h,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class p{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,T.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function g(t){return new p({uri:t,index:0,name:(0,T.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(t,i){return T.extUriBiasedIgnorePathCase.isEqualOrParent(t,i.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function c(t){let i;return A.URI.isUri(t)?i=t:i=t.configuration,i?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=c;function s(t,i){return!f(t,i)&&!c(t)}e.isSavedWorkspace=s;function r(t){return(typeof t=="string"?(0,n.extname)(t):(0,T.extname)(t))===u}e.hasWorkspaceFileExtension=r}),define(ne[28],se([0,1,62,3,2,17,14,7,157,15,13,5,8,246,34,33,6,30,24]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function u(r){const t=r;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&b.URI.isUri(t.location)&&b.URI.isUri(t.globalStorageHome)&&b.URI.isUri(t.settingsResource)&&b.URI.isUri(t.keybindingsResource)&&b.URI.isUri(t.tasksResource)&&b.URI.isUri(t.snippetsHome)&&((0,A.isUndefined)(t.extensionsResource)||b.URI.isUri(t.extensionsResource)))}e.isUserDataProfile=u,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function f(r,t){return{id:r.id,isDefault:r.isDefault,name:r.name,location:b.URI.revive(r.location).with({scheme:t}),globalStorageHome:b.URI.revive(r.globalStorageHome).with({scheme:t}),settingsResource:b.URI.revive(r.settingsResource).with({scheme:t}),keybindingsResource:b.URI.revive(r.keybindingsResource).with({scheme:t}),tasksResource:b.URI.revive(r.tasksResource).with({scheme:t}),snippetsHome:b.URI.revive(r.snippetsHome).with({scheme:t}),extensionsResource:b.URI.revive(r.extensionsResource)?.with({scheme:t}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=f,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(r,t,i,o){return{id:(0,D.hash)(t.path).toString(16),name:r,location:t,isDefault:!1,globalStorageHome:(0,T.joinPath)(t,"globalStorage"),settingsResource:(0,T.joinPath)(t,"settings.json"),keybindingsResource:(0,T.joinPath)(t,"keybindings.json"),tasksResource:(0,T.joinPath)(t,"tasks.json"),snippetsHome:(0,T.joinPath)(t,"snippets"),extensionsResource:(0,T.joinPath)(t,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:i,isTransient:o}}e.toUserDataProfile=c;let s=class extends k.Disposable{constructor(t,i,o,l){super();this.environmentService=t,this.fileService=i,this.uriIdentityService=o,this.logService=l,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new n.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new n.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new n.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new n.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}get profilesObject(){if(!this._profilesObject){const t=this.enabled?this.getStoredProfiles().map(a=>c(a.name,a.location,a.useDefaultFlags)):[];let i;const o=new d.ResourceMap,l=c((0,P.localize)(0,null),this.environmentService.userRoamingDataHome);if(t.unshift({...l,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||t.length>0||this.transientProfilesObject.profiles.length>0?l.extensionsResource:void 0}),t.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[h,v]of Object.entries(a.workspaces)){const R=b.URI.parse(h),M=b.URI.parse(v),F=t.find(O=>this.uriIdentityService.extUri.isEqual(O.location,M));F&&o.set(R,F)}if(a.emptyWindow){const h=b.URI.parse(a.emptyWindow);i=t.find(v=>this.uriIdentityService.extUri.isEqual(v.location,h))}}this._profilesObject={profiles:t,workspaces:o,emptyWindow:i}}return this._profilesObject}async createTransientProfile(t){const i="Temp",o=new RegExp(`${(0,g.escapeRegExpCharacters)(i)}\\s(\\d+)`);let l=0;for(const h of this.profiles){const v=o.exec(h.name),R=v?parseInt(v[1]):0;l=R>l?R:l}const a=`${i} ${l+1}`;return this.createProfile(a,void 0,t,!0)}async createProfile(t,i,o,l){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=await this.doCreateProfile(t,i,l);return o&&await this.setProfileForWorkspace(o,a),a}async doCreateProfile(t,i,o){let l=this.profileCreationPromises.get(t);return l||(l=(async()=>{try{const a=this.profiles.find(R=>R.name===t);if(a)return a;const h=c(t,(0,T.joinPath)(this.profilesHome,(0,D.hash)((0,p.generateUuid)()).toString(16)),i,o);await this.fileService.createFolder(h.location);const v=[];return this._onWillCreateProfile.fire({profile:h,join(R){v.push(R)}}),await C.Promises.settled(v),this.updateProfiles([h],[],[]),h}finally{this.profileCreationPromises.delete(t)}})(),this.profileCreationPromises.set(t,l)),l}async updateProfile(t,i,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let l=this.profiles.find(a=>a.id===t.id);if(!l)throw new Error(`Profile '${t.name}' does not exist`);return l=c(i,l.location,o),this.updateProfiles([],[],[l]),l}async removeProfile(t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const i=this.profiles.find(l=>l.id===t.id);if(!i)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:i,join(l){o.push(l)}}),await C.Promises.settled(o),i.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const l of[...this.profilesObject.workspaces.keys()])i.id===this.profilesObject.workspaces.get(l)?.id&&this.profilesObject.workspaces.delete(l);this.updateStoredProfileAssociations(),this.updateProfiles([],[i],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(i.location,{recursive:!0})}catch(l){this.logService.error(l)}}getOrSetProfileForWorkspace(t,i=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let o=this.getProfileForWorkspace(t);return o||(o=i,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,i){this.setProfileForWorkspaceSync(t,i)}setProfileForWorkspaceSync(t,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(l=>l.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);this.updateWorkspaceAssociation(t,o)}unsetWorkspace(t,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(t,void 0,i)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(i=>i.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,i.resource))).map(i=>this.fileService.del(i.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(i=>!this.isProfileAssociatedToWorkspace(i));await Promise.allSettled(t.map(i=>this.removeProfile(i)))}getProfileForWorkspace(t){const i=this.getWorkspace(t);return b.URI.isUri(i)?this.transientProfilesObject.workspaces.get(i)??this.profilesObject.workspaces.get(i):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(t){return(0,y.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,y.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}isProfileAssociatedToWorkspace(t){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,t.location)||[...this.transientProfilesObject.workspaces.values()].some(i=>this.uriIdentityService.extUri.isEqual(i.location,t.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,t.location)||[...this.profilesObject.workspaces.values()].some(i=>this.uriIdentityService.extUri.isEqual(i.location,t.location)))}updateProfiles(t,i,o){const l=[...this.profiles,...t],a=[];this.transientProfilesObject.profiles=[];for(let h of l)h.isDefault||i.some(v=>h.id===v.id)||(h=o.find(v=>h.id===v.id)??h,h.isTransient?this.transientProfilesObject.profiles.push(h):a.push({location:h.location,name:h.name,useDefaultFlags:h.useDefaultFlags}));this.saveStoredProfiles(a),this._profilesObject=void 0,this.triggerProfilesChanges(t,i,o)}triggerProfilesChanges(t,i,o){this._onDidChangeProfiles.fire({added:t,removed:i,updated:o,all:this.profiles})}updateWorkspaceAssociation(t,i,o){o=i?.isTransient?!0:o,o||this.updateWorkspaceAssociation(t,void 0,!0);const l=this.getWorkspace(t),a=o?this.transientProfilesObject:this.profilesObject;b.URI.isUri(l)?(a.workspaces.delete(l),i&&a.workspaces.set(l,i)):a.emptyWindow=i,o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[o,l]of this.profilesObject.workspaces.entries())t[o.toString()]=l.location.toString();const i=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:t,emptyWindow:i}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}};s.PROFILES_KEY="userDataProfiles",s.PROFILE_ASSOCIATIONS_KEY="profileAssociations",s=me([G(0,I.IEnvironmentService),G(1,E.IFileService),G(2,S.IUriIdentityService),G(3,m.ILogService)],s),e.UserDataProfilesService=s}),define(ne[247],se([0,1,2,28]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let k=class extends D.Disposable{constructor(A){super();A.cleanUp()}};k=me([G(0,n.IUserDataProfilesService)],k),e.UserDataProfilesCleaner=k}),define(ne[248],se([0,1,18,6,21,10,3,2,4,7,139,29,32,43,8,25,22,28]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends b.Disposable{constructor(t,i,o,l,a){super();this.galleryService=t,this.telemetryService=i,this.logService=o,this.productService=l,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,b.toDisposable)(()=>{this.installingExtensions.forEach(h=>h.cancel()),this.uninstallingExtensions.forEach(h=>h.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const i=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,t.allTargetPlatforms,i))}async installFromGallery(t,i={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(E.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,i)}catch(o){throw c(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),f(o)}}async uninstall(t,i={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,i)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const i=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:i,compatible:!0},k.CancellationToken.None);if(!o)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,i,o){const l=M=>`${m.ExtensionKey.create(M).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!I.URI.isUri(i)){const M=this.installingExtensions.get(l(i));if(M){this.logService.info("Extensions is already requested to install",i.identifier.id);const{local:F}=await M.waitUntilTaskIsFinished();return F}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],h=[],v=this.createInstallExtensionTask(t,i,o);I.URI.isUri(i)||this.installingExtensions.set(l(i),v),this._onInstallExtension.fire({identifier:v.identifier,source:i,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",v.identifier.id),a.push({task:v,manifest:t});let R=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const F=await this.getAllDepsAndPackExtensionsToInstall(v.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation);for(const{gallery:O,manifest:L}of F){R=R||!!L.extensionDependencies?.some($=>(0,m.areSameExtensions)({id:$},v.identifier));const N=l(O);if(this.installingExtensions.has(N))this.logService.info("Extension is already requested to install",O.identifier.id);else{const $=this.createInstallExtensionTask(L,O,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(N,$),this._onInstallExtension.fire({identifier:$.identifier,source:O,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",$.identifier.id),a.push({task:$,manifest:L})}}}catch(F){if(I.URI.isUri(v.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",v.identifier.id,F.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",v.identifier.id,F.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),F}const M=a.reduce((F,{task:O,manifest:L})=>(F.set(O.identifier.id.toLowerCase(),{task:O,manifest:L}),F),new Map);for(;M.size;){let F;const O=[...M.values()].filter(({manifest:L})=>!L.extensionDependencies?.some(N=>M.has(N.toLowerCase())));O.length?F=M.size===1?O:O.filter(({task:L})=>!(L===v&&!R)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:L})=>L.identifier.id)),F=[...M.values()]),await this.joinAllSettled(F.map(async({task:L})=>{const N=new Date().getTime();try{const{local:$}=await L.run();if(await this.joinAllSettled(this.participants.map(H=>H.postInstall($,L.source,o,k.CancellationToken.None))),!I.URI.isUri(L.source)){const H=L.operation===3,Y=H?void 0:(new Date().getTime()-L.source.lastUpdated)/1e3;if(c(this.telemetryService,H?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(L.source),duration:new Date().getTime()-N,durationSinceUpdate:Y}),P.isWeb&&L.operation!==3)try{await this.galleryService.reportStatistic($.manifest.publisher,$.manifest.name,$.manifest.version,"install")}catch{}}h.push({local:$,identifier:L.identifier,operation:L.operation,source:L.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:$.isApplicationScoped})}catch($){throw I.URI.isUri(L.source)||c(this.telemetryService,L.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(L.source),duration:new Date().getTime()-N,error:$}),this.logService.error("Error while installing the extension:",L.identifier.id),$}finally{M.delete(L.identifier.id.toLowerCase())}}))}return h.forEach(({identifier:F})=>this.logService.info("Extension installed successfully:",F.id)),this._onDidInstallExtensions.fire(h),h.filter(({identifier:F})=>(0,m.areSameExtensions)(F,v.identifier))[0].local}catch(M){if(a.forEach(({task:F})=>F.cancel()),h.length)try{const F=await Promise.allSettled(h.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let O=0;O<F.length;O++){const L=F[O],{identifier:N}=h[O];L.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,T.getErrorMessage)(L.reason))}}catch(F){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(F),h.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(a.map(({task:F})=>({identifier:F.identifier,operation:2,source:F.source,context:o.context,profileLocation:o.profileLocation}))),M}finally{for(const{task:M}of a)if(!I.URI.isUri(M.source)){const F=l(M.source);this.installingExtensions.delete(F)||this.logService.warn("Installation task is not found in the cache",F)}}}async joinAllSettled(t){const i=[],o=[],l=await Promise.allSettled(t);for(const a of l)a.status==="fulfilled"?i.push(a.value):o.push(a.reason);if(o.length)throw u(o);return i}async getAllDepsAndPackExtensionsToInstall(t,i,o,l,a){if(!this.galleryService.isEnabled())return[];let h=await this.getInstalled(void 0,a);const v=[t,...h.map(F=>F.identifier)],R=[],M=async(F,O)=>{const L=O.extensionDependencies||[],N=[...L];if(O.extensionPack){const $=o?h.find(H=>(0,m.areSameExtensions)(H.identifier,F)):void 0;for(const H of O.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(Y=>(0,m.areSameExtensions)({id:Y},{id:H}))||N.every(Y=>!(0,m.areSameExtensions)({id:Y},{id:H}))&&N.push(H)}if(N.length){const $=[...v,...R.map(Y=>Y.gallery.identifier)],H=N.filter(Y=>$.every(te=>!(0,m.areSameExtensions)(te,{id:Y})));if(H.length){const Y=await this.galleryService.getExtensions(H.map(te=>({id:te,preRelease:l})),k.CancellationToken.None);for(const te of Y){if($.find(x=>(0,m.areSameExtensions)(x,te.identifier)))continue;const q=L.some(x=>(0,m.areSameExtensions)({id:x},te.identifier));let W;try{W=await this.checkAndGetCompatibleVersion(te,!1,l)}catch(x){if(x instanceof w.ExtensionManagementError&&x.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!q){this.logService.info("Skipping the packed extension as it cannot be installed",te.identifier.id);continue}else throw x}R.push({gallery:W.extension,manifest:W.manifest}),await M(W.extension.identifier,W.manifest)}}}};return await M(t,i),h=await this.getInstalled(void 0,a),R.filter(F=>!h.some(O=>(0,m.areSameExtensions)(O.identifier,F.gallery.identifier)))}async checkAndGetCompatibleVersion(t,i,o){if((await this.getExtensionsControlManifest()).malicious.some(v=>(0,m.areSameExtensions)(t.identifier,v)))throw new w.ExtensionManagementError(E.localize(3,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const v=await this.getTargetPlatform();throw new w.ExtensionManagementError(E.localize(4,null,t.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(v)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(t,i,o);if(a){if(o&&!i&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(E.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],k.CancellationToken.None))[0]?new w.ExtensionManagementError(E.localize(6,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(E.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const h=await this.galleryService.getManifest(a,k.CancellationToken.None);if(h===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(h.version!==a.version)throw new w.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:h}}async getCompatibleVersion(t,i,o){const l=await this.getTargetPlatform();let a=null;return!i&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(a=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(t,o,l)&&(a=t),a||(i?a=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(t,o,l)),a}async uninstallExtension(t,i){const o=M=>`${M.id.toLowerCase()}${i.versionOnly?`-${t.manifest.version}`:""}${i.profileLocation?`@${i.profileLocation.toString()}`:""}`,l=this.uninstallingExtensions.get(o(t.identifier));if(l)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),l.waitUntilTaskIsFinished();const a=(M,F)=>{const O=this.createUninstallExtensionTask(M,F);return this.uninstallingExtensions.set(o(O.extension.identifier),O),i.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,i.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this._onUninstallExtension.fire({identifier:M.identifier,profileLocation:i.profileLocation,applicationScoped:M.isApplicationScoped}),O},h=(M,F)=>{F?i.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,i.profileLocation.toString(),F.message):this.logService.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,F.message):i.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,i.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),c(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(M),error:F}),this._onDidUninstallExtension.fire({identifier:M.identifier,version:M.manifest.version,error:F?.code,profileLocation:i.profileLocation,applicationScoped:M.isApplicationScoped})},v=[],R=[];try{v.push(a(t,i));const M=await this.getInstalled(1,i.profileLocation);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.getAllPackExtensionsToUninstall(t,M);for(const O of F)this.uninstallingExtensions.has(o(O.identifier))?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):v.push(a(O,i))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(v.map(F=>F.extension),M,t),await this.joinAllSettled(v.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(F.extension,i,k.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}h(F.extension)}catch(O){const L=O instanceof w.ExtensionManagementError?O:new w.ExtensionManagementError((0,T.getErrorMessage)(O),w.ExtensionManagementErrorCode.Internal);throw h(F.extension,L),L}finally{R.push(F)}}))}catch(M){const F=M instanceof w.ExtensionManagementError?M:new w.ExtensionManagementError((0,T.getErrorMessage)(M),w.ExtensionManagementErrorCode.Internal);for(const O of v){try{O.cancel()}catch{}R.includes(O)||h(O.extension,F)}throw F}finally{for(const M of v)this.uninstallingExtensions.delete(o(M.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}checkForDependents(t,i,o){for(const l of t){const a=this.getDependents(l,i);if(a.length){const h=a.filter(v=>!t.some(R=>(0,m.areSameExtensions)(R.identifier,v.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(l,h,o))}}}getDependentsErrorMessage(t,i,o){return o===t?i.length===1?E.localize(8,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(9,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(10,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(t,i,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const l=t.manifest.extensionPack?t.manifest.extensionPack:[];if(l.length){const a=i.filter(v=>!v.isBuiltin&&l.some(R=>(0,m.areSameExtensions)({id:R},v.identifier))),h=[];for(const v of a)h.push(...this.getAllPackExtensionsToUninstall(v,i,o));return[...a,...h]}return[]}getDependents(t,i){return i.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,m.areSameExtensions)({id:l},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,i,o){return o.profileLocation&&(0,y.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,i,o)}createUninstallExtensionTask(t,i){return i.profileLocation&&t.isApplicationScoped&&(i={...i,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,i)}};g=me([G(0,w.IExtensionGalleryService),G(1,C.ITelemetryService),G(2,d.ILogService),G(3,S.IProductService),G(4,p.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function u(r){const t=Array.isArray(r)?r:[r];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((i,o)=>new Error(`${i.message}${i.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=u;function f(r){if(r instanceof w.ExtensionManagementError)return r;const t=new w.ExtensionManagementError(r.message,w.ExtensionManagementErrorCode.Internal);return t.stack=r.stack,t}function c(r,t,{extensionData:i,duration:o,error:l,durationSinceUpdate:a}){const h=l?l instanceof w.ExtensionManagementError?l.code:w.ExtensionManagementErrorCode.Internal:void 0;r.publicLog(t,{...i,success:!l,duration:o,errorcode:h,durationSinceUpdate:a})}e.reportTelemetry=c;class s{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>new Promise((i,o)=>{const l=t.onCancellationRequested(()=>{l.dispose(),o(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=s}),define(ne[71],se([0,1,18,6,31,16,10,35,121,2,20,9,4,17,55,80,14,7,142,15,32,43,65,13,5,8,25,3,63,48,28,33,170]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g,u,f,c,s,r,t,i,o,l,a,h,v,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(te){function q(W,x){if(W===x)return!0;const K=Object.keys(W),ee=new Set;for(const ce of Object.keys(x))ee.add(ce);if(K.length!==ee.size)return!1;for(const ce of K){if(W[ce]!==x[ce])return!1;ee.delete(ce)}return ee.size===0}te.equals=q})(F=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let O=class extends I.Disposable{constructor(q,W,x,K,ee,ce,z,V,_,U,j){super();this.systemExtensionsLocation=q,this.userExtensionsLocation=W,this.extensionsControlLocation=x,this.cacheLocation=K,this.userDataProfilesService=ee,this.extensionsProfileScannerService=ce,this.fileService=z,this.logService=V,this.environmentService=_,this.productService=U,this.instantiationService=j,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,y.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,y.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(N,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(q,W,x){const[K,ee]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(W)]),ce=x?await this.scanExtensionsUnderDevelopment(q,[...K,...ee]):[];return this.dedupExtensions(K,ee,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const W=[];W.push(this.scanDefaultSystemExtensions(!!q.useCache,q.language)),W.push(this.scanDevSystemExtensions(q.language,!!q.checkControlFile));const[x,K]=await Promise.all(W);return this.applyScanOptions([...x,...K],0,q,!1)}async scanUserExtensions(q){this.logService.trace("Started scanning user extensions");const W=await this.createExtensionScannerInput(q.profileLocation??this.userExtensionsLocation,!!q.profileLocation,1,!q.includeUninstalled,q.language);let K=await(q.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return K=await this.applyScanOptions(K,1,q,!0),this.logService.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(q,W){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(K=>K.scheme===E.Schemas.file).map(async K=>{const ee=await this.createExtensionScannerInput(K,!1,1,!0,q.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ee)).map(z=>(z.type=W.find(V=>(0,f.areSameExtensions)(V.identifier,z.identifier))?.type??z.type,this.extensionsScanner.validate(z,ee)))}))).flat();return this.applyScanOptions(x,"development",q,!0)}return[]}async scanExistingExtension(q,W,x){const K=await this.createExtensionScannerInput(q,!1,W,!0,x.language),ee=await this.extensionsScanner.scanExtension(K);return!ee||!x.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(q,W,x){const K=await this.createExtensionScannerInput(q,!1,W,!0,x.language),ee=await this.extensionsScanner.scanOneOrMultipleExtensions(K);return this.applyScanOptions(ee,W,x,!0)}async scanMetadata(q){const W=(0,y.joinPath)(q,"package.json"),x=(await this.fileService.readFile(W)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(q,W){const x=(0,y.joinPath)(q,"package.json"),K=(await this.fileService.readFile(x)).value.toString(),ee=JSON.parse(K);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,ee.__metadata={...ee.__metadata,...W},await this.fileService.writeFile((0,y.joinPath)(q,"package.json"),T.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async applyScanOptions(q,W,x,K){return x.includeAllVersions||(q=this.dedupExtensions(W===0?q:void 0,W===1?q:void 0,W==="development"?q:void 0,await this.getTargetPlatform(),K)),x.includeInvalid||(q=q.filter(ee=>ee.isValid)),q.sort((ee,ce)=>{const z=w.basename(ee.location.fsPath),V=w.basename(ce.location.fsPath);return z<V?-1:z>V?1:0})}dedupExtensions(q,W,x,K,ee){const ce=(V,_,U)=>{if(V.isValid&&!_.isValid)return!1;if(V.isValid===_.isValid){if(ee&&d.gt(V.manifest.version,_.manifest.version))return this.logService.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(d.eq(V.manifest.version,_.manifest.version)){if(V.type===0)return this.logService.debug(`Skipping extension ${_.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===K)return this.logService.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return U?this.logService.warn(`Overwriting user extension ${V.location.path} with ${_.location.path}.`):this.logService.debug(`Overwriting user extension ${V.location.path} with ${_.location.path}.`),!0},z=new Map;return q?.forEach(V=>{const _=c.ExtensionIdentifier.toKey(V.identifier.id),U=z.get(_);(!U||ce(U,V,!1))&&z.set(_,V)}),W?.forEach(V=>{const _=c.ExtensionIdentifier.toKey(V.identifier.id),U=z.get(_);if(!U&&q&&V.type===0){this.logService.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!U||ce(U,V,!1))&&z.set(_,V)}),x?.forEach(V=>{const _=c.ExtensionIdentifier.toKey(V.identifier.id),U=z.get(_);(!U||ce(U,V,!0))&&z.set(_,V),z.set(_,V)}),[...z.values()]}async scanDefaultSystemExtensions(q,W){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,W),ee=await(q&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",ee.length),ee}async scanDevSystemExtensions(q,W){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const K=W?await this.getBuiltInExtensionControl():{},ee=[],ce=p.URI.file(w.normalize(w.join(E.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const V of x){const _=K[V.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":ee.push((0,y.joinPath)(ce,V.name));break;default:ee.push(p.URI.file(_));break}}const z=await Promise.all(ee.map(async V=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(V,!1,0,!0,q))));return this.logService.trace("Scanned dev system extensions:",z.length),(0,D.coalesce)(z)}async getBuiltInExtensionControl(){try{const q=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(q.value.toString())}catch{return{}}}async createExtensionScannerInput(q,W,x,K,ee,ce=!0){const z=await this.getTranslations(ee??m.language),V=await this.getMtime(q),_=W?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,U=_?await this.getMtime(_):void 0;return new L(q,V,_,U,W,x,K,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ee,z)}async getMtime(q){try{const W=await this.fileService.stat(q);if(typeof W.mtime=="number")return W.mtime}catch{}}};O=me([G(4,v.IUserDataProfilesService),G(5,h.IExtensionsProfileScannerService),G(6,r.IFileService),G(7,i.ILogService),G(8,u.IEnvironmentService),G(9,o.IProductService),G(10,t.IInstantiationService)],O),e.AbstractExtensionsScannerService=O;class L{constructor(q,W,x,K,ee,ce,z,V,_,U,j,B,X,oe){this.location=q,this.mtime=W,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=K,this.profile=ee,this.type=ce,this.excludeObsolete=z,this.validate=V,this.productVersion=_,this.productDate=U,this.productCommit=j,this.devMode=B,this.language=X,this.translations=oe}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,W){return(0,y.isEqual)(q.location,W.location)&&q.mtime===W.mtime&&(0,y.isEqual)(q.applicationExtensionslocation,W.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&q.profile===W.profile&&q.type===W.type&&q.excludeObsolete===W.excludeObsolete&&q.validate===W.validate&&q.productVersion===W.productVersion&&q.productDate===W.productDate&&q.productCommit===W.productCommit&&q.devMode===W.devMode&&q.language===W.language&&F.equals(q.translations,W.translations)}}let N=class extends I.Disposable{constructor(q,W,x,K,ee){super();this.obsoleteFile=q,this.extensionsProfileScannerService=W,this.uriIdentityService=x,this.fileService=K,this.logService=ee}async scanExtensions(q){const W=q.profile?await this.scanExtensionsFromProfile(q):await this.scanExtensionsFromLocation(q);let x={};if(q.excludeObsolete&&q.type===1)try{const K=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(K)}catch{}return(0,C.isEmptyObject)(x)?W:W.filter(K=>!x[f.ExtensionKey.create(K).toString()])}async scanExtensionsFromLocation(q){const W=await this.fileService.resolve(q.location);if(!W.children?.length)return[];const x=await Promise.all(W.children.map(async K=>{if(!K.isDirectory||q.type===1&&(0,y.basename)(K.resource).indexOf(".")===0)return null;const ee=new L(K.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(ee)}));return(0,D.coalesce)(x).sort((K,ee)=>K.location.path<ee.location.path?-1:1)}async scanExtensionsFromProfile(q){let W=await this.scanExtensionsFromProfileResource(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(q.location,q.applicationExtensionslocation)){W=W.filter(K=>!K.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(q.applicationExtensionslocation,K=>!!K.metadata?.isApplicationScoped,q);W.push(...x)}return W}async scanExtensionsFromProfileResource(q,W,x){const K=await this.extensionsProfileScannerService.scanProfileExtensions(q);if(!K.length)return[];const ee=await Promise.all(K.map(async ce=>{if(W(ce)){const z=new L(ce.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(z,ce.metadata)}return null}));return(0,D.coalesce)(ee)}async scanOneOrMultipleExtensions(q){try{if(await this.fileService.exists((0,y.joinPath)(q.location,"package.json"))){const W=await this.scanExtension(q);return W?[W]:[]}else return await this.scanExtensions(q)}catch(W){return this.logService.error(`Error scanning extensions at ${q.location.path}:`,(0,A.getErrorMessage)(W)),[]}}async scanExtension(q,W){try{let x=await this.scanExtensionManifest(q.location);if(x){x.publisher||(x.publisher=c.UNDEFINED_PUBLISHER),W=W??x.__metadata,delete x.__metadata;const K=(0,f.getGalleryExtensionId)(x.publisher,x.name),ee=W?.id?{id:K,uuid:W.id}:{id:K},ce=W?.isSystem?0:q.type,z=ce===0||!!W?.isBuiltin;x=await this.translateManifest(q.location,x,L.createNlsConfiguration(q));const V={type:ce,identifier:ee,manifest:x,location:q.location,isBuiltin:z,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return q.validate?this.validate(V,q):V}}catch(x){q.type!==0&&this.logService.error(x)}return null}validate(q,W){let x=!0;const K=(0,s.validateExtensionManifest)(W.productVersion,W.productDate,W.location,q.manifest,q.isBuiltin);for(const[ee,ce]of K)ee===S.default.Error&&(x=!1,this.logService.error(this.formatMessage(W.location,ce)));return q.isValid=x,q.validations=K,q}async scanExtensionManifest(q){const W=(0,y.joinPath)(q,"package.json");let x;try{x=(await this.fileService.readFile(W)).value.toString()}catch(ee){return(0,r.toFileOperationResult)(ee)!==1&&this.logService.error(this.formatMessage(q,(0,g.localize)(0,null,W.path,ee.message))),null}let K;try{K=JSON.parse(x)}catch{const ce=[];(0,b.parse)(x,ce);for(const z of ce)this.logService.error(this.formatMessage(q,(0,g.localize)(1,null,W.path,z.offset,z.length,(0,P.getParseErrorMessage)(z.error))));return null}return(0,b.getNodeType)(K)!=="object"?(this.logService.error(this.formatMessage(q,(0,g.localize)(2,null,W.path))),null):K}async translateManifest(q,W,x){const K=await this.getLocalizedMessages(q,W,x);if(K)try{const ee=[],ce=await this.resolveOriginalMessageBundle(K.default,ee);if(ee.length>0)return ee.forEach(V=>{this.logService.error(this.formatMessage(q,(0,g.localize)(3,null,K.default?.path,(0,P.getParseErrorMessage)(V.error))))}),W;if((0,b.getNodeType)(K)!=="object")return this.logService.error(this.formatMessage(q,(0,g.localize)(4,null,K.default?.path))),W;const z=K.values||Object.create(null);return(0,M.localizeManifest)(W,z,ce)}catch{}return W}async getLocalizedMessages(q,W,x){const K=(0,y.joinPath)(q,"package.nls.json"),ee=(_,U)=>{U.forEach(j=>{this.logService.error(this.formatMessage(q,(0,g.localize)(5,null,_?.path,(0,P.getParseErrorMessage)(j.error))))})},ce=_=>{this.logService.error(this.formatMessage(q,(0,g.localize)(6,null,_?.path)))},z=`${W.publisher}.${W.name}`,V=x.translations[z];if(V)try{const _=p.URI.file(V),U=(await this.fileService.readFile(_)).value.toString(),j=[],B=(0,b.parse)(U,j);return j.length>0?(ee(_,j),{values:void 0,default:K}):(0,b.getNodeType)(B)!=="object"?(ce(_),{values:void 0,default:K}):{values:B.contents?B.contents.package:void 0,default:K}}catch{return{values:void 0,default:K}}else{if(!await this.fileService.exists(K))return;let U;try{U=await this.findMessageBundles(q,x)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const j=(await this.fileService.readFile(U.localized)).value.toString(),B=[],X=(0,b.parse)(j,B);return B.length>0?(ee(U.localized,B),{values:void 0,default:U.original}):(0,b.getNodeType)(X)!=="object"?(ce(U.localized),{values:void 0,default:U.original}):{values:X,default:U.original}}catch{return{values:void 0,default:U.original}}}}async resolveOriginalMessageBundle(q,W){if(q)try{const x=(await this.fileService.readFile(q)).value.toString();return(0,b.parse)(x,W)}catch{}}findMessageBundles(q,W){return new Promise((x,K)=>{const ee=ce=>{const z=(0,y.joinPath)(q,`package.nls.${ce}.json`);this.fileService.exists(z).then(V=>{V&&x({localized:z,original:(0,y.joinPath)(q,"package.nls.json")});const _=ce.lastIndexOf("-");_===-1?x({localized:(0,y.joinPath)(q,"package.nls.json"),original:null}):(ce=ce.substring(0,_),ee(ce))})};if(W.devMode||W.pseudo||!W.language)return x({localized:(0,y.joinPath)(q,"package.nls.json"),original:null});ee(W.language)})}formatMessage(q,W){return`[${q.path}]: ${W}`}};N=me([G(1,h.IExtensionsProfileScannerService),G(2,R.IUriIdentityService),G(3,r.IFileService),G(4,i.ILogService)],N);let $=class extends N{constructor(q,W,x,K,ee,ce){super(W,x,K,ee,ce);this.cacheFile=q,this.cacheValidatorThrottler=this._register(new n.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(q){const W=await this.readExtensionCache();if(this.input=q,W&&W.input&&L.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(K=>(K.location=p.URI.revive(K.location),K));const x=await super.scanExtensions(q);return await this.writeExtensionCache({input:q,result:x}),x}async readExtensionCache(){try{const q=await this.fileService.readFile(this.cacheFile),W=JSON.parse(q.value.toString());return{result:W.result,input:(0,a.revive)(W.input)}}catch(q){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(q))}return null}async writeExtensionCache(q){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify(q)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const q=await this.readExtensionCache();if(!q)return;const W=q.result,x=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(x,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(K){this.logService.error(K)}}};$=me([G(2,h.IExtensionsProfileScannerService),G(3,R.IUriIdentityService),G(4,r.IFileService),G(5,i.ILogService)],$);function H(te,q){const W=(0,f.getExtensionId)(te.manifest.publisher,te.manifest.name);return{id:W,identifier:new c.ExtensionIdentifier(W),isBuiltin:te.type===0,isUserBuiltin:te.type===1&&te.isBuiltin,isUnderDevelopment:q,extensionLocation:te.location,uuid:te.identifier.uuid,targetPlatform:te.targetPlatform,...te.manifest}}e.toExtensionDescription=H;class Y extends O{constructor(q,W,x,K,ee,ce,z,V,_,U,j){super(q,W,(0,y.joinPath)(x,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(K,c.MANIFEST_CACHE_FOLDER),ee,ce,z,V,_,U,j);this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const B=await this.fileService.readFile(p.URI.file(m.translationsConfigFile));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}getTranslations(q){return this.translationsPromise}}e.NativeExtensionsScannerService=Y}),define(ne[249],se([0,1,54,6,38,3,2,20,9,27,8,28]),function(Q,e,D,n,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends A.Disposable{constructor(d,S){super();this.userDataProfilesService=d,this.logService=S,this.processesLimiter=new n.Limiter(5)}async postUninstall(d){const S=this.parseScript(d,"uninstall");return S&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),C=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${C}`)))),I.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,C=>this.logService.error("Error while removing extension storage path",C))}parseScript(d,S){const C=`vscode:${S}`;if(d.location.scheme===b.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[C]=="string"){const p=d.manifest.scripts[C].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${C} should be a node script`),null):{script:(0,P.join)(d.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(d,S,C,p,g){return new Promise((u,f)=>{const c=this.start(d,S,C,g);let s;const r=t=>{s&&(clearTimeout(s),s=null),t?f(t):u(void 0)};c.on("error",t=>{r((0,k.toErrorMessage)(t)||"Unknown")}),c.on("exit",(t,i)=>{r(t?`post-${S} process exited with code ${t}`:void 0)}),p&&(s=setTimeout(()=>{s=null,c.kill(),f("timed out")},5e3))})}start(d,S,C,p){const g={silent:!0,execArgv:void 0},u=(0,D.fork)(d,[`--type=extension-post-${S}`,...C],g);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const f=T.Event.fromNodeEventEmitter(u.stdout,"data"),c=T.Event.fromNodeEventEmitter(u.stderr,"data");f(t=>this.logService.info(p.identifier.id,p.manifest.version,`post-${S}`,t)),c(t=>this.logService.error(p.identifier.id,p.manifest.version,`post-${S}`,t));const s=T.Event.any(T.Event.map(f,t=>({data:`%c${t}`,format:[""]})),T.Event.map(c,t=>({data:`%c${t}`,format:["color: red"]})));return T.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(p.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),u}getExtensionStoragePath(d){return(0,P.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};m=me([G(0,w.IUserDataProfilesService),G(1,E.ILogService)],m),e.ExtensionsLifecycle=m}),define(ne[250],se([0,1,7,15,48,71,13,5,8,25,28]),function(Q,e,D,n,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends T.NativeExtensionsScannerService{constructor(y,d,S,C,p,g,u){super(D.URI.file(p.builtinExtensionsPath),D.URI.file(p.extensionsPath),p.userHome,D.URI.file(p.userDataPath),y,d,S,C,p,g,u)}};w=me([G(0,E.IUserDataProfilesService),G(1,k.IExtensionsProfileScannerService),G(2,A.IFileService),G(3,P.ILogService),G(4,n.INativeEnvironmentService),G(5,I.IProductService),G(6,b.IInstantiationService)],w),e.ExtensionsScannerService=w}),define(ne[23],se([0,1,6,3,2,190,14,86,5,28]),function(Q,e,D,n,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var m;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(m=e.StorageScope||(e.StorageScope={}));var y;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(u={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=u,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(u,f){if(f===E){switch(u){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:u})}else this._onDidChangeValue.fire({scope:u,key:f,target:this.getKeyTargets(u)[f]})}emitWillSaveState(u){this._onWillSaveState.fire({reason:u})}get(u,f,c){return this.getStorage(f)?.get(u,c)}getBoolean(u,f,c){return this.getStorage(f)?.getBoolean(u,c)}getNumber(u,f,c){return this.getStorage(f)?.getNumber(u,c)}store(u,f,c,s){if((0,A.isUndefinedOrNull)(f)){this.remove(u,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(u,c,s),this.getStorage(c)?.set(u,f)})}remove(u,f){this.withPausedEmitters(()=>{this.updateKeyTarget(u,f,void 0),this.getStorage(f)?.delete(u)})}withPausedEmitters(u){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{u()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(u,f){const c=[],s=this.getKeyTargets(u);for(const r of Object.keys(s))s[r]===f&&c.push(r);return c}updateKeyTarget(u,f,c){const s=this.getKeyTargets(f);typeof c=="number"?s[u]!==c&&(s[u]=c,this.getStorage(f)?.set(E,JSON.stringify(s))):typeof s[u]=="number"&&(delete s[u],this.getStorage(f)?.set(E,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(u){switch(u){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(u){const f=this.get(E,u);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=w.NONE){this._onWillSaveState.fire({reason:u});const f=this.getStorage(-1),c=this.getStorage(0),s=this.getStorage(1);switch(u){case w.NONE:await D.Promises.settled([f?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await D.Promises.settled([f?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return p(u,f,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(u,f){return this.emitWillSaveState(w.NONE),(0,I.isUserDataProfile)(u)?this.switchToProfile(u,f):this.switchToWorkspace(u,f)}canSwitchProfile(u,f){return!(u.id===f.id||S(f)&&S(u))}switchData(u,f,c,s){this.withPausedEmitters(()=>{if(s)for(const[r,t]of u)f.set(r,t);else{const r=new Set;for(const[t,i]of u)r.add(t),f.get(t)!==i&&this.emitDidChangeValue(c,t);for(const[t]of f.items)r.has(t)||this.emitDidChangeValue(c,t)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class C extends d{constructor(){super();this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(u=>this.emitDidChangeValue(1,u))),this._register(this.profileStorage.onDidChangeStorage(u=>this.emitDidChangeValue(0,u))),this._register(this.applicationStorage.onDidChangeStorage(u=>this.emitDidChangeValue(-1,u)))}getStorage(u){switch(u){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=C;async function p(g,u,f,c,s,r){const t=F=>{try{return JSON.parse(F)}catch{return F}},i=new Map,o=new Map;g.forEach((F,O)=>{i.set(O,F),o.set(O,t(F))});const l=new Map,a=new Map;u.forEach((F,O)=>{l.set(O,F),a.set(O,t(F))});const h=new Map,v=new Map;f.forEach((F,O)=>{h.set(O,F),v.set(O,t(F))}),console.group(c!==s?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const R=[];if(i.forEach((F,O)=>{R.push({key:O,value:F})}),console.table(R),console.groupEnd(),console.log(o),c!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const F=[];l.forEach((O,L)=>{F.push({key:L,value:O})}),console.table(F),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const M=[];h.forEach((F,O)=>{M.push({key:O,value:F})}),console.table(M),console.groupEnd(),console.log(v)}e.logStorage=p}),define(ne[251],se([0,1,3,2,14,29,32,23]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends n.Disposable{constructor(w,m){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new I(w)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(m.onDidInstallExtensions(y=>y.forEach(({local:d,operation:S})=>{d&&S===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(w,m){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:m}),!0):!1}async disableExtension(w,m){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){const m=this.getDisabledExtensions();return m.every(y=>!(0,A.areSameExtensions)(y,w))?(m.push(w),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(w){const m=this.getDisabledExtensions();for(let y=0;y<m.length;y++){const d=m[y];if((0,A.areSameExtensions)(d,w))return m.splice(y,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(w){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,m){this.storageManger.set(w,m,0)}};P=me([G(0,b.IStorageService),G(1,T.IExtensionManagementService)],P),e.GlobalExtensionEnablementService=P;class I extends n.Disposable{constructor(w){super();this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(w,m){let y;return m===0?((0,k.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,m)),y=this.storage[w]):y=this._get(w,m),JSON.parse(y)}set(w,m,y){const d=JSON.stringify(m.map(({id:C,uuid:p})=>({id:C,uuid:p})));this._get(w,y)!==d&&(y===0&&(m.length?this.storage[w]=d:delete this.storage[w]),this._set(w,m.length?d:void 0,y))}onDidStorageChange(w){if(w.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const y=this.get(w.key,w.scope);delete this.storage[w.key];const d=this.get(w.key,w.scope),S=y.filter(p=>!d.some(g=>(0,A.areSameExtensions)(p,g))),C=d.filter(p=>!y.some(g=>(0,A.areSameExtensions)(g,p)));(S.length||C.length)&&this._onDidChange.fire([...S,...C])}}_get(w,m){return this.storageService.get(w,m,"[]")}_set(w,m,y){m?this.storageService.store(w,m,y,1):this.storageService.remove(w,y)}}e.StorageManager=I}),define(ne[252],se([0,1,18,21,10,4,36,14,7,19,15,29,32,65,13,8,25,44,219,23,22]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const c=T.isWeb?"web":(0,w.getTargetPlatform)(T.platform,A.arch);var s;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished",_[_.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function r(..._){return String(_.reduce((U,j)=>U|j,0))}var t;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class h{constructor(U=a){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(U,j=this.state.pageSize){return new h({...this.state,pageNumber:U,pageSize:j})}withFilter(U,...j){const B=[...this.state.criteria,...j.length?j.map(X=>({filterType:U,value:X})):[{filterType:U}]];return new h({...this.state,criteria:B})}withSortBy(U){return new h({...this.state,sortBy:U})}withSortOrder(U){return new h({...this.state,sortOrder:U})}withFlags(...U){return new h({...this.state,flags:U.reduce((j,B)=>j|B,0)})}withAssetTypes(...U){return new h({...this.state,assetTypes:U})}withSource(U){return new h({...this.state,source:U})}get raw(){const{criteria:U,pageNumber:j,pageSize:B,sortBy:X,sortOrder:oe,flags:J,assetTypes:ie}=this.state;return{filters:[{criteria:U,pageNumber:j,pageSize:B,sortBy:X,sortOrder:oe}],assetTypes:ie,flags:J}}get searchText(){const U=this.state.criteria.filter(j=>j.filterType===t.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function v(_,U){const j=(_||[]).filter(B=>B.statisticName===U)[0];return j?j.value:0}function R(_){const U="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(B=>B.assetType.indexOf(U)===0).reduce((B,X)=>{const oe=O(_,X.assetType);return oe&&B.push([X.assetType.substring(U.length),oe]),B},[])}function M(_){if(_.properties){const U=_.properties.filter(X=>X.key===i.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=U.filter(X=>j.test(X.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return O(_,i.Repository)}function F(_){return{uri:`${_.fallbackAssetUri}/${i.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${i.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function O(_,U){return _.files.filter(B=>B.assetType===U)[0]?{uri:`${_.assetUri}/${U}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${U}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}:null}function L(_,U){const j=_.properties?_.properties.filter(X=>X.key===U):[],B=j.length>0&&j[0].value;return B?B.split(",").map(X=>(0,m.adoptToGalleryExtensionId)(X)):[]}function N(_){const U=_.properties?_.properties.filter(j=>j.key===o.Engine):[];return U.length>0&&U[0].value||""}function $(_){const U=_.properties?_.properties.filter(j=>j.key===o.PreRelease):[];return U.length>0&&U[0].value==="true"}function H(_){const U=_.properties?_.properties.filter(B=>B.key===o.LocalizedLanguages):[],j=U.length>0&&U[0].value||"";return j?j.split(","):[]}function Y(_){return _.properties?.find(U=>U.key===o.SponsorLink)?.value}function te(_){return _.indexOf("preview")!==-1}function q(_){return _.targetPlatform?(0,w.toTargetPlatform)(_.targetPlatform):"undefined"}function W(_){const U=(0,D.distinct)(_.versions.map(q)),j=!!_.tags?.includes(w.WEB_EXTENSION_TAG),B=U.indexOf("web");return j?B===-1&&U.push("web"):B!==-1&&U.splice(B,1),U}function x(_,U){const j=(0,w.getFallbackTargetPlarforms)(U);for(let B=0;B<_.length;B++){const X=_[B];if(X.version===_[B-1]?.version){let oe=B;const J=q(X);if(J===U)for(;oe>0&&_[oe-1].version===X.version;)oe--;else if(j.includes(J))for(;oe>0&&_[oe-1].version===X.version&&q(_[oe-1])!==U;)oe--;oe!==B&&(_.splice(B,1),_.splice(oe,0,X))}}return _}e.sortExtensionVersions=x;function K(_,U,j){_.telemetryData={index:U,querySource:j}}function ee(_,U,j){const B=_.versions[0],X={manifest:O(U,i.Manifest),readme:O(U,i.Details),changelog:O(U,i.Changelog),license:O(U,i.License),repository:M(U),download:F(U),icon:O(U,i.Icon),coreTranslations:R(U)};return{identifier:{id:(0,m.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:U.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,publisherDomain:_.publisher.domain?{link:_.publisher.domain,verified:!!_.publisher.isDomainVerified}:void 0,publisherSponsorLink:Y(B),description:_.shortDescription||"",installCount:v(_.statistics,"install"),rating:v(_.statistics,"averagerating"),ratingCount:v(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:j,assets:X,properties:{dependencies:L(U,o.Dependency),extensionPack:L(U,o.ExtensionPack),engine:N(U),localizedLanguages:H(U),targetPlatform:q(U),isPreReleaseVersion:$(U)},hasPreReleaseVersion:$(B),hasReleaseVersion:!0,preview:te(_.flags)}}let ce=class{constructor(U,j,B,X,oe,J,ie,re){this.requestService=j,this.logService=B,this.environmentService=X,this.telemetryService=oe,this.fileService=J,this.productService=ie,this.configurationService=re;const ue=ie.extensionsGallery;this.extensionsGalleryUrl=ue&&ue.serviceUrl,this.extensionsControlUrl=ue&&ue.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,U,this.telemetryService)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,j,B){const X=n.CancellationToken.isCancellationToken(j)?{}:j,oe=n.CancellationToken.isCancellationToken(j)?j:B,J=[],ie=[],re=[],ue=[];let he=!0;for(const Ce of U){Ce.uuid?ie.push(Ce.uuid):J.push(Ce.id);const Pe=!!(Ce.version||Ce.preRelease);re.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:Pe}),Ce.version&&ue.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),he=he&&!!Ce.hasPreRelease&&!Pe}if(!ie.length&&!J.length)return[];let ve=new h().withPage(1,U.length);ie.length&&(ve=ve.withFilter(t.ExtensionId,...ie)),J.length&&(ve=ve.withFilter(t.ExtensionName,...J)),(X.queryAllVersions||he)&&(ve=ve.withFlags(ve.flags,s.IncludeVersions)),X.source&&(ve=ve.withSource(X.source));const{extensions:ye}=await this.queryGalleryExtensions(ve,{targetPlatform:X.targetPlatform??c,includePreRelease:re,versions:ue,compatible:!!X.compatible},oe);return X.source&&ye.forEach((Ce,Pe)=>K(Ce,Pe,X.source)),ye}async getCompatibleExtension(U,j,B){if((0,w.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(U,j,B))return U;const X=new h().withFlags(s.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,U.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(X,{targetPlatform:B,compatible:!0,includePreRelease:j},n.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(U,j,B){if(!(0,w.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,B)||!j&&U.properties.isPreReleaseVersion)return!1;let X=U.properties.engine;if(!X){const oe=await this.getManifest(U,n.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");X=oe.engines.vscode}return(0,y.isEngineValid)(X,this.productService.version,this.productService.date)}async isValidVersion(U,j,B,X,oe){if(!(0,w.isTargetPlatformCompatible)(q(U),X,oe)||j!=="any"&&$(U)!==(j==="prerelease"))return!1;if(B)try{const J=await this.getEngine(U);if(!(0,y.isEngineValid)(J,this.productService.version,this.productService.date))return!1}catch(J){return this.logService.error(`Error while getting the engine for the version ${U.version}.`,(0,k.getErrorMessage)(J)),!1}return!0}async query(U,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=U.text||"";const X=U.pageSize??50;let oe=new h().withPage(1,X);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,ye)=>(oe=oe.withFilter(t.Category,ye||ve),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,ye)=>(oe=oe.withFilter(t.Tag,ye||ve),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),oe=oe.withFilter(t.SearchText,B)),oe=oe.withSortBy(0)):U.ids?oe=oe.withFilter(t.ExtensionId,...U.ids):U.names?oe=oe.withFilter(t.ExtensionName,...U.names):oe=oe.withSortBy(4),typeof U.sortBy=="number"&&(oe=oe.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(oe=oe.withSortOrder(U.sortOrder)),U.source&&(oe=oe.withSource(U.source));const J=async(he,ve)=>{const{extensions:ye,total:Ce}=await this.queryGalleryExtensions(he,{targetPlatform:c,compatible:!1,includePreRelease:!!U.includePreRelease},ve);return ye.forEach((Pe,Ue)=>K(Pe,(he.pageNumber-1)*he.pageSize+Ue,U.source)),{extensions:ye,total:Ce}},{extensions:ie,total:re}=await J(oe,j),ue=async(he,ve)=>{if(ve.isCancellationRequested)throw new k.CancellationError;const{extensions:ye}=await J(oe.withPage(he+1),ve);return ye};return{firstPage:ie,total:re,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(U,j,B){const X=U.flags;!!(U.flags&s.IncludeLatestVersionOnly)&&!!(U.flags&s.IncludeVersions)&&(U=U.withFlags(U.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(U.flags&s.IncludeLatestVersionOnly)&&!(U.flags&s.IncludeVersions)&&(U=U.withFlags(U.flags,s.IncludeLatestVersionOnly)),j.versions?.length&&(U=U.withFlags(U.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),U=U.withFlags(U.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:oe,total:J}=await this.queryRawGalleryExtensions(U,B);if(!(U.flags&s.IncludeLatestVersionOnly)){const he=[];for(const ve of oe){const ye=await this.toGalleryExtensionWithCriteria(ve,j);ye&&he.push(ye)}return{extensions:he,total:J}}const re=[],ue=new Map;for(let he=0;he<oe.length;he++){const ve=oe[he],ye={id:(0,m.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ce=(0,b.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(Ue=>(0,m.areSameExtensions)(Ue,ye))?.includePreRelease;if(j.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(W(ve),j.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(ve,j);!Pe||Pe.properties.isPreReleaseVersion&&(!Ce||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==j.targetPlatform&&Pe.hasPreReleaseVersion?ue.set(ve.extensionId,he):re.push([he,Pe])}if(ue.size){const he=new Date().getTime(),ve=new h().withFlags(X&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:ye}=await this.queryGalleryExtensions(ve,j,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-he,count:ue.size});for(const Ce of ye){const Pe=ue.get(Ce.identifier.uuid);re.push([Pe,Ce])}}return{extensions:re.sort((he,ve)=>he[0]-ve[0]).map(([,he])=>he),total:J}}async toGalleryExtensionWithCriteria(U,j){const B={id:(0,m.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},X=j.versions?.find(re=>(0,m.areSameExtensions)(re,B))?.version,oe=(0,b.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(re=>(0,m.areSameExtensions)(re,B))?.includePreRelease,J=W(U),ie=x(U.versions,j.targetPlatform);if(j.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(J,j.targetPlatform))return null;for(let re=0;re<ie.length;re++){const ue=ie[re];if(!(X&&ue.version!==X)){if(await this.isValidVersion(ue,oe?"any":"release",j.compatible,J,j.targetPlatform))return ee(U,ue,J);if(X&&ue.version===X)return null}}return X||j.compatible?null:ee(U,U.versions[0],J)}async queryRawGalleryExtensions(U,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,s.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(s.Unpublished));const B=await this.commonHeadersPromise,X=JSON.stringify(U.raw),oe={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},J=new Date().getTime();let ie,re,ue=0;try{if(ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:X,headers:oe},j),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const he=await(0,p.asJson)(ie);if(he){const ve=he.results[0],ye=ve.extensions,Ce=ve.resultMetadata&&ve.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ue=Ce&&Ce.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ue}}return{galleryExtensions:[],total:ue}}catch(he){throw re=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(X.length),duration:new Date().getTime()-J,success:!!ie&&(0,p.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:re?(0,k.isCancellationError)(re)?"canceled":(0,k.getErrorMessage)(re).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(U,j,B,X){if(!this.isEnabled())return;const oe=T.isWeb?this.api(`/itemName/${U}.${j}/version/${B}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${j}/${B}/stats?statType=${X}`),J=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.commonHeadersPromise,Accept:J};try{await this.requestService.request({type:"POST",url:oe,headers:re},n.CancellationToken.None)}catch{}}async download(U,j,B){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const X=(0,m.getGalleryExtensionTelemetryData)(U),oe=new Date().getTime(),J=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:he}),ie=B===2?"install":B===3?"update":"",re=ie?{uri:`${U.assets.download.uri}${P.URI.parse(U.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${U.assets.download.fallbackUri}${P.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:U.assets.download,ue=await this.getAsset(re);await this.fileService.writeFile(j,ue.stream),J(new Date().getTime()-oe)}async getReadme(U,j){if(U.assets.readme){const B=await this.getAsset(U.assets.readme,{},j);return await(0,p.asTextOrError)(B)||""}return""}async getManifest(U,j){if(U.assets.manifest){const B=await this.getAsset(U.assets.manifest,{},j),X=await(0,p.asTextOrError)(B);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(U,j){const B=O(U,i.Manifest);if(!B)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},oe=await this.getAsset(B,{headers:X});return await(0,p.asJson)(oe)}async getCoreTranslation(U,j){const B=U.assets.coreTranslations.filter(X=>X[0]===j.toUpperCase())[0];if(B){const X=await this.getAsset(B[1]),oe=await(0,p.asTextOrError)(X);return oe?JSON.parse(oe):null}return null}async getChangelog(U,j){if(U.assets.changelog){const B=await this.getAsset(U.assets.changelog,{},j);return await(0,p.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(U,j,B){let X=new h().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?X=X.withFilter(t.ExtensionId,U.identifier.uuid):X=X.withFilter(t.ExtensionName,U.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(X,n.CancellationToken.None);if(!oe.length)return[];const J=W(oe[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(J,B))return[];const ie=[];await Promise.all(oe[0].versions.map(async he=>{try{await this.isValidVersion(he,j?"any":"release",!0,J,B)&&ie.push(he)}catch{}}));const re=[],ue=new Set;for(const he of x(ie,B))ue.has(he.version)||(ue.add(he.version),re.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:$(he)}));return re}async getAsset(U,j={},B=n.CancellationToken.None){const X=await this.commonHeadersPromise,oe={type:"GET"},J={...X,...j.headers||{}};j={...j,...oe,headers:J};const ie=U.uri,re=U.fallbackUri,ue={...j,url:ie};try{const he=await this.requestService.request(ue,B);if(he.res.statusCode===200)return he;const ve=await(0,p.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${ve}`)}catch(he){if((0,k.isCancellationError)(he))throw he;const ve=(0,k.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const ye={...j,url:re};return this.requestService.request(ye,B)}}async getEngine(U){let j=N(U);if(!j){const B=await this.getManifestFromRawExtensionVersion(U,n.CancellationToken.None);if(!B)throw new Error("Manifest was not found");j=B.engines.vscode}return j}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,p.asJson)(U),B=[],X={};if(j){for(const oe of j.malicious)B.push({id:oe});if(j.migrateToPreRelease)for(const[oe,J]of Object.entries(j.migrateToPreRelease))(!J.engine||(0,y.isEngineValid)(J.engine,this.productService.version,this.productService.date))&&(X[oe.toLowerCase()]={disallowInstall:!0,extension:{id:J.id,displayName:J.displayName,autoMigrate:{storage:!!J.migrateStorage},preRelease:!0}});if(j.deprecated)for(const[oe,J]of Object.entries(j.deprecated))J&&(X[oe.toLowerCase()]=(0,b.isBoolean)(J)?{}:J)}return{malicious:B,deprecated:X}}};ce=me([G(1,p.IRequestService),G(2,S.ILogService),G(3,E.IEnvironmentService),G(4,f.ITelemetryService),G(5,d.IFileService),G(6,C.IProductService),G(7,I.IConfigurationService)],ce);let z=class extends ce{constructor(U,j,B,X,oe,J,ie,re){super(U,j,B,X,oe,J,ie,re)}};z=me([G(0,u.IStorageService),G(1,p.IRequestService),G(2,S.ILogService),G(3,E.IEnvironmentService),G(4,f.ITelemetryService),G(5,d.IFileService),G(6,C.IProductService),G(7,I.IConfigurationService)],z),e.ExtensionGalleryService=z;let V=class extends ce{constructor(U,j,B,X,oe,J,ie){super(void 0,U,j,B,X,oe,J,ie)}};V=me([G(0,p.IRequestService),G(1,S.ILogService),G(2,E.IEnvironmentService),G(3,f.ITelemetryService),G(4,d.IFileService),G(5,C.IProductService),G(6,I.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(ne[72],se([0,1,5,3,2,23,32,25,18,8,14]),function(Q,e,D,n,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Je extends k.Disposable{constructor(d,S,C){super();this.storageService=d,this.productService=S,this.logService=C,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(d),this._register(this.storageService.onDidChangeValue(p=>this.onDidChangeStorageValue(p)))}static toKey(d){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const S=w.exec(d);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(d,S){const C=await d.getInstalled(),p=[];for(const[g,u]of Je.readAllExtensionsWithKeysForSync(S)){const f=C.find(c=>(0,A.areSameExtensions)(c.identifier,{id:g}))?.manifest.version;for(const c of u)f!==c&&p.push(Je.toKey({id:g,version:c}))}for(const g of p)S.remove(g,0)}static readAllExtensionsWithKeysForSync(d){const S=new Map,C=d.keys(0,1);for(const p of C){const g=Je.fromKey(p);if(g){let u=S.get(g.id.toLowerCase());u||S.set(g.id.toLowerCase(),u=[]),u.push(g.version)}}return S}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Je.fromKey(d.key);if(S){if(this.storageService.get(d.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let C=this.extensionsWithKeysForSync.get(S.id.toLowerCase());C||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),C=[]),C.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(d){if((0,E.isString)(d))return d;const S=d.manifest?d.manifest.publisher:d.publisher,C=d.manifest?d.manifest.name:d.name;return(0,A.getExtensionId)(S,C)}getExtensionState(d,S){const C=this.getExtensionId(d),p=this.storageService.get(C,S?0:1);if(p)try{return JSON.parse(p)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${C}, global: ${S}): ${g}`)}}setExtensionState(d,S,C){const p=this.getExtensionId(d);S===void 0?this.storageService.remove(p,C?0:1):this.storageService.store(p,JSON.stringify(S),C?0:1,1)}setKeysForSync(d,S){this.storageService.store(Je.toKey(d),JSON.stringify(S),0,1)}getKeysForSync(d){const S=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],C=this.storageService.get(Je.toKey(d),0),p=C?JSON.parse(C):void 0;return p&&S?(0,P.distinct)([...p,...S]):p||S}addToMigrationList(d,S){if(d!==S){const C=this.migrationList.filter(p=>!p.includes(d)&&!p.includes(S));C.push([d,S]),this.migrationList=C}}getSourceExtensionToMigrate(d){const S=this.migrationList.find(([,C])=>d===C);return S?S[0]:void 0}get migrationList(){const d=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(d);if(Array.isArray(S))return S}catch{}return[]}set migrationList(d){d.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};m=me([G(0,T.IStorageService),G(1,b.IProductService),G(2,I.ILogService)],m),e.ExtensionStorageService=m}),define(ne[253],se([0,1,18,6,3,9,4,36,7,143,15,29,32,209,91,13,8,67,25,44,23,22]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g,u,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const s="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let t=class extends y.ExtensionTipsService{constructor(o,l,a,h,v,R,M,F,O,L){super(M,F,O,L);this.environmentService=o,this.telemetryService=l,this.extensionManagementService=a,this.storageService=h,this.nativeHostService=v,this.extensionRecommendationNotificationService=R,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&Object.entries(F.exeBasedExtensionTips).forEach(([N,$])=>{const H=[],Y=[],te=[];Object.entries($.recommendations).forEach(([q,W])=>{W.important?$.important?H.push({extensionId:q,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):Y.push({extensionId:q,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):te.push({extensionId:q,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),H.length&&this.highImportanceExecutableTips.set(N,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H}),Y.length&&this.mediumImportanceExecutableTips.set(N,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:Y}),te.length&&this.allOtherExecutableTips.set(N,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:te})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,a)}groupImportantTipsByExe(o,l){const a=new Map;o.forEach(F=>a.set(F.extensionId.toLowerCase(),F));const{installed:h,uninstalled:v}=this.groupByInstalled([...a.keys()],l);for(const F of h){const O=a.get(F);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:O.exeName})}for(const F of v){const O=a.get(F);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:O.exeName})}const R=this.getPromptedExecutableTips(),M=new Map;for(const F of v){const O=a.get(F);if(O&&(!R[O.exeName]||!R[O.exeName].includes(O.extensionId))){let L=M.get(O.exeName);L||(L=[],M.set(O.exeName,L)),L.push(O)}}return M}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const h=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,n.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),l=Date.now()-o,a=7*24*60*60*1e3;if(l<a){const R=this._register((0,n.disposableTimeout)(()=>{R.dispose(),this.promptMediumImportanceExeBasedTip()},a-l));return}const[h,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(R=>{switch(R){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(v[0].exeName,v);const M=this._register((0,n.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const M=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(M(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const M=this._register((0,n.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(o){const l=await this.extensionManagementService.getInstalled(1),a=o.filter(v=>!v.whenNotInstalled||v.whenNotInstalled.every(R=>l.every(M=>!(0,m.areSameExtensions)(M.identifier,{id:R})))).map(({extensionId:v})=>v.toLowerCase()),h=(0,I.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,h,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(r,-1);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(r,o,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(s,-1,"{}"))}addToRecommendedExecutables(o,l){const a=this.getPromptedExecutableTips();a[o]=l.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(s,JSON.stringify(a),-1,0)}groupByInstalled(o,l){const a=[],h=[],v=l.reduce((R,M)=>(R.add(M.identifier.id.toLowerCase()),R),new Set);return o.forEach(R=>{v.has(R.toLowerCase())?a.push(R):h.push(R)}),{installed:a,uninstalled:h}}async getValidExecutableBasedExtensionTips(o){const l=[],a=new Map;for(const h of o.keys()){const v=o.get(h);if(!v||!(0,D.isNonEmptyArray)(v.recommendations))continue;const R=[];A.isWindows?v.windowsPath&&R.push(v.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(R.push((0,T.join)("/usr/local/bin",h)),R.push((0,T.join)("/usr/bin",h)),R.push((0,T.join)(this.environmentService.userHome.fsPath,h)));for(const M of R){let F=a.get(M);if(F===void 0&&(F=await this.fileService.exists(P.URI.file(M)),a.set(M,F)),F)for(const{extensionId:O,extensionName:L,isExtensionPack:N,whenNotInstalled:$}of v.recommendations)l.push({extensionId:O,extensionName:L,isExtensionPack:N,exeName:h,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath,whenNotInstalled:$})}}return l}};t=me([G(0,E.INativeEnvironmentService),G(1,c.ITelemetryService),G(2,w.IExtensionManagementService),G(3,f.IStorageService),G(4,p.INativeHostService),G(5,d.IExtensionRecommendationNotificationService),G(6,S.IFileService),G(7,g.IProductService),G(8,u.IRequestService),G(9,C.ILogService)],t),e.ExtensionTipsService=t}),define(ne[254],se([0,1,6,2,17,86,23,217]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class P extends A.AbstractStorageService{constructor(E,w,m,y){super();this.initialWorkspace=E,this.initialProfiles=w,this.mainProcessService=m,this.environmentService=y,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new n.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new n.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const E=this._register(new b.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),w=this._register(new T.Storage(E));return this._register(w.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m))),w}createProfileStorage(E){this.profileStorageDisposables.clear(),this.profileStorageProfile=E;let w;if((0,A.isProfileUsingDefaultStorage)(E))w=this.applicationStorage;else{const m=this.profileStorageDisposables.add(new b.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),E));w=this.profileStorageDisposables.add(new T.Storage(m))}return this.profileStorageDisposables.add(w.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),w}createWorkspaceStorage(E){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=E?.id;let w;if(E){const m=this.workspaceStorageDisposables.add(new b.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),E));w=this.workspaceStorageDisposables.add(new T.Storage(m)),this.workspaceStorageDisposables.add(w.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)))}return w}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(E){switch(E){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(E){switch(E){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(E,w){if(!this.canSwitchProfile(this.profileStorageProfile,E))return;const m=this.profileStorage,y=m.items;m!==this.applicationStorage&&await m.close(),this.profileStorage=this.createProfileStorage(E),await this.profileStorage.init(),this.switchData(y,this.profileStorage,0,w)}async switchToWorkspace(E,w){const m=this.workspaceStorage,y=m?.items??new Map;await m?.close(),this.workspaceStorage=this.createWorkspaceStorage(E),await this.workspaceStorage.init(),this.switchData(y,this.workspaceStorage,1,w)}}e.NativeStorageService=P}),define(ne[255],se([0,1,3,2,17,15,94,28]),function(Q,e,D,n,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let P=class extends n.Disposable{constructor(E,w,m){super();this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=w.getChannel("userDataProfiles"),this.profilesHome=(0,k.joinPath)(m.userRoamingDataHome,"profiles"),this._profiles=E.map(y=>(0,b.reviveProfile)(y,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(y=>{const d=y.added.map(p=>(0,b.reviveProfile)(p,this.profilesHome.scheme)),S=y.removed.map(p=>(0,b.reviveProfile)(p,this.profilesHome.scheme)),C=y.updated.map(p=>(0,b.reviveProfile)(p,this.profilesHome.scheme));this._profiles=y.all.map(p=>(0,b.reviveProfile)(p,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:d,removed:S,updated:C,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}async createProfile(E,w,m){const y=await this.channel.call("createProfile",[E,w,m]);return(0,b.reviveProfile)(y,this.profilesHome.scheme)}async createTransientProfile(E){const w=await this.channel.call("createTransientProfile",[E]);return(0,b.reviveProfile)(w,this.profilesHome.scheme)}async setProfileForWorkspace(E,w){await this.channel.call("setProfileForWorkspace",[E,w])}removeProfile(E){return this.channel.call("removeProfile",[E])}async updateProfile(E,w,m){const y=await this.channel.call("updateProfile",[E,w,m]);return(0,b.reviveProfile)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};P=me([G(1,A.IMainProcessService),G(2,T.IEnvironmentService)],P),e.UserDataProfilesNativeService=P}),define(ne[45],se([0,1,18,6,16,21,3,35,2,24,14,7,158,19,15,13,8,47,23,22,33,26,28]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g,u,f,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=r;let t=class extends P.Disposable{constructor(h,v,R,M,F,O,L,N,$,H,Y){super();this.resource=h,this.fileService=v,this.environmentService=R,this.userDataSyncStoreService=F,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=L,this.telemetryService=N,this.logService=$,this.configurationService=H,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,I.uppercaseFirstLetter)(this.resource),this.extUri=Y.extUri,this.syncFolder=this.extUri.joinPath(R.userDataSyncHome,h),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(h,R,this.extUri),this.currentMachineIdPromise=(0,p.getServiceMachineId)(R,v,M)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const h=await this.syncPreviewPromise;this.syncPreviewPromise=null;const v=await this.performSync(h.remoteUserData,h.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(v)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const h=await this.getLastSyncUserData();(h?await this.hasRemoteChanged(h):!0)&&this._onDidChangeLocal.fire()}}setStatus(h){this._status!==h&&(this._status=h,this._onDidChangStatus.fire(h))}async sync(h,v={}){await this._sync(h,!0,this.getUserDataSyncConfiguration(),v)}async preview(h,v,R={}){return this._sync(h,!1,v,R)}async apply(h,v={}){try{this.syncHeaders={...v};const R=await this.doApply(h);return this.setStatus(R),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(h,v,R,M){try{if(this.syncHeaders={...M},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let F="idle";try{const O=await this.getLastSyncUserData(),L=await this.getLatestRemoteUserData(h,O);return F=await this.performSync(L,O,v,R),F==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(F)}}finally{this.syncHeaders={}}}async replace(h){const v=await this.resolveContent(h);if(!v)return!1;const R=this.parseSyncData(v);if(!R)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const M=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(null,M),O=await this.isRemoteDataFromCurrentMachine(F),L=await this.generateSyncPreview({ref:F.ref,syncData:R},M,O,this.getUserDataSyncConfiguration(),T.CancellationToken.None),N=[];for(const $ of L){const H=await this.getAcceptResult($,$.remoteResource,void 0,T.CancellationToken.None),{remoteChange:Y}=await this.getAcceptResult($,$.previewResource,$.remoteContent,T.CancellationToken.None);N.push([$,{...H,remoteChange:Y!==0?Y:2}])}await this.applyResult(F,M,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(h){const v=await this.currentMachineIdPromise;return!!h.syncData?.machineId&&h.syncData.machineId===v}async getLatestRemoteUserData(h,v){if(v){const R=h&&h.latest?h.latest[this.resource]:void 0;if(v.ref===R||R===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async performSync(h,v,R,M){if(h.syncData&&h.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,m.localize)(0,null,this.resource,this.version,h.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(h,v,R,M)}catch(F){if(F instanceof c.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(h,v,R,M);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),h=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.performSync(h,v,R,M)}throw F}}async doSync(h,v,R,M){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(h,v,R,M,O)));const F=await this.syncPreviewPromise;return this.updateConflicts(F.resourcePreviews),F.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":R?await this.doApply(!1):"syncing"}catch(F){throw this.syncPreviewPromise=null,F}}async merge(h){return await this.updateSyncResourcePreview(h,async v=>{const R=await this.getMergeResult(v,T.CancellationToken.None);await this.fileService.writeFile(v.previewResource,k.VSBuffer.fromString(R?.content||""));const M=R&&!R.hasConflicts?await this.getAcceptResult(v,v.previewResource,void 0,T.CancellationToken.None):void 0;return v.acceptResult=M,v.mergeState=R.hasConflicts?"conflict":M?"accepted":"preview",v.localChange=M?M.localChange:R.localChange,v.remoteChange=M?M.remoteChange:R.remoteChange,v}),this.syncPreviewPromise}async accept(h,v){return await this.updateSyncResourcePreview(h,async R=>{const M=await this.getAcceptResult(R,h,v,T.CancellationToken.None);return R.acceptResult=M,R.mergeState="accepted",R.localChange=M.localChange,R.remoteChange=M.remoteChange,R}),this.syncPreviewPromise}async discard(h){return await this.updateSyncResourcePreview(h,async v=>{const R=await this.getMergeResult(v,T.CancellationToken.None);return await this.fileService.writeFile(v.previewResource,k.VSBuffer.fromString(R.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=R.localChange,v.remoteChange=R.remoteChange,v}),this.syncPreviewPromise}async updateSyncResourcePreview(h,v){if(!this.syncPreviewPromise)return;let R=await this.syncPreviewPromise;const M=R.resourcePreviews.findIndex(({localResource:F,remoteResource:O,previewResource:L})=>this.extUri.isEqual(F,h)||this.extUri.isEqual(O,h)||this.extUri.isEqual(L,h));M!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async F=>{const O=[...R.resourcePreviews];return O[M]=await v(O[M]),{...R,resourcePreviews:O}}),R=await this.syncPreviewPromise,this.updateConflicts(R.resourcePreviews),R.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(h){if(!this.syncPreviewPromise)return"idle";const v=await this.syncPreviewPromise;return v.resourcePreviews.some(({mergeState:R})=>R==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:R})=>R!=="accepted")?"syncing":(await this.applyResult(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(R=>[R,R.acceptResult]),h),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(h){const v=h.filter(({mergeState:R})=>R==="conflict");(0,D.equals)(this._conflicts,v,(R,M)=>this.extUri.isEqual(R.previewResource,M.previewResource))||(this._conflicts=v,this._onDidChangeConflicts.fire(v))}async hasPreviouslySynced(){const h=await this.getLastSyncUserData();return!!h&&h.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:v,ref:R})=>({created:v,uri:this.toRemoteBackupResource(R)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:v,ref:R})=>({created:v,uri:this.toLocalBackupResource(R)}))}toRemoteBackupResource(h){return w.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${h}`})}toLocalBackupResource(h){return w.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${h}`})}async getMachineId({uri:h}){const v=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(v))){const{content:R}=await this.getUserData(v);if(R)return this.parseSyncData(R)?.machineId}}async resolveContent(h){const v=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(v))){const{content:R}=await this.getUserData(v);return R}return this.extUri.isEqual(h,this.toLocalBackupResource(v))?this.userDataSyncBackupStoreService.resolveContent(this.resource,v):null}async resolvePreviewContent(h){const v=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(v)for(const R of v.resourcePreviews){if(this.extUri.isEqual(R.acceptedResource,h))return R.acceptResult?R.acceptResult.content:null;if(this.extUri.isEqual(R.remoteResource,h))return R.remoteContent;if(this.extUri.isEqual(R.localResource,h))return R.localContent;if(this.extUri.isEqual(R.baseResource,h))return R.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(h,v,R,M,F){const O=await this.isRemoteDataFromCurrentMachine(h),L=await this.generateSyncPreview(h,v,O,M,F),N=[];for(const $ of L){const H=$.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)N.push({...$,acceptedResource:H,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Y=R?await this.getMergeResult($,F):void 0;if(F.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,k.VSBuffer.fromString(Y?.content||""));const te=Y&&!Y.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,F):void 0;N.push({...$,acceptResult:te,mergeState:Y?.hasConflicts?"conflict":te?"accepted":"preview",localChange:te?te.localChange:Y?Y.localChange:$.localChange,remoteChange:te?te.remoteChange:Y?Y.remoteChange:$.remoteChange})}}return{remoteUserData:h,lastSyncUserData:v,resourcePreviews:N,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const h=await this.fileService.readFile(this.lastSyncResource),v=JSON.parse(h.value.toString()),R=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=v.version&&R&&v.version!==R,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${R}.`),await this.resetLocal(),null;const M=v;if(M.content===null)return{ref:v.ref,syncData:null};const F=JSON.parse(M.content);if(r(F))return{...v,syncData:F,content:void 0}}catch(h){h instanceof S.FileOperationError&&h.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(h)}return null}async updateLastSyncUserData(h,v={}){if(v.ref||v.content||v.version)throw new Error("Cannot have core properties as additional");const R=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),M={ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,version:R,...v};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(M)))}async getRemoteUserData(h){const{ref:v,content:R}=await this.getUserData(h);let M=null;return R!==null&&(M=this.parseSyncData(R)),{ref:v,syncData:M}}parseSyncData(h){try{const v=JSON.parse(h);if(r(v))return v}catch(v){this.logService.error(v)}throw new c.UserDataSyncError((0,m.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(h){if((0,E.isString)(h)){const v=await this.userDataSyncStoreService.resolveContent(this.resource,h);return{ref:h,content:v}}else{const v=h?{ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,v,void 0,this.syncHeaders)}}async updateRemoteUserData(h,v){const R=await this.currentMachineIdPromise,M={version:this.version,machineId:R,content:h};return v=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(M),v,void 0,this.syncHeaders),{ref:v,syncData:M}}async backupLocal(h){const v={version:this.version,content:h};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(v))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=me([G(1,S.IFileService),G(2,d.IEnvironmentService),G(3,g.IStorageService),G(4,c.IUserDataSyncStoreService),G(5,c.IUserDataSyncBackupStoreService),G(6,c.IUserDataSyncEnablementService),G(7,u.ITelemetryService),G(8,c.IUserDataSyncLogService),G(9,y.IConfigurationService),G(10,f.IUriIdentityService)],t),e.AbstractSynchroniser=t;let i=class extends t{constructor(h,v,R,M,F,O,L,N,$,H,Y,te){super(v,R,M,F,O,L,N,$,H,Y,te);this.file=h,this._register(this.fileService.watch(this.extUri.dirname(h))),this._register(this.fileService.onDidFilesChange(q=>this.onFileChanges(q)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(h,v,R){try{v?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(h),R?void 0:v):await this.fileService.createFile(this.file,k.VSBuffer.fromString(h),{overwrite:R})}catch(M){throw M instanceof S.FileOperationError&&M.fileOperationResult===1||M instanceof S.FileOperationError&&M.fileOperationResult===3?new c.UserDataSyncError(M.message,"LocalPreconditionFailed"):M}}onFileChanges(h){!h.contains(this.file)||this.triggerLocalChange()}};i=me([G(2,S.IFileService),G(3,d.IEnvironmentService),G(4,g.IStorageService),G(5,c.IUserDataSyncStoreService),G(6,c.IUserDataSyncBackupStoreService),G(7,c.IUserDataSyncEnablementService),G(8,u.ITelemetryService),G(9,c.IUserDataSyncLogService),G(10,y.IConfigurationService),G(11,f.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let o=class extends i{constructor(h,v,R,M,F,O,L,N,$,H,Y,te,q){super(h,v,R,M,F,O,L,N,$,H,te,q);this.userDataSyncUtilService=Y,this._formattingOptions=void 0}hasErrors(h,v){const R=[],M=(0,b.parse)(h,R,{allowEmptyContent:!0,allowTrailingComma:!0});return R.length>0||!(0,E.isUndefined)(M)&&v!==Array.isArray(M)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=me([G(2,S.IFileService),G(3,d.IEnvironmentService),G(4,g.IStorageService),G(5,c.IUserDataSyncStoreService),G(6,c.IUserDataSyncBackupStoreService),G(7,c.IUserDataSyncEnablementService),G(8,u.ITelemetryService),G(9,c.IUserDataSyncLogService),G(10,c.IUserDataSyncUtilService),G(11,y.IConfigurationService),G(12,f.IUriIdentityService)],o),e.AbstractJsonFileSynchroniser=o;let l=class{constructor(h,v,R,M,F,O){this.resource=h,this.userDataProfilesService=v,this.environmentService=R,this.logService=M,this.fileService=F,this.extUri=O.extUri,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,R,this.extUri)}async initialize({ref:h,content:v}){if(!v){this.logService.info("Remote content does not exist.",this.resource);return}const R=this.parseSyncData(v);if(!!R)try{await this.doInitialize({ref:h,syncData:R})}catch(M){this.logService.error(M)}}parseSyncData(h){try{const v=JSON.parse(h);if(r(v))return v}catch(v){this.logService.error(v)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(h,v={}){const R={ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,...v};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(R)))}};l=me([G(1,s.IUserDataProfilesService),G(2,d.IEnvironmentService),G(3,C.ILogService),G(4,S.IFileService),G(5,f.IUriIdentityService)],l),e.AbstractInitializer=l}),define(ne[256],se([0,1,6,21,10,3,52,24,7,19,15,29,32,72,13,8,23,22,33,28,45,236,107,26]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g,u,f,c,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(l,a){const h=JSON.parse(l.content);if(l.version===1||l.version===2){const v=(await a.getInstalled(0)).filter(R=>R.isBuiltin);for(const R of h)l.version===1&&(R.enabled===!1&&(R.disabled=!0),delete R.enabled),l.version===2&&v.every(M=>!(0,m.areSameExtensions)(M.identifier,R.identifier))&&(R.installed=!0)}return h}let i=class gt extends f.AbstractSynchroniser{constructor(a,h,v,R,M,F,O,L,N,$,H,Y,te,q,W){super("extensions",h,a,v,R,M,Y,te,N,H,W);this.extensionManagementService=F,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=L,this.extensionGalleryService=$,this.extensionStorageService=q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:K})=>!!K)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(a,h){const v=a.syncData?await t(a.syncData,this.extensionManagementService):null,R=h?.skippedExtensions||[],M=h?.syncData?await t(h.syncData,this.extensionManagementService):null,F=await this.extensionManagementService.getInstalled(void 0),O=this.getLocalExtensions(F),L=this.ignoredExtensionsManagementService.getIgnoredExtensions(F);v?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:N,remote:$}=(0,c.merge)(O,v,M,R,L),H={local:N,remote:$,content:this.getPreviewContent(O,N.added,N.updated,N.removed),localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:$!==null?2:0},Y=this.stringify(O,!1);return[{skippedExtensions:R,baseResource:this.baseResource,baseContent:M?this.stringify(M,!1):Y,localResource:this.localResource,localContent:Y,localExtensions:O,remoteResource:this.remoteResource,remoteContent:v?this.stringify(v,!1):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(a){const h=a.syncData?await t(a.syncData,this.extensionManagementService):null,v=await this.extensionManagementService.getInstalled(void 0),R=this.getLocalExtensions(v),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),{remote:F}=(0,c.merge)(R,h,h,a.skippedExtensions||[],M);return F!==null}getPreviewContent(a,h,v,R){const M=[...h,...v],F=new Set,O=L=>{F.add(L.id.toLowerCase()),L.uuid&&F.add(L.uuid)};M.forEach(({identifier:L})=>O(L)),R.forEach(O);for(const L of a)F.has(L.identifier.id.toLowerCase())||L.identifier.uuid&&F.has(L.identifier.uuid)||M.push(L);return this.stringify(M,!1)}async getMergeResult(a,h){return{...a.previewResult,hasConflicts:!1}}async getAcceptResult(a,h,v,R){if(this.extUri.isEqual(h,this.localResource))return this.acceptLocal(a);if(this.extUri.isEqual(h,this.remoteResource))return this.acceptRemote(a);if(this.extUri.isEqual(h,this.previewResource))return a.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async acceptLocal(a){const h=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),R=(0,c.merge)(a.localExtensions,null,null,a.skippedExtensions,v),{local:M,remote:F}=R;return{content:a.localContent,local:M,remote:F,localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:F!==null?2:0}}async acceptRemote(a){const h=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),R=a.remoteContent?JSON.parse(a.remoteContent):null;if(R!==null){const M=(0,c.merge)(a.localExtensions,R,a.localExtensions,[],v),{local:F,remote:O}=M;return{content:a.remoteContent,local:F,remote:O,localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:a.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(a,h,v,R){let{skippedExtensions:M,localExtensions:F}=v[0][0];const{local:O,remote:L,localChange:N,remoteChange:$}=v[0][1];if(N===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),N!==0&&(await this.backupLocal(JSON.stringify(F)),M=await this.updateLocalExtensions(O.added,O.removed,O.updated,M)),L){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const H=JSON.stringify(L.all);a=await this.updateRemoteUserData(H,R?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${L.added.length?` Added: ${JSON.stringify(L.added.map(Y=>Y.identifier.id))}.`:""}${L.updated.length?` Updated: ${JSON.stringify(L.updated.map(Y=>Y.identifier.id))}.`:""}${L.removed.length?` Removed: ${JSON.stringify(L.removed.map(Y=>Y.identifier.id))}.`:""}`)}h?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(a,{skippedExtensions:M}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${M.length?` Skipped: ${JSON.stringify(M.map(H=>H.identifier.id))}.`:""}`))}async getAssociatedResources({uri:a}){return[{resource:this.extUri.joinPath(a,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(a){if(this.extUri.isEqual(a,gt.EXTENSIONS_DATA_URI)){const v=await this.extensionManagementService.getInstalled(),R=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),M=this.getLocalExtensions(v).filter(F=>!R.some(O=>(0,m.areSameExtensions)({id:O},F.identifier)));return this.stringify(M,!0)}if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.baseResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a)){const v=await this.resolvePreviewContent(a);return v&&this.stringify(JSON.parse(v),!0)}let h=await super.resolveContent(a);if(h)return h;if(h=await super.resolveContent(this.extUri.dirname(a)),h){const v=this.parseSyncData(h);if(v)switch(this.extUri.basename(a)){case"extensions.json":return this.stringify(this.parseExtensions(v),!0)}}return null}stringify(a,h){return a.sort((v,R)=>!v.identifier.uuid&&R.identifier.uuid?-1:v.identifier.uuid&&!R.identifier.uuid?1:(0,b.compare)(v.identifier.id,R.identifier.id)),h?(0,A.toFormattedString)(a,{}):JSON.stringify(a)}async hasLocalData(){try{const a=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(a).some(v=>v.installed||v.disabled))return!0}catch{}return!1}async updateLocalExtensions(a,h,v,R){const M=[],F=[],O=await this.extensionManagementService.getInstalled();if(h.length){const N=O.filter(({identifier:$,isBuiltin:H})=>!H&&h.some(Y=>(0,m.areSameExtensions)($,Y)));await D.Promises.settled(N.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),M.push($.identifier)}))}(a.length||v.length)&&await D.Promises.settled([...a,...v].map(async N=>{const $=O.find(Y=>(0,m.areSameExtensions)(Y.identifier,N.identifier));if($&&$.isBuiltin){N.state&&$.manifest.version===N.version&&this.updateExtensionState(N.state,$,$.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(te=>(0,m.areSameExtensions)(te,N.identifier))!==!!N.disabled&&(N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id),await this.extensionEnablementService.disableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id),await this.extensionEnablementService.enableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id))),M.push(N.identifier);return}const H=(await this.extensionGalleryService.getExtensions([{...N.identifier,preRelease:N.preRelease}],n.CancellationToken.None))[0];if(N.state&&($?$.manifest.version===N.version:!!H)&&this.updateExtensionState(N.state,$||H,$?.manifest.version),H)try{this.extensionEnablementService.getDisabledExtensions().some(te=>(0,m.areSameExtensions)(te,N.identifier))!==!!N.disabled&&(N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id,H.version),await this.extensionEnablementService.disableExtension(H.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id,H.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id,H.version),await this.extensionEnablementService.enableExtension(H.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id,H.version))),(!$||$.preRelease!==N.preRelease)&&(await this.extensionManagementService.canInstall(H)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,N.identifier.id,H.version),await this.extensionManagementService.installFromGallery(H,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:N.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,N.identifier.id,H.version),M.push(H.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,H.displayName||H.identifier.id),F.push(N)))}catch(Y){F.push(N),Y instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(Y.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,H.displayName||H.identifier.id):(this.logService.error(Y),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,H.displayName||H.identifier.id))}else F.push(N),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,N.identifier.id)}));const L=[];for(const N of R)M.some($=>(0,m.areSameExtensions)($,N.identifier))||L.push(N);for(const N of F)L.some($=>(0,m.areSameExtensions)($.identifier,N.identifier))||L.push(N);return L}updateExtensionState(a,h,v){const R=this.extensionStorageService.getExtensionState(h,!0)||{},M=v?this.extensionStorageService.getKeysForSync({id:h.identifier.id,version:v}):void 0;M?M.forEach(F=>{R[F]=a[F]}):Object.keys(a).forEach(F=>R[F]=a[F]),this.extensionStorageService.setExtensionState(h,R,!0)}parseExtensions(a){return JSON.parse(a.content)}getLocalExtensions(a){const h=this.extensionEnablementService.getDisabledExtensions();return a.map(v=>{const{identifier:R,isBuiltin:M,manifest:F,preRelease:O}=v,L={identifier:R,preRelease:O,version:F.version};h.some(N=>(0,m.areSameExtensions)(N,R))&&(L.disabled=!0),M||(L.installed=!0);try{const N=this.extensionStorageService.getKeysForSync({id:R.id,version:F.version});if(N){const $=this.extensionStorageService.getExtensionState(v,!0)||{};L.state=Object.keys($).reduce((H,Y)=>(N.includes(Y)&&(H[Y]=$[Y]),H),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)(N))}return L})}};i.EXTENSIONS_DATA_URI=P.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=me([G(0,E.IEnvironmentService),G(1,d.IFileService),G(2,C.IStorageService),G(3,r.IUserDataSyncStoreService),G(4,r.IUserDataSyncBackupStoreService),G(5,w.IExtensionManagementService),G(6,w.IGlobalExtensionEnablementService),G(7,s.IIgnoredExtensionsManagementService),G(8,r.IUserDataSyncLogService),G(9,w.IExtensionGalleryService),G(10,I.IConfigurationService),G(11,r.IUserDataSyncEnablementService),G(12,p.ITelemetryService),G(13,y.IExtensionStorageService),G(14,g.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let o=class extends f.AbstractInitializer{constructor(a,h,v,R,M,F,O){super("extensions",R,M,F,v,O);this.extensionManagementService=a,this.ignoredExtensionsManagementService=h}async parseExtensions(a){return a.syncData?await t(a.syncData,this.extensionManagementService):null}generatePreview(a,h){const v=[],R=[],M=[];for(const F of a){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(F.identifier.id))continue;const O=h.find(L=>(0,m.areSameExtensions)(L.identifier,F.identifier));O?(v.push(O),F.disabled&&M.push(F.identifier)):F.installed&&(R.push({...F.identifier,preRelease:!!F.preRelease}),F.disabled&&M.push(F.identifier))}return{installedExtensions:v,newExtensions:R,disabledExtensions:M,remoteExtensions:a}}};o=me([G(0,w.IExtensionManagementService),G(1,s.IIgnoredExtensionsManagementService),G(2,d.IFileService),G(3,u.IUserDataProfilesService),G(4,E.IEnvironmentService),G(5,S.ILogService),G(6,g.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ne[257],se([0,1,16,10,3,35,52,4,7,30,19,15,13,8,47,23,22,33,45,59,239,26,28]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g,u,f,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",t=["locale"];function i(v,R){const M=v.storage?Object.keys(v.storage).sort():[],F={};return M.forEach(O=>F[O]=v.storage[O]),v.storage=F,R?(0,A.toFormattedString)(v,{}):JSON.stringify(v)}const o=1;let l=class mt extends g.AbstractSynchroniser{constructor(R,M,F,O,L,N,$,H,Y,te){super("globalState",R,L,Y,M,F,N,$,O,H,te);this.storageService=Y,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(R.onDidFilesChange,q=>q.contains(this.environmentService.argvResource)),k.Event.filter(Y.onDidChangeValue,q=>q.scope===0&&q.target!==void 0?q.target===0:Y.keys(0,0).includes(q.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(R,M,F){const O=R.syncData?JSON.parse(R.syncData.content):null;M=M===null&&F?R:M;const L=M&&M.syncData?JSON.parse(M.syncData.content):null,N=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=this.getStorageKeys(L),{local:H,remote:Y}=(0,f.merge)(N.storage,O?O.storage:null,L?L.storage:null,$,this.logService),te={content:null,local:H,remote:Y,localChange:Object.keys(H.added).length>0||Object.keys(H.updated).length>0||H.removed.length>0?2:0,remoteChange:Y!==null?2:0},q=i(N,!1);return[{baseResource:this.baseResource,baseContent:L?i(L,!1):q,localResource:this.localResource,localContent:q,localUserData:N,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async hasRemoteChanged(R){const M=R.syncData?JSON.parse(R.syncData.content):null;if(M===null)return!0;const F=await this.getLocalGlobalState(),O=this.getStorageKeys(M),{remote:L}=(0,f.merge)(F.storage,M.storage,M.storage,O,this.logService);return L!==null}async getMergeResult(R,M){return{...R.previewResult,hasConflicts:!1}}async getAcceptResult(R,M,F,O){if(this.extUri.isEqual(M,this.localResource))return this.acceptLocal(R);if(this.extUri.isEqual(M,this.remoteResource))return this.acceptRemote(R);if(this.extUri.isEqual(M,this.previewResource))return R.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async acceptLocal(R){return{content:R.localContent,local:{added:{},removed:[],updated:{}},remote:R.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(R){if(R.remoteContent!==null){const M=JSON.parse(R.remoteContent),{local:F,remote:O}=(0,f.merge)(R.localUserData.storage,M.storage,null,R.storageKeys,this.logService);return{content:R.remoteContent,local:F,remote:O,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:R.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(R,M,F,O){const{localUserData:L}=F[0][0],{local:N,remote:$,localChange:H,remoteChange:Y}=F[0][1];if(H===0&&Y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),H!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(L)),await this.writeLocalGlobalState(N),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),Y!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const te=JSON.stringify({storage:$});R=await this.updateRemoteUserData(te,O?null:R.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}M?.ref!==R.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(R),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:R}){return[{resource:this.extUri.joinPath(R,"globalState.json"),comparableResource:mt.GLOBAL_STATE_DATA_URI}]}async resolveContent(R){if(this.extUri.isEqual(R,mt.GLOBAL_STATE_DATA_URI)){const F=await this.getLocalGlobalState();return i(F,!0)}if(this.extUri.isEqual(this.remoteResource,R)||this.extUri.isEqual(this.baseResource,R)||this.extUri.isEqual(this.localResource,R)||this.extUri.isEqual(this.acceptedResource,R)){const F=await this.resolvePreviewContent(R);return F&&i(JSON.parse(F),!0)}let M=await super.resolveContent(R);if(M)return M;if(M=await super.resolveContent(this.extUri.dirname(R)),M){const F=this.parseSyncData(M);if(F)switch(this.extUri.basename(R)){case"globalState.json":return i(JSON.parse(F.content),!0)}}return null}async hasLocalData(){try{const{storage:R}=await this.getLocalGlobalState();if(Object.keys(R).length>1||R[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const R={},M=await this.getLocalArgvContent(),F=(0,T.parse)(M);for(const O of t)F[O]!==void 0&&(R[`${r}${O}`]={version:1,value:F[O]});for(const O of this.storageService.keys(0,0)){const L=this.storageService.get(O,0);L&&(R[O]={version:1,value:L})}return{storage:R}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const R=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),R.value.toString()}catch(R){this.logService.debug((0,n.getErrorMessage)(R))}return"{}"}async writeLocalGlobalState({added:R,removed:M,updated:F}){const O={},L={},N=(H,Y)=>{for(const te of H){if(te.startsWith(r)){O[te.substring(r.length)]=Y?Y[te].value:void 0;continue}if(Y){const q=Y[te];q.value!==String(this.storageService.get(te,0))&&(L[te]=q.value)}else this.storageService.get(te,0)!==void 0&&(L[te]=void 0)}};if(N(Object.keys(R),R),N(Object.keys(F),F),N(M),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(L).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const H of Object.keys(L))this.storageService.store(H,L[H],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(L))}}async updateArgv(R){const M=await this.getLocalArgvContent();let F=M;for(const O of Object.keys(R))F=(0,u.edit)(F,[O],R[O],{});M!==F&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(F)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(R){const M=this.storageService.keys(0,0),F=this.storageService.keys(0,1),O=[...M,...F],L=R?.storage?Object.keys(R.storage).filter(N=>!N.startsWith(r)&&!O.includes(N)&&this.storageService.get(N,0)!==void 0):[];if(!b.isWeb){const N=[...c.ALL_SYNC_RESOURCES.map($=>(0,c.getEnablementKey)($)),c.SYNC_SERVICE_URL_TYPE];L.push(...N),F.push(...N)}return{user:M,machine:F,unregistered:L}}};l.GLOBAL_STATE_DATA_URI=P.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),l=me([G(0,m.IFileService),G(1,c.IUserDataSyncStoreService),G(2,c.IUserDataSyncBackupStoreService),G(3,c.IUserDataSyncLogService),G(4,w.IEnvironmentService),G(5,c.IUserDataSyncEnablementService),G(6,C.ITelemetryService),G(7,E.IConfigurationService),G(8,S.IStorageService),G(9,p.IUriIdentityService)],l),e.GlobalStateSynchroniser=l;let a=class extends g.AbstractInitializer{constructor(R,M,F,O,L,N){super("globalState",F,O,L,M,N);this.storageService=R}async doInitialize(R){const M=R.syncData?JSON.parse(R.syncData.content):null;if(!M){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const F={},O={};for(const L of Object.keys(M.storage))L.startsWith(r)?F[L.substring(r.length)]=M.storage[L].value:this.storageService.get(L,0)===void 0&&(O[L]=M.storage[L].value);if(Object.keys(F).length){let L="{}";try{L=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const N of Object.keys(F))L=(0,u.edit)(L,[N],F[N],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(L))}if(Object.keys(O).length)for(const L of Object.keys(O))this.storageService.store(L,O[L],0,0)}};a=me([G(0,S.IStorageService),G(1,m.IFileService),G(2,s.IUserDataProfilesService),G(3,w.IEnvironmentService),G(4,c.IUserDataSyncLogService),G(5,p.IUriIdentityService)],a),e.GlobalStateInitializer=a;let h=class{constructor(R,M,F,O,L){this.userDataSyncStoreClient=R,this.storageService=M,this.environmentService=F,this.fileService=O,this.logService=L}getSyncStoreType(R){return this.parseGlobalState(R)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(R){const M=(0,c.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(R,M)}catch(F){if(F instanceof c.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(R,M)}throw F}}async doSync(R,M){const F=await this.userDataSyncStoreClient.readResource("globalState",null,M),O=this.parseGlobalState(F)||{storage:{}};O.storage[c.SYNC_SERVICE_URL_TYPE]={value:R,version:o};const L=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),N={version:o,machineId:L,content:i(O,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(N),F.ref,M)}parseGlobalState({content:R}){if(!R)return null;const M=JSON.parse(R);if((0,g.isSyncData)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};h=me([G(1,S.IStorageService),G(2,w.IEnvironmentService),G(3,m.IFileService),G(4,y.ILogService)],h),e.UserDataSyncStoreTypeSynchronizer=h}),define(ne[258],se([0,1,18,16,3,35,4,14,159,19,15,13,23,22,33,28,45,237,26]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function u(s,r,t){try{const i=JSON.parse(s);if(!r)return(0,b.isUndefined)(i.all)?null:i.all;switch(A.OS){case 2:return(0,b.isUndefined)(i.mac)?null:i.mac;case 3:return(0,b.isUndefined)(i.linux)?null:i.linux;case 1:return(0,b.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=u;let f=class extends C.AbstractJsonFileSynchroniser{constructor(r,t,i,o,l,a,h,v,R,M,F,O){super(h.defaultProfile.keybindingsResource,"keybindings",a,v,R,r,t,l,F,i,M,o,O);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(o.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,t,i,o){const l=r.syncData?u(r.syncData.content,o.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&i?r:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,h=await this.getLocalFileContent(),v=await this.getFormattingOptions();let R=null,M=!1,F=!1,O=!1;if(l){let $=h?h.value.toString():"[]";if($=$||"[]",this.hasErrors($,!0))throw new g.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==$||a!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const H=await(0,p.merge)($,l,a,v,this.userDataSyncUtilService);H.hasChanges&&(R=H.mergeContent,O=H.hasConflicts,M=O||H.mergeContent!==$,F=O||H.mergeContent!==l)}}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),R=h.value.toString(),F=!0);const L={content:R,localChange:M?h?2:1:0,remoteChange:F?2:0,hasConflicts:O},N=h?h.value.toString():null;return[{fileContent:h,baseResource:this.baseResource,baseContent:a!==null?a:N,localResource:this.localResource,localContent:N,localChange:L.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:L.remoteChange,previewResource:this.previewResource,previewResult:L,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const t=this.getKeybindingsContentFromLastSyncUserData(r);if(t===null)return!0;const i=await this.getLocalFileContent(),o=i?i.value.toString():"",l=await this.getFormattingOptions(),a=await(0,p.merge)(o||"[]",t,t,l,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==t}async getMergeResult(r,t){return r.previewResult}async getAcceptResult(r,t,i,o){if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,o){const{fileContent:l}=i[0][0];let{content:a,localChange:h,remoteChange:v}=i[0][1];if(h===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new g.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),l&&await this.backupLocal(this.toSyncContent(l.value.toString())),await this.updateLocalFileContent(a||"[]",l,o),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),v!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const R=this.toSyncContent(a||"[]",r.syncData?.content);r=await this.updateRemoteUserData(R,o?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=(0,T.parse)(r.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.baseResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return u(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:u(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(o){this.logService.error(o)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,A.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=me([G(0,g.IUserDataSyncStoreService),G(1,g.IUserDataSyncBackupStoreService),G(2,g.IUserDataSyncLogService),G(3,I.IConfigurationService),G(4,g.IUserDataSyncEnablementService),G(5,w.IFileService),G(6,S.IUserDataProfilesService),G(7,E.IEnvironmentService),G(8,m.IStorageService),G(9,g.IUserDataSyncUtilService),G(10,y.ITelemetryService),G(11,d.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let c=class extends C.AbstractInitializer{constructor(r,t,i,o,l){super("keybindings",t,i,o,r,l)}async doInitialize(r){const t=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,n.VSBuffer.fromString(t)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,T.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return u(r,!0,this.logService)}catch(t){return this.logService.error(t),null}}};c=me([G(0,w.IFileService),G(1,S.IUserDataProfilesService),G(2,E.IEnvironmentService),G(3,g.IUserDataSyncLogService),G(4,d.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(ne[259],se([0,1,16,3,160,19,68,15,29,13,23,22,33,28,45,59,240,26]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function u(s){const r=JSON.parse(s);return g(r)?r:{settings:s}}e.parseSettingsSyncContent=u;let f=class extends d.AbstractJsonFileSynchroniser{constructor(r,t,i,o,l,a,h,v,R,M,F,O,L){super(t.defaultProfile.settingsResource,"settings",r,i,o,l,a,M,F,h,v,R,L);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,t),o=this.getSettingsSyncContent(i),l=new A.ConfigurationModelParser(p.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&l.parse(o.settings),l.configurationModel.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,t,i){const o=await this.getLocalFileContent(),l=await this.getFormattingOptions(),a=this.getSettingsSyncContent(r);t=t===null&&i?r:t;const h=t?this.getSettingsSyncContent(t):null,v=await this.getIgnoredSettings();let R=null,M=!1,F=!1,O=!1;if(a){let $=o?o.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const H=(0,C.merge)($,a.settings,h?h.settings:null,v,[],l);R=H.localContent||H.remoteContent,M=H.localContent!==null,F=H.remoteContent!==null,O=H.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),R=o.value.toString().trim()||"{}",this.validateContent(R),F=!0);const L={content:R,localChange:M?2:0,remoteChange:F?2:0,hasConflicts:O},N=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:h?h.settings:N,localResource:this.localResource,localContent:N,localChange:L.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:L.remoteChange,previewResource:this.previewResource,previewResult:L,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const t=this.getSettingsSyncContent(r);if(t===null)return!0;const i=await this.getLocalFileContent(),o=i?i.value.toString().trim():"",l=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,C.merge)(o||"{}",t.settings,t.settings,l,[],a).remoteContent!==null}async getMergeResult(r,t){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,C.updateIgnoredSettings)(r.previewResult.content,"{}",o,i):null}}async getAcceptResult(r,t,i,o){const l=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?(0,C.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",a,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,C.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",a,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,C.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",a,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,o){const{fileContent:l}=i[0][0];let{content:a,localChange:h,remoteChange:v}=i[0][1];if(h===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(a,l,o),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),v!==0){const R=await this.getFormattingOptions(),M=this.getSettingsSyncContent(r),F=await this.getIgnoredSettings(a);a=(0,C.updateIgnoredSettings)(a,M?M.settings:"{}",F,R),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),o?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=await this.getFormattingOptions(),i=(0,S.edit)(r.value.toString(),[p.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,C.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)||this.extUri.isEqual(this.baseResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const i=this.parseSyncData(t);if(i){const o=this.parseSettingsSyncContent(i.content);if(o)switch(this.extUri.basename(r)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(r){let t=await super.resolvePreviewContent(r);if(t){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();t=(0,C.updateIgnoredSettings)(t,"{}",o,i)}return t}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return u(r)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:l})=>!!l)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,C.getIgnoredSettings)(t,this.configurationService,r)}validateContent(r){if(this.hasErrors(r,!1))throw new p.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};f=me([G(0,I.IFileService),G(1,y.IUserDataProfilesService),G(2,b.IEnvironmentService),G(3,E.IStorageService),G(4,p.IUserDataSyncStoreService),G(5,p.IUserDataSyncBackupStoreService),G(6,p.IUserDataSyncLogService),G(7,p.IUserDataSyncUtilService),G(8,T.IConfigurationService),G(9,p.IUserDataSyncEnablementService),G(10,w.ITelemetryService),G(11,P.IExtensionManagementService),G(12,m.IUriIdentityService)],f),e.SettingsSynchroniser=f;let c=class extends d.AbstractInitializer{constructor(r,t,i,o,l){super("settings",t,i,o,r,l)}async doInitialize(r){const t=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,C.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return u(r)}catch(t){this.logService.error(t)}return null}};c=me([G(0,I.IFileService),G(1,y.IUserDataProfilesService),G(2,b.IEnvironmentService),G(3,p.IUserDataSyncLogService),G(4,m.IUriIdentityService)],c),e.SettingsInitializer=c}),define(ne[260],se([0,1,16,3,31,19,15,13,23,22,33,28,45,238,26]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends m.AbstractSynchroniser{constructor(g,u,f,c,s,r,t,i,o,l,a){super("snippets",u,g,c,s,r,o,l,t,i,a);this.version=1,this.snippetsFolder=f.defaultProfile.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,h=>h.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,u,f){const c=await this.getSnippetsFileContents(),s=this.toSnippetsContents(c),r=g.syncData?this.parseSnippets(g.syncData):null;u=u===null&&f?g:u;const t=u&&u.syncData?this.parseSnippets(u.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,y.merge)(s,r,t);return this.getResourcePreviews(i,c,r||{},t||{})}async hasRemoteChanged(g){const u=g.syncData?this.parseSnippets(g.syncData):null;if(u===null)return!0;const f=await this.getSnippetsFileContents(),c=this.toSnippetsContents(f),s=(0,y.merge)(c,u,u);return Object.keys(s.remote.added).length>0||Object.keys(s.remote.updated).length>0||s.remote.removed.length>0||s.conflicts.length>0}async getMergeResult(g,u){return g.previewResult}async getAcceptResult(g,u,f,c){if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder))return f===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:f,localChange:f===null?g.fileContent!==null?3:0:2,remoteChange:f===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async applyResult(g,u,f,c){const s=f.map(([r,t])=>({...r,acceptResult:t}));s.every(({localChange:r,remoteChange:t})=>r===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,c)),s.some(({remoteChange:r})=>r!==0)&&(g=await this.updateRemoteSnippets(s,g,c)),u?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of s)try{await this.fileService.del(r)}catch{}}getResourcePreviews(g,u,f,c){const s=new Map;for(const r of Object.keys(g.local.added)){const t={content:g.local.added[r],hasConflicts:!1,localChange:1,remoteChange:0};s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.local.updated)){const t={content:g.local.updated[r],hasConflicts:!1,localChange:2,remoteChange:0},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.remote.added)){const t={content:g.remote.added[r],hasConflicts:!1,localChange:0,remoteChange:1},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.remote.updated)){const t={content:g.remote.updated[r],hasConflicts:!1,localChange:0,remoteChange:2},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.conflicts){const t={content:u[r]?u[r].value.toString():null,hasConflicts:!0,localChange:u[r]?2:1,remoteChange:f[r]?2:1},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(u))if(!s.has(r)){const t={content:u[r]?u[r].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...s.values()]}async getAssociatedResources({uri:g}){const u=await super.resolveContent(g);if(u){const f=this.parseSyncData(u);if(f){const c=this.parseSnippets(f),s=[];for(const r of Object.keys(c)){const t=this.extUri.joinPath(g,r),i=this.extUri.joinPath(this.snippetsFolder,r),o=await this.fileService.exists(i);s.push({resource:t,comparableResource:o?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let u=await super.resolveContent(g);if(u)return u;if(u=await super.resolveContent(this.extUri.dirname(g)),u){const f=this.parseSyncData(u);if(f)return this.parseSnippets(f)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const u={};for(const f of g)f.fileContent&&(u[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(u)))}async updateLocalSnippets(g,u){for(const{fileContent:f,acceptResult:c,localResource:s,remoteResource:r,localChange:t}of g)if(t!==0){const i=r?this.extUri.basename(r):this.extUri.basename(s),o=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,D.VSBuffer.fromString(c.content),{overwrite:u}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,D.VSBuffer.fromString(c.content),u?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(g,u,f){const c=u.syncData?this.parseSnippets(u.syncData):{},s=(0,k.deepClone)(c);for(const{acceptResult:r,localResource:t,remoteResource:i,remoteChange:o}of g)if(o!==0){const l=t?this.extUri.basename(t):this.extUri.basename(i);o===3?delete s[l]:s[l]=r.content}return(0,y.areSame)(c,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),u=await this.updateRemoteUserData(JSON.stringify(s),f?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),u}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const u={};for(const f of Object.keys(g))u[f]=g[f].value.toString();return u}async getSnippetsFileContents(){const g={};let u;try{u=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof b.FileOperationError&&f.fileOperationResult===1)return g;throw f}for(const f of u.children||[]){const c=f.resource,s=this.extUri.extname(c);if(s===".json"||s===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,c),t=await this.fileService.readFile(c);g[r]=t}}return g}};S=me([G(0,A.IEnvironmentService),G(1,b.IFileService),G(2,w.IUserDataProfilesService),G(3,P.IStorageService),G(4,d.IUserDataSyncStoreService),G(5,d.IUserDataSyncBackupStoreService),G(6,d.IUserDataSyncLogService),G(7,T.IConfigurationService),G(8,d.IUserDataSyncEnablementService),G(9,I.ITelemetryService),G(10,E.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let C=class extends m.AbstractInitializer{constructor(g,u,f,c,s){super("snippets",u,f,c,g,s)}async doInitialize(g){const u=g.syncData?JSON.parse(g.syncData.content):null;if(!u){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(u)){const s=u[c];if(s){const r=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,c);await this.fileService.createFile(r,D.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};C=me([G(0,b.IFileService),G(1,w.IUserDataProfilesService),G(2,A.IEnvironmentService),G(3,d.IUserDataSyncLogService),G(4,E.IUriIdentityService)],C),e.SnippetsInitializer=C}),define(ne[261],se([0,1,16,19,15,13,23,22,33,28,45,26]),function(Q,e,D,n,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(C,p){try{return JSON.parse(C).tasks}catch(g){return p.error(g),null}}e.getTasksContentFromSyncContent=m;let y=class extends E.AbstractFileSynchroniser{constructor(p,g,u,f,c,s,r,t,i,o,l){super(l.defaultProfile.tasksResource,"tasks",s,r,t,p,g,c,i,u,f,o);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(p,g,u,f){const c=p.syncData?m(p.syncData.content,this.logService):null;g=g===null&&u?p:g;const s=g?.syncData?m(g.syncData.content,this.logService):null,r=await this.getLocalFileContent();let t=null,i=!1,o=!1,l=!1;if(c){const v=r?r.value.toString():null;if(!s||s!==v||s!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const R=S(v,c,s);t=R.content,l=R.hasConflicts,i=R.hasLocalChanged,o=R.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),o=!0);const a={content:t,localChange:i?r?2:1:0,remoteChange:o?2:0,hasConflicts:l},h=r?r.value.toString():null;return[{fileContent:r,baseResource:this.baseResource,baseContent:s!==null?s:h,localResource:this.localResource,localContent:h,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(p){const g=p?.syncData?m(p.syncData.content,this.logService):null;if(g===null)return!0;const u=await this.getLocalFileContent(),f=u?u.value.toString():null,c=S(f,g,g);return c.hasLocalChanged||c.hasRemoteChanged}async getMergeResult(p,g){return p.previewResult}async getAcceptResult(p,g,u,f){if(this.extUri.isEqual(g,this.localResource))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:p.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return u===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(p,g,u,f){const{fileContent:c}=u[0][0],{content:s,localChange:r,remoteChange:t}=u[0][1];if(r===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),c&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(c.value.toString()))),await this.updateLocalFileContent(s||"{}",c,f),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(s||"{}"));p=await this.updateRemoteUserData(i,f?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:p}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(p,"tasks.json"),comparableResource:g}]}async resolveContent(p){if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.baseResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p))return this.resolvePreviewContent(p);let g=await super.resolveContent(p);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(p)),g){const u=this.parseSyncData(g);if(u)switch(this.extUri.basename(p)){case"tasks.json":return m(u.content,this.logService)}}return null}toTasksSyncContent(p){return{tasks:p}}};y=me([G(0,w.IUserDataSyncStoreService),G(1,w.IUserDataSyncBackupStoreService),G(2,w.IUserDataSyncLogService),G(3,n.IConfigurationService),G(4,w.IUserDataSyncEnablementService),G(5,T.IFileService),G(6,k.IEnvironmentService),G(7,A.IStorageService),G(8,b.ITelemetryService),G(9,P.IUriIdentityService),G(10,I.IUserDataProfilesService)],y),e.TasksSynchroniser=y;let d=class extends E.AbstractInitializer{constructor(p,g,u,f,c){super("tasks",g,u,f,p,c);this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(p){const g=p.syncData?m(p.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(g)),await this.updateLastSyncUserData(p)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};d=me([G(0,T.IFileService),G(1,I.IUserDataProfilesService),G(2,k.IEnvironmentService),G(3,w.IUserDataSyncLogService),G(4,P.IUriIdentityService)],d),e.TasksInitializer=d;function S(C,p,g){if(C===null&&p===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(C===p)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=g!==C,f=g!==p;return!u&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!f?{content:C,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!u?{content:p,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:C,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[262],se([0,1,3,2,4,15,23,22,26]),function(Q,e,D,n,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const I="sync.enable";let E=class extends n.Disposable{constructor(m,y,d,S){super();this.storageService=m,this.telemetryService=y,this.environmentService=d,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(m.onDidChangeValue(C=>this.onDidStorageChange(C)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(I,{enabled:m}),this.storageService.store(I,m,-1,1))}isResourceEnabled(m){return this.storageService.getBoolean((0,P.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,y){if(this.isResourceEnabled(m)!==y){const d=(0,P.getEnablementKey)(m);this.storeResourceEnablement(d,y)}}getResourceSyncStateVersion(m){}storeResourceEnablement(m,y){this.storageService.store(m,y,-1,k.isWeb?0:1)}onDidStorageChange(m){if(m.scope!==-1)return;if(I===m.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=P.ALL_SYNC_RESOURCES.filter(d=>(0,P.getEnablementKey)(d)===m.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};E=me([G(0,A.IStorageService),G(1,b.ITelemetryService),G(2,T.IEnvironmentService),G(3,P.IUserDataSyncStoreManagementService)],E),e.UserDataSyncEnablementService=E}),define(ne[73],se([0,1,3,2,4,24,163,15,13,5,25,47,23,26]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,I.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",S="Safari",C="Chrome",p="Edge",g="Firefox",u="Android";function f(r){switch(r){case S:case C:case p:case g:case u:case(0,k.PlatformToString)(0):return!0}return!1}e.isWebPlatform=f;function c(){return k.isSafari?S:k.isChrome?C:k.isEdge?p:k.isFirefox?g:k.isAndroid?u:(0,k.PlatformToString)(k.isWeb?0:k.platform)}let s=class tt extends n.Disposable{constructor(t,i,o,l,a,h){super();this.storageService=o,this.userDataSyncStoreService=l,this.logService=a,this.productService=h,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(t,i,o)}async getMachines(t){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(l=>({...l,isCurrent:l.id===i}))}async addCurrentMachine(t){const i=await this.currentMachineIdPromise,o=await this.readMachinesData(t);o.machines.some(({id:l})=>l===i)||(o.machines.push({id:i,name:this.computeCurrentMachineName(o.machines),platform:c()}),await this.writeMachinesData(o))}async removeCurrentMachine(t){const i=await this.currentMachineIdPromise,o=await this.readMachinesData(t),l=o.machines.filter(({id:a})=>a!==i);l.length!==o.machines.length&&(o.machines=l,await this.writeMachinesData(o))}async renameMachine(t,i,o){const l=await this.readMachinesData(o),a=l.machines.find(({id:h})=>h===t);if(a){a.name=i,await this.writeMachinesData(l);const h=await this.currentMachineIdPromise;t===h&&this.storageService.store(d,i,-1,1)}}async setEnablements(t){const i=await this.readMachinesData();for(const[o,l]of t){const a=i.machines.find(h=>h.id===o);a&&(a.disabled=l?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(t){const i=this.storageService.get(d,-1);if(i)return i;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${c()} (${this.productService.nameShort})`,l=new RegExp(`${(0,T.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const h of t){const v=l.exec(h.name),R=v?parseInt(v[1]):0;a=R>a?R:a}return`${o} #${a+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const i=this.parse(this.userData);if(i.version!==tt.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(t){const i=JSON.stringify(t),o=await this.userDataSyncStoreService.write(tt.RESOURCE,i,this.userData?.ref||null);this.userData={ref:o,content:i},this._onDidChange.fire()}async readUserData(t){if(this.userData){const i=t&&t.latest?t.latest[tt.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(tt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.logService.error(i)}return{version:tt.VERSION,machines:[]}}};s.VERSION=1,s.RESOURCE="machines",s=me([G(0,b.IEnvironmentService),G(1,P.IFileService),G(2,m.IStorageService),G(3,y.IUserDataSyncStoreService),G(4,y.IUserDataSyncLogService),G(5,E.IProductService)],s),e.UserDataSyncMachinesService=s}),define(ne[263],se([0,1,6,61,38,10,3,2,4,17,7,161,25,23,22,26,70,73]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",u="sync.sessionId",f="sync.storeUrl",c="sync.productQuality";let s=class extends b.Disposable{constructor(i,o,l,a,h,v,R,M,F,O){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=l,this.userDataSyncEnablementService=a,this.userDataSyncService=h,this.logService=v,this.userDataSyncAccountService=R,this.telemetryService=M,this.userDataSyncMachinesService=F,this.storageService=O,this.autoSync=this._register(new b.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(R.onDidChangeAccount(()=>this.updateAutoSync())),this._register(l.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(h.onDidChangeLocal(L=>this.triggerSync([L],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,L])=>L)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const i=this.storageService.get(f,-1);return i?E.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(f,i.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(c,-1)}set productQuality(i){i?this.storageService.store(c,i,-1,1):this.storageService.remove(c,-1)}updateAutoSync(){const{enabled:i,message:o}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(l=>this.onDidFinishSync(l))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,o,l){try{this.userDataSyncAccountService.account&&!l&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(u,-1),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(o)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const o=S.UserDataSyncError.toUserDataSyncError(i);o instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?P.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(i,o,l){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",l)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};s=me([G(0,m.IProductService),G(1,S.IUserDataSyncStoreManagementService),G(2,S.IUserDataSyncStoreService),G(3,S.IUserDataSyncEnablementService),G(4,S.IUserDataSyncService),G(5,S.IUserDataSyncLogService),G(6,C.IUserDataSyncAccountService),G(7,d.ITelemetryService),G(8,p.IUserDataSyncMachinesService),G(9,y.IStorageService)],s),e.UserDataAutoSyncService=s;class r extends b.Disposable{constructor(i,o,l,a,h,v,R,M){super();this.lastSyncUrl=i,this.interval=o,this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=a,this.userDataSyncService=h,this.userDataSyncMachinesService=v,this.logService=R,this.storageService=M,this.intervalHandler=this._register(new b.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,b.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(r.INTERVAL_SYNCING,!1),this.interval)}sync(i,o){const l=(0,D.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,T.isCancellationError)(h))return}return this.doSync(i,o,a)});return this.syncPromise=l,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!i&&(!(0,I.isEqual)(o.defaultUrl,i.defaultUrl)||!(0,I.isEqual)(o.insidersUrl,i.insidersUrl)||!(0,I.isEqual)(o.stableUrl,i.stableUrl))}async doSync(i,o,l){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),l.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const h=this.storageService.get(u,-1);if(h&&this.manifest&&h!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const v=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(l.isCancellationRequested)return;const R=v.find(M=>M.isCurrent);if(R?.disabled)throw new S.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(M){throw new S.UserDataAutoSyncError((0,k.toErrorMessage)(M),M instanceof S.UserDataSyncError?M.code:"Unknown")}if(this.manifest&&this.manifest.session!==h&&this.storageService.store(u,this.manifest.session,-1,1),l.isCancellationRequested)return;R||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(h){this.logService.error(h),a=h}this._onDidFinishSync.fire(a)}register(i){return super._register(i)}}r.INTERVAL_SYNCING="Interval"}),define(ne[264],se([0,1,18,6,38,3,2,17,14,30,19,29,5,23,22,256,257,258,259,260,261,26]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g,u,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let r=class extends A.Disposable{constructor(a,h,v,R,M,F,O,L){super();this.userDataSyncStoreService=a,this.userDataSyncStoreManagementService=h,this.instantiationService=v,this.configurationService=R,this.logService=M,this.telemetryService=F,this.storageService=O,this.userDataSyncEnablementService=L,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(s,-1,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(a,h){this.checkEnablement();const v=(0,I.generateUuid)();try{const L=(0,c.createSyncHeaders)(v);h&&(L["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(a,L)}catch(L){const N=c.UserDataSyncError.toUserDataSyncError(L);throw this.reportUserDataSyncError(N,v),N}const R=!1,M=this,F=this.getEnabledSynchronizers();let O;return{manifest:a,async run(){if(R)throw new Error("Can run a task only once");return O=(0,n.createCancelablePromise)(L=>M.sync(F,a,v,L)),O.finally(()=>O=void 0)},async stop(){if(O?.cancel(),M.status!=="idle")return M.stop(F)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new c.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const a=(0,I.generateUuid)(),h=(0,c.createSyncHeaders)(a);let v;try{v=await this.userDataSyncStoreService.manifest(null,h)}catch(F){const O=c.UserDataSyncError.toUserDataSyncError(F);throw this.reportUserDataSyncError(O,a),O}await this.resetLocal();const R=this.getEnabledSynchronizers(),M=async()=>{await this.stop(R),await this.resetLocal()};return new t(a,v,h,R,M,this.configurationService,this.logService)}async sync(a,h,v,R){if(R.isCancellationRequested||!a.length)return;const M=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const F=(0,c.createSyncHeaders)(v);for(const O of a){if(R.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(O.resource))return;try{await O.sync(h,F)}catch(L){let N=!1;if(L instanceof c.UserDataSyncError)switch(L.code){case"TooLarge":L=new c.UserDataSyncError(L.message,L.code,O.resource),N=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":N=!0;break}const $=c.UserDataSyncError.toUserDataSyncError(L);if(this.reportUserDataSyncError($,v),N)throw $;this.logService.error(L),this.logService.error(`${O.resource}: ${(0,k.toErrorMessage)(L)}`),this._syncErrors.push([O.resource,$])}}this.logService.info(`Sync done. Took ${new Date().getTime()-M}ms`),this.updateLastSyncTime()}catch(F){const O=c.UserDataSyncError.toUserDataSyncError(F);throw this.reportUserDataSyncError(O,v),O}finally{this.updateStatus(a),this._onSyncErrors.fire(this._syncErrors)}}async stop(a){if(this.status!=="idle")for(const h of a)try{h.status!=="idle"&&await h.stop()}catch(v){this.logService.error(v)}}async replace(a){this.checkEnablement(),await this.performSynchronizerAction(async h=>{if(await h.replace(a))return!0})}async accept(a,h,v,R){this.checkEnablement(),await this.performSynchronizerAction(async M=>{if(M.resource===a)return await M.accept(h,v),R&&await M.apply(!1,(0,c.createSyncHeaders)((0,I.generateUuid)())),!0})}async resolveContent(a){return this.performSynchronizerAction(async h=>{const v=await h.resolveContent(a);if(v)return v})}async getRemoteSyncResourceHandles(a){return await this.performSynchronizerAction(async v=>{if(v.resource===a)return v.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(a){return await this.performSynchronizerAction(async v=>{if(v.resource===a)return v.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(a,h){return await this.performSynchronizerAction(async R=>{if(R.resource===a)return R.getAssociatedResources(h)})||[]}async getMachineId(a,h){return await this.performSynchronizerAction(async R=>{if(R.resource===a)return await R.getMachineId(h)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async h=>{if(h.resource!=="globalState"&&await h.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async h=>{if(await h.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(a){this.logService.error(a)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(s,-1),this.synchronizers.value){for(const a of this.synchronizers.value.enabled)try{await a.resetLocal()}catch(h){this.logService.error(`${a.resource}: ${(0,k.toErrorMessage)(h)}`),this.logService.error(h)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(a){const h=new A.DisposableStore;try{const v=this.synchronizers.value||h.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),R=[...v.enabled,...v.disabled.map(M=>h.add(v.createSynchronizer(M)))];for(const M of R){const F=await a(M);if(!(0,P.isUndefined)(F))return F}return null}finally{h.dispose()}}setStatus(a){const h=this._status;this._status!==a&&(this._status=a,this._onDidChangeStatus.fire(a),h==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(a){this.updateConflicts(a);const h=this.computeStatus(a);this.setStatus(h)}updateConflicts(a){const h=this.computeConflicts(a);(0,D.equals)(this._conflicts,h,([v,R],[M,F])=>v===v&&(0,D.equals)(R,F,(O,L)=>(0,b.isEqual)(O.previewResource,L.previewResource)))||(this._conflicts=this.computeConflicts(a),this._onDidChangeConflicts.fire(h))}computeConflicts(a){return a.filter(h=>h.status==="hasConflicts").map(h=>[h.resource,h.conflicts.map(o)])}computeStatus(a){return this.userDataSyncStoreManagementService.userDataSyncStore?a.some(h=>h.status==="hasConflicts")?"hasConflicts":a.some(h=>h.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(s,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(a,h){this.telemetryService.publicLog2("sync/error",{code:a.code,serverCode:a instanceof c.UserDataSyncStoreError?String(a.serverCode):void 0,url:a instanceof c.UserDataSyncStoreError?a.url:void 0,resource:a.resource,executionId:h,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,a=>this.updateStatus(a),a=>this.updateConflicts(a),a=>this._onDidChangeLocal.fire(a))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=me([G(0,c.IUserDataSyncStoreService),G(1,c.IUserDataSyncStoreManagementService),G(2,m.IInstantiationService),G(3,E.IConfigurationService),G(4,c.IUserDataSyncLogService),G(5,d.ITelemetryService),G(6,y.IStorageService),G(7,c.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class t extends A.Disposable{constructor(a,h,v,R,M,F,O){super();this.id=a,this.manifest=h,this.syncHeaders=v,this.synchronisers=R,this.onStop=M,this.configurationService=F,this.logService=O,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(a=>this.getPreviews(a))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(a){throw this.logService.error(a),a}}async accept(a,h){try{return await this.performAction(a,v=>v.accept(a,h))}catch(v){throw this.logService.error(v),v}}async merge(a){try{return a?await this.performAction(a,h=>h.merge(a)):await this.mergeAll()}catch(h){throw this.logService.error(h),h}}async discard(a){try{return await this.performAction(a,h=>h.discard(a))}catch(h){throw this.logService.error(h),h}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const a=[];for(const[,h]of this.previews)for(const v of h.resourcePreviews)v.mergeState==="conflict"&&a.push(v.previewResource);for(const h of a)await this.discard(h);return this.previews}catch(a){throw this.logService.error(a),a}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const a=[];for(const[h,v]of this.previews){this.synchronizingResources.push([h,v.resourcePreviews.map(F=>F.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const R=this.synchronisers.find(F=>F.resource===h);for(const F of v.resourcePreviews)(F.localChange!==0||F.remoteChange!==0)&&F.mergeState==="preview"&&await R.merge(F.previewResource);const M=await R.apply(!1,this.syncHeaders);M&&a.push(this.toSyncResourcePreview(R.resource,M)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(F=>F[0]===h),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}catch(a){throw this.logService.error(a),a}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(R=>R.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(R=>R.resource===a);for(const R of h.resourcePreviews)await v.accept(R.remoteResource);await v.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(R=>R[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(R=>R.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(R=>R.resource===a);for(const R of h.resourcePreviews)await v.accept(R.localResource);await v.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(R=>R[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async stop(){await this.onStop(),this.reset()}async performAction(a,h){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const v=this.previews.findIndex(([,H])=>H.resourcePreviews.some(({localResource:Y,previewResource:te,remoteResource:q})=>(0,b.isEqual)(a,Y)||(0,b.isEqual)(a,te)||(0,b.isEqual)(a,q)));if(v===-1)return this.previews;const[R,M]=this.previews[v],F=M.resourcePreviews.find(({localResource:H,remoteResource:Y,previewResource:te})=>(0,b.isEqual)(H,a)||(0,b.isEqual)(Y,a)||(0,b.isEqual)(te,a));if(!F)return this.previews;let O=this.synchronizingResources.find(H=>H[0]===R);O||(O=[R,[]],this.synchronizingResources.push(O)),O[1].some(H=>(0,b.isEqual)(H,F.localResource))||(O[1].push(F.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const L=this.synchronisers.find(H=>H.resource===this.previews[v][0]),N=await h(L);N?this.previews.splice(v,1,this.toSyncResourcePreview(L.resource,N)):this.previews.splice(v,1);const $=this.synchronizingResources.findIndex(H=>H[0]===R);return this.synchronizingResources[$][1].splice(O[1].findIndex(H=>(0,b.isEqual)(H,F.localResource)),1),O[1].length||(this.synchronizingResources.splice($,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const a=[];for(const[h,v]of this.previews){this.synchronizingResources.push([h,v.resourcePreviews.map(F=>F.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const R=this.synchronisers.find(F=>F.resource===h);let M=v;for(const F of v.resourcePreviews)(F.localChange!==0||F.remoteChange!==0)&&F.mergeState==="preview"&&(M=await R.merge(F.previewResource));M&&a.push(this.toSyncResourcePreview(R.resource,M)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(F=>F[0]===h),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}async getPreviews(a){const h=[],v=await this.getUserDataSyncConfiguration();for(const R of this.synchronisers){if(a.isCancellationRequested)return[];const M=await R.preview(this.manifest,v,this.syncHeaders);M&&h.push(this.toSyncResourcePreview(R.resource,M))}return h}async getUserDataSyncConfiguration(){const a=this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE),h=this.synchronisers.find(v=>v instanceof g.SettingsSynchroniser);if(h){const v=await h.getRemoteUserDataSyncConfiguration(this.manifest);return{...a,...v}}return a}toSyncResourcePreview(a,h){return[a,{isLastSyncFromCurrentMachine:h.isLastSyncFromCurrentMachine,resourcePreviews:h.resourcePreviews.map(o)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends A.Disposable{constructor(a,h,v,R,M,F,O){super();this.onDidChangeStatus=a,this.onDidChangeConflicts=h,this.onDidChangeLocal=v,this.userDataSyncEnablementService=R,this.instantiationService=M,this.extensionGalleryService=F,this.logService=O,this._enabled=[],this._register(R.onDidChangeResourceEnablement(([L,N])=>this.onDidChangeResourceEnablement(L,N))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,L])=>L.dispose())));for(const L of c.ALL_SYNC_RESOURCES)R.isResourceEnabled(L)&&this.registerSynchronizer(L)}get enabled(){return this._enabled.sort((a,h)=>a[1]-h[1]).map(([a])=>a)}get disabled(){return c.ALL_SYNC_RESOURCES.filter(a=>!this.userDataSyncEnablementService.isResourceEnabled(a))}onDidChangeResourceEnablement(a,h){h?this.registerSynchronizer(a):this.deRegisterSynchronizer(a)}registerSynchronizer(a){if(this._enabled.some(([M])=>M.resource===a))return;if(a==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const h=new A.DisposableStore,v=h.add(this.createSynchronizer(a));h.add(v.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),h.add(v.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),h.add(v.onDidChangeLocal(()=>this.onDidChangeLocal(a)));const R=this.getOrder(a);this._enabled.push([v,R,h])}deRegisterSynchronizer(a){const h=this._enabled.findIndex(([v])=>v.resource===a);if(h!==-1){const v=this._enabled.splice(h,1);for(const[R,,M]of v){if(R.status!=="idle"){const F=R.conflicts.length>0;R.stop(),F&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}M.dispose()}}}createSynchronizer(a){switch(a){case"settings":return this.instantiationService.createInstance(g.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(p.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(u.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(f.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(C.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(S.ExtensionsSynchroniser)}}getOrder(a){switch(a){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};i=me([G(3,c.IUserDataSyncEnablementService),G(4,m.IInstantiationService),G(5,w.IExtensionGalleryService),G(6,c.IUserDataSyncLogService)],i);function o(l){return{baseResource:l.baseResource,localResource:l.localResource,previewResource:l.previewResource,remoteResource:l.remoteResource,acceptedResource:l.acceptedResource,localChange:l.localChange,remoteChange:l.remoteChange,mergeState:l.mergeState}}}),define(ne[265],se([0,1,6,21,10,3,2,123,4,17,9,14,7,30,19,15,13,25,44,47,23,26]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g,u,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const s="sync.previous.store",r="sync.donot-make-requests-until",t="sync.user-session-id",i="sync.machine-session-id",o=100,l=1e3*60*5;let a=class extends A.Disposable{constructor(O,L,N){super();this.productService=O,this.configurationService=L,this.storageService=N,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(N.onDidChangeValue,$=>$.key===c.SYNC_SERVICE_URL_TYPE&&$.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(O){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,O,-1,P.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,L){O=P.isWeb&&O?.web?{...O,...O.web}:O;const N={...O||{},...L||{}};if(N&&(0,w.isString)(N.url)&&(0,w.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every($=>Array.isArray(N.authenticationProviders[$].scopes))){const $=N,H=!!$.canSwitch&&!L?.url,Y=$.url===$.insidersUrl?"insiders":"stable",te=(H?this.userDataSyncStoreType:void 0)||Y,q=L?.url||(te==="insiders"?$.insidersUrl:te==="stable"?$.stableUrl:$.url);return{url:m.URI.parse(q),type:te,defaultType:Y,defaultUrl:m.URI.parse($.url),stableUrl:m.URI.parse($.stableUrl),insidersUrl:m.URI.parse($.insidersUrl),canSwitch:H,authenticationProviders:Object.keys($.authenticationProviders).reduce((W,x)=>(W.push({id:x,scopes:$.authenticationProviders[x].scopes}),W),[])}}}};a=me([G(0,p.IProductService),G(1,d.IConfigurationService),G(2,f.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let h=class extends a{constructor(O,L,N){super(O,L,N);const $=this.storageService.get(s,-1);$&&(this.previousConfigurationSyncStore=JSON.parse($));const H=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];H?this.storageService.store(s,JSON.stringify(H),-1,1):this.storageService.remove(s,-1)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};h=me([G(0,p.IProductService),G(1,d.IConfigurationService),G(2,f.IStorageService)],h),e.UserDataSyncStoreManagementService=h;let v=class extends A.Disposable{constructor(O,L,N,$,H,Y,te){super();this.requestService=N,this.logService=$,this.storageService=te,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,u.getServiceMachineId)(H,Y,te).then(q=>{const W={"X-Client-Name":`${L.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":L.version};return L.commit&&(W["X-Client-Commit"]=L.commit),W}),this.session=new M(o,l,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,L){this.authToken={token:O,type:L}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,I.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,-1);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(L=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),L).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,L=>null)):this.storageService.remove(r,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllResourceRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O),N={},$=await this.request(L.toString(),{type:"GET",headers:N},[],n.CancellationToken.None);return(await(0,g.asJson)($)||[]).map(({url:Y,created:te})=>({ref:(0,I.relativePath)(L,L.with({path:Y})),created:te*1e3}))}async resolveResourceContent(O,L,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,L).toString();N={...N},N["Cache-Control"]="no-cache";const H=await this.request($,{type:"GET",headers:N},[],n.CancellationToken.None);return await(0,g.asTextOrError)(H)}async deleteResource(O,L){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=L!==null?(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,L).toString():(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),$={};await this.request(N,{type:"DELETE",headers:$},[],n.CancellationToken.None)}async readResource(O,L,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();N={...N},N["Cache-Control"]="no-cache",L&&(N["If-None-Match"]=L.ref);const H=await this.request($,{type:"GET",headers:N},[304],n.CancellationToken.None);let Y=null;if(H.res.statusCode===304&&(Y=L),Y===null){const te=H.res.headers.etag;if(!te)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",H.res.statusCode,H.res.headers[c.HEADER_OPERATION_ID]);const q=await(0,g.asTextOrError)(H);if(!q&&H.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",$,"EmptyResponse",H.res.statusCode,H.res.headers[c.HEADER_OPERATION_ID]);Y={ref:te,content:q}}return Y}async writeResource(O,L,N,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();$={...$},$["Content-Type"]=b.Mimes.text,N&&($["If-Match"]=N);const Y=await this.request(H,{type:"POST",data:L,headers:$},[],n.CancellationToken.None),te=Y.res.headers.etag;if(!te)throw new c.UserDataSyncStoreError("Server did not return the ref",H,"NoRef",Y.res.statusCode,Y.res.headers[c.HEADER_OPERATION_ID]);return te}async manifest(O,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,I.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();L={...L},L["Content-Type"]="application/json",O&&(L["If-None-Match"]=O.ref);const $=await this.request(N,{type:"GET",headers:L},[304],n.CancellationToken.None);let H=null;if($.res.statusCode===304&&(H=O),!H){const te=$.res.headers.etag;if(!te)throw new c.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);const q=await(0,g.asTextOrError)($);if(!q&&$.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",N,"EmptyResponse",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);q&&(H={...JSON.parse(q),ref:te})}const Y=this.storageService.get(t,-1);return Y&&H&&Y!==H.session&&this.clearSession(),H===null&&Y&&this.clearSession(),H&&this.storageService.store(t,H.session,-1,1),H}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),L={"Content-Type":b.Mimes.text};await this.request(O,{type:"DELETE",headers:L},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,-1),this.storageService.remove(i,-1)}async request(O,L,N,$){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const H=await this.commonHeadersPromise;L.headers={...L.headers||{},...H,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(L.headers),this.logService.trace("Sending request to server",{url:O,type:L.type,headers:{...L.headers,authorization:void 0}});let Y;try{Y=await this.session.request(O,L,$)}catch(x){if(!(x instanceof c.UserDataSyncStoreError)){let K="RequestFailed";const ee=(0,k.getErrorMessage)(x).toLowerCase();ee.includes("xhr timeout")?K="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?K="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?K="RequestPathNotEscaped":ee.includes("headers must be an object")?K="RequestHeadersNotObject":(0,k.isCancellationError)(x)&&(K="RequestCanceled"),x=new c.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,K,void 0,void 0)}throw this.logService.info("Request failed",O),x}const te=Y.res.headers[c.HEADER_OPERATION_ID],q={url:O,status:Y.res.statusCode,"execution-id":L.headers[c.HEADER_EXECUTION_ID],"operation-id":te},W=(0,g.isSuccess)(Y)||Y.res.statusCode&&N.indexOf(Y.res.statusCode)!==-1;if(W?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),Y.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",Y.res.statusCode,te);if(this._onTokenSucceed.fire(),Y.res.statusCode===409)throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",Y.res.statusCode,te);if(Y.res.statusCode===410)throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",Y.res.statusCode,te);if(Y.res.statusCode===412)throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",Y.res.statusCode,te);if(Y.res.statusCode===413)throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",Y.res.statusCode,te);if(Y.res.statusCode===426)throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",Y.res.statusCode,te);if(Y.res.statusCode===429){const x=Y.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",Y.res.statusCode,te)):new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",Y.res.statusCode,te)}if(!W)throw new c.UserDataSyncStoreError("Server returned "+Y.res.statusCode,O,"Unknown",Y.res.statusCode,te);return Y}addSessionHeaders(O){let L=this.storageService.get(i,-1);L===void 0&&(L=(0,y.generateUuid)(),this.storageService.store(i,L,-1,1)),O["X-Machine-Session-Id"]=L;const N=this.storageService.get(t,-1);N!==void 0&&(O["X-User-Session-Id"]=N)}};v=me([G(1,p.IProductService),G(2,g.IRequestService),G(3,c.IUserDataSyncLogService),G(4,S.IEnvironmentService),G(5,C.IFileService),G(6,f.IStorageService)],v),e.UserDataSyncStoreClient=v;let R=class extends v{constructor(O,L,N,$,H,Y,te){super(O.userDataSyncStore?.url,L,N,$,H,Y,te);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}getAllRefs(O,L){return this.getAllResourceRefs(L?this.getProfileResource(O,L):O)}read(O,L,N,$){return this.readResource(N?this.getProfileResource(O,N):O,L,$)}write(O,L,N,$,H){return this.writeResource($?this.getProfileResource(O,$):O,L,N,H)}delete(O,L,N){return this.deleteResource(N?this.getProfileResource(O,N):O,L)}resolveContent(O,L,N,$){return this.resolveResourceContent(N?this.getProfileResource(O,N):O,L,$)}getProfileResource(O,L){if(O==="profiles")throw new Error(`Invalid Resource Argument: ${O}`);return(0,E.join)("profiles",L,O)}};R=me([G(0,c.IUserDataSyncStoreManagementService),G(1,p.IProductService),G(2,g.IRequestService),G(3,c.IUserDataSyncLogService),G(4,S.IEnvironmentService),G(5,C.IFileService),G(6,f.IStorageService)],R),e.UserDataSyncStoreService=R;class M{constructor(O,L,N,$){this.limit=O,this.interval=L,this.requestService=N,this.logService=$,this.requests=[],this.startTime=void 0}request(O,L,N){if(this.isExpired()&&this.reset(),L.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(L,N)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=M}),define(ne[266],se([0,1,3,67,25,23,22,263,26,70,73]),function(Q,e,D,n,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends b.UserDataAutoSyncService{constructor(y,d,S,C,p,g,u,f,c,s,r){super(y,d,S,C,p,u,f,c,s,r);this._register(D.Event.debounce(D.Event.any(D.Event.map(g.onDidFocusWindow,()=>"windowFocus"),D.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=me([G(0,k.IProductService),G(1,P.IUserDataSyncStoreManagementService),G(2,P.IUserDataSyncStoreService),G(3,P.IUserDataSyncEnablementService),G(4,P.IUserDataSyncService),G(5,n.INativeHostService),G(6,P.IUserDataSyncLogService),G(7,I.IUserDataSyncAccountService),G(8,A.ITelemetryService),G(9,E.IUserDataSyncMachinesService),G(10,T.IStorageService)],w),e.UserDataAutoSyncService=w}),define(ne[108],se([0,1,53,6,9,14,27,135,275,276]),function(Q,e,D,n,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class E extends Error{constructor(s,r){let t=r.message;switch(s){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t);this.type=s,this.cause=r}}e.ExtractError=E;function w(c){const s=c.externalFileAttributes>>16||33188;return[448,56,7].map(r=>s&r).reduce((r,t)=>r+t,s&61440)}function m(c){if(c instanceof E)return c;let s;return/end of central directory record signature not found/.test(c.message)&&(s="CorruptZip"),new E(s,c)}function y(c,s,r,t,i,o){const l=k.dirname(s),a=k.join(t,l);if(!a.startsWith(t))return Promise.reject(new Error(b.localize(0,null,s)));const h=k.join(t,s);let v;return o.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(A.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((R,M)=>{if(!o.isCancellationRequested)try{v=(0,D.createWriteStream)(h,{mode:r}),v.once("close",()=>R()),v.once("error",M),c.once("error",M),c.pipe(v)}catch(F){M(F)}}))}function d(c,s,r,t){let i=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{i.cancel(),c.close()}),new Promise((l,a)=>{const h=new n.Sequencer,v=R=>{R.isCancellationRequested||(o++,c.readEntry())};c.once("error",a),c.once("close",()=>i.then(()=>{t.isCancellationRequested||c.entryCount===o?l():a(new E("Incomplete",new Error(b.localize(1,null,o,c.entryCount))))},a)),c.readEntry(),c.on("entry",R=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(R.fileName)){v(t);return}const M=R.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(M)){const L=k.join(s,M);i=(0,n.createCancelablePromise)(N=>A.Promises.mkdir(L,{recursive:!0}).then(()=>v(N)).then(void 0,a));return}const F=C(c,R),O=w(R);i=(0,n.createCancelablePromise)(L=>h.queue(()=>F.then(N=>y(N,M,O,s,r,L).then(()=>v(L)))).then(null,a))})})}function S(c,s=!1){return new Promise((r,t)=>{(0,P.open)(c,s?{lazyEntries:!0}:void 0,(i,o)=>{i?t(m(i)):r((0,T.assertIsDefined)(o))})})}function C(c,s){return new Promise((r,t)=>{c.openReadStream(s,(i,o)=>{i?t(m(i)):r((0,T.assertIsDefined)(o))})})}function p(c,s){return new Promise((r,t)=>{const i=new I.ZipFile;s.forEach(l=>{l.contents?i.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&i.addFile(l.localPath,l.path)}),i.end();const o=(0,D.createWriteStream)(c);i.outputStream.pipe(o),i.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>r(c))})}e.zip=p;function g(c,s,r={},t){const i=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=S(c,!0);return r.overwrite&&(o=o.then(l=>A.Promises.rm(s).then(()=>l))),o.then(l=>d(l,s,{sourcePathRegex:i},t))}e.extract=g;function u(c,s){return S(c).then(r=>new Promise((t,i)=>{r.on("entry",o=>{o.fileName===s&&C(r,o).then(l=>t(l),l=>i(l))}),r.once("close",()=>i(new Error(b.localize(2,null,s))))}))}function f(c,s){return u(c,s).then(r=>new Promise((t,i)=>{const o=[];r.once("error",i),r.on("data",l=>o.push(l)),r.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(ne[267],se([0,1,108,145]),function(Q,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(T){return(0,D.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=k}),define(ne[109],se([0,1,6,38,10,2,20,9,4,17,55,14,7,30,27,108,144,90,15,248,29,32,48,71,201,249,267,202,233,43,65,13,5,8,25,22,33,28]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g,u,f,c,s,r,t,i,o,l,a,h,v,R,M,F,O,L,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(f.IServerExtensionManagementService);let H=class extends u.AbstractExtensionManagementService{constructor(z,V,_,U,j,B,X,oe,J,ie,re,ue){super(z,V,_,ie,ue);this.extensionsScannerService=j,this.extensionsProfileScannerService=B,this.downloadService=X,this.fileService=J,this.installGalleryExtensionsTasks=new Map;const he=this._register(oe.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(Y,ye=>he.postUninstall(ye))),this.manifestCache=this._register(new l.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(oe.createInstance(t.ExtensionsDownloader));const ve=this._register(new a.ExtensionsWatcher(this,J,U,_,re));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:ye,removed:Ce})=>{ye.length&&this._onDidInstallExtensions.fire(ye.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),Ce.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const V=await this.collectFiles(z),_=await(0,S.zip)((0,I.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)()).fsPath,V);return m.URI.file(_)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const{location:V,cleanup:_}=await this.downloadVsix(z),U=b.resolve(V.fsPath);try{return await(0,o.getManifest)(U)}finally{await _()}}getInstalled(z,V){return this.extensionsScanner.scanExtensions(z??null,V)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(z,V={}){this.logService.trace("ExtensionManagementService#install",z.toString());const{location:_,cleanup:U}=await this.downloadVsix(z);try{const j=await(0,o.getManifest)(b.resolve(_.fsPath));if(j.engines&&j.engines.vscode&&!(0,v.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(C.localize(0,null,(0,c.getGalleryExtensionId)(j.publisher,j.name),this.productService.version));return await this.installExtension(j,_,V)}finally{await U()}}getMetadata(z){return this.extensionsScannerService.scanMetadata(z.location)}async updateMetadata(z,V){this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id);const _={...V};return V.isPreReleaseVersion&&(_.preRelease=!0),z=await this.extensionsScanner.updateMetadata(z,_),this.manifestCache.invalidate(),z}async updateExtensionScope(z,V){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.updateMetadata(z,{isMachineScoped:V}),this.manifestCache.invalidate(),z}removeUninstalledExtensions(z){return this.extensionsScanner.cleanUp(z)}async downloadVsix(z){if(z.scheme===A.Schemas.file)return{location:z,async cleanup(){}};this.logService.trace("Downloading extension from",z.toString());const V=(0,I.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)());return await this.downloadService.download(z,V),this.logService.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.fileService.del(V)}catch(U){this.logService.error(U)}}}}doCreateInstallExtensionTask(z,V,_){let U;if(m.URI.isUri(V))U=new W(z,V,_,this.galleryService,this.extensionsScanner,this.logService);else{const j=c.ExtensionKey.create(V).toString();U=this.installGalleryExtensionsTasks.get(j),U||(this.installGalleryExtensionsTasks.set(j,U=new q(z,V,_,this.extensionsDownloader,this.extensionsScanner,this.logService)),U.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(j)))}return _.profileLocation?new x(U,_.profileLocation,this.extensionsProfileScannerService):U}doCreateUninstallExtensionTask(z,V){return V.profileLocation?new ee(z,V.profileLocation,this.extensionsProfileScannerService):new K(z,V,this.extensionsScanner)}async collectFiles(z){const V=async U=>{let j=await d.Promises.readdir(U);j=j.map(oe=>b.join(U,oe));const B=await Promise.all(j.map(oe=>d.Promises.stat(oe)));let X=Promise.resolve([]);return B.forEach((oe,J)=>{const ie=j[J];oe.isFile()&&(X=X.then(re=>[...re,ie])),oe.isDirectory()&&(X=X.then(re=>V(ie).then(ue=>[...re,...ue])))}),X};return(await V(z.location.fsPath)).map(U=>({path:`extension/${b.relative(z.location.fsPath,U)}`,localPath:U}))}};H=me([G(0,f.IExtensionGalleryService),G(1,L.ITelemetryService),G(2,F.ILogService),G(3,g.INativeEnvironmentService),G(4,r.IExtensionsScannerService),G(5,s.IExtensionsProfileScannerService),G(6,p.IDownloadService),G(7,M.IInstantiationService),G(8,R.IFileService),G(9,O.IProductService),G(10,N.IUriIdentityService),G(11,$.IUserDataProfilesService)],H),e.ExtensionManagementService=H;let Y=class extends T.Disposable{constructor(z,V,_,U){super();this.beforeRemovingExtension=z,this.fileService=V,this.extensionsScannerService=_,this.logService=U,this.uninstalledPath=(0,I.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(z){await this.removeUninstalledExtensions(),z&&await this.removeOutdatedExtensions()}async scanExtensions(z,V){const _={includeInvalid:!0,profileLocation:V};let U=[];return z===null||z===0?U.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},_,!1)):z===1&&U.push(...await this.extensionsScannerService.scanUserExtensions(_)),U=z!==null?U.filter(j=>j.type===z):U,Promise.all(U.map(j=>this.toLocalExtension(j)))}async scanUserExtensions(z){const V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(V.map(_=>this.toLocalExtension(_)))}async extractUserExtension(z,V,_,U){const j=z.toString(),B=b.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),X=b.join(this.extensionsScannerService.userExtensionsLocation.fsPath,j);try{await d.Promises.rm(X)}catch{throw new f.ExtensionManagementError(C.localize(1,null,X,z.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(z,V,B,U),_={..._,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(m.URI.file(B),_);try{await this.rename(z,B,X,Date.now()+2*60*1e3),this.logService.info("Renamed to",X)}catch(oe){try{await d.Promises.rm(B)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(oe)}. Deleted from extracted location`,B),oe}return this.scanLocalExtension(m.URI.file(X),1)}async updateMetadata(z,V){return await this.extensionsScannerService.updateMetadata(z.location,V),this.scanLocalExtension(z.location,z.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...z){const V=z.map(_=>c.ExtensionKey.create(_));await this.withUninstalledExtensions(_=>{V.forEach(U=>_[U.toString()]=!0)})}async setInstalled(z){await this.withUninstalledExtensions(U=>delete U[z.toString()]);const _=(await this.scanUserExtensions(!0)).find(U=>c.ExtensionKey.create(U).equals(z))||null;return _?this.updateMetadata(_,{installedTimestamp:Date.now()}):null}async removeExtension(z,V){this.logService.trace(`Deleting ${V} extension from disk`,z.identifier.id,z.location.fsPath),await d.Promises.rm(z.location.fsPath),this.logService.info("Deleted from disk",z.identifier.id,z.location.fsPath)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.withUninstalledExtensions(V=>delete V[c.ExtensionKey.create(z).toString()])}async withUninstalledExtensions(z){return this.uninstalledFileLimiter.queue(async()=>{let V;try{V=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let _={};if(V)try{_=JSON.parse(V)}catch{}return z&&(z(_),Object.keys(_).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await d.Promises.rm(this.uninstalledPath)),_})}async extractAtLocation(z,V,_,U){this.logService.trace(`Started extracting the extension from ${V} to ${_}`);try{await d.Promises.rm(_)}catch(j){throw new f.ExtensionManagementError(this.joinErrors(j).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(V,_,{sourcePath:"extension",overwrite:!0},U),this.logService.info(`Extracted extension to ${_}:`,z.id)}catch(j){try{await d.Promises.rm(_)}catch{}let B=f.ExtensionManagementErrorCode.Extract;throw j instanceof S.ExtractError&&(j.type==="CorruptZip"?B=f.ExtensionManagementErrorCode.CorruptZip:j.type==="Incomplete"&&(B=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(j.message,B)}}async rename(z,V,_,U){try{await d.Promises.rename(V,_)}catch(j){if(P.isWindows&&j&&j.code==="EPERM"&&Date.now()<U)return this.logService.info(`Failed renaming ${V} to ${_} with 'EPERM' error. Trying again...`,z.id),this.rename(z,V,_,U);throw new f.ExtensionManagementError(j.message||C.localize(2,null,V,_),j.code||f.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(z,V){const _=await this.extensionsScannerService.scanExistingExtension(z,V,{includeInvalid:!0});if(_)return this.toLocalExtension(_);throw new Error(C.localize(3,null,z.path))}async toLocalExtension(z){const V=await this.fileService.resolve(z.location);let _,U;return V.children&&(_=V.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,U=V.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:_,changelogUrl:U,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isApplicationScoped:!!z.metadata?.isApplicationScoped,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated}}async removeUninstalledExtensions(){const z=await this.getUninstalledExtensions(),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const B of V)z[c.ExtensionKey.create(B).toString()]||_.add(B.identifier.id.toLowerCase());const U=(0,c.groupByExtension)(V,B=>B.identifier);await D.Promises.settled(U.map(async B=>{const X=B.sort((oe,J)=>E.rcompare(oe.manifest.version,J.manifest.version))[0];_.has(X.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(X))}));const j=V.filter(B=>z[c.ExtensionKey.create(B).toString()]);await D.Promises.settled(j.map(B=>this.removeUninstalledExtension(B)))}async removeOutdatedExtensions(){const z=await this.extensionsScannerService.scanSystemExtensions({}),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=[],U=await this.extensionsScannerService.getTargetPlatform(),j=(0,c.groupByExtension)(V,B=>B.identifier);for(const B of j)if(B.length>1&&_.push(...B.sort((X,oe)=>{const J=E.rcompare(X.manifest.version,oe.manifest.version);return J!==0?J:X.targetPlatform===U?-1:1}).slice(1)),B[0].type===0){const X=z.find(oe=>(0,c.areSameExtensions)(oe.identifier,B[0].identifier));(!X||E.gte(X.manifest.version,B[0].manifest.version))&&_.push(B[0])}await D.Promises.settled(_.map(B=>this.removeExtension(B,"outdated")))}joinErrors(z){const V=Array.isArray(z)?z:[z];return V.length===1?V[0]instanceof Error?V[0]:new Error(V[0]):V.reduce((_,U)=>new Error(`${_.message}${_.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};Y=me([G(1,R.IFileService),G(2,r.IExtensionsScannerService),G(3,F.ILogService)],Y);class te extends u.AbstractExtensionTask{constructor(z,V,_,U,j){super();this.identifier=z,this.source=V,this.options=_,this.extensionsScanner=U,this.logService=j,this._operation=2}get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(z,V){try{const _=await this.unsetUninstalledAndGetLocal(z.key);if(_)return z.metadata?this.extensionsScanner.updateMetadata(_,z.metadata):_}catch{throw P.isMacintosh?new f.ExtensionManagementError(C.localize(4,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(C.localize(5,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(z,V)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const _=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),_}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.toString()]}async extract({zipPath:z,key:V,metadata:_},U){const j=await this.extensionsScanner.extractUserExtension(V,z,_,U);return this.logService.info("Extracting completed.",V.id),j}}class q extends te{constructor(z,V,_,U,j,B){super(V.identifier,V,_,j,B);this.manifest=z,this.gallery=V,this.extensionsDownloader=U}async doRun(z){const _=(await this.extensionsScanner.scanExtensions(null,void 0)).find(B=>(0,c.areSameExtensions)(B.identifier,this.gallery.identifier));_&&(this._operation=3);const U={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,h.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===0?!0:void 0,updated:!!_,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:_?.preRelease)};if(_?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(_,U),metadata:U};const j=await this.downloadExtension(this.gallery,this._operation);try{const B=await this.installExtension({zipPath:j,key:c.ExtensionKey.create(this.gallery),metadata:U},z);return _&&!this.options.profileLocation&&(_.targetPlatform!==B.targetPlatform||E.neq(_.manifest.version,B.manifest.version))&&await this.extensionsScanner.setUninstalled(_),{local:B,metadata:U}}catch(B){throw await this.deleteDownloadedVSIX(j),B}}async deleteDownloadedVSIX(z){try{await this.extensionsDownloader.delete(m.URI.file(z))}catch(V){this.logService.warn("Error while deleting the downloaded vsix",z.toString(),(0,k.getErrorMessage)(V))}}async downloadExtension(z,V){let _;try{this.logService.trace("Started downloading extension:",z.identifier.id),_=(await this.extensionsDownloader.downloadExtension(z,V)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,_)}catch(U){throw new f.ExtensionManagementError((0,u.joinErrors)(U).message,f.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(_),_}catch(U){throw await this.deleteDownloadedVSIX(_),new f.ExtensionManagementError((0,u.joinErrors)(U).message,f.ExtensionManagementErrorCode.Invalid)}}}class W extends te{constructor(z,V,_,U,j,B){super({id:(0,c.getGalleryExtensionId)(z.publisher,z.name)},V,_,j,B);this.manifest=z,this.location=V,this.galleryService=U}async doRun(z){const V=new c.ExtensionKey(this.identifier,this.manifest.version),U=(await this.extensionsScanner.scanExtensions(1,void 0)).find(X=>(0,c.areSameExtensions)(this.identifier,X.identifier)),j=await this.getMetadata(this.identifier.id,this.manifest.version,z);if(j.isApplicationScoped=(0,h.isApplicationScopedExtension)(this.manifest),j.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||U?.isBuiltin,U)if(this._operation=3,V.equals(new c.ExtensionKey(U.identifier,U.manifest.version)))try{await this.extensionsScanner.removeExtension(U,"existing")}catch{throw new Error(C.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&E.gt(U.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(U);else{const X=await this.unsetUninstalledAndGetLocal(V);if(X)try{await this.extensionsScanner.removeExtension(X,"existing")}catch{throw new Error(C.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:b.resolve(this.location.fsPath),key:V,metadata:j},z),metadata:j}}async getMetadata(z,V,_){try{let[U]=await this.galleryService.getExtensions([{id:z,version:V}],_);if(U||([U]=await this.galleryService.getExtensions([{id:z}],_)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class x{constructor(z,V,_){this.task=z,this.profileLocation=V,this.extensionsProfileScannerService=_,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const z=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[z.local,z.metadata]],this.profileLocation),z}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class K extends u.AbstractExtensionTask{constructor(z,V,_){super();this.extension=z,this.options=V,this.extensionsScanner=_}async doRun(z){const V=[],_=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const U=c.ExtensionKey.create(this.extension);V.push(..._.filter(j=>U.equals(c.ExtensionKey.create(j))))}else V.push(..._.filter(U=>(0,c.areSameExtensions)(U.identifier,this.extension.identifier)));if(!V.length)throw new Error(C.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...V),this.options.remove)for(const U of V)try{z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(U)}catch(j){throw new Error(C.localize(9,null,(0,n.toErrorMessage)(j)))}}}class ee extends u.AbstractExtensionTask{constructor(z,V,_){super();this.extension=z,this.profileLocation=V,this.extensionsProfileScannerService=_}async doRun(z){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[268],se([0,1,2,29,32,48,72,200,109,43,5,8,23,33,28]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let C=class extends D.Disposable{constructor(u,f,c,s,r,t,i,o){super();this.userDataProfilesService=f,u.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,b.migrateUnsupportedExtensions)(u,c,s,r,o),A.ExtensionStorageService.removeOutdatedExtensionVersions(u,i),this._register(t.createInstance(p))}};C=me([G(0,P.INativeServerExtensionManagementService),G(1,d.IUserDataProfilesService),G(2,n.IExtensionGalleryService),G(3,A.IExtensionStorageService),G(4,n.IGlobalExtensionEnablementService),G(5,E.IInstantiationService),G(6,m.IStorageService),G(7,w.ILogService)],C),e.ExtensionsCleaner=C;let p=class extends D.Disposable{constructor(u,f,c,s,r){super();this.extensionManagementService=u,this.userDataProfilesService=f,this.extensionsProfileScannerService=c,this.uriIdentityService=s,this.logService=r,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new D.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:u,removed:f,all:c}){try{await Promise.all(f.map(s=>s.extensionsResource?this.removeExtensionsFromProfile(s.extensionsResource):Promise.resolve()))}catch(s){this.logService.error(s)}if(c.length===1){this.profileModeDisposables.clear();const s=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{s.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{u.length&&(await Promise.all(u.map(s=>s.extensionsResource?this.populateExtensionsFromProfile(s.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new D.DisposableStore,this.profileModeDisposables.value.add((0,D.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(s=>this.onDidChangeProfiles(s))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(s=>this.onDidInstallExtensions(s))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(s=>this.onDidUninstallExtension(s))),await this.uninstallExtensionsNotInProfiles()))}catch(s){this.logService.error(s)}}async uninstallExtensionsNotInProfiles(){const f=(await this.extensionManagementService.getAllUserInstalled()).filter(c=>!this.profileExtensionsLocations.has(this.getKey(c.identifier,c.manifest.version)));f.length&&await Promise.all(f.map(c=>this.extensionManagementService.uninstall(c,S)))}async onDidInstallExtensions(u){for(const{local:f,profileLocation:c}of u)!f||!c||this.addExtensionWithKey(this.getKey(f.identifier,f.manifest.version),c)}async onDidUninstallExtension(u){!u.profileLocation||!u.version||this.removeExtensionWithKey(this.getKey(u.identifier,u.version),u.profileLocation)&&await this.uninstallExtensions([{identifier:u.identifier,version:u.version}])}async populateExtensionsFromProfile(u){const f=await this.extensionsProfileScannerService.scanProfileExtensions(u);for(const c of f)this.addExtensionWithKey(this.getKey(c.identifier,c.version),u)}async removeExtensionsFromProfile(u){const f=[];for(const c of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(c,u))continue;const s=this.fromKey(c);s&&f.push(s)}f.length&&await this.uninstallExtensions(f)}addExtensionWithKey(u,f){let c=this.profileExtensionsLocations.get(u);c||(c=[],this.profileExtensionsLocations.set(u,c)),c.push(f)}removeExtensionWithKey(u,f){const c=this.profileExtensionsLocations.get(u);if(c){const s=c.findIndex(r=>this.uriIdentityService.extUri.isEqual(r,f));s>-1&&c.splice(s,1)}return c?.length?!1:(this.profileExtensionsLocations.delete(u),!0)}async uninstallExtensions(u){const c=(await this.extensionManagementService.getAllUserInstalled()).filter(s=>u.some(r=>this.getKey(s.identifier,s.manifest.version)===this.getKey(r.identifier,r.version)));c.length&&await Promise.all(c.map(s=>this.extensionManagementService.uninstall(s,S)))}getKey(u,f){return`${I.ExtensionIdentifier.toKey(u.id)}@${f}`}fromKey(u){const[f,c]=(0,k.getIdAndVersion)(u);return c?{identifier:{id:f},version:c}:void 0}};p=me([G(0,P.INativeServerExtensionManagementService),G(1,d.IUserDataProfilesService),G(2,T.IExtensionsProfileScannerService),G(3,y.IUriIdentityService),G(4,w.ILogService)],p)}),define(ne[277],se([0,1,85,37,38,10,2,20,17,7,39,133,193,268,194,185,186,187,173,176,19,198,89,218,90,208,15,214,251,252,29,175,253,109,91,171,13,189,191,56,5,183,93,184,94,66,203,8,95,67,96,25,44,23,254,101,22,102,103,104,49,222,105,224,230,72,107,26,70,241,242,243,73,262,264,244,265,266,245,100,216,69,232,205,231,99,213,33,234,4,235,178,196,195,71,250,28,48,192,58,255,211,221,247]),function(Q,e,D,n,k,T,A,b,P,I,E,w,m,y,d,S,C,p,g,u,f,c,s,r,t,i,o,l,a,h,v,R,M,F,O,L,N,$,H,Y,te,q,W,x,K,ee,ce,z,V,_,U,j,B,X,oe,J,ie,re,ue,he,ve,ye,Ce,Pe,Ue,We,Be,qe,ae,de,fe,be,Ie,Me,De,$e,Ae,Te,Ne,Z,le,ge,Se,pe,Ee,Re,ke,Le,_e,Fe,ze,Qe,it,pt,Pt,It,Rt,vt,Dt,St,kt,Lt,Tt,At){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class _t extends A.Disposable{constructor(we){super();this.configuration=we,this.server=this._register(new w.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const we=()=>this.dispose();process.once("exit",we),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",we);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(Ve,Xe)=>{this.onDisposeWorker(Xe)};D.ipcRenderer.on(Oe,je),this._register((0,A.toDisposable)(()=>D.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(we){this.sharedProcessWorkerService?.disposeWorker(we)}async open(){const we=await this.initServices();(0,qe.registerConfiguration)(),we.invokeFunction(Oe=>{const je=Oe.get(z.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,A.combinedDisposable)(we.createInstance(m.CodeCacheCleaner,this.configuration.codeCachePath),we.createInstance(d.LanguagePackCachedDataCleaner),we.createInstance(p.StorageDataCleaner,this.configuration.backupWorkspacesPath),we.createInstance(C.LogsDataCleaner),we.createInstance(S.LocalizationsUpdater),we.createInstance(y.ExtensionsCleaner),we.createInstance(At.UserDataProfilesCleaner)))}async initServices(){const we=new W.ServiceCollection,Oe={_serviceBrand:void 0,...U.default};we.set(j.IProductService,Oe);const je=new E.StaticRouter(Ke=>Ke==="main"),Ve=new x.MessagePortMainProcessService(this.server,je);we.set(K.IMainProcessService,Ve);const Xe=this.configuration.policiesData?new Dt.PolicyChannelClient(this.configuration.policiesData,Ve.getChannel("policy")):new St.NullPolicyService;we.set(St.IPolicyService,Xe);const xe=new l.SharedProcessEnvironmentService(this.configuration.args,Oe);we.set(o.INativeEnvironmentService,xe);const st=new V.LogLevelChannelClient(this.server.getChannel("logLevel",je)),Ze=new V.LoggerChannelClient(this.configuration.logLevel,st.onDidChangeLogLevel,Ve.getChannel("logger"));we.set(z.ILoggerService,Ze);const ct=this._register(new z.MultiplexLogService([this._register(new z.ConsoleLogger(this.configuration.logLevel)),this._register(Ze.createLogger((0,P.joinPath)(I.URI.file(xe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),He=this._register(new V.FollowerLogService(st,ct));we.set(z.ILogService,He),this.sharedProcessWorkerService=new ke.SharedProcessWorkerService(He),we.set(Re.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ye=this._register(new $.FileService(He));we.set(N.IFileService,Ye);const lt=this._register(new H.DiskFileSystemProvider(He));Ye.registerProvider(b.Schemas.file,lt);const ut=this._register(new ze.FileUserDataProvider(b.Schemas.file,this._register(new Qe.DiskFileSystemProviderClient(Ve.getChannel(Qe.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Fe.isLinux})),b.Schemas.vscodeUserData,He));Ye.registerProvider(b.Schemas.vscodeUserData,ut);const et=this._register(new kt.UserDataProfilesNativeService(this.configuration.profiles,Ve,xe));we.set(Rt.IUserDataProfilesService,et);const Ge=this._register(new c.ConfigurationService(et.defaultProfile.settingsResource,Ye,Xe,He));we.set(f.IConfigurationService,Ge);const nt=new oe.NativeStorageService(void 0,{defaultProfile:et.defaultProfile,currentProfile:et.defaultProfile},Ve,xe);we.set(X.IStorageService,nt),this._register((0,A.toDisposable)(()=>nt.flush())),await Promise.all([Ge.initialize(),nt.initialize()]),we.set(Le.IUriIdentityService,new _e.UriIdentityService(Ye)),we.set(B.IRequestService,new Lt.SharedProcessRequestService(Ve,Ge,He)),we.set(g.IChecksumService,new Y.SyncDescriptor(u.ChecksumService)),we.set(pt.IV8InspectProfilingService,new Y.SyncDescriptor(it.InspectProfilingService));const ot=E.ProxyChannel.toService(Ve.getChannel("nativeHost"),{context:this.configuration.windowId});we.set(_.INativeHostService,ot),we.set(t.IDownloadService,new Y.SyncDescriptor(i.DownloadService));const ht=this._register(new Ne.ActiveWindowManager(ot)),Ut=new E.StaticRouter(Ke=>ht.getActiveClientId().then(dt=>Ke===dt));we.set(O.IExtensionRecommendationNotificationService,new L.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ut)));let at;const rt=[],wt=(0,ve.isInternalTelemetry)(Oe,Ge);if((0,ve.supportsTelemetry)(Oe,xe)){const Ke=new ue.TelemetryLogAppender(Ze,xe);rt.push(Ke);const{installSourcePath:dt}=xe;if(Oe.aiConfig?.ariaKey){const bt=new Tt.OneDataSystemAppender(wt,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>bt.flush())),rt.push(bt)}at=new he.TelemetryService({appenders:rt,commonProperties:(0,J.resolveCommonProperties)(Ye,(0,n.release)(),(0,n.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,wt,dt),sendErrorTelemetry:!0,piiPaths:(0,ve.getPiiPathsFromEnvironment)(xe)},Ge,Oe)}else{at=ve.NullTelemetryService;const Ke=ve.NullAppender;rt.push(Ke)}this.server.registerChannel("telemetryAppender",new re.TelemetryAppenderChannel(rt)),we.set(ie.ITelemetryService,at);const Mt=new ye.CustomEndpointTelemetryService(Ge,at,Ze,xe,Oe);we.set(ie.ICustomEndpointTelemetryService,Mt),we.set(vt.IExtensionsProfileScannerService,new Y.SyncDescriptor(vt.ExtensionsProfileScannerService)),we.set(Pt.IExtensionsScannerService,new Y.SyncDescriptor(It.ExtensionsScannerService)),we.set(F.INativeServerExtensionManagementService,new Y.SyncDescriptor(F.ExtensionManagementService)),we.set(v.IExtensionGalleryService,new Y.SyncDescriptor(h.ExtensionGalleryService)),we.set(v.IExtensionTipsService,new Y.SyncDescriptor(M.ExtensionTipsService)),we.set(ee.ILanguagePackService,new Y.SyncDescriptor(ce.NativeLanguagePackService)),we.set(s.IDiagnosticsService,new Y.SyncDescriptor(r.DiagnosticsService)),we.set(ae.IUserDataSyncAccountService,new Y.SyncDescriptor(ae.UserDataSyncAccountService)),we.set(qe.IUserDataSyncLogService,new Y.SyncDescriptor(be.UserDataSyncLogService)),we.set(qe.IUserDataSyncUtilService,new fe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),we.set(v.IGlobalExtensionEnablementService,new Y.SyncDescriptor(a.GlobalExtensionEnablementService)),we.set(Be.IIgnoredExtensionsManagementService,new Y.SyncDescriptor(Be.IgnoredExtensionsManagementService)),we.set(We.IExtensionStorageService,new Y.SyncDescriptor(We.ExtensionStorageService)),we.set(qe.IUserDataSyncStoreManagementService,new Y.SyncDescriptor(Ae.UserDataSyncStoreManagementService)),we.set(qe.IUserDataSyncStoreService,new Y.SyncDescriptor(Ae.UserDataSyncStoreService)),we.set(Ie.IUserDataSyncMachinesService,new Y.SyncDescriptor(Ie.UserDataSyncMachinesService)),we.set(qe.IUserDataSyncBackupStoreService,new Y.SyncDescriptor(de.UserDataSyncBackupStoreService)),we.set(qe.IUserDataSyncEnablementService,new Y.SyncDescriptor(Me.UserDataSyncEnablementService)),we.set(qe.IUserDataSyncService,new Y.SyncDescriptor(De.UserDataSyncService));const Et=new Ue.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ge.getValue("terminal.integrated.persistentSessionScrollback")??100},Ge,xe,He);return Et.initialize(),we.set(Pe.ILocalPtyService,this._register(Et)),we.set(Z.ISignService,new Y.SyncDescriptor(le.SignService)),we.set(ge.ISharedTunnelsService,new Y.SyncDescriptor(Se.SharedTunnelsService)),we.set(pe.ISharedProcessTunnelService,new Y.SyncDescriptor(Ee.SharedProcessTunnelService)),new q.InstantiationService(we)}initChannels(we){const Oe=new R.ExtensionManagementChannel(we.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const je=E.ProxyChannel.fromService(we.get(ee.ILanguagePackService));this.server.registerChannel("languagePacks",je);const Ve=E.ProxyChannel.fromService(we.get(s.IDiagnosticsService));this.server.registerChannel("diagnostics",Ve);const Xe=new R.ExtensionTipsChannel(we.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Xe);const xe=E.ProxyChannel.fromService(we.get(g.IChecksumService));this.server.registerChannel("checksum",xe);const st=E.ProxyChannel.fromService(we.get(pt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",st);const Ze=new fe.UserDataSyncMachinesServiceChannel(we.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ze);const ct=E.ProxyChannel.fromService(we.get(ie.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ct);const He=new fe.UserDataSyncAccountServiceChannel(we.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",He);const Ye=new fe.UserDataSyncStoreManagementServiceChannel(we.get(qe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ye);const lt=new $e.UserDataSyncChannel(we.get(qe.IUserDataSyncService),we.get(z.ILogService));this.server.registerChannel("userDataSync",lt);const ut=this._register(we.get(te.IInstantiationService).createInstance(Te.UserDataAutoSyncService)),et=new fe.UserDataAutoSyncChannel(ut);this.server.registerChannel("userDataAutoSync",et);const Ge=we.get(Pe.ILocalPtyService),nt=E.ProxyChannel.fromService(Ge);this.server.registerChannel(Ce.TerminalIpcChannels.LocalPty,nt);const ot=E.ProxyChannel.fromService(we.get(pe.ISharedProcessTunnelService));this.server.registerChannel(pe.ipcSharedProcessTunnelChannelName,ot);const ht=E.ProxyChannel.fromService(we.get(Re.ISharedProcessWorkerService));this.server.registerChannel(Re.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(we){window.addEventListener("unhandledrejection",Oe=>{(0,T.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Oe=>{const je=(0,k.toErrorMessage)(Oe,!0);!je||we.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Ot(yt){const we=new _t(yt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await we.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ot})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/38de2191e5c0fc5a226fc5aed63ac57269327152/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
