/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var L=["require","exports","vs/base/common/stream","vs/base/common/lifecycle","vs/base/common/buffer","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/base/common/types","vs/base/common/processes","vs/base/common/console","vs/platform/instantiation/common/instantiation","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/base/common/errors","vs/nls","vs/nls!vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain","vs/base/common/arrays","vs/base/common/platform","vs/base/common/uri","vs/base/common/hash","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain","child_process","console","vs/base/common/event","vs/base/common/objects"],$=function(T){for(var e=[],m=0,b=T.length;m<b;m++)e[m]=L[T[m]];return e};define(L[2],$([0,1,13,3]),function(T,e,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function E(n){const t=n;return t?typeof t.read=="function":!1}e.isReadable=E;function k(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=k;function c(n){const t=n;return t?k(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}e.isReadableBufferedStream=c;function s(n,t){return new S(n,t)}e.newWriteableStream=s;class S{constructor(t,a){this.reducer=t,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t!="undefined"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(a=>a(t))}emitError(t){this.listeners.error.length===0?(0,m.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(a=>a(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,a){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(t,a){if(this.state.destroyed)return;let f;switch(t){case"data":f=this.listeners.data;break;case"end":f=this.listeners.end;break;case"error":f=this.listeners.error;break}if(f){const u=f.indexOf(a);u>=0&&f.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(f=>f())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(n,t){const a=[];let f;for(;(f=n.read())!==null;)a.push(f);return t(a)}e.consumeReadable=w;function g(n,t,a){const f=[];let u;for(;(u=n.read())!==null&&f.length<a;)f.push(u);return u===null&&f.length>0?t(f):{read:()=>{if(f.length>0)return f.shift();if(typeof u!="undefined"){const D=u;return u=void 0,D}return n.read()}}}e.peekReadable=g;function o(n,t){return new Promise((a,f)=>{const u=[];l(n,{onData:D=>{t&&u.push(D)},onError:D=>{t?f(D):a(void 0)},onEnd:()=>{a(t?t(u):void 0)}})})}e.consumeStream=o;function l(n,t){let a=!1;return n.on("error",f=>{a||t.onError(f)}),n.on("end",()=>{a||t.onEnd()}),n.on("data",f=>{a||t.onData(f)}),(0,b.toDisposable)(()=>a=!0)}e.listenStream=l;function h(n,t){return new Promise((a,f)=>{const u=new b.DisposableStore,D=[],y=r=>{if(D.push(r),D.length>t)return u.dispose(),n.pause(),a({stream:n,buffer:D,ended:!1})},O=r=>f(r),i=()=>a({stream:n,buffer:D,ended:!0});u.add((0,b.toDisposable)(()=>n.removeListener("error",O))),n.on("error",O),u.add((0,b.toDisposable)(()=>n.removeListener("end",i))),n.on("end",i),u.add((0,b.toDisposable)(()=>n.removeListener("data",y))),n.on("data",y)})}e.peekStream=h;function B(n,t){const a=s(t);return a.end(n),a}e.toStream=B;function W(){const n=s(()=>{throw new Error("not supported")});return n.end(),n}e.emptyStream=W;function _(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}e.toReadable=_;function R(n,t,a){const f=s(a);return l(n,{onData:u=>f.write(t.data(u)),onError:u=>f.error(t.error?t.error(u):u),onEnd:()=>f.end()}),f}e.transform=R;function N(n,t,a){let f=!1;return{read:()=>{const u=t.read();return f?u:(f=!0,u!==null?a([n,u]):n)}}}e.prefixedReadable=N;function A(n,t,a){let f=!1;const u=s(a);return l(t,{onData:D=>f?u.write(D):(f=!0,u.write(a([n,D]))),onError:D=>u.error(D),onEnd:()=>{f||(f=!0,u.write(n)),u.end()}}),u}e.prefixedStream=A}),define(L[4],$([0,1,2]),function(T,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const b=typeof Buffer!="undefined";let E,k;class c{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return b?new c(Buffer.allocUnsafe(r)):new c(new Uint8Array(r))}static wrap(r){return b&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new c(r)}static fromString(r,d){return!(d?.dontUseNodeBuffer||!1)&&b?new c(Buffer.from(r)):(E||(E=new TextEncoder),new c(E.encode(r)))}static fromByteArray(r){const d=c.alloc(r.length);for(let p=0,I=r.length;p<I;p++)d.buffer[p]=r[p];return d}static concat(r,d){if(typeof d=="undefined"){d=0;for(let U=0,M=r.length;U<M;U++)d+=r[U].byteLength}const p=c.alloc(d);let I=0;for(let U=0,M=r.length;U<M;U++){const v=r[U];p.set(v,I),I+=v.byteLength}return p}clone(){const r=c.alloc(this.byteLength);return r.set(this),r}toString(){return b?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(r,d){return new c(this.buffer.subarray(r,d))}set(r,d){if(r instanceof c)this.buffer.set(r.buffer,d);else if(r instanceof Uint8Array)this.buffer.set(r,d);else if(r instanceof ArrayBuffer)this.buffer.set(new Uint8Array(r),d);else if(ArrayBuffer.isView(r))this.buffer.set(new Uint8Array(r.buffer,r.byteOffset,r.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(r){return w(this.buffer,r)}writeUInt32BE(r,d){g(this.buffer,r,d)}readUInt32LE(r){return o(this.buffer,r)}writeUInt32LE(r,d){l(this.buffer,r,d)}readUInt8(r){return h(this.buffer,r)}writeUInt8(r,d){B(this.buffer,r,d)}}e.VSBuffer=c;function s(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0}e.readUInt16LE=s;function S(i,r,d){i[d+0]=r&255,r=r>>>8,i[d+1]=r&255}e.writeUInt16LE=S;function w(i,r){return i[r]*2**24+i[r+1]*2**16+i[r+2]*2**8+i[r+3]}e.readUInt32BE=w;function g(i,r,d){i[d+3]=r,r=r>>>8,i[d+2]=r,r=r>>>8,i[d+1]=r,r=r>>>8,i[d]=r}e.writeUInt32BE=g;function o(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0|i[r+2]<<16>>>0|i[r+3]<<24>>>0}e.readUInt32LE=o;function l(i,r,d){i[d+0]=r&255,r=r>>>8,i[d+1]=r&255,r=r>>>8,i[d+2]=r&255,r=r>>>8,i[d+3]=r&255}e.writeUInt32LE=l;function h(i,r){return i[r]}e.readUInt8=h;function B(i,r,d){i[d]=r}e.writeUInt8=B;function W(i){return m.consumeReadable(i,r=>c.concat(r))}e.readableToBuffer=W;function _(i){return m.toReadable(i)}e.bufferToReadable=_;function R(i){return m.consumeStream(i,r=>c.concat(r))}e.streamToBuffer=R;async function N(i){return i.ended?c.concat(i.buffer):c.concat([...i.buffer,await R(i.stream)])}e.bufferedStreamToBuffer=N;function A(i){return m.toStream(i,r=>c.concat(r))}e.bufferToStream=A;function n(i){return m.transform(i,{data:r=>typeof r=="string"?c.fromString(r):c.wrap(r)},r=>c.concat(r))}e.streamToBufferReadableStream=n;function t(i){return m.newWriteableStream(r=>c.concat(r),i)}e.newWriteableBufferStream=t;function a(i,r){return m.prefixedReadable(i,r,d=>c.concat(d))}e.prefixedBufferReadable=a;function f(i,r){return m.prefixedStream(i,r,d=>c.concat(d))}e.prefixedBufferStream=f;function u(i){let r=0,d=0,p=0;const I=new Uint8Array(Math.floor(i.length/4*3)),U=v=>{switch(d){case 3:I[p++]=r|v,d=0;break;case 2:I[p++]=r|v>>>2,r=v<<6,d=3;break;case 1:I[p++]=r|v>>>4,r=v<<4,d=2;break;default:r=v<<2,d=1}};for(let v=0;v<i.length;v++){const P=i.charCodeAt(v);if(P>=65&&P<=90)U(P-65);else if(P>=97&&P<=122)U(P-97+26);else if(P>=48&&P<=57)U(P-48+52);else if(P===43||P===45)U(62);else if(P===47||P===95)U(63);else{if(P===61)break;throw new SyntaxError(`Unexpected base64 character ${i[v]}`)}}const M=p;for(;d>0;)U(0);return c.wrap(I).slice(0,M)}e.decodeBase64=u;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:i},r=!0,d=!1){const p=d?y:D;let I="";const U=i.byteLength%3;let M=0;for(;M<i.byteLength-U;M+=3){const v=i[M+0],P=i[M+1],C=i[M+2];I+=p[v>>>2],I+=p[(v<<4|P>>>4)&63],I+=p[(P<<2|C>>>6)&63],I+=p[C&63]}if(U===1){const v=i[M+0];I+=p[v>>>2],I+=p[v<<4&63],r&&(I+="==")}else if(U===2){const v=i[M+0],P=i[M+1];I+=p[v>>>2],I+=p[(v<<4|P>>>4)&63],I+=p[P<<2&63],r&&(I+="=")}return I}e.encodeBase64=O}),define(L[5],$([14,15]),function(T,e){return T.create("vs/base/common/errorMessage",e)}),define(L[6],$([0,1,16,7,5]),function(T,e,m,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(o,l){return l&&(o.stack||o.stacktrace)?E.localize(0,null,s(o),c(o.stack)||c(o.stacktrace)):s(o)}function c(o){return Array.isArray(o)?o.join(`
`):o}function s(o){return typeof o.code=="string"&&typeof o.errno=="number"&&typeof o.syscall=="string"?E.localize(1,null,o.message):o.message||E.localize(2,null)}function S(o=null,l=!1){if(!o)return E.localize(3,null);if(Array.isArray(o)){const h=m.coalesce(o),B=S(h[0],l);return h.length>1?E.localize(4,null,B,h.length):B}if(b.isString(o))return o;if(o.detail){const h=o.detail;if(h.error)return k(h.error,l);if(h.exception)return k(h.exception,l)}return o.stack?k(o,l):o.message?o.message:E.localize(5,null)}e.toErrorMessage=S;function w(o){const l=o;return l instanceof Error&&Array.isArray(l.actions)}e.isErrorWithActions=w;function g(o,l){let h;return typeof o=="string"?h=new Error(o):h=o,h.actions=l,h}e.createErrorWithActions=g}),define(L[8],$([0,1,17]),function(T,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var b;(function(s){s[s.stdout=0]="stdout",s[s.stderr=1]="stderr"})(b=e.Source||(e.Source={}));var E;(function(s){s[s.Success=0]="Success",s[s.Unknown=1]="Unknown",s[s.AccessDenied=2]="AccessDenied",s[s.ProcessNotFound=3]="ProcessNotFound"})(E=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(s,...S){const w=S.reduce((l,h)=>(l[h]=!0,l),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(s).filter(l=>!w[l]).forEach(l=>{for(let h=0;h<g.length;h++)if(l.search(g[h])!==-1){delete s[l];break}})}e.sanitizeProcessEnvironment=k;function c(s){!s||(delete s.DEBUG,m.isMacintosh&&delete s.DYLD_LIBRARY_PATH,m.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=c}),define(L[9],$([0,1,18]),function(T,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function b(w){const g=w;return g&&typeof g.type=="string"&&typeof g.severity=="string"}e.isRemoteConsoleLog=b;function E(w){const g=[];let o;try{const l=JSON.parse(w.arguments),h=l[l.length-1];h&&h.__$stack&&(l.pop(),o=h.__$stack),g.push(...l)}catch{g.push("Unable to log remote console arguments",w.arguments)}return{args:g,stack:o}}e.parse=E;function k(w){if(typeof w!="string")return k(E(w).stack);const g=w;if(g){const o=c(g),l=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(o||"");if(l&&l.length===4)return{uri:m.URI.file(l[1]),line:Number(l[2]),column:Number(l[3])}}}e.getFirstFrame=k;function c(w){if(!w)return w;const g=w.indexOf(`
`);return g===-1?w:w.substring(0,g)}function s(w,g){const{args:o,stack:l}=E(w),h=typeof o[0]=="string"&&o.length===1;let B=c(l);B&&(B=`(${B.trim()})`);let W=[];if(typeof o[0]=="string"?B&&h?W=[`%c[${g}] %c${o[0]} %c${B}`,S("blue"),S(""),S("grey")]:W=[`%c[${g}] %c${o[0]}`,S("blue"),S(""),...o.slice(1)]:W=[`%c[${g}]%`,S("blue"),...o],B&&!h&&W.push(B),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,W)}e.log=s;function S(w){return`color: ${w}`}}),define(L[10],$([0,1]),function(T,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(c){c.serviceIds=new Map,c.DI_TARGET="$di$target",c.DI_DEPENDENCIES="$di$dependencies";function s(S){return S[c.DI_DEPENDENCIES]||[]}c.getServiceDependencies=s})(m=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function b(c,s,S){s[m.DI_TARGET]===s?s[m.DI_DEPENDENCIES].push({id:c,index:S}):(s[m.DI_DEPENDENCIES]=[{id:c,index:S}],s[m.DI_TARGET]=s)}function E(c){if(m.serviceIds.has(c))return m.serviceIds.get(c);const s=function(S,w,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");b(s,S,g)};return s.toString=()=>c,m.serviceIds.set(c,s),s}e.createDecorator=E;function k(c){return c}e.refineServiceDecorator=k}),define(L[11],$([0,1,19,10]),function(T,e,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function E(k){return(0,m.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=E,e.ISharedProcessWorkerService=(0,b.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(L[12],$([0,1]),function(T,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var m;(function(b){b.Spawn="vscode:shared-process->shared-process-worker=spawn",b.Terminate="vscode:shared-process->shared-process-worker=terminate",b.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",b.Ready="vscode:shared-process-worker->shared-process=ready",b.Ack="vscode:shared-process-worker->shared-process=ack",b.Trace="vscode:shared-process-worker->shared-process=trace",b.Info="vscode:shared-process-worker->shared-process=info",b.Warn="vscode:shared-process-worker->shared-process=warn",b.Error="vscode:shared-process-worker->shared-process=error"})(m=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(L[20],$([0,1,21,22,4,9,6,23,3,24,7,8,11,12]),function(T,e,m,b,E,k,c,s,S,w,g,o,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;function B(){const A=new W;return N({id:h.SharedProcessWorkerMessages.Ready}),{onmessage:(n,t)=>A.onMessage(n,t)}}e.create=B;class W{constructor(){this.processes=new Map}onMessage(n,t){switch(n.id){case h.SharedProcessWorkerMessages.Spawn:t&&t[0]instanceof MessagePort&&n.environment&&this.spawn(t[0],n.configuration,n.environment);break;case h.SharedProcessWorkerMessages.Terminate:this.terminate(n.configuration);break;default:R.warn(`Unexpected shared process message '${n}'`)}n.nonce&&N({id:h.SharedProcessWorkerMessages.Ack,nonce:n.nonce})}spawn(n,t,a){try{this.terminate(t);const f=new _(n,t,a);f.spawn();const u=s.Event.once(f.onDidProcessSelfTerminate)(y=>{N({id:h.SharedProcessWorkerMessages.SelfTerminated,configuration:t,message:JSON.stringify(y)})}),D=(0,l.hash)(t);this.processes.set(D,(0,S.toDisposable)(()=>{u.dispose(),f.dispose(),this.processes.delete(D)}))}catch(f){R.error(`Unexpected error forking worker process: ${(0,c.toErrorMessage)(f)}`)}}terminate(n){this.processes.get((0,l.hash)(n))?.dispose()}}class _ extends S.Disposable{constructor(n,t,a){super();this.port=n,this.configuration=t,this.environment=a,this._onDidProcessSelfTerminate=this._register(new s.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.child=void 0}spawn(){R.trace("Forking worker process"),this.child=(0,m.fork)(this.environment.bootstrapPath,[`--type=${this.configuration.process.type}`],{env:this.getEnv()}),R.info(`Starting worker process with pid ${this.child.pid} (type: ${this.configuration.process.type}, window: ${this.configuration.reply.windowId}).`);const n=s.Event.fromNodeEventEmitter(this.child,"error");this._register(n(y=>R.warn(`Error from child process: ${(0,c.toErrorMessage)(y)}`)));const t=s.Event.fromNodeEventEmitter(this.child,"exit",(y,O)=>({code:y,signal:O}));this._register(t(({code:y,signal:O})=>{const i=`Worker process with pid ${this.child?.pid} terminated by itself with code ${y}, signal: ${O} (type: ${this.configuration.process.type}, window: ${this.configuration.reply.windowId})`;y!==0&&O!=="SIGTERM"?R.error(i):R.info(i),this.child=void 0,this._onDidProcessSelfTerminate.fire({code:(0,g.withNullAsUndefined)(y),signal:(0,g.withNullAsUndefined)(O)})}));const a=this._register(new s.Emitter),f=s.Event.fromNodeEventEmitter(this.child,"message",y=>y);this._register(f(y=>{(0,k.isRemoteConsoleLog)(y)?(0,b.log)(y,"SharedProcess worker"):a.fire(E.VSBuffer.wrap(Buffer.from(y,"base64")))}));const u=y=>{this.child?.connected?this.child.send(y.buffer.toString("base64")):R.warn("Unable to deliver message to disconnected child")},D=a.event;this._register(D(y=>this.port.postMessage(y.buffer))),this.port.onmessage=y=>u(E.VSBuffer.wrap(y.data)),this._register((0,S.toDisposable)(()=>this.port.onmessage=null))}getEnv(){const n={...(0,w.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:this.configuration.process.moduleId,VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_PARENT_PID:String(process.pid)};return(0,o.removeDangerousEnvVariables)(n),n}dispose(){super.dispose(),!!this.child&&(this.child.kill(),R.info(`Worker process with pid ${this.child?.pid} terminated normally (type: ${this.configuration.process.type}, window: ${this.configuration.reply.windowId}).`))}}var R;(function(A){function n(u){N({id:h.SharedProcessWorkerMessages.Error,message:u})}A.error=n;function t(u){N({id:h.SharedProcessWorkerMessages.Warn,message:u})}A.warn=t;function a(u){N({id:h.SharedProcessWorkerMessages.Info,message:u})}A.info=a;function f(u){N({id:h.SharedProcessWorkerMessages.Trace,message:u})}A.trace=f})(R||(R={}));function N(A){postMessage(A)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/38de2191e5c0fc5a226fc5aed63ac57269327152/core/vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain.js.map
